import { JSX as JSX$3 } from '@ionic/core/dist/types/components';
import { JSX as JSX$2 } from 'ionicons/dist/types/components';
import * as solid_js from 'solid-js';
import { JSX as JSX$1, ParentProps } from 'solid-js';
import { JSX, IonicConfig } from '@ionic/core';
import { ComponentOptions } from 'component-register/types/utils';

type FixKey<TKey extends string> = TKey extends `onIon${infer TRest}` ? `on:ion${TRest}` : TKey;
type FixIonProps<TIonComponent> = {
    [Field in keyof TIonComponent as FixKey<Field & string>]: TIonComponent[Field];
};
type FixVanillaKey<TKey extends string> = TKey extends `onIon${infer TRest}` ? `on:ion${TRest}` : CamelToKebab<TKey>;
type CamelToKebab<S extends string> = S extends `${infer T}${infer U}` ? U extends Uncapitalize<U> ? `${Uncapitalize<T>}${CamelToKebab<U>}` : `${Uncapitalize<T>}-${CamelToKebab<U>}` : '';
type FixVanillaIonProps<TIonComponent> = {
    [Field in keyof TIonComponent as FixVanillaKey<Field & string>]?: TIonComponent[Field];
} & {
    [Field in keyof TIonComponent as `prop:${Field & string}`]?: TIonComponent[Field];
};

type IonAccordionProps = FixIonProps<JSX.IonAccordion> & JSX$1.HTMLAttributes<HTMLIonAccordionElement>;
declare function IonAccordion(props: IonAccordionProps): JSX$1.Element;

type IonAccordionGroupProps = FixIonProps<JSX.IonAccordionGroup> & JSX$1.HTMLAttributes<HTMLIonAccordionGroupElement>;
declare function IonAccordionGroup(props: IonAccordionGroupProps): JSX$1.Element;

type IonActionSheetProps = FixIonProps<JSX.IonActionSheet> & JSX$1.HTMLAttributes<HTMLIonActionSheetElement>;
declare function IonActionSheet(props: IonActionSheetProps): JSX$1.Element;

type IonAlertProps = FixIonProps<JSX.IonAlert> & JSX$1.HTMLAttributes<HTMLIonAlertElement>;
declare function IonAlert(props: IonAlertProps): JSX$1.Element;

type IonAppProps = FixIonProps<JSX.IonApp> & JSX$1.HTMLAttributes<HTMLIonAppElement>;
declare function IonApp(props: IonAppProps): JSX$1.Element;

type IonAvatarProps = FixIonProps<JSX.IonAvatar> & JSX$1.HTMLAttributes<HTMLIonAvatarElement>;
declare function IonAvatar(props: IonAvatarProps): JSX$1.Element;

type IonBackButtonProps = FixIonProps<JSX.IonBackButton> & JSX$1.HTMLAttributes<HTMLIonBackButtonElement>;
declare function IonBackButton(props: IonBackButtonProps): JSX$1.Element;

type IonBackdropProps = FixIonProps<JSX.IonBackdrop> & JSX$1.HTMLAttributes<HTMLIonBackdropElement>;
declare function IonBackdrop(props: IonBackdropProps): JSX$1.Element;

type IonBadgeProps = FixIonProps<JSX.IonBadge> & JSX$1.HTMLAttributes<HTMLIonBadgeElement>;
declare function IonBadge(props: IonBadgeProps): JSX$1.Element;

type IonBreadcrumbProps = FixIonProps<JSX.IonBreadcrumb> & JSX$1.HTMLAttributes<HTMLIonBreadcrumbElement>;
declare function IonBreadcrumb(props: IonBreadcrumbProps): JSX$1.Element;

type IonBreadcrumbsProps = FixIonProps<JSX.IonBreadcrumbs> & JSX$1.HTMLAttributes<HTMLIonBreadcrumbsElement>;
declare function IonBreadcrumbs(props: IonBreadcrumbsProps): JSX$1.Element;

type IonButtonProps = FixIonProps<JSX.IonButton> & JSX$1.HTMLAttributes<HTMLIonButtonElement>;
declare function IonButton(props: IonButtonProps): JSX$1.Element;

type IonButtonsProps = FixIonProps<JSX.IonButtons> & JSX$1.HTMLAttributes<HTMLIonButtonsElement>;
declare function IonButtons(props: IonButtonsProps): JSX$1.Element;

type IonCardProps = FixIonProps<JSX.IonCard> & JSX$1.HTMLAttributes<HTMLIonCardElement>;
declare function IonCard(props: IonCardProps): JSX$1.Element;

type IonCardContentProps = FixIonProps<JSX.IonCardContent> & JSX$1.HTMLAttributes<HTMLIonCardContentElement>;
declare function IonCardContent(props: IonCardContentProps): JSX$1.Element;

type IonCardHeaderProps = FixIonProps<JSX.IonCardHeader> & JSX$1.HTMLAttributes<HTMLIonCardHeaderElement>;
declare function IonCardHeader(props: IonCardHeaderProps): JSX$1.Element;

type IonCardSubtitleProps = FixIonProps<JSX.IonCardSubtitle> & JSX$1.HTMLAttributes<HTMLIonCardSubtitleElement>;
declare function IonCardSubtitle(props: IonCardSubtitleProps): JSX$1.Element;

type IonCardTitleProps = FixIonProps<JSX.IonCardTitle> & JSX$1.HTMLAttributes<HTMLIonCardTitleElement>;
declare function IonCardTitle(props: IonCardTitleProps): JSX$1.Element;

type IonCheckboxProps = FixIonProps<JSX.IonCheckbox> & JSX$1.HTMLAttributes<HTMLIonCheckboxElement>;
declare function IonCheckbox(props: IonCheckboxProps): JSX$1.Element;

type IonChipProps = FixIonProps<JSX.IonChip> & JSX$1.HTMLAttributes<HTMLIonChipElement>;
declare function IonChip(props: IonChipProps): JSX$1.Element;

type IonColProps = FixIonProps<JSX.IonCol> & JSX$1.HTMLAttributes<HTMLIonColElement>;
declare function IonCol(props: IonColProps): JSX$1.Element;

type IonContentProps = FixIonProps<JSX.IonContent> & JSX$1.HTMLAttributes<HTMLIonContentElement>;
declare function IonContent(props: IonContentProps): JSX$1.Element;

type IonDatetimeProps = FixIonProps<JSX.IonDatetime> & JSX$1.HTMLAttributes<HTMLIonDatetimeElement>;
declare function IonDatetime(props: IonDatetimeProps): JSX$1.Element;

type IonDatetimeButtonProps = FixIonProps<JSX.IonDatetimeButton> & JSX$1.HTMLAttributes<HTMLIonDatetimeButtonElement>;
declare function IonDatetimeButton(props: IonDatetimeButtonProps): JSX$1.Element;

type IonFabProps = FixIonProps<JSX.IonFab> & JSX$1.HTMLAttributes<HTMLIonFabElement>;
declare function IonFab(props: IonFabProps): JSX$1.Element;

type IonFabButtonProps = FixIonProps<JSX.IonFabButton> & JSX$1.HTMLAttributes<HTMLIonFabButtonElement>;
declare function IonFabButton(props: IonFabButtonProps): JSX$1.Element;

type IonFabListProps = FixIonProps<JSX.IonFabList> & JSX$1.HTMLAttributes<HTMLIonFabListElement>;
declare function IonFabList(props: IonFabListProps): JSX$1.Element;

type IonFooterProps = FixIonProps<JSX.IonFooter> & JSX$1.HTMLAttributes<HTMLIonFooterElement>;
declare function IonFooter(props: IonFooterProps): JSX$1.Element;

type IonGridProps = FixIonProps<JSX.IonGrid> & JSX$1.HTMLAttributes<HTMLIonGridElement>;
declare function IonGrid(props: IonGridProps): JSX$1.Element;

type IonHeaderProps = FixIonProps<JSX.IonHeader> & JSX$1.HTMLAttributes<HTMLIonHeaderElement>;
declare function IonHeader(props: IonHeaderProps): JSX$1.Element;

type IonImgProps = FixIonProps<JSX.IonImg> & JSX$1.HTMLAttributes<HTMLIonImgElement>;
declare function IonImg(props: IonImgProps): JSX$1.Element;

type IonInfiniteScrollProps = FixIonProps<JSX.IonInfiniteScroll> & JSX$1.HTMLAttributes<HTMLIonInfiniteScrollElement>;
declare function IonInfiniteScroll(props: IonInfiniteScrollProps): JSX$1.Element;

type IonInfiniteScrollContentProps = FixIonProps<JSX.IonInfiniteScrollContent> & JSX$1.HTMLAttributes<HTMLIonInfiniteScrollContentElement>;
declare function IonInfiniteScrollContent(props: IonInfiniteScrollContentProps): JSX$1.Element;

type IonInputProps = FixIonProps<JSX.IonInput> & JSX$1.HTMLAttributes<HTMLIonInputElement>;
declare function IonInput(props: IonInputProps): JSX$1.Element;

type IonInputPasswordToggleProps = FixIonProps<JSX.IonInputPasswordToggle> & JSX$1.HTMLAttributes<HTMLIonInputPasswordToggleElement>;
declare function IonInputPasswordToggle(props: IonInputPasswordToggleProps): JSX$1.Element;

type IonItemProps = FixIonProps<JSX.IonItem> & JSX$1.HTMLAttributes<HTMLIonItemElement>;
declare function IonItem(props: IonItemProps): JSX$1.Element;

type IonItemDividerProps = FixIonProps<JSX.IonItemDivider> & JSX$1.HTMLAttributes<HTMLIonItemDividerElement>;
declare function IonItemDivider(props: IonItemDividerProps): JSX$1.Element;

type IonItemGroupProps = FixIonProps<JSX.IonItemGroup> & JSX$1.HTMLAttributes<HTMLIonItemGroupElement>;
declare function IonItemGroup(props: IonItemGroupProps): JSX$1.Element;

type IonItemOptionProps = FixIonProps<JSX.IonItemOption> & JSX$1.HTMLAttributes<HTMLIonItemOptionElement>;
declare function IonItemOption(props: IonItemOptionProps): JSX$1.Element;

type IonItemOptionsProps = FixIonProps<JSX.IonItemOptions> & JSX$1.HTMLAttributes<HTMLIonItemOptionsElement>;
declare function IonItemOptions(props: IonItemOptionsProps): JSX$1.Element;

type IonItemSlidingProps = FixIonProps<JSX.IonItemSliding> & JSX$1.HTMLAttributes<HTMLIonItemSlidingElement>;
declare function IonItemSliding(props: IonItemSlidingProps): JSX$1.Element;

type IonLabelProps = FixIonProps<JSX.IonLabel> & JSX$1.HTMLAttributes<HTMLIonLabelElement>;
declare function IonLabel(props: IonLabelProps): JSX$1.Element;

type IonListProps = FixIonProps<JSX.IonList> & JSX$1.HTMLAttributes<HTMLIonListElement>;
declare function IonList(props: IonListProps): JSX$1.Element;

type IonListHeaderProps = FixIonProps<JSX.IonListHeader> & JSX$1.HTMLAttributes<HTMLIonListHeaderElement>;
declare function IonListHeader(props: IonListHeaderProps): JSX$1.Element;

type IonLoadingProps = FixIonProps<JSX.IonLoading> & JSX$1.HTMLAttributes<HTMLIonLoadingElement>;
declare function IonLoading(props: IonLoadingProps): JSX$1.Element;

type IonMenuProps = FixIonProps<JSX.IonMenu> & JSX$1.HTMLAttributes<HTMLIonMenuElement>;
declare function IonMenu(props: IonMenuProps): JSX$1.Element;

type IonMenuButtonProps = FixIonProps<JSX.IonMenuButton> & JSX$1.HTMLAttributes<HTMLIonMenuButtonElement>;
declare function IonMenuButton(props: IonMenuButtonProps): JSX$1.Element;

type IonMenuToggleProps = FixIonProps<JSX.IonMenuToggle> & JSX$1.HTMLAttributes<HTMLIonMenuToggleElement>;
declare function IonMenuToggle(props: IonMenuToggleProps): JSX$1.Element;

type IonModalProps = FixIonProps<JSX.IonModal> & JSX$1.HTMLAttributes<HTMLIonModalElement>;
declare function IonModal(props: IonModalProps): JSX$1.Element;

type IonNavProps = FixIonProps<JSX.IonNav> & JSX$1.HTMLAttributes<HTMLIonNavElement>;
declare function IonNav(props: IonNavProps): JSX$1.Element;

type IonNavLinkProps = FixIonProps<JSX.IonNavLink> & JSX$1.HTMLAttributes<HTMLIonNavLinkElement>;
declare function IonNavLink(props: IonNavLinkProps): JSX$1.Element;

type IonNoteProps = FixIonProps<JSX.IonNote> & JSX$1.HTMLAttributes<HTMLIonNoteElement>;
declare function IonNote(props: IonNoteProps): JSX$1.Element;

type IonPickerProps = FixIonProps<JSX.IonPicker> & JSX$1.HTMLAttributes<HTMLIonPickerElement>;
declare function IonPicker(props: IonPickerProps): JSX$1.Element;

type IonPickerColumnProps = FixIonProps<JSX.IonPickerColumn> & JSX$1.HTMLAttributes<HTMLIonPickerColumnElement>;
declare function IonPickerColumn(props: IonPickerColumnProps): JSX$1.Element;

type IonPickerColumnOptionProps = FixIonProps<JSX.IonPickerColumnOption> & JSX$1.HTMLAttributes<HTMLIonPickerColumnOptionElement>;
declare function IonPickerColumnOption(props: IonPickerColumnOptionProps): JSX$1.Element;

type IonPickerLegacyProps = FixIonProps<JSX.IonPickerLegacy> & JSX$1.HTMLAttributes<HTMLIonPickerLegacyElement>;
declare function IonPickerLegacy(props: IonPickerLegacyProps): JSX$1.Element;

type IonPickerLegacyColumnProps = FixIonProps<JSX.IonPickerLegacyColumn> & JSX$1.HTMLAttributes<HTMLIonPickerLegacyColumnElement>;
declare function IonPickerLegacyColumn(props: IonPickerLegacyColumnProps): JSX$1.Element;

type IonPopoverProps = FixIonProps<JSX.IonPopover> & JSX$1.HTMLAttributes<HTMLIonPopoverElement>;
declare function IonPopover(props: IonPopoverProps): JSX$1.Element;

type IonProgressBarProps = FixIonProps<JSX.IonProgressBar> & JSX$1.HTMLAttributes<HTMLIonProgressBarElement>;
declare function IonProgressBar(props: IonProgressBarProps): JSX$1.Element;

type IonRadioProps = FixIonProps<JSX.IonRadio> & JSX$1.HTMLAttributes<HTMLIonRadioElement>;
declare function IonRadio(props: IonRadioProps): JSX$1.Element;

type IonRadioGroupProps = FixIonProps<JSX.IonRadioGroup> & JSX$1.HTMLAttributes<HTMLIonRadioGroupElement>;
declare function IonRadioGroup(props: IonRadioGroupProps): JSX$1.Element;

type IonRangeProps = FixIonProps<JSX.IonRange> & JSX$1.HTMLAttributes<HTMLIonRangeElement>;
declare function IonRange(props: IonRangeProps): JSX$1.Element;

type IonRefresherProps = FixIonProps<JSX.IonRefresher> & JSX$1.HTMLAttributes<HTMLIonRefresherElement>;
declare function IonRefresher(props: IonRefresherProps): JSX$1.Element;

type IonRefresherContentProps = FixIonProps<JSX.IonRefresherContent> & JSX$1.HTMLAttributes<HTMLIonRefresherContentElement>;
declare function IonRefresherContent(props: IonRefresherContentProps): JSX$1.Element;

type IonReorderProps = FixIonProps<JSX.IonReorder> & JSX$1.HTMLAttributes<HTMLIonReorderElement>;
declare function IonReorder(props: IonReorderProps): JSX$1.Element;

type IonReorderGroupProps = FixIonProps<JSX.IonReorderGroup> & JSX$1.HTMLAttributes<HTMLIonReorderGroupElement>;
declare function IonReorderGroup(props: IonReorderGroupProps): JSX$1.Element;

type IonRippleEffectProps = FixIonProps<JSX.IonRippleEffect> & JSX$1.HTMLAttributes<HTMLIonRippleEffectElement>;
declare function IonRippleEffect(props: IonRippleEffectProps): JSX$1.Element;

type IonRouteRedirectProps = FixIonProps<JSX.IonRouteRedirect> & JSX$1.HTMLAttributes<HTMLIonRouteRedirectElement>;
declare function IonRouteRedirect(props: IonRouteRedirectProps): JSX$1.Element;

type IonRouterLinkProps = FixIonProps<JSX.IonRouterLink> & JSX$1.HTMLAttributes<HTMLIonRouterLinkElement>;
declare function IonRouterLink(props: IonRouterLinkProps): JSX$1.Element;

type IonRouterOutletProps = FixIonProps<JSX.IonRouterOutlet> & JSX$1.HTMLAttributes<HTMLIonRouterOutletElement>;
declare function IonRouterOutlet(props: IonRouterOutletProps): JSX$1.Element;

type IonRowProps = FixIonProps<JSX.IonRow> & JSX$1.HTMLAttributes<HTMLIonRowElement>;
declare function IonRow(props: IonRowProps): JSX$1.Element;

type IonSearchbarProps = FixIonProps<JSX.IonSearchbar> & JSX$1.HTMLAttributes<HTMLIonSearchbarElement>;
declare function IonSearchbar(props: IonSearchbarProps): JSX$1.Element;

type IonSegmentProps = FixIonProps<JSX.IonSegment> & JSX$1.HTMLAttributes<HTMLIonSegmentElement>;
declare function IonSegment(props: IonSegmentProps): JSX$1.Element;

type IonSegmentButtonProps = FixIonProps<JSX.IonSegmentButton> & JSX$1.HTMLAttributes<HTMLIonSegmentButtonElement>;
declare function IonSegmentButton(props: IonSegmentButtonProps): JSX$1.Element;

type IonSelectProps = FixIonProps<JSX.IonSelect> & JSX$1.HTMLAttributes<HTMLIonSelectElement>;
declare function IonSelect(props: IonSelectProps): JSX$1.Element;

type IonSelectOptionProps = FixIonProps<JSX.IonSelectOption> & JSX$1.HTMLAttributes<HTMLIonSelectOptionElement>;
declare function IonSelectOption(props: IonSelectOptionProps): JSX$1.Element;

type IonSelectPopoverProps = FixIonProps<JSX.IonSelectPopover> & JSX$1.HTMLAttributes<HTMLIonSelectPopoverElement>;
declare function IonSelectPopover(props: IonSelectPopoverProps): JSX$1.Element;

type IonSkeletonTextProps = FixIonProps<JSX.IonSkeletonText> & JSX$1.HTMLAttributes<HTMLIonSkeletonTextElement>;
declare function IonSkeletonText(props: IonSkeletonTextProps): JSX$1.Element;

type IonSpinnerProps = FixIonProps<JSX.IonSpinner> & JSX$1.HTMLAttributes<HTMLIonSpinnerElement>;
declare function IonSpinner(props: IonSpinnerProps): JSX$1.Element;

type IonSplitPaneProps = FixIonProps<JSX.IonSplitPane> & JSX$1.HTMLAttributes<HTMLIonSplitPaneElement>;
declare function IonSplitPane(props: IonSplitPaneProps): JSX$1.Element;

type IonTabProps = FixIonProps<JSX.IonTab> & JSX$1.HTMLAttributes<HTMLIonTabElement>;
declare function IonTab(props: IonTabProps): JSX$1.Element;

type IonTabBarProps = FixIonProps<JSX.IonTabBar> & JSX$1.HTMLAttributes<HTMLIonTabBarElement>;
declare function IonTabBar(props: IonTabBarProps): JSX$1.Element;

type IonTabButtonProps = FixIonProps<JSX.IonTabButton> & JSX$1.HTMLAttributes<HTMLIonTabButtonElement>;
declare function IonTabButton(props: IonTabButtonProps): JSX$1.Element;

type IonTabsProps = FixIonProps<JSX.IonTabs> & JSX$1.HTMLAttributes<HTMLIonTabsElement>;
declare function IonTabs(props: IonTabsProps): JSX$1.Element;

type IonTextProps = FixIonProps<JSX.IonText> & JSX$1.HTMLAttributes<HTMLIonTextElement>;
declare function IonText(props: IonTextProps): JSX$1.Element;

type IonTextareaProps = FixIonProps<JSX.IonTextarea> & JSX$1.HTMLAttributes<HTMLIonTextareaElement>;
declare function IonTextarea(props: IonTextareaProps): JSX$1.Element;

type IonThumbnailProps = FixIonProps<JSX.IonThumbnail> & JSX$1.HTMLAttributes<HTMLIonThumbnailElement>;
declare function IonThumbnail(props: IonThumbnailProps): JSX$1.Element;

type IonTitleProps = FixIonProps<JSX.IonTitle> & JSX$1.HTMLAttributes<HTMLIonTitleElement>;
declare function IonTitle(props: IonTitleProps): JSX$1.Element;

type IonToastProps = FixIonProps<JSX.IonToast> & JSX$1.HTMLAttributes<HTMLIonToastElement>;
declare function IonToast(props: IonToastProps): JSX$1.Element;

type IonToggleProps = FixIonProps<JSX.IonToggle> & JSX$1.HTMLAttributes<HTMLIonToggleElement>;
declare function IonToggle(props: IonToggleProps): JSX$1.Element;

type IonToolbarProps = FixIonProps<JSX.IonToolbar> & JSX$1.HTMLAttributes<HTMLIonToolbarElement>;
declare function IonToolbar(props: IonToolbarProps): JSX$1.Element;

type RefComponentProps<P = {}> = P & {
    componentOptions: {
        element: ComponentOptions['element'];
    };
};
type ComponentRefProps<TComponent extends (...args: any[]) => any> = {
    component: TComponent;
    data?: any;
} & (TComponent extends () => any ? {
    componentProps?: never;
} : {
    componentProps: Parameters<TComponent>[0];
});
declare function ComponentRef<TComponent extends (...args: any) => any>(props: ComponentRefProps<TComponent>, options: ComponentOptions): solid_js.JSX.Element;
declare const ComponentRefElementName = "solid-ion-component-ref";

type IonIconProps = FixIonProps<JSX$2.IonIcon> & JSX$1.HTMLAttributes<HTMLIonIconElement>;
declare function IonIcon(props: IonIconProps): JSX$1.Element;

type IonRouterProps = FixIonProps<JSX.IonRouter> & JSX$1.HTMLAttributes<HTMLIonRouterElement>;
declare function IonRouter(props: ParentProps<IonRouterProps>): JSX$1.Element;

type IonRouteProps<TComponent> = FixIonProps<Omit<JSX.IonRoute, 'component' | 'componentProps'>> & JSX$1.HTMLAttributes<HTMLIonRouteElement> & {
    component: TComponent;
    data?: any;
} & (TComponent extends () => any ? {
    componentProps?: never;
} : TComponent extends (...args: any[]) => any ? {
    componentProps: Parameters<TComponent>[0];
} : {
    componentProps?: never;
});
declare function IonRoute<TComponent extends string | ((...args: any[]) => any) = string>(props: IonRouteProps<TComponent>): JSX$1.Element;

type WithElementsAndChildren<T> = {
    [P in keyof T]?: ParentProps<FixVanillaIonProps<T[P]> & (P extends keyof HTMLElementTagNameMap ? JSX$1.HTMLAttributes<HTMLElementTagNameMap[P]> : {})>;
};
declare module 'solid-js' {
    namespace JSX {
        interface IntrinsicElements extends WithElementsAndChildren<JSX$3.IntrinsicElements> {
            'ion-icon': FixVanillaIonProps<JSX$2.IonIcon> & JSX$1.HTMLAttributes<HTMLIonIconElement>;
        }
    }
}

declare function setupIonicSolid(config?: IonicConfig): void;

/**
 * A context to get the instance of the router object.
 */
declare const RouterContext: solid_js.Context<HTMLIonRouterElement | undefined>;
/**
 * Hook to access ion-router element.
 */
declare function useRouter(): HTMLIonRouterElement | undefined;
/**
 * @internal
 */
declare const RouterContextProvider: solid_js.ContextProviderComponent<HTMLIonRouterElement | undefined>;

export { ComponentRef, ComponentRefElementName, type ComponentRefProps, IonAccordion, IonAccordionGroup, type IonAccordionGroupProps, type IonAccordionProps, IonActionSheet, type IonActionSheetProps, IonAlert, type IonAlertProps, IonApp, type IonAppProps, IonAvatar, type IonAvatarProps, IonBackButton, type IonBackButtonProps, IonBackdrop, type IonBackdropProps, IonBadge, type IonBadgeProps, IonBreadcrumb, type IonBreadcrumbProps, IonBreadcrumbs, type IonBreadcrumbsProps, IonButton, type IonButtonProps, IonButtons, type IonButtonsProps, IonCard, IonCardContent, type IonCardContentProps, IonCardHeader, type IonCardHeaderProps, type IonCardProps, IonCardSubtitle, type IonCardSubtitleProps, IonCardTitle, type IonCardTitleProps, IonCheckbox, type IonCheckboxProps, IonChip, type IonChipProps, IonCol, type IonColProps, IonContent, type IonContentProps, IonDatetime, IonDatetimeButton, type IonDatetimeButtonProps, type IonDatetimeProps, IonFab, IonFabButton, type IonFabButtonProps, IonFabList, type IonFabListProps, type IonFabProps, IonFooter, type IonFooterProps, IonGrid, type IonGridProps, IonHeader, type IonHeaderProps, IonIcon, type IonIconProps, IonImg, type IonImgProps, IonInfiniteScroll, IonInfiniteScrollContent, type IonInfiniteScrollContentProps, type IonInfiniteScrollProps, IonInput, IonInputPasswordToggle, type IonInputPasswordToggleProps, type IonInputProps, IonItem, IonItemDivider, type IonItemDividerProps, IonItemGroup, type IonItemGroupProps, IonItemOption, type IonItemOptionProps, IonItemOptions, type IonItemOptionsProps, type IonItemProps, IonItemSliding, type IonItemSlidingProps, IonLabel, type IonLabelProps, IonList, IonListHeader, type IonListHeaderProps, type IonListProps, IonLoading, type IonLoadingProps, IonMenu, IonMenuButton, type IonMenuButtonProps, type IonMenuProps, IonMenuToggle, type IonMenuToggleProps, IonModal, type IonModalProps, IonNav, IonNavLink, type IonNavLinkProps, type IonNavProps, IonNote, type IonNoteProps, IonPicker, IonPickerColumn, IonPickerColumnOption, type IonPickerColumnOptionProps, type IonPickerColumnProps, IonPickerLegacy, IonPickerLegacyColumn, type IonPickerLegacyColumnProps, type IonPickerLegacyProps, type IonPickerProps, IonPopover, type IonPopoverProps, IonProgressBar, type IonProgressBarProps, IonRadio, IonRadioGroup, type IonRadioGroupProps, type IonRadioProps, IonRange, type IonRangeProps, IonRefresher, IonRefresherContent, type IonRefresherContentProps, type IonRefresherProps, IonReorder, IonReorderGroup, type IonReorderGroupProps, type IonReorderProps, IonRippleEffect, type IonRippleEffectProps, IonRoute, type IonRouteProps, IonRouteRedirect, type IonRouteRedirectProps, IonRouter, IonRouterLink, type IonRouterLinkProps, IonRouterOutlet, type IonRouterOutletProps, type IonRouterProps, IonRow, type IonRowProps, IonSearchbar, type IonSearchbarProps, IonSegment, IonSegmentButton, type IonSegmentButtonProps, type IonSegmentProps, IonSelect, IonSelectOption, type IonSelectOptionProps, IonSelectPopover, type IonSelectPopoverProps, type IonSelectProps, IonSkeletonText, type IonSkeletonTextProps, IonSpinner, type IonSpinnerProps, IonSplitPane, type IonSplitPaneProps, IonTab, IonTabBar, type IonTabBarProps, IonTabButton, type IonTabButtonProps, type IonTabProps, IonTabs, type IonTabsProps, IonText, type IonTextProps, IonTextarea, type IonTextareaProps, IonThumbnail, type IonThumbnailProps, IonTitle, type IonTitleProps, IonToast, type IonToastProps, IonToggle, type IonToggleProps, IonToolbar, type IonToolbarProps, type RefComponentProps, RouterContext, RouterContextProvider, setupIonicSolid, useRouter };
