"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __glob = (map2) => (path) => {
  var fn = map2[path];
  if (fn)
    return fn();
  throw new Error("Module not found in bundle: " + path);
};
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../../node_modules/@stencil/core/internal/client/shadow-css.js
var shadow_css_exports = {};
__export(shadow_css_exports, {
  scopeCss: () => scopeCss
});
var escapeRegExpSpecialCharacters, safeSelector, restoreSafeSelector, _polyfillHost, _polyfillSlotted, _polyfillHostContext, _parenSuffix, _cssColonHostRe, _cssColonHostContextRe, _cssColonSlottedRe, _polyfillHostNoCombinator, _polyfillHostNoCombinatorRe, _shadowDOMSelectorsRe, _selectorReSuffix, _polyfillHostRe, createSupportsRuleRe, _colonSlottedRe, _colonHostRe, _colonHostContextRe, _commentRe, stripComments, _commentWithHashRe, extractCommentsWithHash, _ruleRe, _curlyRe, _selectorPartsRe, OPEN_CURLY, CLOSE_CURLY, BLOCK_PLACEHOLDER, processRules, escapeBlocks, insertPolyfillHostInCssText, convertColonRule, colonHostPartReplacer, convertColonHost, colonHostContextPartReplacer, convertColonSlotted, convertColonHostContext, convertShadowDOMSelectors, makeScopeMatcher, selectorNeedsScoping, injectScopingSelector, applySimpleSelectorScope, applyStrictSelectorScope, scopeSelector, scopeSelectors, scopeCssText, replaceShadowCssHost, scopeCss;
var init_shadow_css = __esm({
  "../../node_modules/@stencil/core/internal/client/shadow-css.js"() {
    "use strict";
    escapeRegExpSpecialCharacters = (text) => {
      return text.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
    };
    safeSelector = (selector) => {
      const placeholders = [];
      let index = 0;
      selector = selector.replace(/(\[[^\]]*\])/g, (_, keep) => {
        const replaceBy = `__ph-${index}__`;
        placeholders.push(keep);
        index++;
        return replaceBy;
      });
      const content = selector.replace(/(:nth-[-\w]+)(\([^)]+\))/g, (_, pseudo, exp) => {
        const replaceBy = `__ph-${index}__`;
        placeholders.push(exp);
        index++;
        return pseudo + replaceBy;
      });
      const ss = {
        content,
        placeholders
      };
      return ss;
    };
    restoreSafeSelector = (placeholders, content) => {
      return content.replace(/__ph-(\d+)__/g, (_, index) => placeholders[+index]);
    };
    _polyfillHost = "-shadowcsshost";
    _polyfillSlotted = "-shadowcssslotted";
    _polyfillHostContext = "-shadowcsscontext";
    _parenSuffix = ")(?:\\(((?:\\([^)(]*\\)|[^)(]*)+?)\\))?([^,{]*)";
    _cssColonHostRe = new RegExp("(" + _polyfillHost + _parenSuffix, "gim");
    _cssColonHostContextRe = new RegExp("(" + _polyfillHostContext + _parenSuffix, "gim");
    _cssColonSlottedRe = new RegExp("(" + _polyfillSlotted + _parenSuffix, "gim");
    _polyfillHostNoCombinator = _polyfillHost + "-no-combinator";
    _polyfillHostNoCombinatorRe = /-shadowcsshost-no-combinator([^\s]*)/;
    _shadowDOMSelectorsRe = [/::shadow/g, /::content/g];
    _selectorReSuffix = "([>\\s~+[.,{:][\\s\\S]*)?$";
    _polyfillHostRe = /-shadowcsshost/gim;
    createSupportsRuleRe = (selector) => new RegExp(`((?<!(^@supports(.*)))|(?<={.*))(${selector}\\b)`, "gim");
    _colonSlottedRe = createSupportsRuleRe("::slotted");
    _colonHostRe = createSupportsRuleRe(":host");
    _colonHostContextRe = createSupportsRuleRe(":host-context");
    _commentRe = /\/\*\s*[\s\S]*?\*\//g;
    stripComments = (input) => {
      return input.replace(_commentRe, "");
    };
    _commentWithHashRe = /\/\*\s*#\s*source(Mapping)?URL=[\s\S]+?\*\//g;
    extractCommentsWithHash = (input) => {
      return input.match(_commentWithHashRe) || [];
    };
    _ruleRe = /(\s*)([^;\{\}]+?)(\s*)((?:{%BLOCK%}?\s*;?)|(?:\s*;))/g;
    _curlyRe = /([{}])/g;
    _selectorPartsRe = /(^.*?[^\\])??((:+)(.*)|$)/;
    OPEN_CURLY = "{";
    CLOSE_CURLY = "}";
    BLOCK_PLACEHOLDER = "%BLOCK%";
    processRules = (input, ruleCallback) => {
      const inputWithEscapedBlocks = escapeBlocks(input);
      let nextBlockIndex = 0;
      return inputWithEscapedBlocks.escapedString.replace(_ruleRe, (...m) => {
        const selector = m[2];
        let content = "";
        let suffix = m[4];
        let contentPrefix = "";
        if (suffix && suffix.startsWith("{" + BLOCK_PLACEHOLDER)) {
          content = inputWithEscapedBlocks.blocks[nextBlockIndex++];
          suffix = suffix.substring(BLOCK_PLACEHOLDER.length + 1);
          contentPrefix = "{";
        }
        const cssRule = {
          selector,
          content
        };
        const rule = ruleCallback(cssRule);
        return `${m[1]}${rule.selector}${m[3]}${contentPrefix}${rule.content}${suffix}`;
      });
    };
    escapeBlocks = (input) => {
      const inputParts = input.split(_curlyRe);
      const resultParts = [];
      const escapedBlocks = [];
      let bracketCount = 0;
      let currentBlockParts = [];
      for (let partIndex = 0; partIndex < inputParts.length; partIndex++) {
        const part = inputParts[partIndex];
        if (part === CLOSE_CURLY) {
          bracketCount--;
        }
        if (bracketCount > 0) {
          currentBlockParts.push(part);
        } else {
          if (currentBlockParts.length > 0) {
            escapedBlocks.push(currentBlockParts.join(""));
            resultParts.push(BLOCK_PLACEHOLDER);
            currentBlockParts = [];
          }
          resultParts.push(part);
        }
        if (part === OPEN_CURLY) {
          bracketCount++;
        }
      }
      if (currentBlockParts.length > 0) {
        escapedBlocks.push(currentBlockParts.join(""));
        resultParts.push(BLOCK_PLACEHOLDER);
      }
      const strEscapedBlocks = {
        escapedString: resultParts.join(""),
        blocks: escapedBlocks
      };
      return strEscapedBlocks;
    };
    insertPolyfillHostInCssText = (cssText) => {
      cssText = cssText.replace(_colonHostContextRe, `$1${_polyfillHostContext}`).replace(_colonHostRe, `$1${_polyfillHost}`).replace(_colonSlottedRe, `$1${_polyfillSlotted}`);
      return cssText;
    };
    convertColonRule = (cssText, regExp, partReplacer) => {
      return cssText.replace(regExp, (...m) => {
        if (m[2]) {
          const parts = m[2].split(",");
          const r = [];
          for (let i2 = 0; i2 < parts.length; i2++) {
            const p = parts[i2].trim();
            if (!p)
              break;
            r.push(partReplacer(_polyfillHostNoCombinator, p, m[3]));
          }
          return r.join(",");
        } else {
          return _polyfillHostNoCombinator + m[3];
        }
      });
    };
    colonHostPartReplacer = (host, part, suffix) => {
      return host + part.replace(_polyfillHost, "") + suffix;
    };
    convertColonHost = (cssText) => {
      return convertColonRule(cssText, _cssColonHostRe, colonHostPartReplacer);
    };
    colonHostContextPartReplacer = (host, part, suffix) => {
      if (part.indexOf(_polyfillHost) > -1) {
        return colonHostPartReplacer(host, part, suffix);
      } else {
        return host + part + suffix + ", " + part + " " + host + suffix;
      }
    };
    convertColonSlotted = (cssText, slotScopeId) => {
      const slotClass = "." + slotScopeId + " > ";
      const selectors = [];
      cssText = cssText.replace(_cssColonSlottedRe, (...m) => {
        if (m[2]) {
          const compound = m[2].trim();
          const suffix = m[3];
          const slottedSelector = slotClass + compound + suffix;
          let prefixSelector = "";
          for (let i2 = m[4] - 1; i2 >= 0; i2--) {
            const char = m[5][i2];
            if (char === "}" || char === ",") {
              break;
            }
            prefixSelector = char + prefixSelector;
          }
          const orgSelector = (prefixSelector + slottedSelector).trim();
          const addedSelector = `${prefixSelector.trimEnd()}${slottedSelector.trim()}`.trim();
          if (orgSelector !== addedSelector) {
            const updatedSelector = `${addedSelector}, ${orgSelector}`;
            selectors.push({
              orgSelector,
              updatedSelector
            });
          }
          return slottedSelector;
        } else {
          return _polyfillHostNoCombinator + m[3];
        }
      });
      return {
        selectors,
        cssText
      };
    };
    convertColonHostContext = (cssText) => {
      return convertColonRule(cssText, _cssColonHostContextRe, colonHostContextPartReplacer);
    };
    convertShadowDOMSelectors = (cssText) => {
      return _shadowDOMSelectorsRe.reduce((result, pattern) => result.replace(pattern, " "), cssText);
    };
    makeScopeMatcher = (scopeSelector2) => {
      const lre = /\[/g;
      const rre = /\]/g;
      scopeSelector2 = scopeSelector2.replace(lre, "\\[").replace(rre, "\\]");
      return new RegExp("^(" + scopeSelector2 + ")" + _selectorReSuffix, "m");
    };
    selectorNeedsScoping = (selector, scopeSelector2) => {
      const re = makeScopeMatcher(scopeSelector2);
      return !re.test(selector);
    };
    injectScopingSelector = (selector, scopingSelector) => {
      return selector.replace(_selectorPartsRe, (_, before = "", _colonGroup, colon = "", after = "") => {
        return before + scopingSelector + colon + after;
      });
    };
    applySimpleSelectorScope = (selector, scopeSelector2, hostSelector) => {
      _polyfillHostRe.lastIndex = 0;
      if (_polyfillHostRe.test(selector)) {
        const replaceBy = `.${hostSelector}`;
        return selector.replace(_polyfillHostNoCombinatorRe, (_, selector2) => injectScopingSelector(selector2, replaceBy)).replace(_polyfillHostRe, replaceBy + " ");
      }
      return scopeSelector2 + " " + selector;
    };
    applyStrictSelectorScope = (selector, scopeSelector2, hostSelector) => {
      const isRe = /\[is=([^\]]*)\]/g;
      scopeSelector2 = scopeSelector2.replace(isRe, (_, ...parts) => parts[0]);
      const className = "." + scopeSelector2;
      const _scopeSelectorPart = (p) => {
        let scopedP = p.trim();
        if (!scopedP) {
          return "";
        }
        if (p.indexOf(_polyfillHostNoCombinator) > -1) {
          scopedP = applySimpleSelectorScope(p, scopeSelector2, hostSelector);
        } else {
          const t = p.replace(_polyfillHostRe, "");
          if (t.length > 0) {
            scopedP = injectScopingSelector(t, className);
          }
        }
        return scopedP;
      };
      const safeContent = safeSelector(selector);
      selector = safeContent.content;
      let scopedSelector = "";
      let startIndex = 0;
      let res;
      const sep = /( |>|\+|~(?!=))\s*/g;
      const hasHost = selector.indexOf(_polyfillHostNoCombinator) > -1;
      let shouldScope = !hasHost;
      while ((res = sep.exec(selector)) !== null) {
        const separator = res[1];
        const part2 = selector.slice(startIndex, res.index).trim();
        shouldScope = shouldScope || part2.indexOf(_polyfillHostNoCombinator) > -1;
        const scopedPart = shouldScope ? _scopeSelectorPart(part2) : part2;
        scopedSelector += `${scopedPart} ${separator} `;
        startIndex = sep.lastIndex;
      }
      const part = selector.substring(startIndex);
      shouldScope = shouldScope || part.indexOf(_polyfillHostNoCombinator) > -1;
      scopedSelector += shouldScope ? _scopeSelectorPart(part) : part;
      return restoreSafeSelector(safeContent.placeholders, scopedSelector);
    };
    scopeSelector = (selector, scopeSelectorText, hostSelector, slotSelector) => {
      return selector.split(",").map((shallowPart) => {
        if (slotSelector && shallowPart.indexOf("." + slotSelector) > -1) {
          return shallowPart.trim();
        }
        if (selectorNeedsScoping(shallowPart, scopeSelectorText)) {
          return applyStrictSelectorScope(shallowPart, scopeSelectorText, hostSelector).trim();
        } else {
          return shallowPart.trim();
        }
      }).join(", ");
    };
    scopeSelectors = (cssText, scopeSelectorText, hostSelector, slotSelector, commentOriginalSelector) => {
      return processRules(cssText, (rule) => {
        let selector = rule.selector;
        let content = rule.content;
        if (rule.selector[0] !== "@") {
          selector = scopeSelector(rule.selector, scopeSelectorText, hostSelector, slotSelector);
        } else if (rule.selector.startsWith("@media") || rule.selector.startsWith("@supports") || rule.selector.startsWith("@page") || rule.selector.startsWith("@document")) {
          content = scopeSelectors(rule.content, scopeSelectorText, hostSelector, slotSelector, commentOriginalSelector);
        }
        const cssRule = {
          selector: selector.replace(/\s{2,}/g, " ").trim(),
          content
        };
        return cssRule;
      });
    };
    scopeCssText = (cssText, scopeId2, hostScopeId, slotScopeId, commentOriginalSelector) => {
      cssText = insertPolyfillHostInCssText(cssText);
      cssText = convertColonHost(cssText);
      cssText = convertColonHostContext(cssText);
      const slotted = convertColonSlotted(cssText, slotScopeId);
      cssText = slotted.cssText;
      cssText = convertShadowDOMSelectors(cssText);
      if (scopeId2) {
        cssText = scopeSelectors(cssText, scopeId2, hostScopeId, slotScopeId, commentOriginalSelector);
      }
      cssText = replaceShadowCssHost(cssText, hostScopeId);
      cssText = cssText.replace(/>\s*\*\s+([^{, ]+)/gm, " $1 ");
      return {
        cssText: cssText.trim(),
        // We need to replace the shadow CSS host string in each of these selectors since we created
        // them prior to the replacement happening in the components CSS text.
        slottedSelectors: slotted.selectors.map((ref) => ({
          orgSelector: replaceShadowCssHost(ref.orgSelector, hostScopeId),
          updatedSelector: replaceShadowCssHost(ref.updatedSelector, hostScopeId)
        }))
      };
    };
    replaceShadowCssHost = (cssText, hostScopeId) => {
      return cssText.replace(/-shadowcsshost-no-combinator/g, `.${hostScopeId}`);
    };
    scopeCss = (cssText, scopeId2, commentOriginalSelector) => {
      const hostScopeId = scopeId2 + "-h";
      const slotScopeId = scopeId2 + "-s";
      const commentsWithHash = extractCommentsWithHash(cssText);
      cssText = stripComments(cssText);
      const orgSelectors = [];
      if (commentOriginalSelector) {
        const processCommentedSelector = (rule) => {
          const placeholder = `/*!@___${orgSelectors.length}___*/`;
          const comment = `/*!@${rule.selector}*/`;
          orgSelectors.push({ placeholder, comment });
          rule.selector = placeholder + rule.selector;
          return rule;
        };
        cssText = processRules(cssText, (rule) => {
          if (rule.selector[0] !== "@") {
            return processCommentedSelector(rule);
          } else if (rule.selector.startsWith("@media") || rule.selector.startsWith("@supports") || rule.selector.startsWith("@page") || rule.selector.startsWith("@document")) {
            rule.content = processRules(rule.content, processCommentedSelector);
            return rule;
          }
          return rule;
        });
      }
      const scoped = scopeCssText(cssText, scopeId2, hostScopeId, slotScopeId, commentOriginalSelector);
      cssText = [scoped.cssText, ...commentsWithHash].join("\n");
      if (commentOriginalSelector) {
        orgSelectors.forEach(({ placeholder, comment }) => {
          cssText = cssText.replace(placeholder, comment);
        });
      }
      scoped.slottedSelectors.forEach((slottedSelector) => {
        const regex = new RegExp(escapeRegExpSpecialCharacters(slottedSelector.orgSelector), "g");
        cssText = cssText.replace(regex, slottedSelector.updatedSelector);
      });
      return cssText;
    };
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  ComponentRef: () => ComponentRef,
  ComponentRefElementName: () => ComponentRefElementName,
  IonAccordion: () => IonAccordion,
  IonAccordionGroup: () => IonAccordionGroup,
  IonActionSheet: () => IonActionSheet,
  IonAlert: () => IonAlert,
  IonApp: () => IonApp,
  IonAvatar: () => IonAvatar,
  IonBackButton: () => IonBackButton,
  IonBackdrop: () => IonBackdrop,
  IonBadge: () => IonBadge,
  IonBreadcrumb: () => IonBreadcrumb,
  IonBreadcrumbs: () => IonBreadcrumbs,
  IonButton: () => IonButton,
  IonButtons: () => IonButtons,
  IonCard: () => IonCard,
  IonCardContent: () => IonCardContent,
  IonCardHeader: () => IonCardHeader,
  IonCardSubtitle: () => IonCardSubtitle,
  IonCardTitle: () => IonCardTitle,
  IonCheckbox: () => IonCheckbox,
  IonChip: () => IonChip,
  IonCol: () => IonCol,
  IonContent: () => IonContent,
  IonDatetime: () => IonDatetime,
  IonDatetimeButton: () => IonDatetimeButton,
  IonFab: () => IonFab,
  IonFabButton: () => IonFabButton,
  IonFabList: () => IonFabList,
  IonFooter: () => IonFooter,
  IonGrid: () => IonGrid,
  IonHeader: () => IonHeader,
  IonIcon: () => IonIcon,
  IonImg: () => IonImg,
  IonInfiniteScroll: () => IonInfiniteScroll,
  IonInfiniteScrollContent: () => IonInfiniteScrollContent,
  IonInput: () => IonInput,
  IonInputPasswordToggle: () => IonInputPasswordToggle,
  IonItem: () => IonItem,
  IonItemDivider: () => IonItemDivider,
  IonItemGroup: () => IonItemGroup,
  IonItemOption: () => IonItemOption,
  IonItemOptions: () => IonItemOptions,
  IonItemSliding: () => IonItemSliding,
  IonLabel: () => IonLabel,
  IonList: () => IonList,
  IonListHeader: () => IonListHeader,
  IonLoading: () => IonLoading,
  IonMenu: () => IonMenu,
  IonMenuButton: () => IonMenuButton,
  IonMenuToggle: () => IonMenuToggle,
  IonModal: () => IonModal,
  IonNav: () => IonNav,
  IonNavLink: () => IonNavLink,
  IonNote: () => IonNote,
  IonPicker: () => IonPicker,
  IonPickerColumn: () => IonPickerColumn,
  IonPickerColumnOption: () => IonPickerColumnOption,
  IonPickerLegacy: () => IonPickerLegacy,
  IonPickerLegacyColumn: () => IonPickerLegacyColumn,
  IonPopover: () => IonPopover,
  IonProgressBar: () => IonProgressBar,
  IonRadio: () => IonRadio,
  IonRadioGroup: () => IonRadioGroup,
  IonRange: () => IonRange,
  IonRefresher: () => IonRefresher,
  IonRefresherContent: () => IonRefresherContent,
  IonReorder: () => IonReorder,
  IonReorderGroup: () => IonReorderGroup,
  IonRippleEffect: () => IonRippleEffect,
  IonRoute: () => IonRoute,
  IonRouteRedirect: () => IonRouteRedirect,
  IonRouter: () => IonRouter,
  IonRouterLink: () => IonRouterLink,
  IonRouterOutlet: () => IonRouterOutlet,
  IonRow: () => IonRow,
  IonSearchbar: () => IonSearchbar,
  IonSegment: () => IonSegment,
  IonSegmentButton: () => IonSegmentButton,
  IonSelect: () => IonSelect,
  IonSelectOption: () => IonSelectOption,
  IonSelectPopover: () => IonSelectPopover,
  IonSkeletonText: () => IonSkeletonText,
  IonSpinner: () => IonSpinner,
  IonSplitPane: () => IonSplitPane,
  IonTab: () => IonTab,
  IonTabBar: () => IonTabBar,
  IonTabButton: () => IonTabButton,
  IonTabs: () => IonTabs,
  IonText: () => IonText,
  IonTextarea: () => IonTextarea,
  IonThumbnail: () => IonThumbnail,
  IonTitle: () => IonTitle,
  IonToast: () => IonToast,
  IonToggle: () => IonToggle,
  IonToolbar: () => IonToolbar,
  RouterContext: () => RouterContext,
  RouterContextProvider: () => RouterContextProvider,
  setupIonicSolid: () => setupIonicSolid,
  useRouter: () => useRouter
});
module.exports = __toCommonJS(src_exports);

// src/components/generated/ion-accordion.tsx
var import_web = require("solid-js/web");
var import_web2 = require("solid-js/web");
var import_web3 = require("solid-js/web");
var import_web4 = require("solid-js/web");
var import_ion_accordion = require("@ionic/core/components/ion-accordion");

// src/utils/fixProps.ts
var NON_PROP_REGEX = /(^on[A-Z]|^(children|key|class|style)$|:)/;
function fixProps(props) {
  const newProps = {};
  const keys = Object.keys(props);
  for (const key of keys) {
    if (NON_PROP_REGEX.test(key)) {
      newProps[key] = props[key];
    } else {
      newProps[`prop:${key}`] = props[key];
    }
  }
  return newProps;
}

// src/components/generated/ion-accordion.tsx
var _tmpl$ = /* @__PURE__ */ (0, import_web.template)(`<ion-accordion>`, true, false);
(0, import_ion_accordion.defineCustomElement)();
function IonAccordion(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$();
    (0, import_web3.spread)(_el$, (0, import_web4.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web2.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-accordion-group.tsx
var import_web5 = require("solid-js/web");
var import_web6 = require("solid-js/web");
var import_web7 = require("solid-js/web");
var import_web8 = require("solid-js/web");
var import_ion_accordion_group = require("@ionic/core/components/ion-accordion-group");
var _tmpl$2 = /* @__PURE__ */ (0, import_web5.template)(`<ion-accordion-group>`, true, false);
(0, import_ion_accordion_group.defineCustomElement)();
function IonAccordionGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$2();
    (0, import_web7.spread)(_el$, (0, import_web8.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web6.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-action-sheet.tsx
var import_web9 = require("solid-js/web");
var import_web10 = require("solid-js/web");
var import_web11 = require("solid-js/web");
var import_web12 = require("solid-js/web");
var import_ion_action_sheet = require("@ionic/core/components/ion-action-sheet");
var _tmpl$3 = /* @__PURE__ */ (0, import_web9.template)(`<ion-action-sheet>`, true, false);
(0, import_ion_action_sheet.defineCustomElement)();
function IonActionSheet(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$3();
    (0, import_web11.spread)(_el$, (0, import_web12.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web10.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-alert.tsx
var import_web13 = require("solid-js/web");
var import_web14 = require("solid-js/web");
var import_web15 = require("solid-js/web");
var import_web16 = require("solid-js/web");
var import_ion_alert = require("@ionic/core/components/ion-alert");
var _tmpl$4 = /* @__PURE__ */ (0, import_web13.template)(`<ion-alert>`, true, false);
(0, import_ion_alert.defineCustomElement)();
function IonAlert(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$4();
    (0, import_web15.spread)(_el$, (0, import_web16.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web14.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-app.tsx
var import_web17 = require("solid-js/web");
var import_web18 = require("solid-js/web");
var import_web19 = require("solid-js/web");
var import_web20 = require("solid-js/web");
var import_ion_app = require("@ionic/core/components/ion-app");
var _tmpl$5 = /* @__PURE__ */ (0, import_web17.template)(`<ion-app>`, true, false);
(0, import_ion_app.defineCustomElement)();
function IonApp(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$5();
    (0, import_web19.spread)(_el$, (0, import_web20.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web18.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-avatar.tsx
var import_web21 = require("solid-js/web");
var import_web22 = require("solid-js/web");
var import_web23 = require("solid-js/web");
var import_web24 = require("solid-js/web");
var import_ion_avatar = require("@ionic/core/components/ion-avatar");
var _tmpl$6 = /* @__PURE__ */ (0, import_web21.template)(`<ion-avatar>`, true, false);
(0, import_ion_avatar.defineCustomElement)();
function IonAvatar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$6();
    (0, import_web23.spread)(_el$, (0, import_web24.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web22.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-back-button.tsx
var import_web25 = require("solid-js/web");
var import_web26 = require("solid-js/web");
var import_web27 = require("solid-js/web");
var import_web28 = require("solid-js/web");
var import_ion_back_button = require("@ionic/core/components/ion-back-button");
var _tmpl$7 = /* @__PURE__ */ (0, import_web25.template)(`<ion-back-button>`, true, false);
(0, import_ion_back_button.defineCustomElement)();
function IonBackButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$7();
    (0, import_web27.spread)(_el$, (0, import_web28.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web26.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-backdrop.tsx
var import_web29 = require("solid-js/web");
var import_web30 = require("solid-js/web");
var import_web31 = require("solid-js/web");
var import_web32 = require("solid-js/web");
var import_ion_backdrop = require("@ionic/core/components/ion-backdrop");
var _tmpl$8 = /* @__PURE__ */ (0, import_web29.template)(`<ion-backdrop>`, true, false);
(0, import_ion_backdrop.defineCustomElement)();
function IonBackdrop(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$8();
    (0, import_web31.spread)(_el$, (0, import_web32.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web30.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-badge.tsx
var import_web33 = require("solid-js/web");
var import_web34 = require("solid-js/web");
var import_web35 = require("solid-js/web");
var import_web36 = require("solid-js/web");
var import_ion_badge = require("@ionic/core/components/ion-badge");
var _tmpl$9 = /* @__PURE__ */ (0, import_web33.template)(`<ion-badge>`, true, false);
(0, import_ion_badge.defineCustomElement)();
function IonBadge(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$9();
    (0, import_web35.spread)(_el$, (0, import_web36.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web34.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-breadcrumb.tsx
var import_web37 = require("solid-js/web");
var import_web38 = require("solid-js/web");
var import_web39 = require("solid-js/web");
var import_web40 = require("solid-js/web");
var import_ion_breadcrumb = require("@ionic/core/components/ion-breadcrumb");
var _tmpl$10 = /* @__PURE__ */ (0, import_web37.template)(`<ion-breadcrumb>`, true, false);
(0, import_ion_breadcrumb.defineCustomElement)();
function IonBreadcrumb(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$10();
    (0, import_web39.spread)(_el$, (0, import_web40.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web38.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-breadcrumbs.tsx
var import_web41 = require("solid-js/web");
var import_web42 = require("solid-js/web");
var import_web43 = require("solid-js/web");
var import_web44 = require("solid-js/web");
var import_ion_breadcrumbs = require("@ionic/core/components/ion-breadcrumbs");
var _tmpl$11 = /* @__PURE__ */ (0, import_web41.template)(`<ion-breadcrumbs>`, true, false);
(0, import_ion_breadcrumbs.defineCustomElement)();
function IonBreadcrumbs(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$11();
    (0, import_web43.spread)(_el$, (0, import_web44.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web42.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-button.tsx
var import_web45 = require("solid-js/web");
var import_web46 = require("solid-js/web");
var import_web47 = require("solid-js/web");
var import_web48 = require("solid-js/web");
var import_ion_button = require("@ionic/core/components/ion-button");
var _tmpl$12 = /* @__PURE__ */ (0, import_web45.template)(`<ion-button>`, true, false);
(0, import_ion_button.defineCustomElement)();
function IonButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$12();
    (0, import_web47.spread)(_el$, (0, import_web48.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web46.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-buttons.tsx
var import_web49 = require("solid-js/web");
var import_web50 = require("solid-js/web");
var import_web51 = require("solid-js/web");
var import_web52 = require("solid-js/web");
var import_ion_buttons = require("@ionic/core/components/ion-buttons");
var _tmpl$13 = /* @__PURE__ */ (0, import_web49.template)(`<ion-buttons>`, true, false);
(0, import_ion_buttons.defineCustomElement)();
function IonButtons(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$13();
    (0, import_web51.spread)(_el$, (0, import_web52.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web50.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-card.tsx
var import_web53 = require("solid-js/web");
var import_web54 = require("solid-js/web");
var import_web55 = require("solid-js/web");
var import_web56 = require("solid-js/web");
var import_ion_card = require("@ionic/core/components/ion-card");
var _tmpl$14 = /* @__PURE__ */ (0, import_web53.template)(`<ion-card>`, true, false);
(0, import_ion_card.defineCustomElement)();
function IonCard(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$14();
    (0, import_web55.spread)(_el$, (0, import_web56.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web54.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-card-content.tsx
var import_web57 = require("solid-js/web");
var import_web58 = require("solid-js/web");
var import_web59 = require("solid-js/web");
var import_web60 = require("solid-js/web");
var import_ion_card_content = require("@ionic/core/components/ion-card-content");
var _tmpl$15 = /* @__PURE__ */ (0, import_web57.template)(`<ion-card-content>`, true, false);
(0, import_ion_card_content.defineCustomElement)();
function IonCardContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$15();
    (0, import_web59.spread)(_el$, (0, import_web60.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web58.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-card-header.tsx
var import_web61 = require("solid-js/web");
var import_web62 = require("solid-js/web");
var import_web63 = require("solid-js/web");
var import_web64 = require("solid-js/web");
var import_ion_card_header = require("@ionic/core/components/ion-card-header");
var _tmpl$16 = /* @__PURE__ */ (0, import_web61.template)(`<ion-card-header>`, true, false);
(0, import_ion_card_header.defineCustomElement)();
function IonCardHeader(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$16();
    (0, import_web63.spread)(_el$, (0, import_web64.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web62.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-card-subtitle.tsx
var import_web65 = require("solid-js/web");
var import_web66 = require("solid-js/web");
var import_web67 = require("solid-js/web");
var import_web68 = require("solid-js/web");
var import_ion_card_subtitle = require("@ionic/core/components/ion-card-subtitle");
var _tmpl$17 = /* @__PURE__ */ (0, import_web65.template)(`<ion-card-subtitle>`, true, false);
(0, import_ion_card_subtitle.defineCustomElement)();
function IonCardSubtitle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$17();
    (0, import_web67.spread)(_el$, (0, import_web68.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web66.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-card-title.tsx
var import_web69 = require("solid-js/web");
var import_web70 = require("solid-js/web");
var import_web71 = require("solid-js/web");
var import_web72 = require("solid-js/web");
var import_ion_card_title = require("@ionic/core/components/ion-card-title");
var _tmpl$18 = /* @__PURE__ */ (0, import_web69.template)(`<ion-card-title>`, true, false);
(0, import_ion_card_title.defineCustomElement)();
function IonCardTitle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$18();
    (0, import_web71.spread)(_el$, (0, import_web72.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web70.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-checkbox.tsx
var import_web73 = require("solid-js/web");
var import_web74 = require("solid-js/web");
var import_web75 = require("solid-js/web");
var import_web76 = require("solid-js/web");
var import_ion_checkbox = require("@ionic/core/components/ion-checkbox");
var _tmpl$19 = /* @__PURE__ */ (0, import_web73.template)(`<ion-checkbox>`, true, false);
(0, import_ion_checkbox.defineCustomElement)();
function IonCheckbox(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$19();
    (0, import_web75.spread)(_el$, (0, import_web76.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web74.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-chip.tsx
var import_web77 = require("solid-js/web");
var import_web78 = require("solid-js/web");
var import_web79 = require("solid-js/web");
var import_web80 = require("solid-js/web");
var import_ion_chip = require("@ionic/core/components/ion-chip");
var _tmpl$20 = /* @__PURE__ */ (0, import_web77.template)(`<ion-chip>`, true, false);
(0, import_ion_chip.defineCustomElement)();
function IonChip(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$20();
    (0, import_web79.spread)(_el$, (0, import_web80.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web78.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-col.tsx
var import_web81 = require("solid-js/web");
var import_web82 = require("solid-js/web");
var import_web83 = require("solid-js/web");
var import_web84 = require("solid-js/web");
var import_ion_col = require("@ionic/core/components/ion-col");
var _tmpl$21 = /* @__PURE__ */ (0, import_web81.template)(`<ion-col>`, true, false);
(0, import_ion_col.defineCustomElement)();
function IonCol(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$21();
    (0, import_web83.spread)(_el$, (0, import_web84.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web82.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-content.tsx
var import_web85 = require("solid-js/web");
var import_web86 = require("solid-js/web");
var import_web87 = require("solid-js/web");
var import_web88 = require("solid-js/web");
var import_ion_content = require("@ionic/core/components/ion-content");
var _tmpl$22 = /* @__PURE__ */ (0, import_web85.template)(`<ion-content>`, true, false);
(0, import_ion_content.defineCustomElement)();
function IonContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$22();
    (0, import_web87.spread)(_el$, (0, import_web88.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web86.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-datetime.tsx
var import_web89 = require("solid-js/web");
var import_web90 = require("solid-js/web");
var import_web91 = require("solid-js/web");
var import_web92 = require("solid-js/web");
var import_ion_datetime = require("@ionic/core/components/ion-datetime");
var _tmpl$23 = /* @__PURE__ */ (0, import_web89.template)(`<ion-datetime>`, true, false);
(0, import_ion_datetime.defineCustomElement)();
function IonDatetime(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$23();
    (0, import_web91.spread)(_el$, (0, import_web92.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web90.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-datetime-button.tsx
var import_web93 = require("solid-js/web");
var import_web94 = require("solid-js/web");
var import_web95 = require("solid-js/web");
var import_web96 = require("solid-js/web");
var import_ion_datetime_button = require("@ionic/core/components/ion-datetime-button");
var _tmpl$24 = /* @__PURE__ */ (0, import_web93.template)(`<ion-datetime-button>`, true, false);
(0, import_ion_datetime_button.defineCustomElement)();
function IonDatetimeButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$24();
    (0, import_web95.spread)(_el$, (0, import_web96.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web94.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-fab.tsx
var import_web97 = require("solid-js/web");
var import_web98 = require("solid-js/web");
var import_web99 = require("solid-js/web");
var import_web100 = require("solid-js/web");
var import_ion_fab = require("@ionic/core/components/ion-fab");
var _tmpl$25 = /* @__PURE__ */ (0, import_web97.template)(`<ion-fab>`, true, false);
(0, import_ion_fab.defineCustomElement)();
function IonFab(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$25();
    (0, import_web99.spread)(_el$, (0, import_web100.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web98.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-fab-button.tsx
var import_web101 = require("solid-js/web");
var import_web102 = require("solid-js/web");
var import_web103 = require("solid-js/web");
var import_web104 = require("solid-js/web");
var import_ion_fab_button = require("@ionic/core/components/ion-fab-button");
var _tmpl$26 = /* @__PURE__ */ (0, import_web101.template)(`<ion-fab-button>`, true, false);
(0, import_ion_fab_button.defineCustomElement)();
function IonFabButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$26();
    (0, import_web103.spread)(_el$, (0, import_web104.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web102.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-fab-list.tsx
var import_web105 = require("solid-js/web");
var import_web106 = require("solid-js/web");
var import_web107 = require("solid-js/web");
var import_web108 = require("solid-js/web");
var import_ion_fab_list = require("@ionic/core/components/ion-fab-list");
var _tmpl$27 = /* @__PURE__ */ (0, import_web105.template)(`<ion-fab-list>`, true, false);
(0, import_ion_fab_list.defineCustomElement)();
function IonFabList(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$27();
    (0, import_web107.spread)(_el$, (0, import_web108.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web106.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-footer.tsx
var import_web109 = require("solid-js/web");
var import_web110 = require("solid-js/web");
var import_web111 = require("solid-js/web");
var import_web112 = require("solid-js/web");
var import_ion_footer = require("@ionic/core/components/ion-footer");
var _tmpl$28 = /* @__PURE__ */ (0, import_web109.template)(`<ion-footer>`, true, false);
(0, import_ion_footer.defineCustomElement)();
function IonFooter(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$28();
    (0, import_web111.spread)(_el$, (0, import_web112.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web110.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-grid.tsx
var import_web113 = require("solid-js/web");
var import_web114 = require("solid-js/web");
var import_web115 = require("solid-js/web");
var import_web116 = require("solid-js/web");
var import_ion_grid = require("@ionic/core/components/ion-grid");
var _tmpl$29 = /* @__PURE__ */ (0, import_web113.template)(`<ion-grid>`, true, false);
(0, import_ion_grid.defineCustomElement)();
function IonGrid(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$29();
    (0, import_web115.spread)(_el$, (0, import_web116.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web114.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-header.tsx
var import_web117 = require("solid-js/web");
var import_web118 = require("solid-js/web");
var import_web119 = require("solid-js/web");
var import_web120 = require("solid-js/web");
var import_ion_header = require("@ionic/core/components/ion-header");
var _tmpl$30 = /* @__PURE__ */ (0, import_web117.template)(`<ion-header>`, true, false);
(0, import_ion_header.defineCustomElement)();
function IonHeader(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$30();
    (0, import_web119.spread)(_el$, (0, import_web120.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web118.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-img.tsx
var import_web121 = require("solid-js/web");
var import_web122 = require("solid-js/web");
var import_web123 = require("solid-js/web");
var import_web124 = require("solid-js/web");
var import_ion_img = require("@ionic/core/components/ion-img");
var _tmpl$31 = /* @__PURE__ */ (0, import_web121.template)(`<ion-img>`, true, false);
(0, import_ion_img.defineCustomElement)();
function IonImg(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$31();
    (0, import_web123.spread)(_el$, (0, import_web124.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web122.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-infinite-scroll.tsx
var import_web125 = require("solid-js/web");
var import_web126 = require("solid-js/web");
var import_web127 = require("solid-js/web");
var import_web128 = require("solid-js/web");
var import_ion_infinite_scroll = require("@ionic/core/components/ion-infinite-scroll");
var _tmpl$32 = /* @__PURE__ */ (0, import_web125.template)(`<ion-infinite-scroll>`, true, false);
(0, import_ion_infinite_scroll.defineCustomElement)();
function IonInfiniteScroll(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$32();
    (0, import_web127.spread)(_el$, (0, import_web128.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web126.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-infinite-scroll-content.tsx
var import_web129 = require("solid-js/web");
var import_web130 = require("solid-js/web");
var import_web131 = require("solid-js/web");
var import_web132 = require("solid-js/web");
var import_ion_infinite_scroll_content = require("@ionic/core/components/ion-infinite-scroll-content");
var _tmpl$33 = /* @__PURE__ */ (0, import_web129.template)(`<ion-infinite-scroll-content>`, true, false);
(0, import_ion_infinite_scroll_content.defineCustomElement)();
function IonInfiniteScrollContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$33();
    (0, import_web131.spread)(_el$, (0, import_web132.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web130.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-input.tsx
var import_web133 = require("solid-js/web");
var import_web134 = require("solid-js/web");
var import_web135 = require("solid-js/web");
var import_web136 = require("solid-js/web");
var import_ion_input = require("@ionic/core/components/ion-input");
var _tmpl$34 = /* @__PURE__ */ (0, import_web133.template)(`<ion-input>`, true, false);
(0, import_ion_input.defineCustomElement)();
function IonInput(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$34();
    (0, import_web135.spread)(_el$, (0, import_web136.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web134.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-input-password-toggle.tsx
var import_web137 = require("solid-js/web");
var import_web138 = require("solid-js/web");
var import_web139 = require("solid-js/web");
var import_web140 = require("solid-js/web");
var import_ion_input_password_toggle = require("@ionic/core/components/ion-input-password-toggle");
var _tmpl$35 = /* @__PURE__ */ (0, import_web137.template)(`<ion-input-password-toggle>`, true, false);
(0, import_ion_input_password_toggle.defineCustomElement)();
function IonInputPasswordToggle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$35();
    (0, import_web139.spread)(_el$, (0, import_web140.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web138.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-item.tsx
var import_web141 = require("solid-js/web");
var import_web142 = require("solid-js/web");
var import_web143 = require("solid-js/web");
var import_web144 = require("solid-js/web");
var import_ion_item = require("@ionic/core/components/ion-item");
var _tmpl$36 = /* @__PURE__ */ (0, import_web141.template)(`<ion-item>`, true, false);
(0, import_ion_item.defineCustomElement)();
function IonItem(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$36();
    (0, import_web143.spread)(_el$, (0, import_web144.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web142.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-item-divider.tsx
var import_web145 = require("solid-js/web");
var import_web146 = require("solid-js/web");
var import_web147 = require("solid-js/web");
var import_web148 = require("solid-js/web");
var import_ion_item_divider = require("@ionic/core/components/ion-item-divider");
var _tmpl$37 = /* @__PURE__ */ (0, import_web145.template)(`<ion-item-divider>`, true, false);
(0, import_ion_item_divider.defineCustomElement)();
function IonItemDivider(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$37();
    (0, import_web147.spread)(_el$, (0, import_web148.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web146.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-item-group.tsx
var import_web149 = require("solid-js/web");
var import_web150 = require("solid-js/web");
var import_web151 = require("solid-js/web");
var import_web152 = require("solid-js/web");
var import_ion_item_group = require("@ionic/core/components/ion-item-group");
var _tmpl$38 = /* @__PURE__ */ (0, import_web149.template)(`<ion-item-group>`, true, false);
(0, import_ion_item_group.defineCustomElement)();
function IonItemGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$38();
    (0, import_web151.spread)(_el$, (0, import_web152.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web150.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-item-option.tsx
var import_web153 = require("solid-js/web");
var import_web154 = require("solid-js/web");
var import_web155 = require("solid-js/web");
var import_web156 = require("solid-js/web");
var import_ion_item_option = require("@ionic/core/components/ion-item-option");
var _tmpl$39 = /* @__PURE__ */ (0, import_web153.template)(`<ion-item-option>`, true, false);
(0, import_ion_item_option.defineCustomElement)();
function IonItemOption(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$39();
    (0, import_web155.spread)(_el$, (0, import_web156.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web154.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-item-options.tsx
var import_web157 = require("solid-js/web");
var import_web158 = require("solid-js/web");
var import_web159 = require("solid-js/web");
var import_web160 = require("solid-js/web");
var import_ion_item_options = require("@ionic/core/components/ion-item-options");
var _tmpl$40 = /* @__PURE__ */ (0, import_web157.template)(`<ion-item-options>`, true, false);
(0, import_ion_item_options.defineCustomElement)();
function IonItemOptions(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$40();
    (0, import_web159.spread)(_el$, (0, import_web160.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web158.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-item-sliding.tsx
var import_web161 = require("solid-js/web");
var import_web162 = require("solid-js/web");
var import_web163 = require("solid-js/web");
var import_web164 = require("solid-js/web");
var import_ion_item_sliding = require("@ionic/core/components/ion-item-sliding");
var _tmpl$41 = /* @__PURE__ */ (0, import_web161.template)(`<ion-item-sliding>`, true, false);
(0, import_ion_item_sliding.defineCustomElement)();
function IonItemSliding(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$41();
    (0, import_web163.spread)(_el$, (0, import_web164.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web162.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-label.tsx
var import_web165 = require("solid-js/web");
var import_web166 = require("solid-js/web");
var import_web167 = require("solid-js/web");
var import_web168 = require("solid-js/web");
var import_ion_label = require("@ionic/core/components/ion-label");
var _tmpl$42 = /* @__PURE__ */ (0, import_web165.template)(`<ion-label>`, true, false);
(0, import_ion_label.defineCustomElement)();
function IonLabel(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$42();
    (0, import_web167.spread)(_el$, (0, import_web168.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web166.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-list.tsx
var import_web169 = require("solid-js/web");
var import_web170 = require("solid-js/web");
var import_web171 = require("solid-js/web");
var import_web172 = require("solid-js/web");
var import_ion_list = require("@ionic/core/components/ion-list");
var _tmpl$43 = /* @__PURE__ */ (0, import_web169.template)(`<ion-list>`, true, false);
(0, import_ion_list.defineCustomElement)();
function IonList(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$43();
    (0, import_web171.spread)(_el$, (0, import_web172.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web170.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-list-header.tsx
var import_web173 = require("solid-js/web");
var import_web174 = require("solid-js/web");
var import_web175 = require("solid-js/web");
var import_web176 = require("solid-js/web");
var import_ion_list_header = require("@ionic/core/components/ion-list-header");
var _tmpl$44 = /* @__PURE__ */ (0, import_web173.template)(`<ion-list-header>`, true, false);
(0, import_ion_list_header.defineCustomElement)();
function IonListHeader(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$44();
    (0, import_web175.spread)(_el$, (0, import_web176.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web174.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-loading.tsx
var import_web177 = require("solid-js/web");
var import_web178 = require("solid-js/web");
var import_web179 = require("solid-js/web");
var import_web180 = require("solid-js/web");
var import_ion_loading = require("@ionic/core/components/ion-loading");
var _tmpl$45 = /* @__PURE__ */ (0, import_web177.template)(`<ion-loading>`, true, false);
(0, import_ion_loading.defineCustomElement)();
function IonLoading(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$45();
    (0, import_web179.spread)(_el$, (0, import_web180.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web178.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-menu.tsx
var import_web181 = require("solid-js/web");
var import_web182 = require("solid-js/web");
var import_web183 = require("solid-js/web");
var import_web184 = require("solid-js/web");
var import_ion_menu = require("@ionic/core/components/ion-menu");
var _tmpl$46 = /* @__PURE__ */ (0, import_web181.template)(`<ion-menu>`, true, false);
(0, import_ion_menu.defineCustomElement)();
function IonMenu(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$46();
    (0, import_web183.spread)(_el$, (0, import_web184.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web182.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-menu-button.tsx
var import_web185 = require("solid-js/web");
var import_web186 = require("solid-js/web");
var import_web187 = require("solid-js/web");
var import_web188 = require("solid-js/web");
var import_ion_menu_button = require("@ionic/core/components/ion-menu-button");
var _tmpl$47 = /* @__PURE__ */ (0, import_web185.template)(`<ion-menu-button>`, true, false);
(0, import_ion_menu_button.defineCustomElement)();
function IonMenuButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$47();
    (0, import_web187.spread)(_el$, (0, import_web188.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web186.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-menu-toggle.tsx
var import_web189 = require("solid-js/web");
var import_web190 = require("solid-js/web");
var import_web191 = require("solid-js/web");
var import_web192 = require("solid-js/web");
var import_ion_menu_toggle = require("@ionic/core/components/ion-menu-toggle");
var _tmpl$48 = /* @__PURE__ */ (0, import_web189.template)(`<ion-menu-toggle>`, true, false);
(0, import_ion_menu_toggle.defineCustomElement)();
function IonMenuToggle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$48();
    (0, import_web191.spread)(_el$, (0, import_web192.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web190.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-modal.tsx
var import_web193 = require("solid-js/web");
var import_web194 = require("solid-js/web");
var import_web195 = require("solid-js/web");
var import_web196 = require("solid-js/web");
var import_ion_modal = require("@ionic/core/components/ion-modal");
var _tmpl$49 = /* @__PURE__ */ (0, import_web193.template)(`<ion-modal>`, true, false);
(0, import_ion_modal.defineCustomElement)();
function IonModal(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$49();
    (0, import_web195.spread)(_el$, (0, import_web196.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web194.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-nav.tsx
var import_web197 = require("solid-js/web");
var import_web198 = require("solid-js/web");
var import_web199 = require("solid-js/web");
var import_web200 = require("solid-js/web");
var import_ion_nav = require("@ionic/core/components/ion-nav");
var _tmpl$50 = /* @__PURE__ */ (0, import_web197.template)(`<ion-nav>`, true, false);
(0, import_ion_nav.defineCustomElement)();
function IonNav(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$50();
    (0, import_web199.spread)(_el$, (0, import_web200.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web198.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-nav-link.tsx
var import_web201 = require("solid-js/web");
var import_web202 = require("solid-js/web");
var import_web203 = require("solid-js/web");
var import_web204 = require("solid-js/web");
var import_ion_nav_link = require("@ionic/core/components/ion-nav-link");
var _tmpl$51 = /* @__PURE__ */ (0, import_web201.template)(`<ion-nav-link>`, true, false);
(0, import_ion_nav_link.defineCustomElement)();
function IonNavLink(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$51();
    (0, import_web203.spread)(_el$, (0, import_web204.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web202.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-note.tsx
var import_web205 = require("solid-js/web");
var import_web206 = require("solid-js/web");
var import_web207 = require("solid-js/web");
var import_web208 = require("solid-js/web");
var import_ion_note = require("@ionic/core/components/ion-note");
var _tmpl$52 = /* @__PURE__ */ (0, import_web205.template)(`<ion-note>`, true, false);
(0, import_ion_note.defineCustomElement)();
function IonNote(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$52();
    (0, import_web207.spread)(_el$, (0, import_web208.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web206.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-picker.tsx
var import_web209 = require("solid-js/web");
var import_web210 = require("solid-js/web");
var import_web211 = require("solid-js/web");
var import_web212 = require("solid-js/web");
var import_ion_picker = require("@ionic/core/components/ion-picker");
var _tmpl$53 = /* @__PURE__ */ (0, import_web209.template)(`<ion-picker>`, true, false);
(0, import_ion_picker.defineCustomElement)();
function IonPicker(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$53();
    (0, import_web211.spread)(_el$, (0, import_web212.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web210.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-picker-column.tsx
var import_web213 = require("solid-js/web");
var import_web214 = require("solid-js/web");
var import_web215 = require("solid-js/web");
var import_web216 = require("solid-js/web");
var import_ion_picker_column = require("@ionic/core/components/ion-picker-column");
var _tmpl$54 = /* @__PURE__ */ (0, import_web213.template)(`<ion-picker-column>`, true, false);
(0, import_ion_picker_column.defineCustomElement)();
function IonPickerColumn(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$54();
    (0, import_web215.spread)(_el$, (0, import_web216.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web214.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-picker-column-option.tsx
var import_web217 = require("solid-js/web");
var import_web218 = require("solid-js/web");
var import_web219 = require("solid-js/web");
var import_web220 = require("solid-js/web");
var import_ion_picker_column_option = require("@ionic/core/components/ion-picker-column-option");
var _tmpl$55 = /* @__PURE__ */ (0, import_web217.template)(`<ion-picker-column-option>`, true, false);
(0, import_ion_picker_column_option.defineCustomElement)();
function IonPickerColumnOption(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$55();
    (0, import_web219.spread)(_el$, (0, import_web220.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web218.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-picker-legacy.tsx
var import_web221 = require("solid-js/web");
var import_web222 = require("solid-js/web");
var import_web223 = require("solid-js/web");
var import_web224 = require("solid-js/web");
var import_ion_picker_legacy = require("@ionic/core/components/ion-picker-legacy");
var _tmpl$56 = /* @__PURE__ */ (0, import_web221.template)(`<ion-picker-legacy>`, true, false);
(0, import_ion_picker_legacy.defineCustomElement)();
function IonPickerLegacy(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$56();
    (0, import_web223.spread)(_el$, (0, import_web224.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web222.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-picker-legacy-column.tsx
var import_web225 = require("solid-js/web");
var import_web226 = require("solid-js/web");
var import_web227 = require("solid-js/web");
var import_web228 = require("solid-js/web");
var import_ion_picker_legacy_column = require("@ionic/core/components/ion-picker-legacy-column");
var _tmpl$57 = /* @__PURE__ */ (0, import_web225.template)(`<ion-picker-legacy-column>`, true, false);
(0, import_ion_picker_legacy_column.defineCustomElement)();
function IonPickerLegacyColumn(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$57();
    (0, import_web227.spread)(_el$, (0, import_web228.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web226.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-popover.tsx
var import_web229 = require("solid-js/web");
var import_web230 = require("solid-js/web");
var import_web231 = require("solid-js/web");
var import_web232 = require("solid-js/web");
var import_ion_popover = require("@ionic/core/components/ion-popover");
var _tmpl$58 = /* @__PURE__ */ (0, import_web229.template)(`<ion-popover>`, true, false);
(0, import_ion_popover.defineCustomElement)();
function IonPopover(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$58();
    (0, import_web231.spread)(_el$, (0, import_web232.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web230.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-progress-bar.tsx
var import_web233 = require("solid-js/web");
var import_web234 = require("solid-js/web");
var import_web235 = require("solid-js/web");
var import_web236 = require("solid-js/web");
var import_ion_progress_bar = require("@ionic/core/components/ion-progress-bar");
var _tmpl$59 = /* @__PURE__ */ (0, import_web233.template)(`<ion-progress-bar>`, true, false);
(0, import_ion_progress_bar.defineCustomElement)();
function IonProgressBar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$59();
    (0, import_web235.spread)(_el$, (0, import_web236.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web234.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-radio.tsx
var import_web237 = require("solid-js/web");
var import_web238 = require("solid-js/web");
var import_web239 = require("solid-js/web");
var import_web240 = require("solid-js/web");
var import_ion_radio = require("@ionic/core/components/ion-radio");
var _tmpl$60 = /* @__PURE__ */ (0, import_web237.template)(`<ion-radio>`, true, false);
(0, import_ion_radio.defineCustomElement)();
function IonRadio(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$60();
    (0, import_web239.spread)(_el$, (0, import_web240.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web238.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-radio-group.tsx
var import_web241 = require("solid-js/web");
var import_web242 = require("solid-js/web");
var import_web243 = require("solid-js/web");
var import_web244 = require("solid-js/web");
var import_ion_radio_group = require("@ionic/core/components/ion-radio-group");
var _tmpl$61 = /* @__PURE__ */ (0, import_web241.template)(`<ion-radio-group>`, true, false);
(0, import_ion_radio_group.defineCustomElement)();
function IonRadioGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$61();
    (0, import_web243.spread)(_el$, (0, import_web244.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web242.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-range.tsx
var import_web245 = require("solid-js/web");
var import_web246 = require("solid-js/web");
var import_web247 = require("solid-js/web");
var import_web248 = require("solid-js/web");
var import_ion_range = require("@ionic/core/components/ion-range");
var _tmpl$62 = /* @__PURE__ */ (0, import_web245.template)(`<ion-range>`, true, false);
(0, import_ion_range.defineCustomElement)();
function IonRange(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$62();
    (0, import_web247.spread)(_el$, (0, import_web248.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web246.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-refresher.tsx
var import_web249 = require("solid-js/web");
var import_web250 = require("solid-js/web");
var import_web251 = require("solid-js/web");
var import_web252 = require("solid-js/web");
var import_ion_refresher = require("@ionic/core/components/ion-refresher");
var _tmpl$63 = /* @__PURE__ */ (0, import_web249.template)(`<ion-refresher>`, true, false);
(0, import_ion_refresher.defineCustomElement)();
function IonRefresher(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$63();
    (0, import_web251.spread)(_el$, (0, import_web252.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web250.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-refresher-content.tsx
var import_web253 = require("solid-js/web");
var import_web254 = require("solid-js/web");
var import_web255 = require("solid-js/web");
var import_web256 = require("solid-js/web");
var import_ion_refresher_content = require("@ionic/core/components/ion-refresher-content");
var _tmpl$64 = /* @__PURE__ */ (0, import_web253.template)(`<ion-refresher-content>`, true, false);
(0, import_ion_refresher_content.defineCustomElement)();
function IonRefresherContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$64();
    (0, import_web255.spread)(_el$, (0, import_web256.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web254.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-reorder.tsx
var import_web257 = require("solid-js/web");
var import_web258 = require("solid-js/web");
var import_web259 = require("solid-js/web");
var import_web260 = require("solid-js/web");
var import_ion_reorder = require("@ionic/core/components/ion-reorder");
var _tmpl$65 = /* @__PURE__ */ (0, import_web257.template)(`<ion-reorder>`, true, false);
(0, import_ion_reorder.defineCustomElement)();
function IonReorder(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$65();
    (0, import_web259.spread)(_el$, (0, import_web260.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web258.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-reorder-group.tsx
var import_web261 = require("solid-js/web");
var import_web262 = require("solid-js/web");
var import_web263 = require("solid-js/web");
var import_web264 = require("solid-js/web");
var import_ion_reorder_group = require("@ionic/core/components/ion-reorder-group");
var _tmpl$66 = /* @__PURE__ */ (0, import_web261.template)(`<ion-reorder-group>`, true, false);
(0, import_ion_reorder_group.defineCustomElement)();
function IonReorderGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$66();
    (0, import_web263.spread)(_el$, (0, import_web264.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web262.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-ripple-effect.tsx
var import_web265 = require("solid-js/web");
var import_web266 = require("solid-js/web");
var import_web267 = require("solid-js/web");
var import_web268 = require("solid-js/web");
var import_ion_ripple_effect = require("@ionic/core/components/ion-ripple-effect");
var _tmpl$67 = /* @__PURE__ */ (0, import_web265.template)(`<ion-ripple-effect>`, true, false);
(0, import_ion_ripple_effect.defineCustomElement)();
function IonRippleEffect(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$67();
    (0, import_web267.spread)(_el$, (0, import_web268.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web266.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-route-redirect.tsx
var import_web269 = require("solid-js/web");
var import_web270 = require("solid-js/web");
var import_web271 = require("solid-js/web");
var import_web272 = require("solid-js/web");
var import_ion_route_redirect = require("@ionic/core/components/ion-route-redirect");
var _tmpl$68 = /* @__PURE__ */ (0, import_web269.template)(`<ion-route-redirect>`, true, false);
(0, import_ion_route_redirect.defineCustomElement)();
function IonRouteRedirect(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$68();
    (0, import_web271.spread)(_el$, (0, import_web272.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web270.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-router-link.tsx
var import_web273 = require("solid-js/web");
var import_web274 = require("solid-js/web");
var import_web275 = require("solid-js/web");
var import_web276 = require("solid-js/web");
var import_ion_router_link = require("@ionic/core/components/ion-router-link");
var _tmpl$69 = /* @__PURE__ */ (0, import_web273.template)(`<ion-router-link>`, true, false);
(0, import_ion_router_link.defineCustomElement)();
function IonRouterLink(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$69();
    (0, import_web275.spread)(_el$, (0, import_web276.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web274.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-router-outlet.tsx
var import_web277 = require("solid-js/web");
var import_web278 = require("solid-js/web");
var import_web279 = require("solid-js/web");
var import_web280 = require("solid-js/web");
var import_ion_router_outlet = require("@ionic/core/components/ion-router-outlet");
var _tmpl$70 = /* @__PURE__ */ (0, import_web277.template)(`<ion-router-outlet>`, true, false);
(0, import_ion_router_outlet.defineCustomElement)();
function IonRouterOutlet(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$70();
    (0, import_web279.spread)(_el$, (0, import_web280.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web278.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-row.tsx
var import_web281 = require("solid-js/web");
var import_web282 = require("solid-js/web");
var import_web283 = require("solid-js/web");
var import_web284 = require("solid-js/web");
var import_ion_row = require("@ionic/core/components/ion-row");
var _tmpl$71 = /* @__PURE__ */ (0, import_web281.template)(`<ion-row>`, true, false);
(0, import_ion_row.defineCustomElement)();
function IonRow(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$71();
    (0, import_web283.spread)(_el$, (0, import_web284.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web282.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-searchbar.tsx
var import_web285 = require("solid-js/web");
var import_web286 = require("solid-js/web");
var import_web287 = require("solid-js/web");
var import_web288 = require("solid-js/web");
var import_ion_searchbar = require("@ionic/core/components/ion-searchbar");
var _tmpl$72 = /* @__PURE__ */ (0, import_web285.template)(`<ion-searchbar>`, true, false);
(0, import_ion_searchbar.defineCustomElement)();
function IonSearchbar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$72();
    (0, import_web287.spread)(_el$, (0, import_web288.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web286.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-segment.tsx
var import_web289 = require("solid-js/web");
var import_web290 = require("solid-js/web");
var import_web291 = require("solid-js/web");
var import_web292 = require("solid-js/web");
var import_ion_segment = require("@ionic/core/components/ion-segment");
var _tmpl$73 = /* @__PURE__ */ (0, import_web289.template)(`<ion-segment>`, true, false);
(0, import_ion_segment.defineCustomElement)();
function IonSegment(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$73();
    (0, import_web291.spread)(_el$, (0, import_web292.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web290.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-segment-button.tsx
var import_web293 = require("solid-js/web");
var import_web294 = require("solid-js/web");
var import_web295 = require("solid-js/web");
var import_web296 = require("solid-js/web");
var import_ion_segment_button = require("@ionic/core/components/ion-segment-button");
var _tmpl$74 = /* @__PURE__ */ (0, import_web293.template)(`<ion-segment-button>`, true, false);
(0, import_ion_segment_button.defineCustomElement)();
function IonSegmentButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$74();
    (0, import_web295.spread)(_el$, (0, import_web296.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web294.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-select.tsx
var import_web297 = require("solid-js/web");
var import_web298 = require("solid-js/web");
var import_web299 = require("solid-js/web");
var import_web300 = require("solid-js/web");
var import_ion_select = require("@ionic/core/components/ion-select");
var _tmpl$75 = /* @__PURE__ */ (0, import_web297.template)(`<ion-select>`, true, false);
(0, import_ion_select.defineCustomElement)();
function IonSelect(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$75();
    (0, import_web299.spread)(_el$, (0, import_web300.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web298.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-select-option.tsx
var import_web301 = require("solid-js/web");
var import_web302 = require("solid-js/web");
var import_web303 = require("solid-js/web");
var import_web304 = require("solid-js/web");
var import_ion_select_option = require("@ionic/core/components/ion-select-option");
var _tmpl$76 = /* @__PURE__ */ (0, import_web301.template)(`<ion-select-option>`, true, false);
(0, import_ion_select_option.defineCustomElement)();
function IonSelectOption(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$76();
    (0, import_web303.spread)(_el$, (0, import_web304.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web302.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-select-popover.tsx
var import_web305 = require("solid-js/web");
var import_web306 = require("solid-js/web");
var import_web307 = require("solid-js/web");
var import_web308 = require("solid-js/web");
var import_ion_select_popover = require("@ionic/core/components/ion-select-popover");
var _tmpl$77 = /* @__PURE__ */ (0, import_web305.template)(`<ion-select-popover>`, true, false);
(0, import_ion_select_popover.defineCustomElement)();
function IonSelectPopover(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$77();
    (0, import_web307.spread)(_el$, (0, import_web308.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web306.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-skeleton-text.tsx
var import_web309 = require("solid-js/web");
var import_web310 = require("solid-js/web");
var import_web311 = require("solid-js/web");
var import_web312 = require("solid-js/web");
var import_ion_skeleton_text = require("@ionic/core/components/ion-skeleton-text");
var _tmpl$78 = /* @__PURE__ */ (0, import_web309.template)(`<ion-skeleton-text>`, true, false);
(0, import_ion_skeleton_text.defineCustomElement)();
function IonSkeletonText(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$78();
    (0, import_web311.spread)(_el$, (0, import_web312.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web310.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-spinner.tsx
var import_web313 = require("solid-js/web");
var import_web314 = require("solid-js/web");
var import_web315 = require("solid-js/web");
var import_web316 = require("solid-js/web");
var import_ion_spinner = require("@ionic/core/components/ion-spinner");
var _tmpl$79 = /* @__PURE__ */ (0, import_web313.template)(`<ion-spinner>`, true, false);
(0, import_ion_spinner.defineCustomElement)();
function IonSpinner(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$79();
    (0, import_web315.spread)(_el$, (0, import_web316.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web314.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-split-pane.tsx
var import_web317 = require("solid-js/web");
var import_web318 = require("solid-js/web");
var import_web319 = require("solid-js/web");
var import_web320 = require("solid-js/web");
var import_ion_split_pane = require("@ionic/core/components/ion-split-pane");
var _tmpl$80 = /* @__PURE__ */ (0, import_web317.template)(`<ion-split-pane>`, true, false);
(0, import_ion_split_pane.defineCustomElement)();
function IonSplitPane(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$80();
    (0, import_web319.spread)(_el$, (0, import_web320.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web318.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-tab.tsx
var import_web321 = require("solid-js/web");
var import_web322 = require("solid-js/web");
var import_web323 = require("solid-js/web");
var import_web324 = require("solid-js/web");
var import_ion_tab = require("@ionic/core/components/ion-tab");
var _tmpl$81 = /* @__PURE__ */ (0, import_web321.template)(`<ion-tab>`, true, false);
(0, import_ion_tab.defineCustomElement)();
function IonTab(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$81();
    (0, import_web323.spread)(_el$, (0, import_web324.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web322.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-tab-bar.tsx
var import_web325 = require("solid-js/web");
var import_web326 = require("solid-js/web");
var import_web327 = require("solid-js/web");
var import_web328 = require("solid-js/web");
var import_ion_tab_bar = require("@ionic/core/components/ion-tab-bar");
var _tmpl$82 = /* @__PURE__ */ (0, import_web325.template)(`<ion-tab-bar>`, true, false);
(0, import_ion_tab_bar.defineCustomElement)();
function IonTabBar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$82();
    (0, import_web327.spread)(_el$, (0, import_web328.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web326.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-tab-button.tsx
var import_web329 = require("solid-js/web");
var import_web330 = require("solid-js/web");
var import_web331 = require("solid-js/web");
var import_web332 = require("solid-js/web");
var import_ion_tab_button = require("@ionic/core/components/ion-tab-button");
var _tmpl$83 = /* @__PURE__ */ (0, import_web329.template)(`<ion-tab-button>`, true, false);
(0, import_ion_tab_button.defineCustomElement)();
function IonTabButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$83();
    (0, import_web331.spread)(_el$, (0, import_web332.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web330.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-tabs.tsx
var import_web333 = require("solid-js/web");
var import_web334 = require("solid-js/web");
var import_web335 = require("solid-js/web");
var import_web336 = require("solid-js/web");
var import_ion_tabs = require("@ionic/core/components/ion-tabs");
var _tmpl$84 = /* @__PURE__ */ (0, import_web333.template)(`<ion-tabs>`, true, false);
(0, import_ion_tabs.defineCustomElement)();
function IonTabs(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$84();
    (0, import_web335.spread)(_el$, (0, import_web336.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web334.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-text.tsx
var import_web337 = require("solid-js/web");
var import_web338 = require("solid-js/web");
var import_web339 = require("solid-js/web");
var import_web340 = require("solid-js/web");
var import_ion_text = require("@ionic/core/components/ion-text");
var _tmpl$85 = /* @__PURE__ */ (0, import_web337.template)(`<ion-text>`, true, false);
(0, import_ion_text.defineCustomElement)();
function IonText(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$85();
    (0, import_web339.spread)(_el$, (0, import_web340.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web338.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-textarea.tsx
var import_web341 = require("solid-js/web");
var import_web342 = require("solid-js/web");
var import_web343 = require("solid-js/web");
var import_web344 = require("solid-js/web");
var import_ion_textarea = require("@ionic/core/components/ion-textarea");
var _tmpl$86 = /* @__PURE__ */ (0, import_web341.template)(`<ion-textarea>`, true, false);
(0, import_ion_textarea.defineCustomElement)();
function IonTextarea(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$86();
    (0, import_web343.spread)(_el$, (0, import_web344.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web342.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-thumbnail.tsx
var import_web345 = require("solid-js/web");
var import_web346 = require("solid-js/web");
var import_web347 = require("solid-js/web");
var import_web348 = require("solid-js/web");
var import_ion_thumbnail = require("@ionic/core/components/ion-thumbnail");
var _tmpl$87 = /* @__PURE__ */ (0, import_web345.template)(`<ion-thumbnail>`, true, false);
(0, import_ion_thumbnail.defineCustomElement)();
function IonThumbnail(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$87();
    (0, import_web347.spread)(_el$, (0, import_web348.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web346.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-title.tsx
var import_web349 = require("solid-js/web");
var import_web350 = require("solid-js/web");
var import_web351 = require("solid-js/web");
var import_web352 = require("solid-js/web");
var import_ion_title = require("@ionic/core/components/ion-title");
var _tmpl$88 = /* @__PURE__ */ (0, import_web349.template)(`<ion-title>`, true, false);
(0, import_ion_title.defineCustomElement)();
function IonTitle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$88();
    (0, import_web351.spread)(_el$, (0, import_web352.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web350.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-toast.tsx
var import_web353 = require("solid-js/web");
var import_web354 = require("solid-js/web");
var import_web355 = require("solid-js/web");
var import_web356 = require("solid-js/web");
var import_ion_toast = require("@ionic/core/components/ion-toast");
var _tmpl$89 = /* @__PURE__ */ (0, import_web353.template)(`<ion-toast>`, true, false);
(0, import_ion_toast.defineCustomElement)();
function IonToast(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$89();
    (0, import_web355.spread)(_el$, (0, import_web356.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web354.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-toggle.tsx
var import_web357 = require("solid-js/web");
var import_web358 = require("solid-js/web");
var import_web359 = require("solid-js/web");
var import_web360 = require("solid-js/web");
var import_ion_toggle = require("@ionic/core/components/ion-toggle");
var _tmpl$90 = /* @__PURE__ */ (0, import_web357.template)(`<ion-toggle>`, true, false);
(0, import_ion_toggle.defineCustomElement)();
function IonToggle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$90();
    (0, import_web359.spread)(_el$, (0, import_web360.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web358.getOwner)();
    return _el$;
  })();
}

// src/components/generated/ion-toolbar.tsx
var import_web361 = require("solid-js/web");
var import_web362 = require("solid-js/web");
var import_web363 = require("solid-js/web");
var import_web364 = require("solid-js/web");
var import_ion_toolbar = require("@ionic/core/components/ion-toolbar");
var _tmpl$91 = /* @__PURE__ */ (0, import_web361.template)(`<ion-toolbar>`, true, false);
(0, import_ion_toolbar.defineCustomElement)();
function IonToolbar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$91();
    (0, import_web363.spread)(_el$, (0, import_web364.mergeProps)(fixedProps), false, false);
    _el$._$owner = (0, import_web362.getOwner)();
    return _el$;
  })();
}

// src/components/ComponentRef.tsx
var import_web365 = require("solid-js/web");
var import_solid_element = require("solid-element");
var import_solid_js = require("solid-js");
function ComponentRef(props, options) {
  const mergedProps = (0, import_solid_js.mergeProps)(props.componentProps ?? {}, {
    componentOptions: {
      element: options.element
    }
  });
  return (0, import_web365.memo)(() => props.component(mergedProps));
}
var ComponentRefElementName = "solid-ion-component-ref";
(0, import_solid_element.customElement)(ComponentRefElementName, {
  component: () => [],
  componentProps: void 0,
  data: void 0
}, ComponentRef);

// src/components/ion-icon.tsx
var import_web366 = require("solid-js/web");
var import_web367 = require("solid-js/web");
var import_web368 = require("solid-js/web");

// ../../node_modules/@stencil/core/internal/app-data/index.js
var BUILD = {
  allRenderFn: false,
  cmpDidLoad: true,
  cmpDidUnload: false,
  cmpDidUpdate: true,
  cmpDidRender: true,
  cmpWillLoad: true,
  cmpWillUpdate: true,
  cmpWillRender: true,
  connectedCallback: true,
  disconnectedCallback: true,
  element: true,
  event: true,
  hasRenderFn: true,
  lifecycle: true,
  hostListener: true,
  hostListenerTargetWindow: true,
  hostListenerTargetDocument: true,
  hostListenerTargetBody: true,
  hostListenerTargetParent: false,
  hostListenerTarget: true,
  member: true,
  method: true,
  mode: true,
  observeAttribute: true,
  prop: true,
  propMutable: true,
  reflect: true,
  scoped: true,
  shadowDom: true,
  slot: true,
  cssAnnotations: true,
  state: true,
  style: true,
  formAssociated: false,
  svg: true,
  updatable: true,
  vdomAttribute: true,
  vdomXlink: true,
  vdomClass: true,
  vdomFunctional: true,
  vdomKey: true,
  vdomListener: true,
  vdomRef: true,
  vdomPropOrAttr: true,
  vdomRender: true,
  vdomStyle: true,
  vdomText: true,
  watchCallback: true,
  taskQueue: true,
  hotModuleReplacement: false,
  isDebug: false,
  isDev: false,
  isTesting: false,
  hydrateServerSide: false,
  hydrateClientSide: false,
  lifecycleDOMEvents: false,
  lazyLoad: false,
  profile: false,
  slotRelocation: true,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  appendChildSlotFix: false,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  cloneNodeFix: false,
  hydratedAttribute: false,
  hydratedClass: true,
  scriptDataOpts: false,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  scopedSlotTextContentFix: false,
  // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
  shadowDomShim: false,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  slotChildNodesFix: false,
  invisiblePrehydration: true,
  propBoolean: true,
  propNumber: true,
  propString: true,
  constructableCSS: true,
  cmpShouldUpdate: true,
  devTools: false,
  shadowDelegatesFocus: true,
  initializeNextTick: false,
  asyncLoading: false,
  asyncQueue: false,
  transformTagName: false,
  attachStyles: true,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  experimentalSlotFixes: false
};
var NAMESPACE = (
  /* default */
  "app"
);

// import("./**/*.entry.js*") in ../../node_modules/@stencil/core/internal/client/index.js
var globImport_entry_js = __glob({});

// ../../node_modules/@stencil/core/internal/client/index.js
var __defProp2 = Object.defineProperty;
var __export2 = (target, all) => {
  for (var name in all)
    __defProp2(target, name, { get: all[name], enumerable: true });
};
var Build = {
  isDev: BUILD.isDev ? true : false,
  isBrowser: true,
  isServer: false,
  isTesting: BUILD.isTesting ? true : false
};
var getAssetPath = (path) => {
  const assetUrl = new URL(path, plt.$resourcesUrl$);
  return assetUrl.origin !== win.location.origin ? assetUrl.href : assetUrl.pathname;
};
var EMPTY_OBJ = {};
var SVG_NS = "http://www.w3.org/2000/svg";
var HTML_NS = "http://www.w3.org/1999/xhtml";
var isDef = (v) => v != null;
var isComplexType = (o) => {
  o = typeof o;
  return o === "object" || o === "function";
};
function queryNonceMetaTagContent(doc2) {
  var _a, _b, _c;
  return (_c = (_b = (_a = doc2.head) == null ? void 0 : _a.querySelector('meta[name="csp-nonce"]')) == null ? void 0 : _b.getAttribute("content")) != null ? _c : void 0;
}
var result_exports = {};
__export2(result_exports, {
  err: () => err,
  map: () => map,
  ok: () => ok,
  unwrap: () => unwrap,
  unwrapErr: () => unwrapErr
});
var ok = (value) => ({
  isOk: true,
  isErr: false,
  value
});
var err = (value) => ({
  isOk: false,
  isErr: true,
  value
});
function map(result, fn) {
  if (result.isOk) {
    const val = fn(result.value);
    if (val instanceof Promise) {
      return val.then((newVal) => ok(newVal));
    } else {
      return ok(val);
    }
  }
  if (result.isErr) {
    const value = result.value;
    return err(value);
  }
  throw "should never get here";
}
var unwrap = (result) => {
  if (result.isOk) {
    return result.value;
  } else {
    throw result.value;
  }
};
var unwrapErr = (result) => {
  if (result.isErr) {
    return result.value;
  } else {
    throw result.value;
  }
};
var i = 0;
var createTime = (fnName, tagName = "") => {
  if (BUILD.profile && performance.mark) {
    const key = `st:${fnName}:${tagName}:${i++}`;
    performance.mark(key);
    return () => performance.measure(`[Stencil] ${fnName}() <${tagName}>`, key);
  } else {
    return () => {
      return;
    };
  }
};
var uniqueTime = (key, measureText) => {
  if (BUILD.profile && performance.mark) {
    if (performance.getEntriesByName(key, "mark").length === 0) {
      performance.mark(key);
    }
    return () => {
      if (performance.getEntriesByName(measureText, "measure").length === 0) {
        performance.measure(measureText, key);
      }
    };
  } else {
    return () => {
      return;
    };
  }
};
var CONTENT_REF_ID = "r";
var ORG_LOCATION_ID = "o";
var SLOT_NODE_ID = "s";
var TEXT_NODE_ID = "t";
var HYDRATE_ID = "s-id";
var HYDRATED_STYLE_ID = "sty-id";
var HYDRATE_CHILD_ID = "c-id";
var SLOT_FB_CSS = "slot-fb{display:contents}slot-fb[hidden]{display:none}";
var XLINK_NS = "http://www.w3.org/1999/xlink";
var FORM_ASSOCIATED_CUSTOM_ELEMENT_CALLBACKS = [
  "formAssociatedCallback",
  "formResetCallback",
  "formDisabledCallback",
  "formStateRestoreCallback"
];
var h = (nodeName, vnodeData, ...children) => {
  let child = null;
  let key = null;
  let slotName = null;
  let simple = false;
  let lastSimple = false;
  const vNodeChildren = [];
  const walk = (c) => {
    for (let i2 = 0; i2 < c.length; i2++) {
      child = c[i2];
      if (Array.isArray(child)) {
        walk(child);
      } else if (child != null && typeof child !== "boolean") {
        if (simple = typeof nodeName !== "function" && !isComplexType(child)) {
          child = String(child);
        } else if (BUILD.isDev && typeof nodeName !== "function" && child.$flags$ === void 0) {
          consoleDevError(`vNode passed as children has unexpected type.
Make sure it's using the correct h() function.
Empty objects can also be the cause, look for JSX comments that became objects.`);
        }
        if (simple && lastSimple) {
          vNodeChildren[vNodeChildren.length - 1].$text$ += child;
        } else {
          vNodeChildren.push(simple ? newVNode(null, child) : child);
        }
        lastSimple = simple;
      }
    }
  };
  walk(children);
  if (vnodeData) {
    if (BUILD.isDev && nodeName === "input") {
      validateInputProperties(vnodeData);
    }
    if (BUILD.vdomKey && vnodeData.key) {
      key = vnodeData.key;
    }
    if (BUILD.slotRelocation && vnodeData.name) {
      slotName = vnodeData.name;
    }
    if (BUILD.vdomClass) {
      const classData = vnodeData.className || vnodeData.class;
      if (classData) {
        vnodeData.class = typeof classData !== "object" ? classData : Object.keys(classData).filter((k) => classData[k]).join(" ");
      }
    }
  }
  if (BUILD.isDev && vNodeChildren.some(isHost)) {
    consoleDevError(`The <Host> must be the single root component. Make sure:
- You are NOT using hostData() and <Host> in the same component.
- <Host> is used once, and it's the single root component of the render() function.`);
  }
  if (BUILD.vdomFunctional && typeof nodeName === "function") {
    return nodeName(
      vnodeData === null ? {} : vnodeData,
      vNodeChildren,
      vdomFnUtils
    );
  }
  const vnode = newVNode(nodeName, null);
  vnode.$attrs$ = vnodeData;
  if (vNodeChildren.length > 0) {
    vnode.$children$ = vNodeChildren;
  }
  if (BUILD.vdomKey) {
    vnode.$key$ = key;
  }
  if (BUILD.slotRelocation) {
    vnode.$name$ = slotName;
  }
  return vnode;
};
var newVNode = (tag, text) => {
  const vnode = {
    $flags$: 0,
    $tag$: tag,
    $text$: text,
    $elm$: null,
    $children$: null
  };
  if (BUILD.vdomAttribute) {
    vnode.$attrs$ = null;
  }
  if (BUILD.vdomKey) {
    vnode.$key$ = null;
  }
  if (BUILD.slotRelocation) {
    vnode.$name$ = null;
  }
  return vnode;
};
var Host = {};
var isHost = (node) => node && node.$tag$ === Host;
var vdomFnUtils = {
  forEach: (children, cb) => children.map(convertToPublic).forEach(cb),
  map: (children, cb) => children.map(convertToPublic).map(cb).map(convertToPrivate)
};
var convertToPublic = (node) => ({
  vattrs: node.$attrs$,
  vchildren: node.$children$,
  vkey: node.$key$,
  vname: node.$name$,
  vtag: node.$tag$,
  vtext: node.$text$
});
var convertToPrivate = (node) => {
  if (typeof node.vtag === "function") {
    const vnodeData = { ...node.vattrs };
    if (node.vkey) {
      vnodeData.key = node.vkey;
    }
    if (node.vname) {
      vnodeData.name = node.vname;
    }
    return h(node.vtag, vnodeData, ...node.vchildren || []);
  }
  const vnode = newVNode(node.vtag, node.vtext);
  vnode.$attrs$ = node.vattrs;
  vnode.$children$ = node.vchildren;
  vnode.$key$ = node.vkey;
  vnode.$name$ = node.vname;
  return vnode;
};
var validateInputProperties = (inputElm) => {
  const props = Object.keys(inputElm);
  const value = props.indexOf("value");
  if (value === -1) {
    return;
  }
  const typeIndex = props.indexOf("type");
  const minIndex = props.indexOf("min");
  const maxIndex = props.indexOf("max");
  const stepIndex = props.indexOf("step");
  if (value < typeIndex || value < minIndex || value < maxIndex || value < stepIndex) {
    consoleDevWarn(`The "value" prop of <input> should be set after "min", "max", "type" and "step"`);
  }
};
var initializeClientHydrate = (hostElm, tagName, hostId, hostRef) => {
  const endHydrate = createTime("hydrateClient", tagName);
  const shadowRoot = hostElm.shadowRoot;
  const childRenderNodes = [];
  const slotNodes = [];
  const shadowRootNodes = BUILD.shadowDom && shadowRoot ? [] : null;
  const vnode = hostRef.$vnode$ = newVNode(tagName, null);
  if (!plt.$orgLocNodes$) {
    initializeDocumentHydrate(doc.body, plt.$orgLocNodes$ = /* @__PURE__ */ new Map());
  }
  hostElm[HYDRATE_ID] = hostId;
  hostElm.removeAttribute(HYDRATE_ID);
  clientHydrate(vnode, childRenderNodes, slotNodes, shadowRootNodes, hostElm, hostElm, hostId);
  childRenderNodes.map((c) => {
    const orgLocationId = c.$hostId$ + "." + c.$nodeId$;
    const orgLocationNode = plt.$orgLocNodes$.get(orgLocationId);
    const node = c.$elm$;
    if (orgLocationNode && supportsShadow && orgLocationNode["s-en"] === "") {
      orgLocationNode.parentNode.insertBefore(node, orgLocationNode.nextSibling);
    }
    if (!shadowRoot) {
      node["s-hn"] = tagName;
      if (orgLocationNode) {
        node["s-ol"] = orgLocationNode;
        node["s-ol"]["s-nr"] = node;
      }
    }
    plt.$orgLocNodes$.delete(orgLocationId);
  });
  if (BUILD.shadowDom && shadowRoot) {
    shadowRootNodes.map((shadowRootNode) => {
      if (shadowRootNode) {
        shadowRoot.appendChild(shadowRootNode);
      }
    });
  }
  endHydrate();
};
var clientHydrate = (parentVNode, childRenderNodes, slotNodes, shadowRootNodes, hostElm, node, hostId) => {
  let childNodeType;
  let childIdSplt;
  let childVNode;
  let i2;
  if (node.nodeType === 1) {
    childNodeType = node.getAttribute(HYDRATE_CHILD_ID);
    if (childNodeType) {
      childIdSplt = childNodeType.split(".");
      if (childIdSplt[0] === hostId || childIdSplt[0] === "0") {
        childVNode = {
          $flags$: 0,
          $hostId$: childIdSplt[0],
          $nodeId$: childIdSplt[1],
          $depth$: childIdSplt[2],
          $index$: childIdSplt[3],
          $tag$: node.tagName.toLowerCase(),
          $elm$: node,
          $attrs$: null,
          $children$: null,
          $key$: null,
          $name$: null,
          $text$: null
        };
        childRenderNodes.push(childVNode);
        node.removeAttribute(HYDRATE_CHILD_ID);
        if (!parentVNode.$children$) {
          parentVNode.$children$ = [];
        }
        parentVNode.$children$[childVNode.$index$] = childVNode;
        parentVNode = childVNode;
        if (shadowRootNodes && childVNode.$depth$ === "0") {
          shadowRootNodes[childVNode.$index$] = childVNode.$elm$;
        }
      }
    }
    for (i2 = node.childNodes.length - 1; i2 >= 0; i2--) {
      clientHydrate(
        parentVNode,
        childRenderNodes,
        slotNodes,
        shadowRootNodes,
        hostElm,
        node.childNodes[i2],
        hostId
      );
    }
    if (node.shadowRoot) {
      for (i2 = node.shadowRoot.childNodes.length - 1; i2 >= 0; i2--) {
        clientHydrate(
          parentVNode,
          childRenderNodes,
          slotNodes,
          shadowRootNodes,
          hostElm,
          node.shadowRoot.childNodes[i2],
          hostId
        );
      }
    }
  } else if (node.nodeType === 8) {
    childIdSplt = node.nodeValue.split(".");
    if (childIdSplt[1] === hostId || childIdSplt[1] === "0") {
      childNodeType = childIdSplt[0];
      childVNode = {
        $flags$: 0,
        $hostId$: childIdSplt[1],
        $nodeId$: childIdSplt[2],
        $depth$: childIdSplt[3],
        $index$: childIdSplt[4],
        $elm$: node,
        $attrs$: null,
        $children$: null,
        $key$: null,
        $name$: null,
        $tag$: null,
        $text$: null
      };
      if (childNodeType === TEXT_NODE_ID) {
        childVNode.$elm$ = node.nextSibling;
        if (childVNode.$elm$ && childVNode.$elm$.nodeType === 3) {
          childVNode.$text$ = childVNode.$elm$.textContent;
          childRenderNodes.push(childVNode);
          node.remove();
          if (!parentVNode.$children$) {
            parentVNode.$children$ = [];
          }
          parentVNode.$children$[childVNode.$index$] = childVNode;
          if (shadowRootNodes && childVNode.$depth$ === "0") {
            shadowRootNodes[childVNode.$index$] = childVNode.$elm$;
          }
        }
      } else if (childVNode.$hostId$ === hostId) {
        if (childNodeType === SLOT_NODE_ID) {
          childVNode.$tag$ = "slot";
          if (childIdSplt[5]) {
            node["s-sn"] = childVNode.$name$ = childIdSplt[5];
          } else {
            node["s-sn"] = "";
          }
          node["s-sr"] = true;
          if (BUILD.shadowDom && shadowRootNodes) {
            childVNode.$elm$ = doc.createElement(childVNode.$tag$);
            if (childVNode.$name$) {
              childVNode.$elm$.setAttribute("name", childVNode.$name$);
            }
            node.parentNode.insertBefore(childVNode.$elm$, node);
            node.remove();
            if (childVNode.$depth$ === "0") {
              shadowRootNodes[childVNode.$index$] = childVNode.$elm$;
            }
          }
          slotNodes.push(childVNode);
          if (!parentVNode.$children$) {
            parentVNode.$children$ = [];
          }
          parentVNode.$children$[childVNode.$index$] = childVNode;
        } else if (childNodeType === CONTENT_REF_ID) {
          if (BUILD.shadowDom && shadowRootNodes) {
            node.remove();
          } else if (BUILD.slotRelocation) {
            hostElm["s-cr"] = node;
            node["s-cn"] = true;
          }
        }
      }
    }
  } else if (parentVNode && parentVNode.$tag$ === "style") {
    const vnode = newVNode(null, node.textContent);
    vnode.$elm$ = node;
    vnode.$index$ = "0";
    parentVNode.$children$ = [vnode];
  }
};
var initializeDocumentHydrate = (node, orgLocNodes) => {
  if (node.nodeType === 1) {
    let i2 = 0;
    for (; i2 < node.childNodes.length; i2++) {
      initializeDocumentHydrate(node.childNodes[i2], orgLocNodes);
    }
    if (node.shadowRoot) {
      for (i2 = 0; i2 < node.shadowRoot.childNodes.length; i2++) {
        initializeDocumentHydrate(node.shadowRoot.childNodes[i2], orgLocNodes);
      }
    }
  } else if (node.nodeType === 8) {
    const childIdSplt = node.nodeValue.split(".");
    if (childIdSplt[0] === ORG_LOCATION_ID) {
      orgLocNodes.set(childIdSplt[1] + "." + childIdSplt[2], node);
      node.nodeValue = "";
      node["s-en"] = childIdSplt[3];
    }
  }
};
var computeMode = (elm) => modeResolutionChain.map((h2) => h2(elm)).find((m) => !!m);
var parsePropertyValue = (propValue, propType) => {
  if (propValue != null && !isComplexType(propValue)) {
    if (BUILD.propBoolean && propType & 4) {
      return propValue === "false" ? false : propValue === "" || !!propValue;
    }
    if (BUILD.propNumber && propType & 2) {
      return parseFloat(propValue);
    }
    if (BUILD.propString && propType & 1) {
      return String(propValue);
    }
    return propValue;
  }
  return propValue;
};
var emitEvent = (elm, name, opts) => {
  const ev = plt.ce(name, opts);
  elm.dispatchEvent(ev);
  return ev;
};
var rootAppliedStyles = /* @__PURE__ */ new WeakMap();
var registerStyle = (scopeId2, cssText, allowCS) => {
  let style = styles.get(scopeId2);
  if (supportsConstructableStylesheets && allowCS) {
    style = style || new CSSStyleSheet();
    if (typeof style === "string") {
      style = cssText;
    } else {
      style.replaceSync(cssText);
    }
  } else {
    style = cssText;
  }
  styles.set(scopeId2, style);
};
var addStyle = (styleContainerNode, cmpMeta, mode) => {
  var _a;
  const scopeId2 = getScopeId(cmpMeta, mode);
  const style = styles.get(scopeId2);
  if (!BUILD.attachStyles) {
    return scopeId2;
  }
  styleContainerNode = styleContainerNode.nodeType === 11 ? styleContainerNode : doc;
  if (style) {
    if (typeof style === "string") {
      styleContainerNode = styleContainerNode.head || styleContainerNode;
      let appliedStyles = rootAppliedStyles.get(styleContainerNode);
      let styleElm;
      if (!appliedStyles) {
        rootAppliedStyles.set(styleContainerNode, appliedStyles = /* @__PURE__ */ new Set());
      }
      if (!appliedStyles.has(scopeId2)) {
        if (BUILD.hydrateClientSide && styleContainerNode.host && (styleElm = styleContainerNode.querySelector(`[${HYDRATED_STYLE_ID}="${scopeId2}"]`))) {
          styleElm.innerHTML = style;
        } else {
          styleElm = doc.createElement("style");
          styleElm.innerHTML = style;
          const nonce = (_a = plt.$nonce$) != null ? _a : queryNonceMetaTagContent(doc);
          if (nonce != null) {
            styleElm.setAttribute("nonce", nonce);
          }
          if (BUILD.hydrateServerSide || BUILD.hotModuleReplacement) {
            styleElm.setAttribute(HYDRATED_STYLE_ID, scopeId2);
          }
          styleContainerNode.insertBefore(styleElm, styleContainerNode.querySelector("link"));
        }
        if (cmpMeta.$flags$ & 4) {
          styleElm.innerHTML += SLOT_FB_CSS;
        }
        if (appliedStyles) {
          appliedStyles.add(scopeId2);
        }
      }
    } else if (BUILD.constructableCSS && !styleContainerNode.adoptedStyleSheets.includes(style)) {
      styleContainerNode.adoptedStyleSheets = [...styleContainerNode.adoptedStyleSheets, style];
    }
  }
  return scopeId2;
};
var attachStyles = (hostRef) => {
  const cmpMeta = hostRef.$cmpMeta$;
  const elm = hostRef.$hostElement$;
  const flags = cmpMeta.$flags$;
  const endAttachStyles = createTime("attachStyles", cmpMeta.$tagName$);
  const scopeId2 = addStyle(
    BUILD.shadowDom && supportsShadow && elm.shadowRoot ? elm.shadowRoot : elm.getRootNode(),
    cmpMeta,
    hostRef.$modeName$
  );
  if ((BUILD.shadowDom || BUILD.scoped) && BUILD.cssAnnotations && flags & 10) {
    elm["s-sc"] = scopeId2;
    elm.classList.add(scopeId2 + "-h");
    if (BUILD.scoped && flags & 2) {
      elm.classList.add(scopeId2 + "-s");
    }
  }
  endAttachStyles();
};
var getScopeId = (cmp, mode) => "sc-" + (BUILD.mode && mode && cmp.$flags$ & 32 ? cmp.$tagName$ + "-" + mode : cmp.$tagName$);
var setAccessor = (elm, memberName, oldValue, newValue, isSvg, flags) => {
  if (oldValue !== newValue) {
    let isProp = isMemberInElement(elm, memberName);
    let ln = memberName.toLowerCase();
    if (BUILD.vdomClass && memberName === "class") {
      const classList = elm.classList;
      const oldClasses = parseClassList(oldValue);
      const newClasses = parseClassList(newValue);
      classList.remove(...oldClasses.filter((c) => c && !newClasses.includes(c)));
      classList.add(...newClasses.filter((c) => c && !oldClasses.includes(c)));
    } else if (BUILD.vdomStyle && memberName === "style") {
      if (BUILD.updatable) {
        for (const prop in oldValue) {
          if (!newValue || newValue[prop] == null) {
            if (!BUILD.hydrateServerSide && prop.includes("-")) {
              elm.style.removeProperty(prop);
            } else {
              elm.style[prop] = "";
            }
          }
        }
      }
      for (const prop in newValue) {
        if (!oldValue || newValue[prop] !== oldValue[prop]) {
          if (!BUILD.hydrateServerSide && prop.includes("-")) {
            elm.style.setProperty(prop, newValue[prop]);
          } else {
            elm.style[prop] = newValue[prop];
          }
        }
      }
    } else if (BUILD.vdomKey && memberName === "key") {
    } else if (BUILD.vdomRef && memberName === "ref") {
      if (newValue) {
        newValue(elm);
      }
    } else if (BUILD.vdomListener && (BUILD.lazyLoad ? !isProp : !elm.__lookupSetter__(memberName)) && memberName[0] === "o" && memberName[1] === "n") {
      if (memberName[2] === "-") {
        memberName = memberName.slice(3);
      } else if (isMemberInElement(win, ln)) {
        memberName = ln.slice(2);
      } else {
        memberName = ln[2] + memberName.slice(3);
      }
      if (oldValue || newValue) {
        const capture = memberName.endsWith(CAPTURE_EVENT_SUFFIX);
        memberName = memberName.replace(CAPTURE_EVENT_REGEX, "");
        if (oldValue) {
          plt.rel(elm, memberName, oldValue, capture);
        }
        if (newValue) {
          plt.ael(elm, memberName, newValue, capture);
        }
      }
    } else if (BUILD.vdomPropOrAttr) {
      const isComplex = isComplexType(newValue);
      if ((isProp || isComplex && newValue !== null) && !isSvg) {
        try {
          if (!elm.tagName.includes("-")) {
            const n = newValue == null ? "" : newValue;
            if (memberName === "list") {
              isProp = false;
            } else if (oldValue == null || elm[memberName] != n) {
              elm[memberName] = n;
            }
          } else {
            elm[memberName] = newValue;
          }
        } catch (e) {
        }
      }
      let xlink = false;
      if (BUILD.vdomXlink) {
        if (ln !== (ln = ln.replace(/^xlink\:?/, ""))) {
          memberName = ln;
          xlink = true;
        }
      }
      if (newValue == null || newValue === false) {
        if (newValue !== false || elm.getAttribute(memberName) === "") {
          if (BUILD.vdomXlink && xlink) {
            elm.removeAttributeNS(XLINK_NS, memberName);
          } else {
            elm.removeAttribute(memberName);
          }
        }
      } else if ((!isProp || flags & 4 || isSvg) && !isComplex) {
        newValue = newValue === true ? "" : newValue;
        if (BUILD.vdomXlink && xlink) {
          elm.setAttributeNS(XLINK_NS, memberName, newValue);
        } else {
          elm.setAttribute(memberName, newValue);
        }
      }
    }
  }
};
var parseClassListRegex = /\s/;
var parseClassList = (value) => !value ? [] : value.split(parseClassListRegex);
var CAPTURE_EVENT_SUFFIX = "Capture";
var CAPTURE_EVENT_REGEX = new RegExp(CAPTURE_EVENT_SUFFIX + "$");
var updateElement = (oldVnode, newVnode, isSvgMode2) => {
  const elm = newVnode.$elm$.nodeType === 11 && newVnode.$elm$.host ? newVnode.$elm$.host : newVnode.$elm$;
  const oldVnodeAttrs = oldVnode && oldVnode.$attrs$ || EMPTY_OBJ;
  const newVnodeAttrs = newVnode.$attrs$ || EMPTY_OBJ;
  if (BUILD.updatable) {
    for (const memberName of sortedAttrNames(Object.keys(oldVnodeAttrs))) {
      if (!(memberName in newVnodeAttrs)) {
        setAccessor(elm, memberName, oldVnodeAttrs[memberName], void 0, isSvgMode2, newVnode.$flags$);
      }
    }
  }
  for (const memberName of sortedAttrNames(Object.keys(newVnodeAttrs))) {
    setAccessor(elm, memberName, oldVnodeAttrs[memberName], newVnodeAttrs[memberName], isSvgMode2, newVnode.$flags$);
  }
};
function sortedAttrNames(attrNames) {
  return attrNames.includes("ref") ? (
    // we need to sort these to ensure that `'ref'` is the last attr
    [...attrNames.filter((attr) => attr !== "ref"), "ref"]
  ) : (
    // no need to sort, return the original array
    attrNames
  );
}
var scopeId;
var contentRef;
var hostTagName;
var useNativeShadowDom = false;
var checkSlotFallbackVisibility = false;
var checkSlotRelocate = false;
var isSvgMode = false;
var createElm = (oldParentVNode, newParentVNode, childIndex, parentElm) => {
  var _a;
  const newVNode2 = newParentVNode.$children$[childIndex];
  let i2 = 0;
  let elm;
  let childNode;
  let oldVNode;
  if (BUILD.slotRelocation && !useNativeShadowDom) {
    checkSlotRelocate = true;
    if (newVNode2.$tag$ === "slot") {
      if (scopeId) {
        parentElm.classList.add(scopeId + "-s");
      }
      newVNode2.$flags$ |= newVNode2.$children$ ? (
        // slot element has fallback content
        // still create an element that "mocks" the slot element
        2
      ) : (
        // slot element does not have fallback content
        // create an html comment we'll use to always reference
        // where actual slot content should sit next to
        1
      );
    }
  }
  if (BUILD.isDev && newVNode2.$elm$) {
    consoleDevError(
      `The JSX ${newVNode2.$text$ !== null ? `"${newVNode2.$text$}" text` : `"${newVNode2.$tag$}" element`} node should not be shared within the same renderer. The renderer caches element lookups in order to improve performance. However, a side effect from this is that the exact same JSX node should not be reused. For more information please see https://stenciljs.com/docs/templating-jsx#avoid-shared-jsx-nodes`
    );
  }
  if (BUILD.vdomText && newVNode2.$text$ !== null) {
    elm = newVNode2.$elm$ = doc.createTextNode(newVNode2.$text$);
  } else if (BUILD.slotRelocation && newVNode2.$flags$ & 1) {
    elm = newVNode2.$elm$ = BUILD.isDebug || BUILD.hydrateServerSide ? slotReferenceDebugNode(newVNode2) : doc.createTextNode("");
  } else {
    if (BUILD.svg && !isSvgMode) {
      isSvgMode = newVNode2.$tag$ === "svg";
    }
    elm = newVNode2.$elm$ = BUILD.svg ? doc.createElementNS(
      isSvgMode ? SVG_NS : HTML_NS,
      BUILD.slotRelocation && newVNode2.$flags$ & 2 ? "slot-fb" : newVNode2.$tag$
    ) : doc.createElement(
      BUILD.slotRelocation && newVNode2.$flags$ & 2 ? "slot-fb" : newVNode2.$tag$
    );
    if (BUILD.svg && isSvgMode && newVNode2.$tag$ === "foreignObject") {
      isSvgMode = false;
    }
    if (BUILD.vdomAttribute) {
      updateElement(null, newVNode2, isSvgMode);
    }
    if ((BUILD.shadowDom || BUILD.scoped) && isDef(scopeId) && elm["s-si"] !== scopeId) {
      elm.classList.add(elm["s-si"] = scopeId);
    }
    if (newVNode2.$children$) {
      for (i2 = 0; i2 < newVNode2.$children$.length; ++i2) {
        childNode = createElm(oldParentVNode, newVNode2, i2, elm);
        if (childNode) {
          elm.appendChild(childNode);
        }
      }
    }
    if (BUILD.svg) {
      if (newVNode2.$tag$ === "svg") {
        isSvgMode = false;
      } else if (elm.tagName === "foreignObject") {
        isSvgMode = true;
      }
    }
  }
  elm["s-hn"] = hostTagName;
  if (BUILD.slotRelocation) {
    if (newVNode2.$flags$ & (2 | 1)) {
      elm["s-sr"] = true;
      elm["s-cr"] = contentRef;
      elm["s-sn"] = newVNode2.$name$ || "";
      elm["s-rf"] = (_a = newVNode2.$attrs$) == null ? void 0 : _a.ref;
      oldVNode = oldParentVNode && oldParentVNode.$children$ && oldParentVNode.$children$[childIndex];
      if (oldVNode && oldVNode.$tag$ === newVNode2.$tag$ && oldParentVNode.$elm$) {
        if (BUILD.experimentalSlotFixes) {
          relocateToHostRoot(oldParentVNode.$elm$);
        } else {
          putBackInOriginalLocation(oldParentVNode.$elm$, false);
        }
      }
    }
  }
  return elm;
};
var relocateToHostRoot = (parentElm) => {
  plt.$flags$ |= 1;
  const host = parentElm.closest(hostTagName.toLowerCase());
  if (host != null) {
    const contentRefNode = Array.from(host.childNodes).find((ref) => ref["s-cr"]);
    const childNodeArray = Array.from(parentElm.childNodes);
    for (const childNode of contentRefNode ? childNodeArray.reverse() : childNodeArray) {
      if (childNode["s-sh"] != null) {
        host.insertBefore(childNode, contentRefNode != null ? contentRefNode : null);
        childNode["s-sh"] = void 0;
        checkSlotRelocate = true;
      }
    }
  }
  plt.$flags$ &= ~1;
};
var putBackInOriginalLocation = (parentElm, recursive) => {
  plt.$flags$ |= 1;
  const oldSlotChildNodes = Array.from(parentElm.childNodes);
  if (parentElm["s-sr"] && BUILD.experimentalSlotFixes) {
    let node = parentElm;
    while (node = node.nextSibling) {
      if (node && node["s-sn"] === parentElm["s-sn"] && node["s-sh"] === hostTagName) {
        oldSlotChildNodes.push(node);
      }
    }
  }
  for (let i2 = oldSlotChildNodes.length - 1; i2 >= 0; i2--) {
    const childNode = oldSlotChildNodes[i2];
    if (childNode["s-hn"] !== hostTagName && childNode["s-ol"]) {
      parentReferenceNode(childNode).insertBefore(childNode, referenceNode(childNode));
      childNode["s-ol"].remove();
      childNode["s-ol"] = void 0;
      childNode["s-sh"] = void 0;
      checkSlotRelocate = true;
    }
    if (recursive) {
      putBackInOriginalLocation(childNode, recursive);
    }
  }
  plt.$flags$ &= ~1;
};
var addVnodes = (parentElm, before, parentVNode, vnodes, startIdx, endIdx) => {
  let containerElm = BUILD.slotRelocation && parentElm["s-cr"] && parentElm["s-cr"].parentNode || parentElm;
  let childNode;
  if (BUILD.shadowDom && containerElm.shadowRoot && containerElm.tagName === hostTagName) {
    containerElm = containerElm.shadowRoot;
  }
  for (; startIdx <= endIdx; ++startIdx) {
    if (vnodes[startIdx]) {
      childNode = createElm(null, parentVNode, startIdx, parentElm);
      if (childNode) {
        vnodes[startIdx].$elm$ = childNode;
        containerElm.insertBefore(childNode, BUILD.slotRelocation ? referenceNode(before) : before);
      }
    }
  }
};
var removeVnodes = (vnodes, startIdx, endIdx) => {
  for (let index = startIdx; index <= endIdx; ++index) {
    const vnode = vnodes[index];
    if (vnode) {
      const elm = vnode.$elm$;
      nullifyVNodeRefs(vnode);
      if (elm) {
        if (BUILD.slotRelocation) {
          checkSlotFallbackVisibility = true;
          if (elm["s-ol"]) {
            elm["s-ol"].remove();
          } else {
            putBackInOriginalLocation(elm, true);
          }
        }
        elm.remove();
      }
    }
  }
};
var updateChildren = (parentElm, oldCh, newVNode2, newCh, isInitialRender = false) => {
  let oldStartIdx = 0;
  let newStartIdx = 0;
  let idxInOld = 0;
  let i2 = 0;
  let oldEndIdx = oldCh.length - 1;
  let oldStartVnode = oldCh[0];
  let oldEndVnode = oldCh[oldEndIdx];
  let newEndIdx = newCh.length - 1;
  let newStartVnode = newCh[0];
  let newEndVnode = newCh[newEndIdx];
  let node;
  let elmToMove;
  while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
    if (oldStartVnode == null) {
      oldStartVnode = oldCh[++oldStartIdx];
    } else if (oldEndVnode == null) {
      oldEndVnode = oldCh[--oldEndIdx];
    } else if (newStartVnode == null) {
      newStartVnode = newCh[++newStartIdx];
    } else if (newEndVnode == null) {
      newEndVnode = newCh[--newEndIdx];
    } else if (isSameVnode(oldStartVnode, newStartVnode, isInitialRender)) {
      patch(oldStartVnode, newStartVnode, isInitialRender);
      oldStartVnode = oldCh[++oldStartIdx];
      newStartVnode = newCh[++newStartIdx];
    } else if (isSameVnode(oldEndVnode, newEndVnode, isInitialRender)) {
      patch(oldEndVnode, newEndVnode, isInitialRender);
      oldEndVnode = oldCh[--oldEndIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (isSameVnode(oldStartVnode, newEndVnode, isInitialRender)) {
      if (BUILD.slotRelocation && (oldStartVnode.$tag$ === "slot" || newEndVnode.$tag$ === "slot")) {
        putBackInOriginalLocation(oldStartVnode.$elm$.parentNode, false);
      }
      patch(oldStartVnode, newEndVnode, isInitialRender);
      parentElm.insertBefore(oldStartVnode.$elm$, oldEndVnode.$elm$.nextSibling);
      oldStartVnode = oldCh[++oldStartIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (isSameVnode(oldEndVnode, newStartVnode, isInitialRender)) {
      if (BUILD.slotRelocation && (oldStartVnode.$tag$ === "slot" || newEndVnode.$tag$ === "slot")) {
        putBackInOriginalLocation(oldEndVnode.$elm$.parentNode, false);
      }
      patch(oldEndVnode, newStartVnode, isInitialRender);
      parentElm.insertBefore(oldEndVnode.$elm$, oldStartVnode.$elm$);
      oldEndVnode = oldCh[--oldEndIdx];
      newStartVnode = newCh[++newStartIdx];
    } else {
      idxInOld = -1;
      if (BUILD.vdomKey) {
        for (i2 = oldStartIdx; i2 <= oldEndIdx; ++i2) {
          if (oldCh[i2] && oldCh[i2].$key$ !== null && oldCh[i2].$key$ === newStartVnode.$key$) {
            idxInOld = i2;
            break;
          }
        }
      }
      if (BUILD.vdomKey && idxInOld >= 0) {
        elmToMove = oldCh[idxInOld];
        if (elmToMove.$tag$ !== newStartVnode.$tag$) {
          node = createElm(oldCh && oldCh[newStartIdx], newVNode2, idxInOld, parentElm);
        } else {
          patch(elmToMove, newStartVnode, isInitialRender);
          oldCh[idxInOld] = void 0;
          node = elmToMove.$elm$;
        }
        newStartVnode = newCh[++newStartIdx];
      } else {
        node = createElm(oldCh && oldCh[newStartIdx], newVNode2, newStartIdx, parentElm);
        newStartVnode = newCh[++newStartIdx];
      }
      if (node) {
        if (BUILD.slotRelocation) {
          parentReferenceNode(oldStartVnode.$elm$).insertBefore(node, referenceNode(oldStartVnode.$elm$));
        } else {
          oldStartVnode.$elm$.parentNode.insertBefore(node, oldStartVnode.$elm$);
        }
      }
    }
  }
  if (oldStartIdx > oldEndIdx) {
    addVnodes(
      parentElm,
      newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].$elm$,
      newVNode2,
      newCh,
      newStartIdx,
      newEndIdx
    );
  } else if (BUILD.updatable && newStartIdx > newEndIdx) {
    removeVnodes(oldCh, oldStartIdx, oldEndIdx);
  }
};
var isSameVnode = (leftVNode, rightVNode, isInitialRender = false) => {
  if (leftVNode.$tag$ === rightVNode.$tag$) {
    if (BUILD.slotRelocation && leftVNode.$tag$ === "slot") {
      return leftVNode.$name$ === rightVNode.$name$;
    }
    if (BUILD.vdomKey && !isInitialRender) {
      return leftVNode.$key$ === rightVNode.$key$;
    }
    return true;
  }
  return false;
};
var referenceNode = (node) => {
  return node && node["s-ol"] || node;
};
var parentReferenceNode = (node) => (node["s-ol"] ? node["s-ol"] : node).parentNode;
var patch = (oldVNode, newVNode2, isInitialRender = false) => {
  const elm = newVNode2.$elm$ = oldVNode.$elm$;
  const oldChildren = oldVNode.$children$;
  const newChildren = newVNode2.$children$;
  const tag = newVNode2.$tag$;
  const text = newVNode2.$text$;
  let defaultHolder;
  if (!BUILD.vdomText || text === null) {
    if (BUILD.svg) {
      isSvgMode = tag === "svg" ? true : tag === "foreignObject" ? false : isSvgMode;
    }
    if (BUILD.vdomAttribute || BUILD.reflect) {
      if (BUILD.slot && tag === "slot" && !useNativeShadowDom) {
        if (BUILD.experimentalSlotFixes && oldVNode.$name$ !== newVNode2.$name$) {
          newVNode2.$elm$["s-sn"] = newVNode2.$name$ || "";
          relocateToHostRoot(newVNode2.$elm$.parentElement);
        }
      } else {
        updateElement(oldVNode, newVNode2, isSvgMode);
      }
    }
    if (BUILD.updatable && oldChildren !== null && newChildren !== null) {
      updateChildren(elm, oldChildren, newVNode2, newChildren, isInitialRender);
    } else if (newChildren !== null) {
      if (BUILD.updatable && BUILD.vdomText && oldVNode.$text$ !== null) {
        elm.textContent = "";
      }
      addVnodes(elm, null, newVNode2, newChildren, 0, newChildren.length - 1);
    } else if (BUILD.updatable && oldChildren !== null) {
      removeVnodes(oldChildren, 0, oldChildren.length - 1);
    }
    if (BUILD.svg && isSvgMode && tag === "svg") {
      isSvgMode = false;
    }
  } else if (BUILD.vdomText && BUILD.slotRelocation && (defaultHolder = elm["s-cr"])) {
    defaultHolder.parentNode.textContent = text;
  } else if (BUILD.vdomText && oldVNode.$text$ !== text) {
    elm.data = text;
  }
};
var updateFallbackSlotVisibility = (elm) => {
  const childNodes = elm.childNodes;
  for (const childNode of childNodes) {
    if (childNode.nodeType === 1) {
      if (childNode["s-sr"]) {
        const slotName = childNode["s-sn"];
        childNode.hidden = false;
        for (const siblingNode of childNodes) {
          if (siblingNode !== childNode) {
            if (siblingNode["s-hn"] !== childNode["s-hn"] || slotName !== "") {
              if (siblingNode.nodeType === 1 && (slotName === siblingNode.getAttribute("slot") || slotName === siblingNode["s-sn"]) || siblingNode.nodeType === 3 && slotName === siblingNode["s-sn"]) {
                childNode.hidden = true;
                break;
              }
            } else {
              if (siblingNode.nodeType === 1 || siblingNode.nodeType === 3 && siblingNode.textContent.trim() !== "") {
                childNode.hidden = true;
                break;
              }
            }
          }
        }
      }
      updateFallbackSlotVisibility(childNode);
    }
  }
};
var relocateNodes = [];
var markSlotContentForRelocation = (elm) => {
  let node;
  let hostContentNodes;
  let j;
  for (const childNode of elm.childNodes) {
    if (childNode["s-sr"] && (node = childNode["s-cr"]) && node.parentNode) {
      hostContentNodes = node.parentNode.childNodes;
      const slotName = childNode["s-sn"];
      for (j = hostContentNodes.length - 1; j >= 0; j--) {
        node = hostContentNodes[j];
        if (!node["s-cn"] && !node["s-nr"] && node["s-hn"] !== childNode["s-hn"] && (!BUILD.experimentalSlotFixes || !node["s-sh"] || node["s-sh"] !== childNode["s-hn"])) {
          if (isNodeLocatedInSlot(node, slotName)) {
            let relocateNodeData = relocateNodes.find((r) => r.$nodeToRelocate$ === node);
            checkSlotFallbackVisibility = true;
            node["s-sn"] = node["s-sn"] || slotName;
            if (relocateNodeData) {
              relocateNodeData.$nodeToRelocate$["s-sh"] = childNode["s-hn"];
              relocateNodeData.$slotRefNode$ = childNode;
            } else {
              node["s-sh"] = childNode["s-hn"];
              relocateNodes.push({
                $slotRefNode$: childNode,
                $nodeToRelocate$: node
              });
            }
            if (node["s-sr"]) {
              relocateNodes.map((relocateNode) => {
                if (isNodeLocatedInSlot(relocateNode.$nodeToRelocate$, node["s-sn"])) {
                  relocateNodeData = relocateNodes.find((r) => r.$nodeToRelocate$ === node);
                  if (relocateNodeData && !relocateNode.$slotRefNode$) {
                    relocateNode.$slotRefNode$ = relocateNodeData.$slotRefNode$;
                  }
                }
              });
            }
          } else if (!relocateNodes.some((r) => r.$nodeToRelocate$ === node)) {
            relocateNodes.push({
              $nodeToRelocate$: node
            });
          }
        }
      }
    }
    if (childNode.nodeType === 1) {
      markSlotContentForRelocation(childNode);
    }
  }
};
var isNodeLocatedInSlot = (nodeToRelocate, slotName) => {
  if (nodeToRelocate.nodeType === 1) {
    if (nodeToRelocate.getAttribute("slot") === null && slotName === "") {
      return true;
    }
    if (nodeToRelocate.getAttribute("slot") === slotName) {
      return true;
    }
    return false;
  }
  if (nodeToRelocate["s-sn"] === slotName) {
    return true;
  }
  return slotName === "";
};
var nullifyVNodeRefs = (vNode) => {
  if (BUILD.vdomRef) {
    vNode.$attrs$ && vNode.$attrs$.ref && vNode.$attrs$.ref(null);
    vNode.$children$ && vNode.$children$.map(nullifyVNodeRefs);
  }
};
var renderVdom = (hostRef, renderFnResults, isInitialLoad = false) => {
  var _a, _b, _c, _d, _e;
  const hostElm = hostRef.$hostElement$;
  const cmpMeta = hostRef.$cmpMeta$;
  const oldVNode = hostRef.$vnode$ || newVNode(null, null);
  const rootVnode = isHost(renderFnResults) ? renderFnResults : h(null, null, renderFnResults);
  hostTagName = hostElm.tagName;
  if (BUILD.isDev && Array.isArray(renderFnResults) && renderFnResults.some(isHost)) {
    throw new Error(`The <Host> must be the single root component.
Looks like the render() function of "${hostTagName.toLowerCase()}" is returning an array that contains the <Host>.

The render() function should look like this instead:

render() {
  // Do not return an array
  return (
    <Host>{content}</Host>
  );
}
  `);
  }
  if (BUILD.reflect && cmpMeta.$attrsToReflect$) {
    rootVnode.$attrs$ = rootVnode.$attrs$ || {};
    cmpMeta.$attrsToReflect$.map(
      ([propName, attribute]) => rootVnode.$attrs$[attribute] = hostElm[propName]
    );
  }
  if (isInitialLoad && rootVnode.$attrs$) {
    for (const key of Object.keys(rootVnode.$attrs$)) {
      if (hostElm.hasAttribute(key) && !["key", "ref", "style", "class"].includes(key)) {
        rootVnode.$attrs$[key] = hostElm[key];
      }
    }
  }
  rootVnode.$tag$ = null;
  rootVnode.$flags$ |= 4;
  hostRef.$vnode$ = rootVnode;
  rootVnode.$elm$ = oldVNode.$elm$ = BUILD.shadowDom ? hostElm.shadowRoot || hostElm : hostElm;
  if (BUILD.scoped || BUILD.shadowDom) {
    scopeId = hostElm["s-sc"];
  }
  useNativeShadowDom = supportsShadow && (cmpMeta.$flags$ & 1) !== 0;
  if (BUILD.slotRelocation) {
    contentRef = hostElm["s-cr"];
    checkSlotFallbackVisibility = false;
  }
  patch(oldVNode, rootVnode, isInitialLoad);
  if (BUILD.slotRelocation) {
    plt.$flags$ |= 1;
    if (checkSlotRelocate) {
      markSlotContentForRelocation(rootVnode.$elm$);
      for (const relocateData of relocateNodes) {
        const nodeToRelocate = relocateData.$nodeToRelocate$;
        if (!nodeToRelocate["s-ol"]) {
          const orgLocationNode = BUILD.isDebug || BUILD.hydrateServerSide ? originalLocationDebugNode(nodeToRelocate) : doc.createTextNode("");
          orgLocationNode["s-nr"] = nodeToRelocate;
          nodeToRelocate.parentNode.insertBefore(nodeToRelocate["s-ol"] = orgLocationNode, nodeToRelocate);
        }
      }
      for (const relocateData of relocateNodes) {
        const nodeToRelocate = relocateData.$nodeToRelocate$;
        const slotRefNode = relocateData.$slotRefNode$;
        if (slotRefNode) {
          const parentNodeRef = slotRefNode.parentNode;
          let insertBeforeNode = slotRefNode.nextSibling;
          if (!BUILD.experimentalSlotFixes || insertBeforeNode && insertBeforeNode.nodeType === 1) {
            let orgLocationNode = (_a = nodeToRelocate["s-ol"]) == null ? void 0 : _a.previousSibling;
            while (orgLocationNode) {
              let refNode = (_b = orgLocationNode["s-nr"]) != null ? _b : null;
              if (refNode && refNode["s-sn"] === nodeToRelocate["s-sn"] && parentNodeRef === refNode.parentNode) {
                refNode = refNode.nextSibling;
                while (refNode === nodeToRelocate || (refNode == null ? void 0 : refNode["s-sr"])) {
                  refNode = refNode == null ? void 0 : refNode.nextSibling;
                }
                if (!refNode || !refNode["s-nr"]) {
                  insertBeforeNode = refNode;
                  break;
                }
              }
              orgLocationNode = orgLocationNode.previousSibling;
            }
          }
          if (!insertBeforeNode && parentNodeRef !== nodeToRelocate.parentNode || nodeToRelocate.nextSibling !== insertBeforeNode) {
            if (nodeToRelocate !== insertBeforeNode) {
              if (!BUILD.experimentalSlotFixes && !nodeToRelocate["s-hn"] && nodeToRelocate["s-ol"]) {
                nodeToRelocate["s-hn"] = nodeToRelocate["s-ol"].parentNode.nodeName;
              }
              parentNodeRef.insertBefore(nodeToRelocate, insertBeforeNode);
              if (nodeToRelocate.nodeType === 1) {
                nodeToRelocate.hidden = (_c = nodeToRelocate["s-ih"]) != null ? _c : false;
              }
            }
          }
          nodeToRelocate && typeof slotRefNode["s-rf"] === "function" && slotRefNode["s-rf"](nodeToRelocate);
        } else {
          if (nodeToRelocate.nodeType === 1) {
            if (isInitialLoad) {
              nodeToRelocate["s-ih"] = (_d = nodeToRelocate.hidden) != null ? _d : false;
            }
            nodeToRelocate.hidden = true;
          }
        }
      }
    }
    if (checkSlotFallbackVisibility) {
      updateFallbackSlotVisibility(rootVnode.$elm$);
    }
    plt.$flags$ &= ~1;
    relocateNodes.length = 0;
  }
  if (BUILD.experimentalScopedSlotChanges && cmpMeta.$flags$ & 2) {
    for (const childNode of rootVnode.$elm$.childNodes) {
      if (childNode["s-hn"] !== hostTagName && !childNode["s-sh"]) {
        if (isInitialLoad && childNode["s-ih"] == null) {
          childNode["s-ih"] = (_e = childNode.hidden) != null ? _e : false;
        }
        childNode.hidden = true;
      }
    }
  }
  contentRef = void 0;
};
var slotReferenceDebugNode = (slotVNode) => doc.createComment(
  `<slot${slotVNode.$name$ ? ' name="' + slotVNode.$name$ + '"' : ""}> (host=${hostTagName.toLowerCase()})`
);
var originalLocationDebugNode = (nodeToRelocate) => doc.createComment(
  `org-location for ` + (nodeToRelocate.localName ? `<${nodeToRelocate.localName}> (host=${nodeToRelocate["s-hn"]})` : `[${nodeToRelocate.textContent}]`)
);
var attachToAncestor = (hostRef, ancestorComponent) => {
  if (BUILD.asyncLoading && ancestorComponent && !hostRef.$onRenderResolve$ && ancestorComponent["s-p"]) {
    ancestorComponent["s-p"].push(new Promise((r) => hostRef.$onRenderResolve$ = r));
  }
};
var scheduleUpdate = (hostRef, isInitialLoad) => {
  if (BUILD.taskQueue && BUILD.updatable) {
    hostRef.$flags$ |= 16;
  }
  if (BUILD.asyncLoading && hostRef.$flags$ & 4) {
    hostRef.$flags$ |= 512;
    return;
  }
  attachToAncestor(hostRef, hostRef.$ancestorComponent$);
  const dispatch = () => dispatchHooks(hostRef, isInitialLoad);
  return BUILD.taskQueue ? writeTask(dispatch) : dispatch();
};
var dispatchHooks = (hostRef, isInitialLoad) => {
  const elm = hostRef.$hostElement$;
  const endSchedule = createTime("scheduleUpdate", hostRef.$cmpMeta$.$tagName$);
  const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
  let maybePromise;
  if (isInitialLoad) {
    if (BUILD.lazyLoad && BUILD.hostListener) {
      hostRef.$flags$ |= 256;
      if (hostRef.$queuedListeners$) {
        hostRef.$queuedListeners$.map(([methodName, event]) => safeCall(instance, methodName, event));
        hostRef.$queuedListeners$ = void 0;
      }
    }
    emitLifecycleEvent(elm, "componentWillLoad");
    if (BUILD.cmpWillLoad) {
      maybePromise = safeCall(instance, "componentWillLoad");
    }
  } else {
    emitLifecycleEvent(elm, "componentWillUpdate");
    if (BUILD.cmpWillUpdate) {
      maybePromise = safeCall(instance, "componentWillUpdate");
    }
  }
  emitLifecycleEvent(elm, "componentWillRender");
  if (BUILD.cmpWillRender) {
    maybePromise = enqueue(maybePromise, () => safeCall(instance, "componentWillRender"));
  }
  endSchedule();
  return enqueue(maybePromise, () => updateComponent(hostRef, instance, isInitialLoad));
};
var enqueue = (maybePromise, fn) => isPromisey(maybePromise) ? maybePromise.then(fn) : fn();
var isPromisey = (maybePromise) => maybePromise instanceof Promise || maybePromise && maybePromise.then && typeof maybePromise.then === "function";
var updateComponent = async (hostRef, instance, isInitialLoad) => {
  var _a;
  const elm = hostRef.$hostElement$;
  const endUpdate = createTime("update", hostRef.$cmpMeta$.$tagName$);
  const rc = elm["s-rc"];
  if (BUILD.style && isInitialLoad) {
    attachStyles(hostRef);
  }
  const endRender = createTime("render", hostRef.$cmpMeta$.$tagName$);
  if (BUILD.isDev) {
    hostRef.$flags$ |= 1024;
  }
  if (BUILD.hydrateServerSide) {
    await callRender(hostRef, instance, elm, isInitialLoad);
  } else {
    callRender(hostRef, instance, elm, isInitialLoad);
  }
  if (BUILD.isDev) {
    hostRef.$renderCount$ = hostRef.$renderCount$ === void 0 ? 1 : hostRef.$renderCount$ + 1;
    hostRef.$flags$ &= ~1024;
  }
  if (BUILD.hydrateServerSide) {
    try {
      serverSideConnected(elm);
      if (isInitialLoad) {
        if (hostRef.$cmpMeta$.$flags$ & 1) {
          elm["s-en"] = "";
        } else if (hostRef.$cmpMeta$.$flags$ & 2) {
          elm["s-en"] = "c";
        }
      }
    } catch (e) {
      consoleError(e, elm);
    }
  }
  if (BUILD.asyncLoading && rc) {
    rc.map((cb) => cb());
    elm["s-rc"] = void 0;
  }
  endRender();
  endUpdate();
  if (BUILD.asyncLoading) {
    const childrenPromises = (_a = elm["s-p"]) != null ? _a : [];
    const postUpdate = () => postUpdateComponent(hostRef);
    if (childrenPromises.length === 0) {
      postUpdate();
    } else {
      Promise.all(childrenPromises).then(postUpdate);
      hostRef.$flags$ |= 4;
      childrenPromises.length = 0;
    }
  } else {
    postUpdateComponent(hostRef);
  }
};
var renderingRef = null;
var callRender = (hostRef, instance, elm, isInitialLoad) => {
  const allRenderFn = BUILD.allRenderFn ? true : false;
  const lazyLoad = BUILD.lazyLoad ? true : false;
  const taskQueue = BUILD.taskQueue ? true : false;
  const updatable = BUILD.updatable ? true : false;
  try {
    renderingRef = instance;
    instance = allRenderFn ? instance.render() : instance.render && instance.render();
    if (updatable && taskQueue) {
      hostRef.$flags$ &= ~16;
    }
    if (updatable || lazyLoad) {
      hostRef.$flags$ |= 2;
    }
    if (BUILD.hasRenderFn || BUILD.reflect) {
      if (BUILD.vdomRender || BUILD.reflect) {
        if (BUILD.hydrateServerSide) {
          return Promise.resolve(instance).then((value) => renderVdom(hostRef, value, isInitialLoad));
        } else {
          renderVdom(hostRef, instance, isInitialLoad);
        }
      } else {
        const shadowRoot = elm.shadowRoot;
        if (hostRef.$cmpMeta$.$flags$ & 1) {
          shadowRoot.textContent = instance;
        } else {
          elm.textContent = instance;
        }
      }
    }
  } catch (e) {
    consoleError(e, hostRef.$hostElement$);
  }
  renderingRef = null;
  return null;
};
var postUpdateComponent = (hostRef) => {
  const tagName = hostRef.$cmpMeta$.$tagName$;
  const elm = hostRef.$hostElement$;
  const endPostUpdate = createTime("postUpdate", tagName);
  const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
  const ancestorComponent = hostRef.$ancestorComponent$;
  if (BUILD.cmpDidRender) {
    if (BUILD.isDev) {
      hostRef.$flags$ |= 1024;
    }
    safeCall(instance, "componentDidRender");
    if (BUILD.isDev) {
      hostRef.$flags$ &= ~1024;
    }
  }
  emitLifecycleEvent(elm, "componentDidRender");
  if (!(hostRef.$flags$ & 64)) {
    hostRef.$flags$ |= 64;
    if (BUILD.asyncLoading && BUILD.cssAnnotations) {
      addHydratedFlag(elm);
    }
    if (BUILD.cmpDidLoad) {
      if (BUILD.isDev) {
        hostRef.$flags$ |= 2048;
      }
      safeCall(instance, "componentDidLoad");
      if (BUILD.isDev) {
        hostRef.$flags$ &= ~2048;
      }
    }
    emitLifecycleEvent(elm, "componentDidLoad");
    endPostUpdate();
    if (BUILD.asyncLoading) {
      hostRef.$onReadyResolve$(elm);
      if (!ancestorComponent) {
        appDidLoad(tagName);
      }
    }
  } else {
    if (BUILD.cmpDidUpdate) {
      if (BUILD.isDev) {
        hostRef.$flags$ |= 1024;
      }
      safeCall(instance, "componentDidUpdate");
      if (BUILD.isDev) {
        hostRef.$flags$ &= ~1024;
      }
    }
    emitLifecycleEvent(elm, "componentDidUpdate");
    endPostUpdate();
  }
  if (BUILD.method && BUILD.lazyLoad) {
    hostRef.$onInstanceResolve$(elm);
  }
  if (BUILD.asyncLoading) {
    if (hostRef.$onRenderResolve$) {
      hostRef.$onRenderResolve$();
      hostRef.$onRenderResolve$ = void 0;
    }
    if (hostRef.$flags$ & 512) {
      nextTick(() => scheduleUpdate(hostRef, false));
    }
    hostRef.$flags$ &= ~(4 | 512);
  }
};
var appDidLoad = (who) => {
  if (BUILD.cssAnnotations) {
    addHydratedFlag(doc.documentElement);
  }
  if (BUILD.asyncQueue) {
    plt.$flags$ |= 2;
  }
  nextTick(() => emitEvent(win, "appload", { detail: { namespace: NAMESPACE } }));
  if (BUILD.profile && performance.measure) {
    performance.measure(`[Stencil] ${NAMESPACE} initial load (by ${who})`, "st:app:start");
  }
};
var safeCall = (instance, method, arg) => {
  if (instance && instance[method]) {
    try {
      return instance[method](arg);
    } catch (e) {
      consoleError(e);
    }
  }
  return void 0;
};
var emitLifecycleEvent = (elm, lifecycleName) => {
  if (BUILD.lifecycleDOMEvents) {
    emitEvent(elm, "stencil_" + lifecycleName, {
      bubbles: true,
      composed: true,
      detail: {
        namespace: NAMESPACE
      }
    });
  }
};
var addHydratedFlag = (elm) => BUILD.hydratedClass ? elm.classList.add("hydrated") : BUILD.hydratedAttribute ? elm.setAttribute("hydrated", "") : void 0;
var serverSideConnected = (elm) => {
  const children = elm.children;
  if (children != null) {
    for (let i2 = 0, ii = children.length; i2 < ii; i2++) {
      const childElm = children[i2];
      if (typeof childElm.connectedCallback === "function") {
        childElm.connectedCallback();
      }
      serverSideConnected(childElm);
    }
  }
};
var getValue = (ref, propName) => getHostRef(ref).$instanceValues$.get(propName);
var setValue = (ref, propName, newVal, cmpMeta) => {
  const hostRef = getHostRef(ref);
  const elm = BUILD.lazyLoad ? hostRef.$hostElement$ : ref;
  const oldVal = hostRef.$instanceValues$.get(propName);
  const flags = hostRef.$flags$;
  const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
  newVal = parsePropertyValue(newVal, cmpMeta.$members$[propName][0]);
  const areBothNaN = Number.isNaN(oldVal) && Number.isNaN(newVal);
  const didValueChange = newVal !== oldVal && !areBothNaN;
  if ((!BUILD.lazyLoad || !(flags & 8) || oldVal === void 0) && didValueChange) {
    hostRef.$instanceValues$.set(propName, newVal);
    if (BUILD.isDev) {
      if (hostRef.$flags$ & 1024) {
        consoleDevWarn(
          `The state/prop "${propName}" changed during rendering. This can potentially lead to infinite-loops and other bugs.`,
          "\nElement",
          elm,
          "\nNew value",
          newVal,
          "\nOld value",
          oldVal
        );
      } else if (hostRef.$flags$ & 2048) {
        consoleDevWarn(
          `The state/prop "${propName}" changed during "componentDidLoad()", this triggers extra re-renders, try to setup on "componentWillLoad()"`,
          "\nElement",
          elm,
          "\nNew value",
          newVal,
          "\nOld value",
          oldVal
        );
      }
    }
    if (!BUILD.lazyLoad || instance) {
      if (BUILD.watchCallback && cmpMeta.$watchers$ && flags & 128) {
        const watchMethods = cmpMeta.$watchers$[propName];
        if (watchMethods) {
          watchMethods.map((watchMethodName) => {
            try {
              instance[watchMethodName](newVal, oldVal, propName);
            } catch (e) {
              consoleError(e, elm);
            }
          });
        }
      }
      if (BUILD.updatable && (flags & (2 | 16)) === 2) {
        if (BUILD.cmpShouldUpdate && instance.componentShouldUpdate) {
          if (instance.componentShouldUpdate(newVal, oldVal, propName) === false) {
            return;
          }
        }
        scheduleUpdate(hostRef, false);
      }
    }
  }
};
var proxyComponent = (Cstr, cmpMeta, flags) => {
  var _a;
  const prototype = Cstr.prototype;
  if (BUILD.formAssociated && cmpMeta.$flags$ & 64 && flags & 1) {
    FORM_ASSOCIATED_CUSTOM_ELEMENT_CALLBACKS.forEach(
      (cbName) => Object.defineProperty(prototype, cbName, {
        value(...args) {
          const hostRef = getHostRef(this);
          const elm = BUILD.lazyLoad ? hostRef.$hostElement$ : this;
          const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
          if (!instance) {
            hostRef.$onReadyPromise$.then((instance2) => {
              const cb = instance2[cbName];
              typeof cb === "function" && cb.call(instance2, ...args);
            });
          } else {
            const cb = instance[cbName];
            typeof cb === "function" && cb.call(instance, ...args);
          }
        }
      })
    );
  }
  if (BUILD.member && cmpMeta.$members$) {
    if (BUILD.watchCallback && Cstr.watchers) {
      cmpMeta.$watchers$ = Cstr.watchers;
    }
    const members = Object.entries(cmpMeta.$members$);
    members.map(([memberName, [memberFlags]]) => {
      if ((BUILD.prop || BUILD.state) && (memberFlags & 31 || (!BUILD.lazyLoad || flags & 2) && memberFlags & 32)) {
        Object.defineProperty(prototype, memberName, {
          get() {
            return getValue(this, memberName);
          },
          set(newValue) {
            if (BUILD.isDev) {
              const ref = getHostRef(this);
              if (
                // we are proxying the instance (not element)
                (flags & 1) === 0 && // the element is not constructing
                (ref && ref.$flags$ & 8) === 0 && // the member is a prop
                (memberFlags & 31) !== 0 && // the member is not mutable
                (memberFlags & 1024) === 0
              ) {
                consoleDevWarn(
                  `@Prop() "${memberName}" on <${cmpMeta.$tagName$}> is immutable but was modified from within the component.
More information: https://stenciljs.com/docs/properties#prop-mutability`
                );
              }
            }
            setValue(this, memberName, newValue, cmpMeta);
          },
          configurable: true,
          enumerable: true
        });
      } else if (BUILD.lazyLoad && BUILD.method && flags & 1 && memberFlags & 64) {
        Object.defineProperty(prototype, memberName, {
          value(...args) {
            var _a2;
            const ref = getHostRef(this);
            return (_a2 = ref == null ? void 0 : ref.$onInstancePromise$) == null ? void 0 : _a2.then(() => {
              var _a3;
              return (_a3 = ref.$lazyInstance$) == null ? void 0 : _a3[memberName](...args);
            });
          }
        });
      }
    });
    if (BUILD.observeAttribute && (!BUILD.lazyLoad || flags & 1)) {
      const attrNameToPropName = /* @__PURE__ */ new Map();
      prototype.attributeChangedCallback = function(attrName, oldValue, newValue) {
        plt.jmp(() => {
          var _a2;
          const propName = attrNameToPropName.get(attrName);
          if (this.hasOwnProperty(propName)) {
            newValue = this[propName];
            delete this[propName];
          } else if (prototype.hasOwnProperty(propName) && typeof this[propName] === "number" && this[propName] == newValue) {
            return;
          } else if (propName == null) {
            const hostRef = getHostRef(this);
            const flags2 = hostRef == null ? void 0 : hostRef.$flags$;
            if (flags2 && !(flags2 & 8) && flags2 & 128 && newValue !== oldValue) {
              const elm = BUILD.lazyLoad ? hostRef.$hostElement$ : this;
              const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
              const entry = (_a2 = cmpMeta.$watchers$) == null ? void 0 : _a2[attrName];
              entry == null ? void 0 : entry.forEach((callbackName) => {
                if (instance[callbackName] != null) {
                  instance[callbackName].call(instance, newValue, oldValue, attrName);
                }
              });
            }
            return;
          }
          this[propName] = newValue === null && typeof this[propName] === "boolean" ? false : newValue;
        });
      };
      Cstr.observedAttributes = Array.from(
        /* @__PURE__ */ new Set([
          ...Object.keys((_a = cmpMeta.$watchers$) != null ? _a : {}),
          ...members.filter(
            ([_, m]) => m[0] & 15
            /* HasAttribute */
          ).map(([propName, m]) => {
            var _a2;
            const attrName = m[1] || propName;
            attrNameToPropName.set(attrName, propName);
            if (BUILD.reflect && m[0] & 512) {
              (_a2 = cmpMeta.$attrsToReflect$) == null ? void 0 : _a2.push([propName, attrName]);
            }
            return attrName;
          })
        ])
      );
    }
  }
  return Cstr;
};
var initializeComponent = async (elm, hostRef, cmpMeta, hmrVersionId) => {
  let Cstr;
  if ((hostRef.$flags$ & 32) === 0) {
    hostRef.$flags$ |= 32;
    const bundleId = cmpMeta.$lazyBundleId$;
    if ((BUILD.lazyLoad || BUILD.hydrateClientSide) && bundleId) {
      Cstr = loadModule(cmpMeta, hostRef, hmrVersionId);
      if (Cstr.then) {
        const endLoad = uniqueTime(
          `st:load:${cmpMeta.$tagName$}:${hostRef.$modeName$}`,
          `[Stencil] Load module for <${cmpMeta.$tagName$}>`
        );
        Cstr = await Cstr;
        endLoad();
      }
      if ((BUILD.isDev || BUILD.isDebug) && !Cstr) {
        throw new Error(`Constructor for "${cmpMeta.$tagName$}#${hostRef.$modeName$}" was not found`);
      }
      if (BUILD.member && !Cstr.isProxied) {
        if (BUILD.watchCallback) {
          cmpMeta.$watchers$ = Cstr.watchers;
        }
        proxyComponent(
          Cstr,
          cmpMeta,
          2
          /* proxyState */
        );
        Cstr.isProxied = true;
      }
      const endNewInstance = createTime("createInstance", cmpMeta.$tagName$);
      if (BUILD.member) {
        hostRef.$flags$ |= 8;
      }
      try {
        new Cstr(hostRef);
      } catch (e) {
        consoleError(e);
      }
      if (BUILD.member) {
        hostRef.$flags$ &= ~8;
      }
      if (BUILD.watchCallback) {
        hostRef.$flags$ |= 128;
      }
      endNewInstance();
      fireConnectedCallback(hostRef.$lazyInstance$);
    } else {
      Cstr = elm.constructor;
      customElements.whenDefined(cmpMeta.$tagName$).then(
        () => hostRef.$flags$ |= 128
        /* isWatchReady */
      );
    }
    if (BUILD.style && Cstr.style) {
      let style = Cstr.style;
      if (BUILD.mode && typeof style !== "string") {
        style = style[hostRef.$modeName$ = computeMode(elm)];
        if (BUILD.hydrateServerSide && hostRef.$modeName$) {
          elm.setAttribute("s-mode", hostRef.$modeName$);
        }
      }
      const scopeId2 = getScopeId(cmpMeta, hostRef.$modeName$);
      if (!styles.has(scopeId2)) {
        const endRegisterStyles = createTime("registerStyles", cmpMeta.$tagName$);
        if (!BUILD.hydrateServerSide && BUILD.shadowDom && // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
        BUILD.shadowDomShim && cmpMeta.$flags$ & 8) {
          style = await Promise.resolve().then(() => (init_shadow_css(), shadow_css_exports)).then((m) => m.scopeCss(style, scopeId2, false));
        }
        registerStyle(scopeId2, style, !!(cmpMeta.$flags$ & 1));
        endRegisterStyles();
      }
    }
  }
  const ancestorComponent = hostRef.$ancestorComponent$;
  const schedule = () => scheduleUpdate(hostRef, true);
  if (BUILD.asyncLoading && ancestorComponent && ancestorComponent["s-rc"]) {
    ancestorComponent["s-rc"].push(schedule);
  } else {
    schedule();
  }
};
var fireConnectedCallback = (instance) => {
  if (BUILD.lazyLoad && BUILD.connectedCallback) {
    safeCall(instance, "connectedCallback");
  }
};
var connectedCallback = (elm) => {
  if ((plt.$flags$ & 1) === 0) {
    const hostRef = getHostRef(elm);
    const cmpMeta = hostRef.$cmpMeta$;
    const endConnected = createTime("connectedCallback", cmpMeta.$tagName$);
    if (BUILD.hostListenerTargetParent) {
      addHostEventListeners(elm, hostRef, cmpMeta.$listeners$, true);
    }
    if (!(hostRef.$flags$ & 1)) {
      hostRef.$flags$ |= 1;
      let hostId;
      if (BUILD.hydrateClientSide) {
        hostId = elm.getAttribute(HYDRATE_ID);
        if (hostId) {
          if (BUILD.shadowDom && supportsShadow && cmpMeta.$flags$ & 1) {
            const scopeId2 = BUILD.mode ? addStyle(elm.shadowRoot, cmpMeta, elm.getAttribute("s-mode")) : addStyle(elm.shadowRoot, cmpMeta);
            elm.classList.remove(scopeId2 + "-h", scopeId2 + "-s");
          }
          initializeClientHydrate(elm, cmpMeta.$tagName$, hostId, hostRef);
        }
      }
      if (BUILD.slotRelocation && !hostId) {
        if (BUILD.hydrateServerSide || (BUILD.slot || BUILD.shadowDom) && // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
        cmpMeta.$flags$ & (4 | 8)) {
          setContentReference(elm);
        }
      }
      if (BUILD.asyncLoading) {
        let ancestorComponent = elm;
        while (ancestorComponent = ancestorComponent.parentNode || ancestorComponent.host) {
          if (BUILD.hydrateClientSide && ancestorComponent.nodeType === 1 && ancestorComponent.hasAttribute("s-id") && ancestorComponent["s-p"] || ancestorComponent["s-p"]) {
            attachToAncestor(hostRef, hostRef.$ancestorComponent$ = ancestorComponent);
            break;
          }
        }
      }
      if (BUILD.prop && !BUILD.hydrateServerSide && cmpMeta.$members$) {
        Object.entries(cmpMeta.$members$).map(([memberName, [memberFlags]]) => {
          if (memberFlags & 31 && elm.hasOwnProperty(memberName)) {
            const value = elm[memberName];
            delete elm[memberName];
            elm[memberName] = value;
          }
        });
      }
      if (BUILD.initializeNextTick) {
        nextTick(() => initializeComponent(elm, hostRef, cmpMeta));
      } else {
        initializeComponent(elm, hostRef, cmpMeta);
      }
    } else {
      addHostEventListeners(elm, hostRef, cmpMeta.$listeners$, false);
      if (hostRef == null ? void 0 : hostRef.$lazyInstance$) {
        fireConnectedCallback(hostRef.$lazyInstance$);
      } else if (hostRef == null ? void 0 : hostRef.$onReadyPromise$) {
        hostRef.$onReadyPromise$.then(() => fireConnectedCallback(hostRef.$lazyInstance$));
      }
    }
    endConnected();
  }
};
var setContentReference = (elm) => {
  const contentRefElm = elm["s-cr"] = doc.createComment(
    BUILD.isDebug ? `content-ref (host=${elm.localName})` : ""
  );
  contentRefElm["s-cn"] = true;
  elm.insertBefore(contentRefElm, elm.firstChild);
};
var disconnectInstance = (instance) => {
  if (BUILD.lazyLoad && BUILD.disconnectedCallback) {
    safeCall(instance, "disconnectedCallback");
  }
  if (BUILD.cmpDidUnload) {
    safeCall(instance, "componentDidUnload");
  }
};
var disconnectedCallback = async (elm) => {
  if ((plt.$flags$ & 1) === 0) {
    const hostRef = getHostRef(elm);
    if (BUILD.hostListener) {
      if (hostRef.$rmListeners$) {
        hostRef.$rmListeners$.map((rmListener) => rmListener());
        hostRef.$rmListeners$ = void 0;
      }
    }
    if (!BUILD.lazyLoad) {
      disconnectInstance(elm);
    } else if (hostRef == null ? void 0 : hostRef.$lazyInstance$) {
      disconnectInstance(hostRef.$lazyInstance$);
    } else if (hostRef == null ? void 0 : hostRef.$onReadyPromise$) {
      hostRef.$onReadyPromise$.then(() => disconnectInstance(hostRef.$lazyInstance$));
    }
  }
};
var patchPseudoShadowDom = (hostElementPrototype, descriptorPrototype) => {
  patchCloneNode(hostElementPrototype);
  patchSlotAppendChild(hostElementPrototype);
  patchSlotAppend(hostElementPrototype);
  patchSlotPrepend(hostElementPrototype);
  patchSlotInsertAdjacentElement(hostElementPrototype);
  patchSlotInsertAdjacentHTML(hostElementPrototype);
  patchSlotInsertAdjacentText(hostElementPrototype);
  patchTextContent(hostElementPrototype);
  patchChildSlotNodes(hostElementPrototype, descriptorPrototype);
  patchSlotRemoveChild(hostElementPrototype);
};
var patchCloneNode = (HostElementPrototype) => {
  const orgCloneNode = HostElementPrototype.cloneNode;
  HostElementPrototype.cloneNode = function(deep) {
    const srcNode = this;
    const isShadowDom = BUILD.shadowDom ? srcNode.shadowRoot && supportsShadow : false;
    const clonedNode = orgCloneNode.call(srcNode, isShadowDom ? deep : false);
    if (BUILD.slot && !isShadowDom && deep) {
      let i2 = 0;
      let slotted, nonStencilNode;
      const stencilPrivates = [
        "s-id",
        "s-cr",
        "s-lr",
        "s-rc",
        "s-sc",
        "s-p",
        "s-cn",
        "s-sr",
        "s-sn",
        "s-hn",
        "s-ol",
        "s-nr",
        "s-si",
        "s-rf"
      ];
      for (; i2 < srcNode.childNodes.length; i2++) {
        slotted = srcNode.childNodes[i2]["s-nr"];
        nonStencilNode = stencilPrivates.every((privateField) => !srcNode.childNodes[i2][privateField]);
        if (slotted) {
          if (BUILD.appendChildSlotFix && clonedNode.__appendChild) {
            clonedNode.__appendChild(slotted.cloneNode(true));
          } else {
            clonedNode.appendChild(slotted.cloneNode(true));
          }
        }
        if (nonStencilNode) {
          clonedNode.appendChild(srcNode.childNodes[i2].cloneNode(true));
        }
      }
    }
    return clonedNode;
  };
};
var patchSlotAppendChild = (HostElementPrototype) => {
  HostElementPrototype.__appendChild = HostElementPrototype.appendChild;
  HostElementPrototype.appendChild = function(newChild) {
    const slotName = newChild["s-sn"] = getSlotName(newChild);
    const slotNode = getHostSlotNode(this.childNodes, slotName, this.tagName);
    if (slotNode) {
      const slotChildNodes = getHostSlotChildNodes(slotNode, slotName);
      const appendAfter = slotChildNodes[slotChildNodes.length - 1];
      const insertedNode = appendAfter.parentNode.insertBefore(newChild, appendAfter.nextSibling);
      updateFallbackSlotVisibility(this);
      return insertedNode;
    }
    return this.__appendChild(newChild);
  };
};
var patchSlotRemoveChild = (ElementPrototype) => {
  ElementPrototype.__removeChild = ElementPrototype.removeChild;
  ElementPrototype.removeChild = function(toRemove) {
    if (toRemove && typeof toRemove["s-sn"] !== "undefined") {
      const slotNode = getHostSlotNode(this.childNodes, toRemove["s-sn"], this.tagName);
      if (slotNode) {
        const slotChildNodes = getHostSlotChildNodes(slotNode, toRemove["s-sn"]);
        const existingNode = slotChildNodes.find((n) => n === toRemove);
        if (existingNode) {
          existingNode.remove();
          updateFallbackSlotVisibility(this);
          return;
        }
      }
    }
    return this.__removeChild(toRemove);
  };
};
var patchSlotPrepend = (HostElementPrototype) => {
  const originalPrepend = HostElementPrototype.prepend;
  HostElementPrototype.prepend = function(...newChildren) {
    newChildren.forEach((newChild) => {
      if (typeof newChild === "string") {
        newChild = this.ownerDocument.createTextNode(newChild);
      }
      const slotName = newChild["s-sn"] = getSlotName(newChild);
      const slotNode = getHostSlotNode(this.childNodes, slotName, this.tagName);
      if (slotNode) {
        const slotPlaceholder = document.createTextNode("");
        slotPlaceholder["s-nr"] = newChild;
        slotNode["s-cr"].parentNode.__appendChild(slotPlaceholder);
        newChild["s-ol"] = slotPlaceholder;
        const slotChildNodes = getHostSlotChildNodes(slotNode, slotName);
        const appendAfter = slotChildNodes[0];
        return appendAfter.parentNode.insertBefore(newChild, appendAfter.nextSibling);
      }
      if (newChild.nodeType === 1 && !!newChild.getAttribute("slot")) {
        newChild.hidden = true;
      }
      return originalPrepend.call(this, newChild);
    });
  };
};
var patchSlotAppend = (HostElementPrototype) => {
  HostElementPrototype.append = function(...newChildren) {
    newChildren.forEach((newChild) => {
      if (typeof newChild === "string") {
        newChild = this.ownerDocument.createTextNode(newChild);
      }
      this.appendChild(newChild);
    });
  };
};
var patchSlotInsertAdjacentHTML = (HostElementPrototype) => {
  const originalInsertAdjacentHtml = HostElementPrototype.insertAdjacentHTML;
  HostElementPrototype.insertAdjacentHTML = function(position, text) {
    if (position !== "afterbegin" && position !== "beforeend") {
      return originalInsertAdjacentHtml.call(this, position, text);
    }
    const container = this.ownerDocument.createElement("_");
    let node;
    container.innerHTML = text;
    if (position === "afterbegin") {
      while (node = container.firstChild) {
        this.prepend(node);
      }
    } else if (position === "beforeend") {
      while (node = container.firstChild) {
        this.append(node);
      }
    }
  };
};
var patchSlotInsertAdjacentText = (HostElementPrototype) => {
  HostElementPrototype.insertAdjacentText = function(position, text) {
    this.insertAdjacentHTML(position, text);
  };
};
var patchSlotInsertAdjacentElement = (HostElementPrototype) => {
  const originalInsertAdjacentElement = HostElementPrototype.insertAdjacentElement;
  HostElementPrototype.insertAdjacentElement = function(position, element) {
    if (position !== "afterbegin" && position !== "beforeend") {
      return originalInsertAdjacentElement.call(this, position, element);
    }
    if (position === "afterbegin") {
      this.prepend(element);
      return element;
    } else if (position === "beforeend") {
      this.append(element);
      return element;
    }
    return element;
  };
};
var patchTextContent = (hostElementPrototype) => {
  const descriptor = Object.getOwnPropertyDescriptor(Node.prototype, "textContent");
  Object.defineProperty(hostElementPrototype, "__textContent", descriptor);
  if (BUILD.experimentalScopedSlotChanges) {
    Object.defineProperty(hostElementPrototype, "textContent", {
      // To mimic shadow root behavior, we need to return the text content of all
      // nodes in a slot reference node
      get() {
        const slotRefNodes = getAllChildSlotNodes(this.childNodes);
        const textContent = slotRefNodes.map((node) => {
          var _a, _b;
          const text = [];
          let slotContent = node.nextSibling;
          while (slotContent && slotContent["s-sn"] === node["s-sn"]) {
            if (slotContent.nodeType === 3 || slotContent.nodeType === 1) {
              text.push((_b = (_a = slotContent.textContent) == null ? void 0 : _a.trim()) != null ? _b : "");
            }
            slotContent = slotContent.nextSibling;
          }
          return text.filter((ref) => ref !== "").join(" ");
        }).filter((text) => text !== "").join(" ");
        return " " + textContent + " ";
      },
      // To mimic shadow root behavior, we need to overwrite all nodes in a slot
      // reference node. If a default slot reference node exists, the text content will be
      // placed there. Otherwise, the new text node will be hidden
      set(value) {
        const slotRefNodes = getAllChildSlotNodes(this.childNodes);
        slotRefNodes.forEach((node) => {
          let slotContent = node.nextSibling;
          while (slotContent && slotContent["s-sn"] === node["s-sn"]) {
            const tmp = slotContent;
            slotContent = slotContent.nextSibling;
            tmp.remove();
          }
          if (node["s-sn"] === "") {
            const textNode = this.ownerDocument.createTextNode(value);
            textNode["s-sn"] = "";
            node.parentElement.insertBefore(textNode, node.nextSibling);
          } else {
            node.remove();
          }
        });
      }
    });
  } else {
    Object.defineProperty(hostElementPrototype, "textContent", {
      get() {
        var _a;
        const slotNode = getHostSlotNode(this.childNodes, "", this.tagName);
        if (((_a = slotNode == null ? void 0 : slotNode.nextSibling) == null ? void 0 : _a.nodeType) === 3) {
          return slotNode.nextSibling.textContent;
        } else if (slotNode) {
          return slotNode.textContent;
        } else {
          return this.__textContent;
        }
      },
      set(value) {
        var _a;
        const slotNode = getHostSlotNode(this.childNodes, "", this.tagName);
        if (((_a = slotNode == null ? void 0 : slotNode.nextSibling) == null ? void 0 : _a.nodeType) === 3) {
          slotNode.nextSibling.textContent = value;
        } else if (slotNode) {
          slotNode.textContent = value;
        } else {
          this.__textContent = value;
          const contentRefElm = this["s-cr"];
          if (contentRefElm) {
            this.insertBefore(contentRefElm, this.firstChild);
          }
        }
      }
    });
  }
};
var patchChildSlotNodes = (elm, cmpMeta) => {
  class FakeNodeList extends Array {
    item(n) {
      return this[n];
    }
  }
  if (cmpMeta.$flags$ & 8) {
    const childNodesFn = elm.__lookupGetter__("childNodes");
    Object.defineProperty(elm, "children", {
      get() {
        return this.childNodes.map((n) => n.nodeType === 1);
      }
    });
    Object.defineProperty(elm, "childElementCount", {
      get() {
        return elm.children.length;
      }
    });
    Object.defineProperty(elm, "childNodes", {
      get() {
        const childNodes = childNodesFn.call(this);
        if ((plt.$flags$ & 1) === 0 && getHostRef(this).$flags$ & 2) {
          const result = new FakeNodeList();
          for (let i2 = 0; i2 < childNodes.length; i2++) {
            const slot = childNodes[i2]["s-nr"];
            if (slot) {
              result.push(slot);
            }
          }
          return result;
        }
        return FakeNodeList.from(childNodes);
      }
    });
  }
};
var getAllChildSlotNodes = (childNodes) => {
  const slotRefNodes = [];
  for (const childNode of Array.from(childNodes)) {
    if (childNode["s-sr"]) {
      slotRefNodes.push(childNode);
    }
    slotRefNodes.push(...getAllChildSlotNodes(childNode.childNodes));
  }
  return slotRefNodes;
};
var getSlotName = (node) => node["s-sn"] || node.nodeType === 1 && node.getAttribute("slot") || "";
var getHostSlotNode = (childNodes, slotName, hostName) => {
  let i2 = 0;
  let childNode;
  for (; i2 < childNodes.length; i2++) {
    childNode = childNodes[i2];
    if (childNode["s-sr"] && childNode["s-sn"] === slotName && childNode["s-hn"] === hostName) {
      return childNode;
    }
    childNode = getHostSlotNode(childNode.childNodes, slotName, hostName);
    if (childNode) {
      return childNode;
    }
  }
  return null;
};
var getHostSlotChildNodes = (n, slotName) => {
  const childNodes = [n];
  while ((n = n.nextSibling) && n["s-sn"] === slotName) {
    childNodes.push(n);
  }
  return childNodes;
};
var proxyCustomElement = (Cstr, compactMeta) => {
  const cmpMeta = {
    $flags$: compactMeta[0],
    $tagName$: compactMeta[1]
  };
  if (BUILD.member) {
    cmpMeta.$members$ = compactMeta[2];
  }
  if (BUILD.hostListener) {
    cmpMeta.$listeners$ = compactMeta[3];
  }
  if (BUILD.watchCallback) {
    cmpMeta.$watchers$ = Cstr.$watchers$;
  }
  if (BUILD.reflect) {
    cmpMeta.$attrsToReflect$ = [];
  }
  if (BUILD.shadowDom && !supportsShadow && cmpMeta.$flags$ & 1) {
    cmpMeta.$flags$ |= 8;
  }
  if (BUILD.experimentalSlotFixes) {
    if (BUILD.scoped && cmpMeta.$flags$ & 2) {
      patchPseudoShadowDom(Cstr.prototype, cmpMeta);
    }
  } else {
    if (BUILD.slotChildNodesFix) {
      patchChildSlotNodes(Cstr.prototype, cmpMeta);
    }
    if (BUILD.cloneNodeFix) {
      patchCloneNode(Cstr.prototype);
    }
    if (BUILD.appendChildSlotFix) {
      patchSlotAppendChild(Cstr.prototype);
    }
    if (BUILD.scopedSlotTextContentFix && cmpMeta.$flags$ & 2) {
      patchTextContent(Cstr.prototype);
    }
  }
  const originalConnectedCallback = Cstr.prototype.connectedCallback;
  const originalDisconnectedCallback = Cstr.prototype.disconnectedCallback;
  Object.assign(Cstr.prototype, {
    __registerHost() {
      registerHost(this, cmpMeta);
    },
    connectedCallback() {
      connectedCallback(this);
      if (BUILD.connectedCallback && originalConnectedCallback) {
        originalConnectedCallback.call(this);
      }
    },
    disconnectedCallback() {
      disconnectedCallback(this);
      if (BUILD.disconnectedCallback && originalDisconnectedCallback) {
        originalDisconnectedCallback.call(this);
      }
    },
    __attachShadow() {
      if (supportsShadow) {
        if (BUILD.shadowDelegatesFocus) {
          this.attachShadow({
            mode: "open",
            delegatesFocus: !!(cmpMeta.$flags$ & 16)
          });
        } else {
          this.attachShadow({ mode: "open" });
        }
      } else {
        this.shadowRoot = this;
      }
    }
  });
  Cstr.is = cmpMeta.$tagName$;
  return proxyComponent(
    Cstr,
    cmpMeta,
    1 | 2
    /* proxyState */
  );
};
var addHostEventListeners = (elm, hostRef, listeners, attachParentListeners) => {
  if (BUILD.hostListener && listeners) {
    if (BUILD.hostListenerTargetParent) {
      if (attachParentListeners) {
        listeners = listeners.filter(
          ([flags]) => flags & 32
          /* TargetParent */
        );
      } else {
        listeners = listeners.filter(([flags]) => !(flags & 32));
      }
    }
    listeners.map(([flags, name, method]) => {
      const target = BUILD.hostListenerTarget ? getHostListenerTarget(elm, flags) : elm;
      const handler = hostListenerProxy(hostRef, method);
      const opts = hostListenerOpts(flags);
      plt.ael(target, name, handler, opts);
      (hostRef.$rmListeners$ = hostRef.$rmListeners$ || []).push(() => plt.rel(target, name, handler, opts));
    });
  }
};
var hostListenerProxy = (hostRef, methodName) => (ev) => {
  try {
    if (BUILD.lazyLoad) {
      if (hostRef.$flags$ & 256) {
        hostRef.$lazyInstance$[methodName](ev);
      } else {
        (hostRef.$queuedListeners$ = hostRef.$queuedListeners$ || []).push([methodName, ev]);
      }
    } else {
      hostRef.$hostElement$[methodName](ev);
    }
  } catch (e) {
    consoleError(e);
  }
};
var getHostListenerTarget = (elm, flags) => {
  if (BUILD.hostListenerTargetDocument && flags & 4)
    return doc;
  if (BUILD.hostListenerTargetWindow && flags & 8)
    return win;
  if (BUILD.hostListenerTargetBody && flags & 16)
    return doc.body;
  if (BUILD.hostListenerTargetParent && flags & 32)
    return elm.parentElement;
  return elm;
};
var hostListenerOpts = (flags) => supportsListenerOptions ? {
  passive: (flags & 1) !== 0,
  capture: (flags & 2) !== 0
} : (flags & 2) !== 0;
var hostRefs = BUILD.hotModuleReplacement ? window.__STENCIL_HOSTREFS__ || (window.__STENCIL_HOSTREFS__ = /* @__PURE__ */ new WeakMap()) : /* @__PURE__ */ new WeakMap();
var getHostRef = (ref) => hostRefs.get(ref);
var registerHost = (hostElement, cmpMeta) => {
  const hostRef = {
    $flags$: 0,
    $hostElement$: hostElement,
    $cmpMeta$: cmpMeta,
    $instanceValues$: /* @__PURE__ */ new Map()
  };
  if (BUILD.isDev) {
    hostRef.$renderCount$ = 0;
  }
  if (BUILD.method && BUILD.lazyLoad) {
    hostRef.$onInstancePromise$ = new Promise((r) => hostRef.$onInstanceResolve$ = r);
  }
  if (BUILD.asyncLoading) {
    hostRef.$onReadyPromise$ = new Promise((r) => hostRef.$onReadyResolve$ = r);
    hostElement["s-p"] = [];
    hostElement["s-rc"] = [];
  }
  addHostEventListeners(hostElement, hostRef, cmpMeta.$listeners$, false);
  return hostRefs.set(hostElement, hostRef);
};
var isMemberInElement = (elm, memberName) => memberName in elm;
var customError;
var consoleError = (e, el) => (customError || console.error)(e, el);
var STENCIL_DEV_MODE = BUILD.isTesting ? ["STENCIL:"] : [
  "%cstencil",
  "color: white;background:#4c47ff;font-weight: bold; font-size:10px; padding:2px 6px; border-radius: 5px"
];
var consoleDevError = (...m) => console.error(...STENCIL_DEV_MODE, ...m);
var consoleDevWarn = (...m) => console.warn(...STENCIL_DEV_MODE, ...m);
var cmpModules = /* @__PURE__ */ new Map();
var loadModule = (cmpMeta, hostRef, hmrVersionId) => {
  const exportName = cmpMeta.$tagName$.replace(/-/g, "_");
  const bundleId = cmpMeta.$lazyBundleId$;
  if (BUILD.isDev && typeof bundleId !== "string") {
    consoleDevError(
      `Trying to lazily load component <${cmpMeta.$tagName$}> with style mode "${hostRef.$modeName$}", but it does not exist.`
    );
    return void 0;
  }
  const module2 = !BUILD.hotModuleReplacement ? cmpModules.get(bundleId) : false;
  if (module2) {
    return module2[exportName];
  }
  return /* @vite-ignore */ /* webpackInclude: /\.entry\.js$/ */ /* webpackExclude: /\.system\.entry\.js$/ */ /* webpackMode: "lazy" */ globImport_entry_js(`./${bundleId}.entry.js${BUILD.hotModuleReplacement && hmrVersionId ? "?s-hmr=" + hmrVersionId : ""}`).then((importedModule) => {
    if (!BUILD.hotModuleReplacement) {
      cmpModules.set(bundleId, importedModule);
    }
    return importedModule[exportName];
  }, consoleError);
};
var styles = /* @__PURE__ */ new Map();
var modeResolutionChain = [];
var win = typeof window !== "undefined" ? window : {};
var doc = win.document || { head: {} };
var H = win.HTMLElement || class {
};
var plt = {
  $flags$: 0,
  $resourcesUrl$: "",
  jmp: (h2) => h2(),
  raf: (h2) => requestAnimationFrame(h2),
  ael: (el, eventName, listener, opts) => el.addEventListener(eventName, listener, opts),
  rel: (el, eventName, listener, opts) => el.removeEventListener(eventName, listener, opts),
  ce: (eventName, opts) => new CustomEvent(eventName, opts)
};
var supportsShadow = (
  // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
  BUILD.shadowDomShim && BUILD.shadowDom ? /* @__PURE__ */ (() => (doc.head.attachShadow + "").indexOf("[native") > -1)() : true
);
var supportsListenerOptions = /* @__PURE__ */ (() => {
  let supportsListenerOptions2 = false;
  try {
    doc.addEventListener(
      "e",
      null,
      Object.defineProperty({}, "passive", {
        get() {
          supportsListenerOptions2 = true;
        }
      })
    );
  } catch (e) {
  }
  return supportsListenerOptions2;
})();
var promiseResolve = (v) => Promise.resolve(v);
var supportsConstructableStylesheets = BUILD.constructableCSS ? /* @__PURE__ */ (() => {
  try {
    new CSSStyleSheet();
    return typeof new CSSStyleSheet().replaceSync === "function";
  } catch (e) {
  }
  return false;
})() : false;
var queueCongestion = 0;
var queuePending = false;
var queueDomReads = [];
var queueDomWrites = [];
var queueDomWritesLow = [];
var queueTask = (queue, write) => (cb) => {
  queue.push(cb);
  if (!queuePending) {
    queuePending = true;
    if (write && plt.$flags$ & 4) {
      nextTick(flush);
    } else {
      plt.raf(flush);
    }
  }
};
var consume = (queue) => {
  for (let i2 = 0; i2 < queue.length; i2++) {
    try {
      queue[i2](performance.now());
    } catch (e) {
      consoleError(e);
    }
  }
  queue.length = 0;
};
var consumeTimeout = (queue, timeout) => {
  let i2 = 0;
  let ts = 0;
  while (i2 < queue.length && (ts = performance.now()) < timeout) {
    try {
      queue[i2++](ts);
    } catch (e) {
      consoleError(e);
    }
  }
  if (i2 === queue.length) {
    queue.length = 0;
  } else if (i2 !== 0) {
    queue.splice(0, i2);
  }
};
var flush = () => {
  if (BUILD.asyncQueue) {
    queueCongestion++;
  }
  consume(queueDomReads);
  if (BUILD.asyncQueue) {
    const timeout = (plt.$flags$ & 6) === 2 ? performance.now() + 14 * Math.ceil(queueCongestion * (1 / 10)) : Infinity;
    consumeTimeout(queueDomWrites, timeout);
    consumeTimeout(queueDomWritesLow, timeout);
    if (queueDomWrites.length > 0) {
      queueDomWritesLow.push(...queueDomWrites);
      queueDomWrites.length = 0;
    }
    if (queuePending = queueDomReads.length + queueDomWrites.length + queueDomWritesLow.length > 0) {
      plt.raf(flush);
    } else {
      queueCongestion = 0;
    }
  } else {
    consume(queueDomWrites);
    if (queuePending = queueDomReads.length > 0) {
      plt.raf(flush);
    }
  }
};
var nextTick = (cb) => promiseResolve().then(cb);
var writeTask = /* @__PURE__ */ queueTask(queueDomWrites, true);

// ../../node_modules/ionicons/components/utils.js
var CACHED_MAP;
var getIconMap = () => {
  if (typeof window === "undefined") {
    return /* @__PURE__ */ new Map();
  } else {
    if (!CACHED_MAP) {
      const win2 = window;
      win2.Ionicons = win2.Ionicons || {};
      CACHED_MAP = win2.Ionicons.map = win2.Ionicons.map || /* @__PURE__ */ new Map();
    }
    return CACHED_MAP;
  }
};
var getUrl = (i2) => {
  let url = getSrc(i2.src);
  if (url) {
    return url;
  }
  url = getName(i2.name, i2.icon, i2.mode, i2.ios, i2.md);
  if (url) {
    return getNamedUrl(url, i2);
  }
  if (i2.icon) {
    url = getSrc(i2.icon);
    if (url) {
      return url;
    }
    url = getSrc(i2.icon[i2.mode]);
    if (url) {
      return url;
    }
  }
  return null;
};
var getNamedUrl = (iconName, iconEl) => {
  const url = getIconMap().get(iconName);
  if (url) {
    return url;
  }
  try {
    return getAssetPath(`svg/${iconName}.svg`);
  } catch (e) {
    console.warn(`[Ionicons Warning]: Could not load icon with name "${iconName}". Ensure that the icon is registered using addIcons or that the icon SVG data is passed directly to the icon component.`, iconEl);
  }
};
var getName = (iconName, icon, mode, ios, md) => {
  mode = (mode && toLower(mode)) === "ios" ? "ios" : "md";
  if (ios && mode === "ios") {
    iconName = toLower(ios);
  } else if (md && mode === "md") {
    iconName = toLower(md);
  } else {
    if (!iconName && icon && !isSrc(icon)) {
      iconName = icon;
    }
    if (isStr(iconName)) {
      iconName = toLower(iconName);
    }
  }
  if (!isStr(iconName) || iconName.trim() === "") {
    return null;
  }
  const invalidChars = iconName.replace(/[a-z]|-|\d/gi, "");
  if (invalidChars !== "") {
    return null;
  }
  return iconName;
};
var getSrc = (src) => {
  if (isStr(src)) {
    src = src.trim();
    if (isSrc(src)) {
      return src;
    }
  }
  return null;
};
var isSrc = (str) => str.length > 0 && /(\/|\.)/.test(str);
var isStr = (val) => typeof val === "string";
var toLower = (val) => val.toLowerCase();
var inheritAttributes = (el, attributes = []) => {
  const attributeObject = {};
  attributes.forEach((attr) => {
    if (el.hasAttribute(attr)) {
      const value = el.getAttribute(attr);
      if (value !== null) {
        attributeObject[attr] = el.getAttribute(attr);
      }
      el.removeAttribute(attr);
    }
  });
  return attributeObject;
};
var isRTL = (hostEl) => {
  if (hostEl) {
    if (hostEl.dir !== "") {
      return hostEl.dir.toLowerCase() === "rtl";
    }
  }
  return (document === null || document === void 0 ? void 0 : document.dir.toLowerCase()) === "rtl";
};

// ../../node_modules/ionicons/components/ion-icon.js
var validateContent = (svgContent) => {
  const div = document.createElement("div");
  div.innerHTML = svgContent;
  for (let i2 = div.childNodes.length - 1; i2 >= 0; i2--) {
    if (div.childNodes[i2].nodeName.toLowerCase() !== "svg") {
      div.removeChild(div.childNodes[i2]);
    }
  }
  const svgElm = div.firstElementChild;
  if (svgElm && svgElm.nodeName.toLowerCase() === "svg") {
    const svgClass = svgElm.getAttribute("class") || "";
    svgElm.setAttribute("class", (svgClass + " s-ion-icon").trim());
    if (isValid(svgElm)) {
      return div.innerHTML;
    }
  }
  return "";
};
var isValid = (elm) => {
  if (elm.nodeType === 1) {
    if (elm.nodeName.toLowerCase() === "script") {
      return false;
    }
    for (let i2 = 0; i2 < elm.attributes.length; i2++) {
      const name = elm.attributes[i2].name;
      if (isStr(name) && name.toLowerCase().indexOf("on") === 0) {
        return false;
      }
    }
    for (let i2 = 0; i2 < elm.childNodes.length; i2++) {
      if (!isValid(elm.childNodes[i2])) {
        return false;
      }
    }
  }
  return true;
};
var isSvgDataUrl = (url) => url.startsWith("data:image/svg+xml");
var isEncodedDataUrl = (url) => url.indexOf(";utf8,") !== -1;
var ioniconContent = /* @__PURE__ */ new Map();
var requests = /* @__PURE__ */ new Map();
var parser;
var getSvgContent = (url, sanitize) => {
  let req = requests.get(url);
  if (!req) {
    if (typeof fetch !== "undefined" && typeof document !== "undefined") {
      if (isSvgDataUrl(url) && isEncodedDataUrl(url)) {
        if (!parser) {
          parser = new DOMParser();
        }
        const doc2 = parser.parseFromString(url, "text/html");
        const svg = doc2.querySelector("svg");
        if (svg) {
          ioniconContent.set(url, svg.outerHTML);
        }
        return Promise.resolve();
      } else {
        req = fetch(url).then((rsp) => {
          if (rsp.ok) {
            return rsp.text().then((svgContent) => {
              if (svgContent && sanitize !== false) {
                svgContent = validateContent(svgContent);
              }
              ioniconContent.set(url, svgContent || "");
            });
          }
          ioniconContent.set(url, "");
        });
        requests.set(url, req);
      }
    } else {
      ioniconContent.set(url, "");
      return Promise.resolve();
    }
  }
  return req;
};
var iconCss = ":host{display:inline-block;width:1em;height:1em;contain:strict;fill:currentColor;-webkit-box-sizing:content-box !important;box-sizing:content-box !important}:host .ionicon{stroke:currentColor}.ionicon-fill-none{fill:none}.ionicon-stroke-width{stroke-width:32px;stroke-width:var(--ionicon-stroke-width, 32px)}.icon-inner,.ionicon,svg{display:block;height:100%;width:100%}@supports (background: -webkit-named-image(i)){:host(.icon-rtl) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}}@supports not selector(:dir(rtl)) and selector(:host-context([dir='rtl'])){:host(.icon-rtl) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}}:host(.flip-rtl):host-context([dir='rtl']) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}@supports selector(:dir(rtl)){:host(.flip-rtl:dir(rtl)) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}:host(.flip-rtl:dir(ltr)) .icon-inner{-webkit-transform:scaleX(1);transform:scaleX(1)}}:host(.icon-small){font-size:1.125rem !important}:host(.icon-large){font-size:2rem !important}:host(.ion-color){color:var(--ion-color-base) !important}:host(.ion-color-primary){--ion-color-base:var(--ion-color-primary, #3880ff)}:host(.ion-color-secondary){--ion-color-base:var(--ion-color-secondary, #0cd1e8)}:host(.ion-color-tertiary){--ion-color-base:var(--ion-color-tertiary, #f4a942)}:host(.ion-color-success){--ion-color-base:var(--ion-color-success, #10dc60)}:host(.ion-color-warning){--ion-color-base:var(--ion-color-warning, #ffce00)}:host(.ion-color-danger){--ion-color-base:var(--ion-color-danger, #f14141)}:host(.ion-color-light){--ion-color-base:var(--ion-color-light, #f4f5f8)}:host(.ion-color-medium){--ion-color-base:var(--ion-color-medium, #989aa2)}:host(.ion-color-dark){--ion-color-base:var(--ion-color-dark, #222428)}";
var Icon = /* @__PURE__ */ proxyCustomElement(class Icon2 extends H {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.iconName = null;
    this.inheritedAttributes = {};
    this.didLoadIcon = false;
    this.svgContent = void 0;
    this.isVisible = false;
    this.mode = getIonMode();
    this.color = void 0;
    this.ios = void 0;
    this.md = void 0;
    this.flipRtl = void 0;
    this.name = void 0;
    this.src = void 0;
    this.icon = void 0;
    this.size = void 0;
    this.lazy = false;
    this.sanitize = true;
  }
  componentWillLoad() {
    this.inheritedAttributes = inheritAttributes(this.el, ["aria-label"]);
  }
  connectedCallback() {
    this.waitUntilVisible(this.el, "50px", () => {
      this.isVisible = true;
      this.loadIcon();
    });
  }
  componentDidLoad() {
    if (!this.didLoadIcon) {
      this.loadIcon();
    }
  }
  disconnectedCallback() {
    if (this.io) {
      this.io.disconnect();
      this.io = void 0;
    }
  }
  waitUntilVisible(el, rootMargin, cb) {
    if (Build.isBrowser && this.lazy && typeof window !== "undefined" && window.IntersectionObserver) {
      const io = this.io = new window.IntersectionObserver((data) => {
        if (data[0].isIntersecting) {
          io.disconnect();
          this.io = void 0;
          cb();
        }
      }, { rootMargin });
      io.observe(el);
    } else {
      cb();
    }
  }
  loadIcon() {
    if (Build.isBrowser && this.isVisible) {
      const url = getUrl(this);
      if (url) {
        if (ioniconContent.has(url)) {
          this.svgContent = ioniconContent.get(url);
        } else {
          getSvgContent(url, this.sanitize).then(() => this.svgContent = ioniconContent.get(url));
        }
        this.didLoadIcon = true;
      }
    }
    this.iconName = getName(this.name, this.icon, this.mode, this.ios, this.md);
  }
  render() {
    const { flipRtl, iconName, inheritedAttributes, el } = this;
    const mode = this.mode || "md";
    const shouldAutoFlip = iconName ? (iconName.includes("arrow") || iconName.includes("chevron")) && flipRtl !== false : false;
    const shouldBeFlippable = flipRtl || shouldAutoFlip;
    return h(Host, Object.assign({ role: "img", class: Object.assign(Object.assign({ [mode]: true }, createColorClasses(this.color)), { [`icon-${this.size}`]: !!this.size, "flip-rtl": shouldBeFlippable, "icon-rtl": shouldBeFlippable && isRTL(el) }) }, inheritedAttributes), Build.isBrowser && this.svgContent ? h("div", { class: "icon-inner", innerHTML: this.svgContent }) : h("div", { class: "icon-inner" }));
  }
  static get assetsDirs() {
    return ["svg"];
  }
  get el() {
    return this;
  }
  static get watchers() {
    return {
      "name": ["loadIcon"],
      "src": ["loadIcon"],
      "icon": ["loadIcon"],
      "ios": ["loadIcon"],
      "md": ["loadIcon"]
    };
  }
  static get style() {
    return iconCss;
  }
}, [1, "ion-icon", {
  "mode": [1025],
  "color": [1],
  "ios": [1],
  "md": [1],
  "flipRtl": [4, "flip-rtl"],
  "name": [513],
  "src": [1],
  "icon": [8],
  "size": [1],
  "lazy": [4],
  "sanitize": [4],
  "svgContent": [32],
  "isVisible": [32]
}]);
var getIonMode = () => Build.isBrowser && typeof document !== "undefined" && document.documentElement.getAttribute("mode") || "md";
var createColorClasses = (color) => {
  return color ? {
    "ion-color": true,
    [`ion-color-${color}`]: true
  } : null;
};
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["ion-icon"];
  components.forEach((tagName) => {
    switch (tagName) {
      case "ion-icon":
        if (!customElements.get(tagName)) {
          customElements.define(tagName, Icon);
        }
        break;
    }
  });
}
var defineCustomElement92 = defineCustomElement$1;

// src/components/ion-icon.tsx
var _tmpl$92 = /* @__PURE__ */ (0, import_web366.template)(`<ion-icon>`, true, false);
defineCustomElement92();
function IonIcon(props) {
  return (() => {
    var _el$ = _tmpl$92();
    (0, import_web368.spread)(_el$, props, false, false);
    _el$._$owner = (0, import_web367.getOwner)();
    return _el$;
  })();
}

// src/components/ion-router.tsx
var import_web369 = require("solid-js/web");
var import_web370 = require("solid-js/web");
var import_web371 = require("solid-js/web");
var import_web372 = require("solid-js/web");
var import_web373 = require("solid-js/web");
var import_web374 = require("solid-js/web");
var import_web375 = require("solid-js/web");
var import_ion_router = require("@ionic/core/components/ion-router");
var import_solid_js3 = require("solid-js");

// src/hooks/useRouter.tsx
var import_solid_js2 = require("solid-js");
var RouterContext = (0, import_solid_js2.createContext)();
function useRouter() {
  return (0, import_solid_js2.useContext)(RouterContext);
}
var RouterContextProvider = RouterContext.Provider;

// src/components/ion-router.tsx
var _tmpl$93 = /* @__PURE__ */ (0, import_web369.template)(`<ion-router>`, true, false);
(0, import_ion_router.defineCustomElement)();
function IonRouter(props) {
  const [_, propsToFix] = (0, import_solid_js3.splitProps)(props, ["ref"]);
  const fixedProps = () => fixProps(propsToFix);
  const [router, setRouter] = (0, import_solid_js3.createSignal)();
  (0, import_solid_js3.createEffect)(() => {
    const routerElement = router();
    if (typeof props.ref === "function") {
      if (routerElement) {
        props.ref(routerElement);
      }
    } else if (props.ref !== void 0) {
      props.ref = routerElement;
    }
  });
  return (() => {
    var _el$ = _tmpl$93();
    (0, import_web373.use)(setRouter, _el$);
    (0, import_web374.spread)(_el$, (0, import_web375.mergeProps)(fixedProps), false, true);
    _el$._$owner = (0, import_web372.getOwner)();
    (0, import_web370.insert)(_el$, (0, import_web371.createComponent)(RouterContextProvider, {
      get value() {
        return router();
      },
      get children() {
        return props.children;
      }
    }));
    return _el$;
  })();
}

// src/components/ion-route.tsx
var import_web376 = require("solid-js/web");
var import_web377 = require("solid-js/web");
var import_web378 = require("solid-js/web");
var import_web379 = require("solid-js/web");
var import_web380 = require("solid-js/web");
var import_web381 = require("solid-js/web");
var import_web382 = require("solid-js/web");
var import_ion_route = require("@ionic/core/components/ion-route");
var import_solid_js4 = require("solid-js");
var _tmpl$94 = /* @__PURE__ */ (0, import_web376.template)(`<ion-route>`, true, false);
(0, import_ion_route.defineCustomElement)();
function RouteRouterContextProvider(props) {
  Object.defineProperty(props.componentOptions.element, "renderRoot", {
    value: props.componentOptions.element
  });
  return (0, import_web382.createComponent)(RouterContextProvider, {
    get value() {
      return props.router;
    },
    get children() {
      return props.component(props.componentProps);
    }
  });
}
function IonRoute(props) {
  const router = useRouter();
  const [_, propsToFix] = (0, import_solid_js4.splitProps)(props, ["component", "componentProps"]);
  const fixedProps = () => fixProps(propsToFix);
  return (() => {
    var _el$ = _tmpl$94();
    (0, import_web379.spread)(_el$, (0, import_web380.mergeProps)(fixedProps, {
      get component() {
        return typeof props.component === "string" ? props.component : ComponentRefElementName;
      }
    }), false, false);
    _el$._$owner = (0, import_web378.getOwner)();
    (0, import_web377.effect)(() => _el$.componentProps = typeof props.component === "string" ? void 0 : {
      component: RouteRouterContextProvider,
      componentProps: {
        component: props.component,
        componentProps: props.componentProps ?? {},
        router
      }
    });
    return _el$;
  })();
}

// src/utils/setupIonicSolid.ts
var import_components = require("@ionic/core/components");
function setupIonicSolid(config = {}) {
  if (typeof document !== "undefined") {
    document.documentElement.classList.add("ion-ce");
  }
  (0, import_components.initialize)({
    ...config
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ComponentRef,
  ComponentRefElementName,
  IonAccordion,
  IonAccordionGroup,
  IonActionSheet,
  IonAlert,
  IonApp,
  IonAvatar,
  IonBackButton,
  IonBackdrop,
  IonBadge,
  IonBreadcrumb,
  IonBreadcrumbs,
  IonButton,
  IonButtons,
  IonCard,
  IonCardContent,
  IonCardHeader,
  IonCardSubtitle,
  IonCardTitle,
  IonCheckbox,
  IonChip,
  IonCol,
  IonContent,
  IonDatetime,
  IonDatetimeButton,
  IonFab,
  IonFabButton,
  IonFabList,
  IonFooter,
  IonGrid,
  IonHeader,
  IonIcon,
  IonImg,
  IonInfiniteScroll,
  IonInfiniteScrollContent,
  IonInput,
  IonInputPasswordToggle,
  IonItem,
  IonItemDivider,
  IonItemGroup,
  IonItemOption,
  IonItemOptions,
  IonItemSliding,
  IonLabel,
  IonList,
  IonListHeader,
  IonLoading,
  IonMenu,
  IonMenuButton,
  IonMenuToggle,
  IonModal,
  IonNav,
  IonNavLink,
  IonNote,
  IonPicker,
  IonPickerColumn,
  IonPickerColumnOption,
  IonPickerLegacy,
  IonPickerLegacyColumn,
  IonPopover,
  IonProgressBar,
  IonRadio,
  IonRadioGroup,
  IonRange,
  IonRefresher,
  IonRefresherContent,
  IonReorder,
  IonReorderGroup,
  IonRippleEffect,
  IonRoute,
  IonRouteRedirect,
  IonRouter,
  IonRouterLink,
  IonRouterOutlet,
  IonRow,
  IonSearchbar,
  IonSegment,
  IonSegmentButton,
  IonSelect,
  IonSelectOption,
  IonSelectPopover,
  IonSkeletonText,
  IonSpinner,
  IonSplitPane,
  IonTab,
  IonTabBar,
  IonTabButton,
  IonTabs,
  IonText,
  IonTextarea,
  IonThumbnail,
  IonTitle,
  IonToast,
  IonToggle,
  IonToolbar,
  RouterContext,
  RouterContextProvider,
  setupIonicSolid,
  useRouter
});
/*! Bundled license information:

@stencil/core/internal/client/shadow-css.js:
  (**
   * @license
   * Copyright Google Inc. All Rights Reserved.
   *
   * Use of this source code is governed by an MIT-style license that can be
   * found in the LICENSE file at https://angular.io/license
   *
   * This file is a port of shadowCSS from `webcomponents.js` to TypeScript.
   * https://github.com/webcomponents/webcomponentsjs/blob/4efecd7e0e/src/ShadowCSS/ShadowCSS.js
   * https://github.com/angular/angular/blob/master/packages/compiler/src/shadow_css.ts
   *)

@stencil/core/internal/client/index.js:
  (*!__STENCIL_STATIC_IMPORT_SWITCH__*)
*/
//# sourceMappingURL=index.js.map