var __defProp = Object.defineProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __glob = (map2) => (path) => {
  var fn = map2[path];
  if (fn)
    return fn();
  throw new Error("Module not found in bundle: " + path);
};
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};

// ../../node_modules/@stencil/core/internal/client/shadow-css.js
var shadow_css_exports = {};
__export(shadow_css_exports, {
  scopeCss: () => scopeCss
});
var escapeRegExpSpecialCharacters, safeSelector, restoreSafeSelector, _polyfillHost, _polyfillSlotted, _polyfillHostContext, _parenSuffix, _cssColonHostRe, _cssColonHostContextRe, _cssColonSlottedRe, _polyfillHostNoCombinator, _polyfillHostNoCombinatorRe, _shadowDOMSelectorsRe, _selectorReSuffix, _polyfillHostRe, createSupportsRuleRe, _colonSlottedRe, _colonHostRe, _colonHostContextRe, _commentRe, stripComments, _commentWithHashRe, extractCommentsWithHash, _ruleRe, _curlyRe, _selectorPartsRe, OPEN_CURLY, CLOSE_CURLY, BLOCK_PLACEHOLDER, processRules, escapeBlocks, insertPolyfillHostInCssText, convertColonRule, colonHostPartReplacer, convertColonHost, colonHostContextPartReplacer, convertColonSlotted, convertColonHostContext, convertShadowDOMSelectors, makeScopeMatcher, selectorNeedsScoping, injectScopingSelector, applySimpleSelectorScope, applyStrictSelectorScope, scopeSelector, scopeSelectors, scopeCssText, replaceShadowCssHost, scopeCss;
var init_shadow_css = __esm({
  "../../node_modules/@stencil/core/internal/client/shadow-css.js"() {
    "use strict";
    escapeRegExpSpecialCharacters = (text) => {
      return text.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
    };
    safeSelector = (selector) => {
      const placeholders = [];
      let index = 0;
      selector = selector.replace(/(\[[^\]]*\])/g, (_, keep) => {
        const replaceBy = `__ph-${index}__`;
        placeholders.push(keep);
        index++;
        return replaceBy;
      });
      const content = selector.replace(/(:nth-[-\w]+)(\([^)]+\))/g, (_, pseudo, exp) => {
        const replaceBy = `__ph-${index}__`;
        placeholders.push(exp);
        index++;
        return pseudo + replaceBy;
      });
      const ss = {
        content,
        placeholders
      };
      return ss;
    };
    restoreSafeSelector = (placeholders, content) => {
      return content.replace(/__ph-(\d+)__/g, (_, index) => placeholders[+index]);
    };
    _polyfillHost = "-shadowcsshost";
    _polyfillSlotted = "-shadowcssslotted";
    _polyfillHostContext = "-shadowcsscontext";
    _parenSuffix = ")(?:\\(((?:\\([^)(]*\\)|[^)(]*)+?)\\))?([^,{]*)";
    _cssColonHostRe = new RegExp("(" + _polyfillHost + _parenSuffix, "gim");
    _cssColonHostContextRe = new RegExp("(" + _polyfillHostContext + _parenSuffix, "gim");
    _cssColonSlottedRe = new RegExp("(" + _polyfillSlotted + _parenSuffix, "gim");
    _polyfillHostNoCombinator = _polyfillHost + "-no-combinator";
    _polyfillHostNoCombinatorRe = /-shadowcsshost-no-combinator([^\s]*)/;
    _shadowDOMSelectorsRe = [/::shadow/g, /::content/g];
    _selectorReSuffix = "([>\\s~+[.,{:][\\s\\S]*)?$";
    _polyfillHostRe = /-shadowcsshost/gim;
    createSupportsRuleRe = (selector) => new RegExp(`((?<!(^@supports(.*)))|(?<={.*))(${selector}\\b)`, "gim");
    _colonSlottedRe = createSupportsRuleRe("::slotted");
    _colonHostRe = createSupportsRuleRe(":host");
    _colonHostContextRe = createSupportsRuleRe(":host-context");
    _commentRe = /\/\*\s*[\s\S]*?\*\//g;
    stripComments = (input) => {
      return input.replace(_commentRe, "");
    };
    _commentWithHashRe = /\/\*\s*#\s*source(Mapping)?URL=[\s\S]+?\*\//g;
    extractCommentsWithHash = (input) => {
      return input.match(_commentWithHashRe) || [];
    };
    _ruleRe = /(\s*)([^;\{\}]+?)(\s*)((?:{%BLOCK%}?\s*;?)|(?:\s*;))/g;
    _curlyRe = /([{}])/g;
    _selectorPartsRe = /(^.*?[^\\])??((:+)(.*)|$)/;
    OPEN_CURLY = "{";
    CLOSE_CURLY = "}";
    BLOCK_PLACEHOLDER = "%BLOCK%";
    processRules = (input, ruleCallback) => {
      const inputWithEscapedBlocks = escapeBlocks(input);
      let nextBlockIndex = 0;
      return inputWithEscapedBlocks.escapedString.replace(_ruleRe, (...m) => {
        const selector = m[2];
        let content = "";
        let suffix = m[4];
        let contentPrefix = "";
        if (suffix && suffix.startsWith("{" + BLOCK_PLACEHOLDER)) {
          content = inputWithEscapedBlocks.blocks[nextBlockIndex++];
          suffix = suffix.substring(BLOCK_PLACEHOLDER.length + 1);
          contentPrefix = "{";
        }
        const cssRule = {
          selector,
          content
        };
        const rule = ruleCallback(cssRule);
        return `${m[1]}${rule.selector}${m[3]}${contentPrefix}${rule.content}${suffix}`;
      });
    };
    escapeBlocks = (input) => {
      const inputParts = input.split(_curlyRe);
      const resultParts = [];
      const escapedBlocks = [];
      let bracketCount = 0;
      let currentBlockParts = [];
      for (let partIndex = 0; partIndex < inputParts.length; partIndex++) {
        const part = inputParts[partIndex];
        if (part === CLOSE_CURLY) {
          bracketCount--;
        }
        if (bracketCount > 0) {
          currentBlockParts.push(part);
        } else {
          if (currentBlockParts.length > 0) {
            escapedBlocks.push(currentBlockParts.join(""));
            resultParts.push(BLOCK_PLACEHOLDER);
            currentBlockParts = [];
          }
          resultParts.push(part);
        }
        if (part === OPEN_CURLY) {
          bracketCount++;
        }
      }
      if (currentBlockParts.length > 0) {
        escapedBlocks.push(currentBlockParts.join(""));
        resultParts.push(BLOCK_PLACEHOLDER);
      }
      const strEscapedBlocks = {
        escapedString: resultParts.join(""),
        blocks: escapedBlocks
      };
      return strEscapedBlocks;
    };
    insertPolyfillHostInCssText = (cssText) => {
      cssText = cssText.replace(_colonHostContextRe, `$1${_polyfillHostContext}`).replace(_colonHostRe, `$1${_polyfillHost}`).replace(_colonSlottedRe, `$1${_polyfillSlotted}`);
      return cssText;
    };
    convertColonRule = (cssText, regExp, partReplacer) => {
      return cssText.replace(regExp, (...m) => {
        if (m[2]) {
          const parts = m[2].split(",");
          const r = [];
          for (let i2 = 0; i2 < parts.length; i2++) {
            const p = parts[i2].trim();
            if (!p)
              break;
            r.push(partReplacer(_polyfillHostNoCombinator, p, m[3]));
          }
          return r.join(",");
        } else {
          return _polyfillHostNoCombinator + m[3];
        }
      });
    };
    colonHostPartReplacer = (host, part, suffix) => {
      return host + part.replace(_polyfillHost, "") + suffix;
    };
    convertColonHost = (cssText) => {
      return convertColonRule(cssText, _cssColonHostRe, colonHostPartReplacer);
    };
    colonHostContextPartReplacer = (host, part, suffix) => {
      if (part.indexOf(_polyfillHost) > -1) {
        return colonHostPartReplacer(host, part, suffix);
      } else {
        return host + part + suffix + ", " + part + " " + host + suffix;
      }
    };
    convertColonSlotted = (cssText, slotScopeId) => {
      const slotClass = "." + slotScopeId + " > ";
      const selectors = [];
      cssText = cssText.replace(_cssColonSlottedRe, (...m) => {
        if (m[2]) {
          const compound = m[2].trim();
          const suffix = m[3];
          const slottedSelector = slotClass + compound + suffix;
          let prefixSelector = "";
          for (let i2 = m[4] - 1; i2 >= 0; i2--) {
            const char = m[5][i2];
            if (char === "}" || char === ",") {
              break;
            }
            prefixSelector = char + prefixSelector;
          }
          const orgSelector = (prefixSelector + slottedSelector).trim();
          const addedSelector = `${prefixSelector.trimEnd()}${slottedSelector.trim()}`.trim();
          if (orgSelector !== addedSelector) {
            const updatedSelector = `${addedSelector}, ${orgSelector}`;
            selectors.push({
              orgSelector,
              updatedSelector
            });
          }
          return slottedSelector;
        } else {
          return _polyfillHostNoCombinator + m[3];
        }
      });
      return {
        selectors,
        cssText
      };
    };
    convertColonHostContext = (cssText) => {
      return convertColonRule(cssText, _cssColonHostContextRe, colonHostContextPartReplacer);
    };
    convertShadowDOMSelectors = (cssText) => {
      return _shadowDOMSelectorsRe.reduce((result, pattern) => result.replace(pattern, " "), cssText);
    };
    makeScopeMatcher = (scopeSelector2) => {
      const lre = /\[/g;
      const rre = /\]/g;
      scopeSelector2 = scopeSelector2.replace(lre, "\\[").replace(rre, "\\]");
      return new RegExp("^(" + scopeSelector2 + ")" + _selectorReSuffix, "m");
    };
    selectorNeedsScoping = (selector, scopeSelector2) => {
      const re = makeScopeMatcher(scopeSelector2);
      return !re.test(selector);
    };
    injectScopingSelector = (selector, scopingSelector) => {
      return selector.replace(_selectorPartsRe, (_, before = "", _colonGroup, colon = "", after = "") => {
        return before + scopingSelector + colon + after;
      });
    };
    applySimpleSelectorScope = (selector, scopeSelector2, hostSelector) => {
      _polyfillHostRe.lastIndex = 0;
      if (_polyfillHostRe.test(selector)) {
        const replaceBy = `.${hostSelector}`;
        return selector.replace(_polyfillHostNoCombinatorRe, (_, selector2) => injectScopingSelector(selector2, replaceBy)).replace(_polyfillHostRe, replaceBy + " ");
      }
      return scopeSelector2 + " " + selector;
    };
    applyStrictSelectorScope = (selector, scopeSelector2, hostSelector) => {
      const isRe = /\[is=([^\]]*)\]/g;
      scopeSelector2 = scopeSelector2.replace(isRe, (_, ...parts) => parts[0]);
      const className = "." + scopeSelector2;
      const _scopeSelectorPart = (p) => {
        let scopedP = p.trim();
        if (!scopedP) {
          return "";
        }
        if (p.indexOf(_polyfillHostNoCombinator) > -1) {
          scopedP = applySimpleSelectorScope(p, scopeSelector2, hostSelector);
        } else {
          const t = p.replace(_polyfillHostRe, "");
          if (t.length > 0) {
            scopedP = injectScopingSelector(t, className);
          }
        }
        return scopedP;
      };
      const safeContent = safeSelector(selector);
      selector = safeContent.content;
      let scopedSelector = "";
      let startIndex = 0;
      let res;
      const sep = /( |>|\+|~(?!=))\s*/g;
      const hasHost = selector.indexOf(_polyfillHostNoCombinator) > -1;
      let shouldScope = !hasHost;
      while ((res = sep.exec(selector)) !== null) {
        const separator = res[1];
        const part2 = selector.slice(startIndex, res.index).trim();
        shouldScope = shouldScope || part2.indexOf(_polyfillHostNoCombinator) > -1;
        const scopedPart = shouldScope ? _scopeSelectorPart(part2) : part2;
        scopedSelector += `${scopedPart} ${separator} `;
        startIndex = sep.lastIndex;
      }
      const part = selector.substring(startIndex);
      shouldScope = shouldScope || part.indexOf(_polyfillHostNoCombinator) > -1;
      scopedSelector += shouldScope ? _scopeSelectorPart(part) : part;
      return restoreSafeSelector(safeContent.placeholders, scopedSelector);
    };
    scopeSelector = (selector, scopeSelectorText, hostSelector, slotSelector) => {
      return selector.split(",").map((shallowPart) => {
        if (slotSelector && shallowPart.indexOf("." + slotSelector) > -1) {
          return shallowPart.trim();
        }
        if (selectorNeedsScoping(shallowPart, scopeSelectorText)) {
          return applyStrictSelectorScope(shallowPart, scopeSelectorText, hostSelector).trim();
        } else {
          return shallowPart.trim();
        }
      }).join(", ");
    };
    scopeSelectors = (cssText, scopeSelectorText, hostSelector, slotSelector, commentOriginalSelector) => {
      return processRules(cssText, (rule) => {
        let selector = rule.selector;
        let content = rule.content;
        if (rule.selector[0] !== "@") {
          selector = scopeSelector(rule.selector, scopeSelectorText, hostSelector, slotSelector);
        } else if (rule.selector.startsWith("@media") || rule.selector.startsWith("@supports") || rule.selector.startsWith("@page") || rule.selector.startsWith("@document")) {
          content = scopeSelectors(rule.content, scopeSelectorText, hostSelector, slotSelector, commentOriginalSelector);
        }
        const cssRule = {
          selector: selector.replace(/\s{2,}/g, " ").trim(),
          content
        };
        return cssRule;
      });
    };
    scopeCssText = (cssText, scopeId2, hostScopeId, slotScopeId, commentOriginalSelector) => {
      cssText = insertPolyfillHostInCssText(cssText);
      cssText = convertColonHost(cssText);
      cssText = convertColonHostContext(cssText);
      const slotted = convertColonSlotted(cssText, slotScopeId);
      cssText = slotted.cssText;
      cssText = convertShadowDOMSelectors(cssText);
      if (scopeId2) {
        cssText = scopeSelectors(cssText, scopeId2, hostScopeId, slotScopeId, commentOriginalSelector);
      }
      cssText = replaceShadowCssHost(cssText, hostScopeId);
      cssText = cssText.replace(/>\s*\*\s+([^{, ]+)/gm, " $1 ");
      return {
        cssText: cssText.trim(),
        // We need to replace the shadow CSS host string in each of these selectors since we created
        // them prior to the replacement happening in the components CSS text.
        slottedSelectors: slotted.selectors.map((ref) => ({
          orgSelector: replaceShadowCssHost(ref.orgSelector, hostScopeId),
          updatedSelector: replaceShadowCssHost(ref.updatedSelector, hostScopeId)
        }))
      };
    };
    replaceShadowCssHost = (cssText, hostScopeId) => {
      return cssText.replace(/-shadowcsshost-no-combinator/g, `.${hostScopeId}`);
    };
    scopeCss = (cssText, scopeId2, commentOriginalSelector) => {
      const hostScopeId = scopeId2 + "-h";
      const slotScopeId = scopeId2 + "-s";
      const commentsWithHash = extractCommentsWithHash(cssText);
      cssText = stripComments(cssText);
      const orgSelectors = [];
      if (commentOriginalSelector) {
        const processCommentedSelector = (rule) => {
          const placeholder = `/*!@___${orgSelectors.length}___*/`;
          const comment = `/*!@${rule.selector}*/`;
          orgSelectors.push({ placeholder, comment });
          rule.selector = placeholder + rule.selector;
          return rule;
        };
        cssText = processRules(cssText, (rule) => {
          if (rule.selector[0] !== "@") {
            return processCommentedSelector(rule);
          } else if (rule.selector.startsWith("@media") || rule.selector.startsWith("@supports") || rule.selector.startsWith("@page") || rule.selector.startsWith("@document")) {
            rule.content = processRules(rule.content, processCommentedSelector);
            return rule;
          }
          return rule;
        });
      }
      const scoped = scopeCssText(cssText, scopeId2, hostScopeId, slotScopeId, commentOriginalSelector);
      cssText = [scoped.cssText, ...commentsWithHash].join("\n");
      if (commentOriginalSelector) {
        orgSelectors.forEach(({ placeholder, comment }) => {
          cssText = cssText.replace(placeholder, comment);
        });
      }
      scoped.slottedSelectors.forEach((slottedSelector) => {
        const regex = new RegExp(escapeRegExpSpecialCharacters(slottedSelector.orgSelector), "g");
        cssText = cssText.replace(regex, slottedSelector.updatedSelector);
      });
      return cssText;
    };
  }
});

// src/components/generated/ion-accordion.tsx
import { template as _$template } from "solid-js/web";
import { getOwner as _$getOwner } from "solid-js/web";
import { spread as _$spread } from "solid-js/web";
import { mergeProps as _$mergeProps } from "solid-js/web";
import { defineCustomElement } from "@ionic/core/components/ion-accordion";

// src/utils/fixProps.ts
var NON_PROP_REGEX = /(^on[A-Z]|^(children|key|class|style)$|:)/;
function fixProps(props) {
  const newProps = {};
  const keys = Object.keys(props);
  for (const key of keys) {
    if (NON_PROP_REGEX.test(key)) {
      newProps[key] = props[key];
    } else {
      newProps[`prop:${key}`] = props[key];
    }
  }
  return newProps;
}

// src/components/generated/ion-accordion.tsx
var _tmpl$ = /* @__PURE__ */ _$template(`<ion-accordion>`, true, false);
defineCustomElement();
function IonAccordion(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$();
    _$spread(_el$, _$mergeProps(fixedProps), false, false);
    _el$._$owner = _$getOwner();
    return _el$;
  })();
}

// src/components/generated/ion-accordion-group.tsx
import { template as _$template2 } from "solid-js/web";
import { getOwner as _$getOwner2 } from "solid-js/web";
import { spread as _$spread2 } from "solid-js/web";
import { mergeProps as _$mergeProps2 } from "solid-js/web";
import { defineCustomElement as defineCustomElement2 } from "@ionic/core/components/ion-accordion-group";
var _tmpl$2 = /* @__PURE__ */ _$template2(`<ion-accordion-group>`, true, false);
defineCustomElement2();
function IonAccordionGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$2();
    _$spread2(_el$, _$mergeProps2(fixedProps), false, false);
    _el$._$owner = _$getOwner2();
    return _el$;
  })();
}

// src/components/generated/ion-action-sheet.tsx
import { template as _$template3 } from "solid-js/web";
import { getOwner as _$getOwner3 } from "solid-js/web";
import { spread as _$spread3 } from "solid-js/web";
import { mergeProps as _$mergeProps3 } from "solid-js/web";
import { defineCustomElement as defineCustomElement3 } from "@ionic/core/components/ion-action-sheet";
var _tmpl$3 = /* @__PURE__ */ _$template3(`<ion-action-sheet>`, true, false);
defineCustomElement3();
function IonActionSheet(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$3();
    _$spread3(_el$, _$mergeProps3(fixedProps), false, false);
    _el$._$owner = _$getOwner3();
    return _el$;
  })();
}

// src/components/generated/ion-alert.tsx
import { template as _$template4 } from "solid-js/web";
import { getOwner as _$getOwner4 } from "solid-js/web";
import { spread as _$spread4 } from "solid-js/web";
import { mergeProps as _$mergeProps4 } from "solid-js/web";
import { defineCustomElement as defineCustomElement4 } from "@ionic/core/components/ion-alert";
var _tmpl$4 = /* @__PURE__ */ _$template4(`<ion-alert>`, true, false);
defineCustomElement4();
function IonAlert(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$4();
    _$spread4(_el$, _$mergeProps4(fixedProps), false, false);
    _el$._$owner = _$getOwner4();
    return _el$;
  })();
}

// src/components/generated/ion-app.tsx
import { template as _$template5 } from "solid-js/web";
import { getOwner as _$getOwner5 } from "solid-js/web";
import { spread as _$spread5 } from "solid-js/web";
import { mergeProps as _$mergeProps5 } from "solid-js/web";
import { defineCustomElement as defineCustomElement5 } from "@ionic/core/components/ion-app";
var _tmpl$5 = /* @__PURE__ */ _$template5(`<ion-app>`, true, false);
defineCustomElement5();
function IonApp(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$5();
    _$spread5(_el$, _$mergeProps5(fixedProps), false, false);
    _el$._$owner = _$getOwner5();
    return _el$;
  })();
}

// src/components/generated/ion-avatar.tsx
import { template as _$template6 } from "solid-js/web";
import { getOwner as _$getOwner6 } from "solid-js/web";
import { spread as _$spread6 } from "solid-js/web";
import { mergeProps as _$mergeProps6 } from "solid-js/web";
import { defineCustomElement as defineCustomElement6 } from "@ionic/core/components/ion-avatar";
var _tmpl$6 = /* @__PURE__ */ _$template6(`<ion-avatar>`, true, false);
defineCustomElement6();
function IonAvatar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$6();
    _$spread6(_el$, _$mergeProps6(fixedProps), false, false);
    _el$._$owner = _$getOwner6();
    return _el$;
  })();
}

// src/components/generated/ion-back-button.tsx
import { template as _$template7 } from "solid-js/web";
import { getOwner as _$getOwner7 } from "solid-js/web";
import { spread as _$spread7 } from "solid-js/web";
import { mergeProps as _$mergeProps7 } from "solid-js/web";
import { defineCustomElement as defineCustomElement7 } from "@ionic/core/components/ion-back-button";
var _tmpl$7 = /* @__PURE__ */ _$template7(`<ion-back-button>`, true, false);
defineCustomElement7();
function IonBackButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$7();
    _$spread7(_el$, _$mergeProps7(fixedProps), false, false);
    _el$._$owner = _$getOwner7();
    return _el$;
  })();
}

// src/components/generated/ion-backdrop.tsx
import { template as _$template8 } from "solid-js/web";
import { getOwner as _$getOwner8 } from "solid-js/web";
import { spread as _$spread8 } from "solid-js/web";
import { mergeProps as _$mergeProps8 } from "solid-js/web";
import { defineCustomElement as defineCustomElement8 } from "@ionic/core/components/ion-backdrop";
var _tmpl$8 = /* @__PURE__ */ _$template8(`<ion-backdrop>`, true, false);
defineCustomElement8();
function IonBackdrop(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$8();
    _$spread8(_el$, _$mergeProps8(fixedProps), false, false);
    _el$._$owner = _$getOwner8();
    return _el$;
  })();
}

// src/components/generated/ion-badge.tsx
import { template as _$template9 } from "solid-js/web";
import { getOwner as _$getOwner9 } from "solid-js/web";
import { spread as _$spread9 } from "solid-js/web";
import { mergeProps as _$mergeProps9 } from "solid-js/web";
import { defineCustomElement as defineCustomElement9 } from "@ionic/core/components/ion-badge";
var _tmpl$9 = /* @__PURE__ */ _$template9(`<ion-badge>`, true, false);
defineCustomElement9();
function IonBadge(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$9();
    _$spread9(_el$, _$mergeProps9(fixedProps), false, false);
    _el$._$owner = _$getOwner9();
    return _el$;
  })();
}

// src/components/generated/ion-breadcrumb.tsx
import { template as _$template10 } from "solid-js/web";
import { getOwner as _$getOwner10 } from "solid-js/web";
import { spread as _$spread10 } from "solid-js/web";
import { mergeProps as _$mergeProps10 } from "solid-js/web";
import { defineCustomElement as defineCustomElement10 } from "@ionic/core/components/ion-breadcrumb";
var _tmpl$10 = /* @__PURE__ */ _$template10(`<ion-breadcrumb>`, true, false);
defineCustomElement10();
function IonBreadcrumb(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$10();
    _$spread10(_el$, _$mergeProps10(fixedProps), false, false);
    _el$._$owner = _$getOwner10();
    return _el$;
  })();
}

// src/components/generated/ion-breadcrumbs.tsx
import { template as _$template11 } from "solid-js/web";
import { getOwner as _$getOwner11 } from "solid-js/web";
import { spread as _$spread11 } from "solid-js/web";
import { mergeProps as _$mergeProps11 } from "solid-js/web";
import { defineCustomElement as defineCustomElement11 } from "@ionic/core/components/ion-breadcrumbs";
var _tmpl$11 = /* @__PURE__ */ _$template11(`<ion-breadcrumbs>`, true, false);
defineCustomElement11();
function IonBreadcrumbs(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$11();
    _$spread11(_el$, _$mergeProps11(fixedProps), false, false);
    _el$._$owner = _$getOwner11();
    return _el$;
  })();
}

// src/components/generated/ion-button.tsx
import { template as _$template12 } from "solid-js/web";
import { getOwner as _$getOwner12 } from "solid-js/web";
import { spread as _$spread12 } from "solid-js/web";
import { mergeProps as _$mergeProps12 } from "solid-js/web";
import { defineCustomElement as defineCustomElement12 } from "@ionic/core/components/ion-button";
var _tmpl$12 = /* @__PURE__ */ _$template12(`<ion-button>`, true, false);
defineCustomElement12();
function IonButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$12();
    _$spread12(_el$, _$mergeProps12(fixedProps), false, false);
    _el$._$owner = _$getOwner12();
    return _el$;
  })();
}

// src/components/generated/ion-buttons.tsx
import { template as _$template13 } from "solid-js/web";
import { getOwner as _$getOwner13 } from "solid-js/web";
import { spread as _$spread13 } from "solid-js/web";
import { mergeProps as _$mergeProps13 } from "solid-js/web";
import { defineCustomElement as defineCustomElement13 } from "@ionic/core/components/ion-buttons";
var _tmpl$13 = /* @__PURE__ */ _$template13(`<ion-buttons>`, true, false);
defineCustomElement13();
function IonButtons(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$13();
    _$spread13(_el$, _$mergeProps13(fixedProps), false, false);
    _el$._$owner = _$getOwner13();
    return _el$;
  })();
}

// src/components/generated/ion-card.tsx
import { template as _$template14 } from "solid-js/web";
import { getOwner as _$getOwner14 } from "solid-js/web";
import { spread as _$spread14 } from "solid-js/web";
import { mergeProps as _$mergeProps14 } from "solid-js/web";
import { defineCustomElement as defineCustomElement14 } from "@ionic/core/components/ion-card";
var _tmpl$14 = /* @__PURE__ */ _$template14(`<ion-card>`, true, false);
defineCustomElement14();
function IonCard(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$14();
    _$spread14(_el$, _$mergeProps14(fixedProps), false, false);
    _el$._$owner = _$getOwner14();
    return _el$;
  })();
}

// src/components/generated/ion-card-content.tsx
import { template as _$template15 } from "solid-js/web";
import { getOwner as _$getOwner15 } from "solid-js/web";
import { spread as _$spread15 } from "solid-js/web";
import { mergeProps as _$mergeProps15 } from "solid-js/web";
import { defineCustomElement as defineCustomElement15 } from "@ionic/core/components/ion-card-content";
var _tmpl$15 = /* @__PURE__ */ _$template15(`<ion-card-content>`, true, false);
defineCustomElement15();
function IonCardContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$15();
    _$spread15(_el$, _$mergeProps15(fixedProps), false, false);
    _el$._$owner = _$getOwner15();
    return _el$;
  })();
}

// src/components/generated/ion-card-header.tsx
import { template as _$template16 } from "solid-js/web";
import { getOwner as _$getOwner16 } from "solid-js/web";
import { spread as _$spread16 } from "solid-js/web";
import { mergeProps as _$mergeProps16 } from "solid-js/web";
import { defineCustomElement as defineCustomElement16 } from "@ionic/core/components/ion-card-header";
var _tmpl$16 = /* @__PURE__ */ _$template16(`<ion-card-header>`, true, false);
defineCustomElement16();
function IonCardHeader(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$16();
    _$spread16(_el$, _$mergeProps16(fixedProps), false, false);
    _el$._$owner = _$getOwner16();
    return _el$;
  })();
}

// src/components/generated/ion-card-subtitle.tsx
import { template as _$template17 } from "solid-js/web";
import { getOwner as _$getOwner17 } from "solid-js/web";
import { spread as _$spread17 } from "solid-js/web";
import { mergeProps as _$mergeProps17 } from "solid-js/web";
import { defineCustomElement as defineCustomElement17 } from "@ionic/core/components/ion-card-subtitle";
var _tmpl$17 = /* @__PURE__ */ _$template17(`<ion-card-subtitle>`, true, false);
defineCustomElement17();
function IonCardSubtitle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$17();
    _$spread17(_el$, _$mergeProps17(fixedProps), false, false);
    _el$._$owner = _$getOwner17();
    return _el$;
  })();
}

// src/components/generated/ion-card-title.tsx
import { template as _$template18 } from "solid-js/web";
import { getOwner as _$getOwner18 } from "solid-js/web";
import { spread as _$spread18 } from "solid-js/web";
import { mergeProps as _$mergeProps18 } from "solid-js/web";
import { defineCustomElement as defineCustomElement18 } from "@ionic/core/components/ion-card-title";
var _tmpl$18 = /* @__PURE__ */ _$template18(`<ion-card-title>`, true, false);
defineCustomElement18();
function IonCardTitle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$18();
    _$spread18(_el$, _$mergeProps18(fixedProps), false, false);
    _el$._$owner = _$getOwner18();
    return _el$;
  })();
}

// src/components/generated/ion-checkbox.tsx
import { template as _$template19 } from "solid-js/web";
import { getOwner as _$getOwner19 } from "solid-js/web";
import { spread as _$spread19 } from "solid-js/web";
import { mergeProps as _$mergeProps19 } from "solid-js/web";
import { defineCustomElement as defineCustomElement19 } from "@ionic/core/components/ion-checkbox";
var _tmpl$19 = /* @__PURE__ */ _$template19(`<ion-checkbox>`, true, false);
defineCustomElement19();
function IonCheckbox(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$19();
    _$spread19(_el$, _$mergeProps19(fixedProps), false, false);
    _el$._$owner = _$getOwner19();
    return _el$;
  })();
}

// src/components/generated/ion-chip.tsx
import { template as _$template20 } from "solid-js/web";
import { getOwner as _$getOwner20 } from "solid-js/web";
import { spread as _$spread20 } from "solid-js/web";
import { mergeProps as _$mergeProps20 } from "solid-js/web";
import { defineCustomElement as defineCustomElement20 } from "@ionic/core/components/ion-chip";
var _tmpl$20 = /* @__PURE__ */ _$template20(`<ion-chip>`, true, false);
defineCustomElement20();
function IonChip(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$20();
    _$spread20(_el$, _$mergeProps20(fixedProps), false, false);
    _el$._$owner = _$getOwner20();
    return _el$;
  })();
}

// src/components/generated/ion-col.tsx
import { template as _$template21 } from "solid-js/web";
import { getOwner as _$getOwner21 } from "solid-js/web";
import { spread as _$spread21 } from "solid-js/web";
import { mergeProps as _$mergeProps21 } from "solid-js/web";
import { defineCustomElement as defineCustomElement21 } from "@ionic/core/components/ion-col";
var _tmpl$21 = /* @__PURE__ */ _$template21(`<ion-col>`, true, false);
defineCustomElement21();
function IonCol(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$21();
    _$spread21(_el$, _$mergeProps21(fixedProps), false, false);
    _el$._$owner = _$getOwner21();
    return _el$;
  })();
}

// src/components/generated/ion-content.tsx
import { template as _$template22 } from "solid-js/web";
import { getOwner as _$getOwner22 } from "solid-js/web";
import { spread as _$spread22 } from "solid-js/web";
import { mergeProps as _$mergeProps22 } from "solid-js/web";
import { defineCustomElement as defineCustomElement22 } from "@ionic/core/components/ion-content";
var _tmpl$22 = /* @__PURE__ */ _$template22(`<ion-content>`, true, false);
defineCustomElement22();
function IonContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$22();
    _$spread22(_el$, _$mergeProps22(fixedProps), false, false);
    _el$._$owner = _$getOwner22();
    return _el$;
  })();
}

// src/components/generated/ion-datetime.tsx
import { template as _$template23 } from "solid-js/web";
import { getOwner as _$getOwner23 } from "solid-js/web";
import { spread as _$spread23 } from "solid-js/web";
import { mergeProps as _$mergeProps23 } from "solid-js/web";
import { defineCustomElement as defineCustomElement23 } from "@ionic/core/components/ion-datetime";
var _tmpl$23 = /* @__PURE__ */ _$template23(`<ion-datetime>`, true, false);
defineCustomElement23();
function IonDatetime(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$23();
    _$spread23(_el$, _$mergeProps23(fixedProps), false, false);
    _el$._$owner = _$getOwner23();
    return _el$;
  })();
}

// src/components/generated/ion-datetime-button.tsx
import { template as _$template24 } from "solid-js/web";
import { getOwner as _$getOwner24 } from "solid-js/web";
import { spread as _$spread24 } from "solid-js/web";
import { mergeProps as _$mergeProps24 } from "solid-js/web";
import { defineCustomElement as defineCustomElement24 } from "@ionic/core/components/ion-datetime-button";
var _tmpl$24 = /* @__PURE__ */ _$template24(`<ion-datetime-button>`, true, false);
defineCustomElement24();
function IonDatetimeButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$24();
    _$spread24(_el$, _$mergeProps24(fixedProps), false, false);
    _el$._$owner = _$getOwner24();
    return _el$;
  })();
}

// src/components/generated/ion-fab.tsx
import { template as _$template25 } from "solid-js/web";
import { getOwner as _$getOwner25 } from "solid-js/web";
import { spread as _$spread25 } from "solid-js/web";
import { mergeProps as _$mergeProps25 } from "solid-js/web";
import { defineCustomElement as defineCustomElement25 } from "@ionic/core/components/ion-fab";
var _tmpl$25 = /* @__PURE__ */ _$template25(`<ion-fab>`, true, false);
defineCustomElement25();
function IonFab(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$25();
    _$spread25(_el$, _$mergeProps25(fixedProps), false, false);
    _el$._$owner = _$getOwner25();
    return _el$;
  })();
}

// src/components/generated/ion-fab-button.tsx
import { template as _$template26 } from "solid-js/web";
import { getOwner as _$getOwner26 } from "solid-js/web";
import { spread as _$spread26 } from "solid-js/web";
import { mergeProps as _$mergeProps26 } from "solid-js/web";
import { defineCustomElement as defineCustomElement26 } from "@ionic/core/components/ion-fab-button";
var _tmpl$26 = /* @__PURE__ */ _$template26(`<ion-fab-button>`, true, false);
defineCustomElement26();
function IonFabButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$26();
    _$spread26(_el$, _$mergeProps26(fixedProps), false, false);
    _el$._$owner = _$getOwner26();
    return _el$;
  })();
}

// src/components/generated/ion-fab-list.tsx
import { template as _$template27 } from "solid-js/web";
import { getOwner as _$getOwner27 } from "solid-js/web";
import { spread as _$spread27 } from "solid-js/web";
import { mergeProps as _$mergeProps27 } from "solid-js/web";
import { defineCustomElement as defineCustomElement27 } from "@ionic/core/components/ion-fab-list";
var _tmpl$27 = /* @__PURE__ */ _$template27(`<ion-fab-list>`, true, false);
defineCustomElement27();
function IonFabList(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$27();
    _$spread27(_el$, _$mergeProps27(fixedProps), false, false);
    _el$._$owner = _$getOwner27();
    return _el$;
  })();
}

// src/components/generated/ion-footer.tsx
import { template as _$template28 } from "solid-js/web";
import { getOwner as _$getOwner28 } from "solid-js/web";
import { spread as _$spread28 } from "solid-js/web";
import { mergeProps as _$mergeProps28 } from "solid-js/web";
import { defineCustomElement as defineCustomElement28 } from "@ionic/core/components/ion-footer";
var _tmpl$28 = /* @__PURE__ */ _$template28(`<ion-footer>`, true, false);
defineCustomElement28();
function IonFooter(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$28();
    _$spread28(_el$, _$mergeProps28(fixedProps), false, false);
    _el$._$owner = _$getOwner28();
    return _el$;
  })();
}

// src/components/generated/ion-grid.tsx
import { template as _$template29 } from "solid-js/web";
import { getOwner as _$getOwner29 } from "solid-js/web";
import { spread as _$spread29 } from "solid-js/web";
import { mergeProps as _$mergeProps29 } from "solid-js/web";
import { defineCustomElement as defineCustomElement29 } from "@ionic/core/components/ion-grid";
var _tmpl$29 = /* @__PURE__ */ _$template29(`<ion-grid>`, true, false);
defineCustomElement29();
function IonGrid(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$29();
    _$spread29(_el$, _$mergeProps29(fixedProps), false, false);
    _el$._$owner = _$getOwner29();
    return _el$;
  })();
}

// src/components/generated/ion-header.tsx
import { template as _$template30 } from "solid-js/web";
import { getOwner as _$getOwner30 } from "solid-js/web";
import { spread as _$spread30 } from "solid-js/web";
import { mergeProps as _$mergeProps30 } from "solid-js/web";
import { defineCustomElement as defineCustomElement30 } from "@ionic/core/components/ion-header";
var _tmpl$30 = /* @__PURE__ */ _$template30(`<ion-header>`, true, false);
defineCustomElement30();
function IonHeader(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$30();
    _$spread30(_el$, _$mergeProps30(fixedProps), false, false);
    _el$._$owner = _$getOwner30();
    return _el$;
  })();
}

// src/components/generated/ion-img.tsx
import { template as _$template31 } from "solid-js/web";
import { getOwner as _$getOwner31 } from "solid-js/web";
import { spread as _$spread31 } from "solid-js/web";
import { mergeProps as _$mergeProps31 } from "solid-js/web";
import { defineCustomElement as defineCustomElement31 } from "@ionic/core/components/ion-img";
var _tmpl$31 = /* @__PURE__ */ _$template31(`<ion-img>`, true, false);
defineCustomElement31();
function IonImg(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$31();
    _$spread31(_el$, _$mergeProps31(fixedProps), false, false);
    _el$._$owner = _$getOwner31();
    return _el$;
  })();
}

// src/components/generated/ion-infinite-scroll.tsx
import { template as _$template32 } from "solid-js/web";
import { getOwner as _$getOwner32 } from "solid-js/web";
import { spread as _$spread32 } from "solid-js/web";
import { mergeProps as _$mergeProps32 } from "solid-js/web";
import { defineCustomElement as defineCustomElement32 } from "@ionic/core/components/ion-infinite-scroll";
var _tmpl$32 = /* @__PURE__ */ _$template32(`<ion-infinite-scroll>`, true, false);
defineCustomElement32();
function IonInfiniteScroll(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$32();
    _$spread32(_el$, _$mergeProps32(fixedProps), false, false);
    _el$._$owner = _$getOwner32();
    return _el$;
  })();
}

// src/components/generated/ion-infinite-scroll-content.tsx
import { template as _$template33 } from "solid-js/web";
import { getOwner as _$getOwner33 } from "solid-js/web";
import { spread as _$spread33 } from "solid-js/web";
import { mergeProps as _$mergeProps33 } from "solid-js/web";
import { defineCustomElement as defineCustomElement33 } from "@ionic/core/components/ion-infinite-scroll-content";
var _tmpl$33 = /* @__PURE__ */ _$template33(`<ion-infinite-scroll-content>`, true, false);
defineCustomElement33();
function IonInfiniteScrollContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$33();
    _$spread33(_el$, _$mergeProps33(fixedProps), false, false);
    _el$._$owner = _$getOwner33();
    return _el$;
  })();
}

// src/components/generated/ion-input.tsx
import { template as _$template34 } from "solid-js/web";
import { getOwner as _$getOwner34 } from "solid-js/web";
import { spread as _$spread34 } from "solid-js/web";
import { mergeProps as _$mergeProps34 } from "solid-js/web";
import { defineCustomElement as defineCustomElement34 } from "@ionic/core/components/ion-input";
var _tmpl$34 = /* @__PURE__ */ _$template34(`<ion-input>`, true, false);
defineCustomElement34();
function IonInput(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$34();
    _$spread34(_el$, _$mergeProps34(fixedProps), false, false);
    _el$._$owner = _$getOwner34();
    return _el$;
  })();
}

// src/components/generated/ion-input-password-toggle.tsx
import { template as _$template35 } from "solid-js/web";
import { getOwner as _$getOwner35 } from "solid-js/web";
import { spread as _$spread35 } from "solid-js/web";
import { mergeProps as _$mergeProps35 } from "solid-js/web";
import { defineCustomElement as defineCustomElement35 } from "@ionic/core/components/ion-input-password-toggle";
var _tmpl$35 = /* @__PURE__ */ _$template35(`<ion-input-password-toggle>`, true, false);
defineCustomElement35();
function IonInputPasswordToggle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$35();
    _$spread35(_el$, _$mergeProps35(fixedProps), false, false);
    _el$._$owner = _$getOwner35();
    return _el$;
  })();
}

// src/components/generated/ion-item.tsx
import { template as _$template36 } from "solid-js/web";
import { getOwner as _$getOwner36 } from "solid-js/web";
import { spread as _$spread36 } from "solid-js/web";
import { mergeProps as _$mergeProps36 } from "solid-js/web";
import { defineCustomElement as defineCustomElement36 } from "@ionic/core/components/ion-item";
var _tmpl$36 = /* @__PURE__ */ _$template36(`<ion-item>`, true, false);
defineCustomElement36();
function IonItem(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$36();
    _$spread36(_el$, _$mergeProps36(fixedProps), false, false);
    _el$._$owner = _$getOwner36();
    return _el$;
  })();
}

// src/components/generated/ion-item-divider.tsx
import { template as _$template37 } from "solid-js/web";
import { getOwner as _$getOwner37 } from "solid-js/web";
import { spread as _$spread37 } from "solid-js/web";
import { mergeProps as _$mergeProps37 } from "solid-js/web";
import { defineCustomElement as defineCustomElement37 } from "@ionic/core/components/ion-item-divider";
var _tmpl$37 = /* @__PURE__ */ _$template37(`<ion-item-divider>`, true, false);
defineCustomElement37();
function IonItemDivider(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$37();
    _$spread37(_el$, _$mergeProps37(fixedProps), false, false);
    _el$._$owner = _$getOwner37();
    return _el$;
  })();
}

// src/components/generated/ion-item-group.tsx
import { template as _$template38 } from "solid-js/web";
import { getOwner as _$getOwner38 } from "solid-js/web";
import { spread as _$spread38 } from "solid-js/web";
import { mergeProps as _$mergeProps38 } from "solid-js/web";
import { defineCustomElement as defineCustomElement38 } from "@ionic/core/components/ion-item-group";
var _tmpl$38 = /* @__PURE__ */ _$template38(`<ion-item-group>`, true, false);
defineCustomElement38();
function IonItemGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$38();
    _$spread38(_el$, _$mergeProps38(fixedProps), false, false);
    _el$._$owner = _$getOwner38();
    return _el$;
  })();
}

// src/components/generated/ion-item-option.tsx
import { template as _$template39 } from "solid-js/web";
import { getOwner as _$getOwner39 } from "solid-js/web";
import { spread as _$spread39 } from "solid-js/web";
import { mergeProps as _$mergeProps39 } from "solid-js/web";
import { defineCustomElement as defineCustomElement39 } from "@ionic/core/components/ion-item-option";
var _tmpl$39 = /* @__PURE__ */ _$template39(`<ion-item-option>`, true, false);
defineCustomElement39();
function IonItemOption(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$39();
    _$spread39(_el$, _$mergeProps39(fixedProps), false, false);
    _el$._$owner = _$getOwner39();
    return _el$;
  })();
}

// src/components/generated/ion-item-options.tsx
import { template as _$template40 } from "solid-js/web";
import { getOwner as _$getOwner40 } from "solid-js/web";
import { spread as _$spread40 } from "solid-js/web";
import { mergeProps as _$mergeProps40 } from "solid-js/web";
import { defineCustomElement as defineCustomElement40 } from "@ionic/core/components/ion-item-options";
var _tmpl$40 = /* @__PURE__ */ _$template40(`<ion-item-options>`, true, false);
defineCustomElement40();
function IonItemOptions(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$40();
    _$spread40(_el$, _$mergeProps40(fixedProps), false, false);
    _el$._$owner = _$getOwner40();
    return _el$;
  })();
}

// src/components/generated/ion-item-sliding.tsx
import { template as _$template41 } from "solid-js/web";
import { getOwner as _$getOwner41 } from "solid-js/web";
import { spread as _$spread41 } from "solid-js/web";
import { mergeProps as _$mergeProps41 } from "solid-js/web";
import { defineCustomElement as defineCustomElement41 } from "@ionic/core/components/ion-item-sliding";
var _tmpl$41 = /* @__PURE__ */ _$template41(`<ion-item-sliding>`, true, false);
defineCustomElement41();
function IonItemSliding(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$41();
    _$spread41(_el$, _$mergeProps41(fixedProps), false, false);
    _el$._$owner = _$getOwner41();
    return _el$;
  })();
}

// src/components/generated/ion-label.tsx
import { template as _$template42 } from "solid-js/web";
import { getOwner as _$getOwner42 } from "solid-js/web";
import { spread as _$spread42 } from "solid-js/web";
import { mergeProps as _$mergeProps42 } from "solid-js/web";
import { defineCustomElement as defineCustomElement42 } from "@ionic/core/components/ion-label";
var _tmpl$42 = /* @__PURE__ */ _$template42(`<ion-label>`, true, false);
defineCustomElement42();
function IonLabel(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$42();
    _$spread42(_el$, _$mergeProps42(fixedProps), false, false);
    _el$._$owner = _$getOwner42();
    return _el$;
  })();
}

// src/components/generated/ion-list.tsx
import { template as _$template43 } from "solid-js/web";
import { getOwner as _$getOwner43 } from "solid-js/web";
import { spread as _$spread43 } from "solid-js/web";
import { mergeProps as _$mergeProps43 } from "solid-js/web";
import { defineCustomElement as defineCustomElement43 } from "@ionic/core/components/ion-list";
var _tmpl$43 = /* @__PURE__ */ _$template43(`<ion-list>`, true, false);
defineCustomElement43();
function IonList(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$43();
    _$spread43(_el$, _$mergeProps43(fixedProps), false, false);
    _el$._$owner = _$getOwner43();
    return _el$;
  })();
}

// src/components/generated/ion-list-header.tsx
import { template as _$template44 } from "solid-js/web";
import { getOwner as _$getOwner44 } from "solid-js/web";
import { spread as _$spread44 } from "solid-js/web";
import { mergeProps as _$mergeProps44 } from "solid-js/web";
import { defineCustomElement as defineCustomElement44 } from "@ionic/core/components/ion-list-header";
var _tmpl$44 = /* @__PURE__ */ _$template44(`<ion-list-header>`, true, false);
defineCustomElement44();
function IonListHeader(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$44();
    _$spread44(_el$, _$mergeProps44(fixedProps), false, false);
    _el$._$owner = _$getOwner44();
    return _el$;
  })();
}

// src/components/generated/ion-loading.tsx
import { template as _$template45 } from "solid-js/web";
import { getOwner as _$getOwner45 } from "solid-js/web";
import { spread as _$spread45 } from "solid-js/web";
import { mergeProps as _$mergeProps45 } from "solid-js/web";
import { defineCustomElement as defineCustomElement45 } from "@ionic/core/components/ion-loading";
var _tmpl$45 = /* @__PURE__ */ _$template45(`<ion-loading>`, true, false);
defineCustomElement45();
function IonLoading(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$45();
    _$spread45(_el$, _$mergeProps45(fixedProps), false, false);
    _el$._$owner = _$getOwner45();
    return _el$;
  })();
}

// src/components/generated/ion-menu.tsx
import { template as _$template46 } from "solid-js/web";
import { getOwner as _$getOwner46 } from "solid-js/web";
import { spread as _$spread46 } from "solid-js/web";
import { mergeProps as _$mergeProps46 } from "solid-js/web";
import { defineCustomElement as defineCustomElement46 } from "@ionic/core/components/ion-menu";
var _tmpl$46 = /* @__PURE__ */ _$template46(`<ion-menu>`, true, false);
defineCustomElement46();
function IonMenu(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$46();
    _$spread46(_el$, _$mergeProps46(fixedProps), false, false);
    _el$._$owner = _$getOwner46();
    return _el$;
  })();
}

// src/components/generated/ion-menu-button.tsx
import { template as _$template47 } from "solid-js/web";
import { getOwner as _$getOwner47 } from "solid-js/web";
import { spread as _$spread47 } from "solid-js/web";
import { mergeProps as _$mergeProps47 } from "solid-js/web";
import { defineCustomElement as defineCustomElement47 } from "@ionic/core/components/ion-menu-button";
var _tmpl$47 = /* @__PURE__ */ _$template47(`<ion-menu-button>`, true, false);
defineCustomElement47();
function IonMenuButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$47();
    _$spread47(_el$, _$mergeProps47(fixedProps), false, false);
    _el$._$owner = _$getOwner47();
    return _el$;
  })();
}

// src/components/generated/ion-menu-toggle.tsx
import { template as _$template48 } from "solid-js/web";
import { getOwner as _$getOwner48 } from "solid-js/web";
import { spread as _$spread48 } from "solid-js/web";
import { mergeProps as _$mergeProps48 } from "solid-js/web";
import { defineCustomElement as defineCustomElement48 } from "@ionic/core/components/ion-menu-toggle";
var _tmpl$48 = /* @__PURE__ */ _$template48(`<ion-menu-toggle>`, true, false);
defineCustomElement48();
function IonMenuToggle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$48();
    _$spread48(_el$, _$mergeProps48(fixedProps), false, false);
    _el$._$owner = _$getOwner48();
    return _el$;
  })();
}

// src/components/generated/ion-modal.tsx
import { template as _$template49 } from "solid-js/web";
import { getOwner as _$getOwner49 } from "solid-js/web";
import { spread as _$spread49 } from "solid-js/web";
import { mergeProps as _$mergeProps49 } from "solid-js/web";
import { defineCustomElement as defineCustomElement49 } from "@ionic/core/components/ion-modal";
var _tmpl$49 = /* @__PURE__ */ _$template49(`<ion-modal>`, true, false);
defineCustomElement49();
function IonModal(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$49();
    _$spread49(_el$, _$mergeProps49(fixedProps), false, false);
    _el$._$owner = _$getOwner49();
    return _el$;
  })();
}

// src/components/generated/ion-nav.tsx
import { template as _$template50 } from "solid-js/web";
import { getOwner as _$getOwner50 } from "solid-js/web";
import { spread as _$spread50 } from "solid-js/web";
import { mergeProps as _$mergeProps50 } from "solid-js/web";
import { defineCustomElement as defineCustomElement50 } from "@ionic/core/components/ion-nav";
var _tmpl$50 = /* @__PURE__ */ _$template50(`<ion-nav>`, true, false);
defineCustomElement50();
function IonNav(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$50();
    _$spread50(_el$, _$mergeProps50(fixedProps), false, false);
    _el$._$owner = _$getOwner50();
    return _el$;
  })();
}

// src/components/generated/ion-nav-link.tsx
import { template as _$template51 } from "solid-js/web";
import { getOwner as _$getOwner51 } from "solid-js/web";
import { spread as _$spread51 } from "solid-js/web";
import { mergeProps as _$mergeProps51 } from "solid-js/web";
import { defineCustomElement as defineCustomElement51 } from "@ionic/core/components/ion-nav-link";
var _tmpl$51 = /* @__PURE__ */ _$template51(`<ion-nav-link>`, true, false);
defineCustomElement51();
function IonNavLink(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$51();
    _$spread51(_el$, _$mergeProps51(fixedProps), false, false);
    _el$._$owner = _$getOwner51();
    return _el$;
  })();
}

// src/components/generated/ion-note.tsx
import { template as _$template52 } from "solid-js/web";
import { getOwner as _$getOwner52 } from "solid-js/web";
import { spread as _$spread52 } from "solid-js/web";
import { mergeProps as _$mergeProps52 } from "solid-js/web";
import { defineCustomElement as defineCustomElement52 } from "@ionic/core/components/ion-note";
var _tmpl$52 = /* @__PURE__ */ _$template52(`<ion-note>`, true, false);
defineCustomElement52();
function IonNote(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$52();
    _$spread52(_el$, _$mergeProps52(fixedProps), false, false);
    _el$._$owner = _$getOwner52();
    return _el$;
  })();
}

// src/components/generated/ion-picker.tsx
import { template as _$template53 } from "solid-js/web";
import { getOwner as _$getOwner53 } from "solid-js/web";
import { spread as _$spread53 } from "solid-js/web";
import { mergeProps as _$mergeProps53 } from "solid-js/web";
import { defineCustomElement as defineCustomElement53 } from "@ionic/core/components/ion-picker";
var _tmpl$53 = /* @__PURE__ */ _$template53(`<ion-picker>`, true, false);
defineCustomElement53();
function IonPicker(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$53();
    _$spread53(_el$, _$mergeProps53(fixedProps), false, false);
    _el$._$owner = _$getOwner53();
    return _el$;
  })();
}

// src/components/generated/ion-picker-column.tsx
import { template as _$template54 } from "solid-js/web";
import { getOwner as _$getOwner54 } from "solid-js/web";
import { spread as _$spread54 } from "solid-js/web";
import { mergeProps as _$mergeProps54 } from "solid-js/web";
import { defineCustomElement as defineCustomElement54 } from "@ionic/core/components/ion-picker-column";
var _tmpl$54 = /* @__PURE__ */ _$template54(`<ion-picker-column>`, true, false);
defineCustomElement54();
function IonPickerColumn(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$54();
    _$spread54(_el$, _$mergeProps54(fixedProps), false, false);
    _el$._$owner = _$getOwner54();
    return _el$;
  })();
}

// src/components/generated/ion-picker-column-option.tsx
import { template as _$template55 } from "solid-js/web";
import { getOwner as _$getOwner55 } from "solid-js/web";
import { spread as _$spread55 } from "solid-js/web";
import { mergeProps as _$mergeProps55 } from "solid-js/web";
import { defineCustomElement as defineCustomElement55 } from "@ionic/core/components/ion-picker-column-option";
var _tmpl$55 = /* @__PURE__ */ _$template55(`<ion-picker-column-option>`, true, false);
defineCustomElement55();
function IonPickerColumnOption(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$55();
    _$spread55(_el$, _$mergeProps55(fixedProps), false, false);
    _el$._$owner = _$getOwner55();
    return _el$;
  })();
}

// src/components/generated/ion-picker-legacy.tsx
import { template as _$template56 } from "solid-js/web";
import { getOwner as _$getOwner56 } from "solid-js/web";
import { spread as _$spread56 } from "solid-js/web";
import { mergeProps as _$mergeProps56 } from "solid-js/web";
import { defineCustomElement as defineCustomElement56 } from "@ionic/core/components/ion-picker-legacy";
var _tmpl$56 = /* @__PURE__ */ _$template56(`<ion-picker-legacy>`, true, false);
defineCustomElement56();
function IonPickerLegacy(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$56();
    _$spread56(_el$, _$mergeProps56(fixedProps), false, false);
    _el$._$owner = _$getOwner56();
    return _el$;
  })();
}

// src/components/generated/ion-picker-legacy-column.tsx
import { template as _$template57 } from "solid-js/web";
import { getOwner as _$getOwner57 } from "solid-js/web";
import { spread as _$spread57 } from "solid-js/web";
import { mergeProps as _$mergeProps57 } from "solid-js/web";
import { defineCustomElement as defineCustomElement57 } from "@ionic/core/components/ion-picker-legacy-column";
var _tmpl$57 = /* @__PURE__ */ _$template57(`<ion-picker-legacy-column>`, true, false);
defineCustomElement57();
function IonPickerLegacyColumn(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$57();
    _$spread57(_el$, _$mergeProps57(fixedProps), false, false);
    _el$._$owner = _$getOwner57();
    return _el$;
  })();
}

// src/components/generated/ion-popover.tsx
import { template as _$template58 } from "solid-js/web";
import { getOwner as _$getOwner58 } from "solid-js/web";
import { spread as _$spread58 } from "solid-js/web";
import { mergeProps as _$mergeProps58 } from "solid-js/web";
import { defineCustomElement as defineCustomElement58 } from "@ionic/core/components/ion-popover";
var _tmpl$58 = /* @__PURE__ */ _$template58(`<ion-popover>`, true, false);
defineCustomElement58();
function IonPopover(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$58();
    _$spread58(_el$, _$mergeProps58(fixedProps), false, false);
    _el$._$owner = _$getOwner58();
    return _el$;
  })();
}

// src/components/generated/ion-progress-bar.tsx
import { template as _$template59 } from "solid-js/web";
import { getOwner as _$getOwner59 } from "solid-js/web";
import { spread as _$spread59 } from "solid-js/web";
import { mergeProps as _$mergeProps59 } from "solid-js/web";
import { defineCustomElement as defineCustomElement59 } from "@ionic/core/components/ion-progress-bar";
var _tmpl$59 = /* @__PURE__ */ _$template59(`<ion-progress-bar>`, true, false);
defineCustomElement59();
function IonProgressBar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$59();
    _$spread59(_el$, _$mergeProps59(fixedProps), false, false);
    _el$._$owner = _$getOwner59();
    return _el$;
  })();
}

// src/components/generated/ion-radio.tsx
import { template as _$template60 } from "solid-js/web";
import { getOwner as _$getOwner60 } from "solid-js/web";
import { spread as _$spread60 } from "solid-js/web";
import { mergeProps as _$mergeProps60 } from "solid-js/web";
import { defineCustomElement as defineCustomElement60 } from "@ionic/core/components/ion-radio";
var _tmpl$60 = /* @__PURE__ */ _$template60(`<ion-radio>`, true, false);
defineCustomElement60();
function IonRadio(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$60();
    _$spread60(_el$, _$mergeProps60(fixedProps), false, false);
    _el$._$owner = _$getOwner60();
    return _el$;
  })();
}

// src/components/generated/ion-radio-group.tsx
import { template as _$template61 } from "solid-js/web";
import { getOwner as _$getOwner61 } from "solid-js/web";
import { spread as _$spread61 } from "solid-js/web";
import { mergeProps as _$mergeProps61 } from "solid-js/web";
import { defineCustomElement as defineCustomElement61 } from "@ionic/core/components/ion-radio-group";
var _tmpl$61 = /* @__PURE__ */ _$template61(`<ion-radio-group>`, true, false);
defineCustomElement61();
function IonRadioGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$61();
    _$spread61(_el$, _$mergeProps61(fixedProps), false, false);
    _el$._$owner = _$getOwner61();
    return _el$;
  })();
}

// src/components/generated/ion-range.tsx
import { template as _$template62 } from "solid-js/web";
import { getOwner as _$getOwner62 } from "solid-js/web";
import { spread as _$spread62 } from "solid-js/web";
import { mergeProps as _$mergeProps62 } from "solid-js/web";
import { defineCustomElement as defineCustomElement62 } from "@ionic/core/components/ion-range";
var _tmpl$62 = /* @__PURE__ */ _$template62(`<ion-range>`, true, false);
defineCustomElement62();
function IonRange(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$62();
    _$spread62(_el$, _$mergeProps62(fixedProps), false, false);
    _el$._$owner = _$getOwner62();
    return _el$;
  })();
}

// src/components/generated/ion-refresher.tsx
import { template as _$template63 } from "solid-js/web";
import { getOwner as _$getOwner63 } from "solid-js/web";
import { spread as _$spread63 } from "solid-js/web";
import { mergeProps as _$mergeProps63 } from "solid-js/web";
import { defineCustomElement as defineCustomElement63 } from "@ionic/core/components/ion-refresher";
var _tmpl$63 = /* @__PURE__ */ _$template63(`<ion-refresher>`, true, false);
defineCustomElement63();
function IonRefresher(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$63();
    _$spread63(_el$, _$mergeProps63(fixedProps), false, false);
    _el$._$owner = _$getOwner63();
    return _el$;
  })();
}

// src/components/generated/ion-refresher-content.tsx
import { template as _$template64 } from "solid-js/web";
import { getOwner as _$getOwner64 } from "solid-js/web";
import { spread as _$spread64 } from "solid-js/web";
import { mergeProps as _$mergeProps64 } from "solid-js/web";
import { defineCustomElement as defineCustomElement64 } from "@ionic/core/components/ion-refresher-content";
var _tmpl$64 = /* @__PURE__ */ _$template64(`<ion-refresher-content>`, true, false);
defineCustomElement64();
function IonRefresherContent(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$64();
    _$spread64(_el$, _$mergeProps64(fixedProps), false, false);
    _el$._$owner = _$getOwner64();
    return _el$;
  })();
}

// src/components/generated/ion-reorder.tsx
import { template as _$template65 } from "solid-js/web";
import { getOwner as _$getOwner65 } from "solid-js/web";
import { spread as _$spread65 } from "solid-js/web";
import { mergeProps as _$mergeProps65 } from "solid-js/web";
import { defineCustomElement as defineCustomElement65 } from "@ionic/core/components/ion-reorder";
var _tmpl$65 = /* @__PURE__ */ _$template65(`<ion-reorder>`, true, false);
defineCustomElement65();
function IonReorder(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$65();
    _$spread65(_el$, _$mergeProps65(fixedProps), false, false);
    _el$._$owner = _$getOwner65();
    return _el$;
  })();
}

// src/components/generated/ion-reorder-group.tsx
import { template as _$template66 } from "solid-js/web";
import { getOwner as _$getOwner66 } from "solid-js/web";
import { spread as _$spread66 } from "solid-js/web";
import { mergeProps as _$mergeProps66 } from "solid-js/web";
import { defineCustomElement as defineCustomElement66 } from "@ionic/core/components/ion-reorder-group";
var _tmpl$66 = /* @__PURE__ */ _$template66(`<ion-reorder-group>`, true, false);
defineCustomElement66();
function IonReorderGroup(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$66();
    _$spread66(_el$, _$mergeProps66(fixedProps), false, false);
    _el$._$owner = _$getOwner66();
    return _el$;
  })();
}

// src/components/generated/ion-ripple-effect.tsx
import { template as _$template67 } from "solid-js/web";
import { getOwner as _$getOwner67 } from "solid-js/web";
import { spread as _$spread67 } from "solid-js/web";
import { mergeProps as _$mergeProps67 } from "solid-js/web";
import { defineCustomElement as defineCustomElement67 } from "@ionic/core/components/ion-ripple-effect";
var _tmpl$67 = /* @__PURE__ */ _$template67(`<ion-ripple-effect>`, true, false);
defineCustomElement67();
function IonRippleEffect(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$67();
    _$spread67(_el$, _$mergeProps67(fixedProps), false, false);
    _el$._$owner = _$getOwner67();
    return _el$;
  })();
}

// src/components/generated/ion-route-redirect.tsx
import { template as _$template68 } from "solid-js/web";
import { getOwner as _$getOwner68 } from "solid-js/web";
import { spread as _$spread68 } from "solid-js/web";
import { mergeProps as _$mergeProps68 } from "solid-js/web";
import { defineCustomElement as defineCustomElement68 } from "@ionic/core/components/ion-route-redirect";
var _tmpl$68 = /* @__PURE__ */ _$template68(`<ion-route-redirect>`, true, false);
defineCustomElement68();
function IonRouteRedirect(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$68();
    _$spread68(_el$, _$mergeProps68(fixedProps), false, false);
    _el$._$owner = _$getOwner68();
    return _el$;
  })();
}

// src/components/generated/ion-router-link.tsx
import { template as _$template69 } from "solid-js/web";
import { getOwner as _$getOwner69 } from "solid-js/web";
import { spread as _$spread69 } from "solid-js/web";
import { mergeProps as _$mergeProps69 } from "solid-js/web";
import { defineCustomElement as defineCustomElement69 } from "@ionic/core/components/ion-router-link";
var _tmpl$69 = /* @__PURE__ */ _$template69(`<ion-router-link>`, true, false);
defineCustomElement69();
function IonRouterLink(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$69();
    _$spread69(_el$, _$mergeProps69(fixedProps), false, false);
    _el$._$owner = _$getOwner69();
    return _el$;
  })();
}

// src/components/generated/ion-router-outlet.tsx
import { template as _$template70 } from "solid-js/web";
import { getOwner as _$getOwner70 } from "solid-js/web";
import { spread as _$spread70 } from "solid-js/web";
import { mergeProps as _$mergeProps70 } from "solid-js/web";
import { defineCustomElement as defineCustomElement70 } from "@ionic/core/components/ion-router-outlet";
var _tmpl$70 = /* @__PURE__ */ _$template70(`<ion-router-outlet>`, true, false);
defineCustomElement70();
function IonRouterOutlet(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$70();
    _$spread70(_el$, _$mergeProps70(fixedProps), false, false);
    _el$._$owner = _$getOwner70();
    return _el$;
  })();
}

// src/components/generated/ion-row.tsx
import { template as _$template71 } from "solid-js/web";
import { getOwner as _$getOwner71 } from "solid-js/web";
import { spread as _$spread71 } from "solid-js/web";
import { mergeProps as _$mergeProps71 } from "solid-js/web";
import { defineCustomElement as defineCustomElement71 } from "@ionic/core/components/ion-row";
var _tmpl$71 = /* @__PURE__ */ _$template71(`<ion-row>`, true, false);
defineCustomElement71();
function IonRow(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$71();
    _$spread71(_el$, _$mergeProps71(fixedProps), false, false);
    _el$._$owner = _$getOwner71();
    return _el$;
  })();
}

// src/components/generated/ion-searchbar.tsx
import { template as _$template72 } from "solid-js/web";
import { getOwner as _$getOwner72 } from "solid-js/web";
import { spread as _$spread72 } from "solid-js/web";
import { mergeProps as _$mergeProps72 } from "solid-js/web";
import { defineCustomElement as defineCustomElement72 } from "@ionic/core/components/ion-searchbar";
var _tmpl$72 = /* @__PURE__ */ _$template72(`<ion-searchbar>`, true, false);
defineCustomElement72();
function IonSearchbar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$72();
    _$spread72(_el$, _$mergeProps72(fixedProps), false, false);
    _el$._$owner = _$getOwner72();
    return _el$;
  })();
}

// src/components/generated/ion-segment.tsx
import { template as _$template73 } from "solid-js/web";
import { getOwner as _$getOwner73 } from "solid-js/web";
import { spread as _$spread73 } from "solid-js/web";
import { mergeProps as _$mergeProps73 } from "solid-js/web";
import { defineCustomElement as defineCustomElement73 } from "@ionic/core/components/ion-segment";
var _tmpl$73 = /* @__PURE__ */ _$template73(`<ion-segment>`, true, false);
defineCustomElement73();
function IonSegment(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$73();
    _$spread73(_el$, _$mergeProps73(fixedProps), false, false);
    _el$._$owner = _$getOwner73();
    return _el$;
  })();
}

// src/components/generated/ion-segment-button.tsx
import { template as _$template74 } from "solid-js/web";
import { getOwner as _$getOwner74 } from "solid-js/web";
import { spread as _$spread74 } from "solid-js/web";
import { mergeProps as _$mergeProps74 } from "solid-js/web";
import { defineCustomElement as defineCustomElement74 } from "@ionic/core/components/ion-segment-button";
var _tmpl$74 = /* @__PURE__ */ _$template74(`<ion-segment-button>`, true, false);
defineCustomElement74();
function IonSegmentButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$74();
    _$spread74(_el$, _$mergeProps74(fixedProps), false, false);
    _el$._$owner = _$getOwner74();
    return _el$;
  })();
}

// src/components/generated/ion-select.tsx
import { template as _$template75 } from "solid-js/web";
import { getOwner as _$getOwner75 } from "solid-js/web";
import { spread as _$spread75 } from "solid-js/web";
import { mergeProps as _$mergeProps75 } from "solid-js/web";
import { defineCustomElement as defineCustomElement75 } from "@ionic/core/components/ion-select";
var _tmpl$75 = /* @__PURE__ */ _$template75(`<ion-select>`, true, false);
defineCustomElement75();
function IonSelect(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$75();
    _$spread75(_el$, _$mergeProps75(fixedProps), false, false);
    _el$._$owner = _$getOwner75();
    return _el$;
  })();
}

// src/components/generated/ion-select-option.tsx
import { template as _$template76 } from "solid-js/web";
import { getOwner as _$getOwner76 } from "solid-js/web";
import { spread as _$spread76 } from "solid-js/web";
import { mergeProps as _$mergeProps76 } from "solid-js/web";
import { defineCustomElement as defineCustomElement76 } from "@ionic/core/components/ion-select-option";
var _tmpl$76 = /* @__PURE__ */ _$template76(`<ion-select-option>`, true, false);
defineCustomElement76();
function IonSelectOption(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$76();
    _$spread76(_el$, _$mergeProps76(fixedProps), false, false);
    _el$._$owner = _$getOwner76();
    return _el$;
  })();
}

// src/components/generated/ion-select-popover.tsx
import { template as _$template77 } from "solid-js/web";
import { getOwner as _$getOwner77 } from "solid-js/web";
import { spread as _$spread77 } from "solid-js/web";
import { mergeProps as _$mergeProps77 } from "solid-js/web";
import { defineCustomElement as defineCustomElement77 } from "@ionic/core/components/ion-select-popover";
var _tmpl$77 = /* @__PURE__ */ _$template77(`<ion-select-popover>`, true, false);
defineCustomElement77();
function IonSelectPopover(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$77();
    _$spread77(_el$, _$mergeProps77(fixedProps), false, false);
    _el$._$owner = _$getOwner77();
    return _el$;
  })();
}

// src/components/generated/ion-skeleton-text.tsx
import { template as _$template78 } from "solid-js/web";
import { getOwner as _$getOwner78 } from "solid-js/web";
import { spread as _$spread78 } from "solid-js/web";
import { mergeProps as _$mergeProps78 } from "solid-js/web";
import { defineCustomElement as defineCustomElement78 } from "@ionic/core/components/ion-skeleton-text";
var _tmpl$78 = /* @__PURE__ */ _$template78(`<ion-skeleton-text>`, true, false);
defineCustomElement78();
function IonSkeletonText(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$78();
    _$spread78(_el$, _$mergeProps78(fixedProps), false, false);
    _el$._$owner = _$getOwner78();
    return _el$;
  })();
}

// src/components/generated/ion-spinner.tsx
import { template as _$template79 } from "solid-js/web";
import { getOwner as _$getOwner79 } from "solid-js/web";
import { spread as _$spread79 } from "solid-js/web";
import { mergeProps as _$mergeProps79 } from "solid-js/web";
import { defineCustomElement as defineCustomElement79 } from "@ionic/core/components/ion-spinner";
var _tmpl$79 = /* @__PURE__ */ _$template79(`<ion-spinner>`, true, false);
defineCustomElement79();
function IonSpinner(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$79();
    _$spread79(_el$, _$mergeProps79(fixedProps), false, false);
    _el$._$owner = _$getOwner79();
    return _el$;
  })();
}

// src/components/generated/ion-split-pane.tsx
import { template as _$template80 } from "solid-js/web";
import { getOwner as _$getOwner80 } from "solid-js/web";
import { spread as _$spread80 } from "solid-js/web";
import { mergeProps as _$mergeProps80 } from "solid-js/web";
import { defineCustomElement as defineCustomElement80 } from "@ionic/core/components/ion-split-pane";
var _tmpl$80 = /* @__PURE__ */ _$template80(`<ion-split-pane>`, true, false);
defineCustomElement80();
function IonSplitPane(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$80();
    _$spread80(_el$, _$mergeProps80(fixedProps), false, false);
    _el$._$owner = _$getOwner80();
    return _el$;
  })();
}

// src/components/generated/ion-tab.tsx
import { template as _$template81 } from "solid-js/web";
import { getOwner as _$getOwner81 } from "solid-js/web";
import { spread as _$spread81 } from "solid-js/web";
import { mergeProps as _$mergeProps81 } from "solid-js/web";
import { defineCustomElement as defineCustomElement81 } from "@ionic/core/components/ion-tab";
var _tmpl$81 = /* @__PURE__ */ _$template81(`<ion-tab>`, true, false);
defineCustomElement81();
function IonTab(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$81();
    _$spread81(_el$, _$mergeProps81(fixedProps), false, false);
    _el$._$owner = _$getOwner81();
    return _el$;
  })();
}

// src/components/generated/ion-tab-bar.tsx
import { template as _$template82 } from "solid-js/web";
import { getOwner as _$getOwner82 } from "solid-js/web";
import { spread as _$spread82 } from "solid-js/web";
import { mergeProps as _$mergeProps82 } from "solid-js/web";
import { defineCustomElement as defineCustomElement82 } from "@ionic/core/components/ion-tab-bar";
var _tmpl$82 = /* @__PURE__ */ _$template82(`<ion-tab-bar>`, true, false);
defineCustomElement82();
function IonTabBar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$82();
    _$spread82(_el$, _$mergeProps82(fixedProps), false, false);
    _el$._$owner = _$getOwner82();
    return _el$;
  })();
}

// src/components/generated/ion-tab-button.tsx
import { template as _$template83 } from "solid-js/web";
import { getOwner as _$getOwner83 } from "solid-js/web";
import { spread as _$spread83 } from "solid-js/web";
import { mergeProps as _$mergeProps83 } from "solid-js/web";
import { defineCustomElement as defineCustomElement83 } from "@ionic/core/components/ion-tab-button";
var _tmpl$83 = /* @__PURE__ */ _$template83(`<ion-tab-button>`, true, false);
defineCustomElement83();
function IonTabButton(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$83();
    _$spread83(_el$, _$mergeProps83(fixedProps), false, false);
    _el$._$owner = _$getOwner83();
    return _el$;
  })();
}

// src/components/generated/ion-tabs.tsx
import { template as _$template84 } from "solid-js/web";
import { getOwner as _$getOwner84 } from "solid-js/web";
import { spread as _$spread84 } from "solid-js/web";
import { mergeProps as _$mergeProps84 } from "solid-js/web";
import { defineCustomElement as defineCustomElement84 } from "@ionic/core/components/ion-tabs";
var _tmpl$84 = /* @__PURE__ */ _$template84(`<ion-tabs>`, true, false);
defineCustomElement84();
function IonTabs(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$84();
    _$spread84(_el$, _$mergeProps84(fixedProps), false, false);
    _el$._$owner = _$getOwner84();
    return _el$;
  })();
}

// src/components/generated/ion-text.tsx
import { template as _$template85 } from "solid-js/web";
import { getOwner as _$getOwner85 } from "solid-js/web";
import { spread as _$spread85 } from "solid-js/web";
import { mergeProps as _$mergeProps85 } from "solid-js/web";
import { defineCustomElement as defineCustomElement85 } from "@ionic/core/components/ion-text";
var _tmpl$85 = /* @__PURE__ */ _$template85(`<ion-text>`, true, false);
defineCustomElement85();
function IonText(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$85();
    _$spread85(_el$, _$mergeProps85(fixedProps), false, false);
    _el$._$owner = _$getOwner85();
    return _el$;
  })();
}

// src/components/generated/ion-textarea.tsx
import { template as _$template86 } from "solid-js/web";
import { getOwner as _$getOwner86 } from "solid-js/web";
import { spread as _$spread86 } from "solid-js/web";
import { mergeProps as _$mergeProps86 } from "solid-js/web";
import { defineCustomElement as defineCustomElement86 } from "@ionic/core/components/ion-textarea";
var _tmpl$86 = /* @__PURE__ */ _$template86(`<ion-textarea>`, true, false);
defineCustomElement86();
function IonTextarea(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$86();
    _$spread86(_el$, _$mergeProps86(fixedProps), false, false);
    _el$._$owner = _$getOwner86();
    return _el$;
  })();
}

// src/components/generated/ion-thumbnail.tsx
import { template as _$template87 } from "solid-js/web";
import { getOwner as _$getOwner87 } from "solid-js/web";
import { spread as _$spread87 } from "solid-js/web";
import { mergeProps as _$mergeProps87 } from "solid-js/web";
import { defineCustomElement as defineCustomElement87 } from "@ionic/core/components/ion-thumbnail";
var _tmpl$87 = /* @__PURE__ */ _$template87(`<ion-thumbnail>`, true, false);
defineCustomElement87();
function IonThumbnail(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$87();
    _$spread87(_el$, _$mergeProps87(fixedProps), false, false);
    _el$._$owner = _$getOwner87();
    return _el$;
  })();
}

// src/components/generated/ion-title.tsx
import { template as _$template88 } from "solid-js/web";
import { getOwner as _$getOwner88 } from "solid-js/web";
import { spread as _$spread88 } from "solid-js/web";
import { mergeProps as _$mergeProps88 } from "solid-js/web";
import { defineCustomElement as defineCustomElement88 } from "@ionic/core/components/ion-title";
var _tmpl$88 = /* @__PURE__ */ _$template88(`<ion-title>`, true, false);
defineCustomElement88();
function IonTitle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$88();
    _$spread88(_el$, _$mergeProps88(fixedProps), false, false);
    _el$._$owner = _$getOwner88();
    return _el$;
  })();
}

// src/components/generated/ion-toast.tsx
import { template as _$template89 } from "solid-js/web";
import { getOwner as _$getOwner89 } from "solid-js/web";
import { spread as _$spread89 } from "solid-js/web";
import { mergeProps as _$mergeProps89 } from "solid-js/web";
import { defineCustomElement as defineCustomElement89 } from "@ionic/core/components/ion-toast";
var _tmpl$89 = /* @__PURE__ */ _$template89(`<ion-toast>`, true, false);
defineCustomElement89();
function IonToast(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$89();
    _$spread89(_el$, _$mergeProps89(fixedProps), false, false);
    _el$._$owner = _$getOwner89();
    return _el$;
  })();
}

// src/components/generated/ion-toggle.tsx
import { template as _$template90 } from "solid-js/web";
import { getOwner as _$getOwner90 } from "solid-js/web";
import { spread as _$spread90 } from "solid-js/web";
import { mergeProps as _$mergeProps90 } from "solid-js/web";
import { defineCustomElement as defineCustomElement90 } from "@ionic/core/components/ion-toggle";
var _tmpl$90 = /* @__PURE__ */ _$template90(`<ion-toggle>`, true, false);
defineCustomElement90();
function IonToggle(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$90();
    _$spread90(_el$, _$mergeProps90(fixedProps), false, false);
    _el$._$owner = _$getOwner90();
    return _el$;
  })();
}

// src/components/generated/ion-toolbar.tsx
import { template as _$template91 } from "solid-js/web";
import { getOwner as _$getOwner91 } from "solid-js/web";
import { spread as _$spread91 } from "solid-js/web";
import { mergeProps as _$mergeProps91 } from "solid-js/web";
import { defineCustomElement as defineCustomElement91 } from "@ionic/core/components/ion-toolbar";
var _tmpl$91 = /* @__PURE__ */ _$template91(`<ion-toolbar>`, true, false);
defineCustomElement91();
function IonToolbar(props) {
  const fixedProps = () => fixProps(props);
  return (() => {
    var _el$ = _tmpl$91();
    _$spread91(_el$, _$mergeProps91(fixedProps), false, false);
    _el$._$owner = _$getOwner91();
    return _el$;
  })();
}

// src/components/ComponentRef.tsx
import { memo as _$memo } from "solid-js/web";
import { customElement } from "solid-element";
import { mergeProps } from "solid-js";
function ComponentRef(props, options) {
  const mergedProps = mergeProps(props.componentProps ?? {}, {
    componentOptions: {
      element: options.element
    }
  });
  return _$memo(() => props.component(mergedProps));
}
var ComponentRefElementName = "solid-ion-component-ref";
customElement(ComponentRefElementName, {
  component: () => [],
  componentProps: void 0,
  data: void 0
}, ComponentRef);

// src/components/ion-icon.tsx
import { template as _$template92 } from "solid-js/web";
import { getOwner as _$getOwner92 } from "solid-js/web";
import { spread as _$spread92 } from "solid-js/web";

// ../../node_modules/@stencil/core/internal/app-data/index.js
var BUILD = {
  allRenderFn: false,
  cmpDidLoad: true,
  cmpDidUnload: false,
  cmpDidUpdate: true,
  cmpDidRender: true,
  cmpWillLoad: true,
  cmpWillUpdate: true,
  cmpWillRender: true,
  connectedCallback: true,
  disconnectedCallback: true,
  element: true,
  event: true,
  hasRenderFn: true,
  lifecycle: true,
  hostListener: true,
  hostListenerTargetWindow: true,
  hostListenerTargetDocument: true,
  hostListenerTargetBody: true,
  hostListenerTargetParent: false,
  hostListenerTarget: true,
  member: true,
  method: true,
  mode: true,
  observeAttribute: true,
  prop: true,
  propMutable: true,
  reflect: true,
  scoped: true,
  shadowDom: true,
  slot: true,
  cssAnnotations: true,
  state: true,
  style: true,
  formAssociated: false,
  svg: true,
  updatable: true,
  vdomAttribute: true,
  vdomXlink: true,
  vdomClass: true,
  vdomFunctional: true,
  vdomKey: true,
  vdomListener: true,
  vdomRef: true,
  vdomPropOrAttr: true,
  vdomRender: true,
  vdomStyle: true,
  vdomText: true,
  watchCallback: true,
  taskQueue: true,
  hotModuleReplacement: false,
  isDebug: false,
  isDev: false,
  isTesting: false,
  hydrateServerSide: false,
  hydrateClientSide: false,
  lifecycleDOMEvents: false,
  lazyLoad: false,
  profile: false,
  slotRelocation: true,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  appendChildSlotFix: false,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  cloneNodeFix: false,
  hydratedAttribute: false,
  hydratedClass: true,
  scriptDataOpts: false,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  scopedSlotTextContentFix: false,
  // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
  shadowDomShim: false,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  slotChildNodesFix: false,
  invisiblePrehydration: true,
  propBoolean: true,
  propNumber: true,
  propString: true,
  constructableCSS: true,
  cmpShouldUpdate: true,
  devTools: false,
  shadowDelegatesFocus: true,
  initializeNextTick: false,
  asyncLoading: false,
  asyncQueue: false,
  transformTagName: false,
  attachStyles: true,
  // TODO(STENCIL-914): remove this option when `experimentalSlotFixes` is the default behavior
  experimentalSlotFixes: false
};
var NAMESPACE = (
  /* default */
  "app"
);

// import("./**/*.entry.js*") in ../../node_modules/@stencil/core/internal/client/index.js
var globImport_entry_js = __glob({});

// ../../node_modules/@stencil/core/internal/client/index.js
var __defProp2 = Object.defineProperty;
var __export2 = (target, all) => {
  for (var name in all)
    __defProp2(target, name, { get: all[name], enumerable: true });
};
var Build = {
  isDev: BUILD.isDev ? true : false,
  isBrowser: true,
  isServer: false,
  isTesting: BUILD.isTesting ? true : false
};
var getAssetPath = (path) => {
  const assetUrl = new URL(path, plt.$resourcesUrl$);
  return assetUrl.origin !== win.location.origin ? assetUrl.href : assetUrl.pathname;
};
var EMPTY_OBJ = {};
var SVG_NS = "http://www.w3.org/2000/svg";
var HTML_NS = "http://www.w3.org/1999/xhtml";
var isDef = (v) => v != null;
var isComplexType = (o) => {
  o = typeof o;
  return o === "object" || o === "function";
};
function queryNonceMetaTagContent(doc2) {
  var _a, _b, _c;
  return (_c = (_b = (_a = doc2.head) == null ? void 0 : _a.querySelector('meta[name="csp-nonce"]')) == null ? void 0 : _b.getAttribute("content")) != null ? _c : void 0;
}
var result_exports = {};
__export2(result_exports, {
  err: () => err,
  map: () => map,
  ok: () => ok,
  unwrap: () => unwrap,
  unwrapErr: () => unwrapErr
});
var ok = (value) => ({
  isOk: true,
  isErr: false,
  value
});
var err = (value) => ({
  isOk: false,
  isErr: true,
  value
});
function map(result, fn) {
  if (result.isOk) {
    const val = fn(result.value);
    if (val instanceof Promise) {
      return val.then((newVal) => ok(newVal));
    } else {
      return ok(val);
    }
  }
  if (result.isErr) {
    const value = result.value;
    return err(value);
  }
  throw "should never get here";
}
var unwrap = (result) => {
  if (result.isOk) {
    return result.value;
  } else {
    throw result.value;
  }
};
var unwrapErr = (result) => {
  if (result.isErr) {
    return result.value;
  } else {
    throw result.value;
  }
};
var i = 0;
var createTime = (fnName, tagName = "") => {
  if (BUILD.profile && performance.mark) {
    const key = `st:${fnName}:${tagName}:${i++}`;
    performance.mark(key);
    return () => performance.measure(`[Stencil] ${fnName}() <${tagName}>`, key);
  } else {
    return () => {
      return;
    };
  }
};
var uniqueTime = (key, measureText) => {
  if (BUILD.profile && performance.mark) {
    if (performance.getEntriesByName(key, "mark").length === 0) {
      performance.mark(key);
    }
    return () => {
      if (performance.getEntriesByName(measureText, "measure").length === 0) {
        performance.measure(measureText, key);
      }
    };
  } else {
    return () => {
      return;
    };
  }
};
var CONTENT_REF_ID = "r";
var ORG_LOCATION_ID = "o";
var SLOT_NODE_ID = "s";
var TEXT_NODE_ID = "t";
var HYDRATE_ID = "s-id";
var HYDRATED_STYLE_ID = "sty-id";
var HYDRATE_CHILD_ID = "c-id";
var SLOT_FB_CSS = "slot-fb{display:contents}slot-fb[hidden]{display:none}";
var XLINK_NS = "http://www.w3.org/1999/xlink";
var FORM_ASSOCIATED_CUSTOM_ELEMENT_CALLBACKS = [
  "formAssociatedCallback",
  "formResetCallback",
  "formDisabledCallback",
  "formStateRestoreCallback"
];
var h = (nodeName, vnodeData, ...children) => {
  let child = null;
  let key = null;
  let slotName = null;
  let simple = false;
  let lastSimple = false;
  const vNodeChildren = [];
  const walk = (c) => {
    for (let i2 = 0; i2 < c.length; i2++) {
      child = c[i2];
      if (Array.isArray(child)) {
        walk(child);
      } else if (child != null && typeof child !== "boolean") {
        if (simple = typeof nodeName !== "function" && !isComplexType(child)) {
          child = String(child);
        } else if (BUILD.isDev && typeof nodeName !== "function" && child.$flags$ === void 0) {
          consoleDevError(`vNode passed as children has unexpected type.
Make sure it's using the correct h() function.
Empty objects can also be the cause, look for JSX comments that became objects.`);
        }
        if (simple && lastSimple) {
          vNodeChildren[vNodeChildren.length - 1].$text$ += child;
        } else {
          vNodeChildren.push(simple ? newVNode(null, child) : child);
        }
        lastSimple = simple;
      }
    }
  };
  walk(children);
  if (vnodeData) {
    if (BUILD.isDev && nodeName === "input") {
      validateInputProperties(vnodeData);
    }
    if (BUILD.vdomKey && vnodeData.key) {
      key = vnodeData.key;
    }
    if (BUILD.slotRelocation && vnodeData.name) {
      slotName = vnodeData.name;
    }
    if (BUILD.vdomClass) {
      const classData = vnodeData.className || vnodeData.class;
      if (classData) {
        vnodeData.class = typeof classData !== "object" ? classData : Object.keys(classData).filter((k) => classData[k]).join(" ");
      }
    }
  }
  if (BUILD.isDev && vNodeChildren.some(isHost)) {
    consoleDevError(`The <Host> must be the single root component. Make sure:
- You are NOT using hostData() and <Host> in the same component.
- <Host> is used once, and it's the single root component of the render() function.`);
  }
  if (BUILD.vdomFunctional && typeof nodeName === "function") {
    return nodeName(
      vnodeData === null ? {} : vnodeData,
      vNodeChildren,
      vdomFnUtils
    );
  }
  const vnode = newVNode(nodeName, null);
  vnode.$attrs$ = vnodeData;
  if (vNodeChildren.length > 0) {
    vnode.$children$ = vNodeChildren;
  }
  if (BUILD.vdomKey) {
    vnode.$key$ = key;
  }
  if (BUILD.slotRelocation) {
    vnode.$name$ = slotName;
  }
  return vnode;
};
var newVNode = (tag, text) => {
  const vnode = {
    $flags$: 0,
    $tag$: tag,
    $text$: text,
    $elm$: null,
    $children$: null
  };
  if (BUILD.vdomAttribute) {
    vnode.$attrs$ = null;
  }
  if (BUILD.vdomKey) {
    vnode.$key$ = null;
  }
  if (BUILD.slotRelocation) {
    vnode.$name$ = null;
  }
  return vnode;
};
var Host = {};
var isHost = (node) => node && node.$tag$ === Host;
var vdomFnUtils = {
  forEach: (children, cb) => children.map(convertToPublic).forEach(cb),
  map: (children, cb) => children.map(convertToPublic).map(cb).map(convertToPrivate)
};
var convertToPublic = (node) => ({
  vattrs: node.$attrs$,
  vchildren: node.$children$,
  vkey: node.$key$,
  vname: node.$name$,
  vtag: node.$tag$,
  vtext: node.$text$
});
var convertToPrivate = (node) => {
  if (typeof node.vtag === "function") {
    const vnodeData = { ...node.vattrs };
    if (node.vkey) {
      vnodeData.key = node.vkey;
    }
    if (node.vname) {
      vnodeData.name = node.vname;
    }
    return h(node.vtag, vnodeData, ...node.vchildren || []);
  }
  const vnode = newVNode(node.vtag, node.vtext);
  vnode.$attrs$ = node.vattrs;
  vnode.$children$ = node.vchildren;
  vnode.$key$ = node.vkey;
  vnode.$name$ = node.vname;
  return vnode;
};
var validateInputProperties = (inputElm) => {
  const props = Object.keys(inputElm);
  const value = props.indexOf("value");
  if (value === -1) {
    return;
  }
  const typeIndex = props.indexOf("type");
  const minIndex = props.indexOf("min");
  const maxIndex = props.indexOf("max");
  const stepIndex = props.indexOf("step");
  if (value < typeIndex || value < minIndex || value < maxIndex || value < stepIndex) {
    consoleDevWarn(`The "value" prop of <input> should be set after "min", "max", "type" and "step"`);
  }
};
var initializeClientHydrate = (hostElm, tagName, hostId, hostRef) => {
  const endHydrate = createTime("hydrateClient", tagName);
  const shadowRoot = hostElm.shadowRoot;
  const childRenderNodes = [];
  const slotNodes = [];
  const shadowRootNodes = BUILD.shadowDom && shadowRoot ? [] : null;
  const vnode = hostRef.$vnode$ = newVNode(tagName, null);
  if (!plt.$orgLocNodes$) {
    initializeDocumentHydrate(doc.body, plt.$orgLocNodes$ = /* @__PURE__ */ new Map());
  }
  hostElm[HYDRATE_ID] = hostId;
  hostElm.removeAttribute(HYDRATE_ID);
  clientHydrate(vnode, childRenderNodes, slotNodes, shadowRootNodes, hostElm, hostElm, hostId);
  childRenderNodes.map((c) => {
    const orgLocationId = c.$hostId$ + "." + c.$nodeId$;
    const orgLocationNode = plt.$orgLocNodes$.get(orgLocationId);
    const node = c.$elm$;
    if (orgLocationNode && supportsShadow && orgLocationNode["s-en"] === "") {
      orgLocationNode.parentNode.insertBefore(node, orgLocationNode.nextSibling);
    }
    if (!shadowRoot) {
      node["s-hn"] = tagName;
      if (orgLocationNode) {
        node["s-ol"] = orgLocationNode;
        node["s-ol"]["s-nr"] = node;
      }
    }
    plt.$orgLocNodes$.delete(orgLocationId);
  });
  if (BUILD.shadowDom && shadowRoot) {
    shadowRootNodes.map((shadowRootNode) => {
      if (shadowRootNode) {
        shadowRoot.appendChild(shadowRootNode);
      }
    });
  }
  endHydrate();
};
var clientHydrate = (parentVNode, childRenderNodes, slotNodes, shadowRootNodes, hostElm, node, hostId) => {
  let childNodeType;
  let childIdSplt;
  let childVNode;
  let i2;
  if (node.nodeType === 1) {
    childNodeType = node.getAttribute(HYDRATE_CHILD_ID);
    if (childNodeType) {
      childIdSplt = childNodeType.split(".");
      if (childIdSplt[0] === hostId || childIdSplt[0] === "0") {
        childVNode = {
          $flags$: 0,
          $hostId$: childIdSplt[0],
          $nodeId$: childIdSplt[1],
          $depth$: childIdSplt[2],
          $index$: childIdSplt[3],
          $tag$: node.tagName.toLowerCase(),
          $elm$: node,
          $attrs$: null,
          $children$: null,
          $key$: null,
          $name$: null,
          $text$: null
        };
        childRenderNodes.push(childVNode);
        node.removeAttribute(HYDRATE_CHILD_ID);
        if (!parentVNode.$children$) {
          parentVNode.$children$ = [];
        }
        parentVNode.$children$[childVNode.$index$] = childVNode;
        parentVNode = childVNode;
        if (shadowRootNodes && childVNode.$depth$ === "0") {
          shadowRootNodes[childVNode.$index$] = childVNode.$elm$;
        }
      }
    }
    for (i2 = node.childNodes.length - 1; i2 >= 0; i2--) {
      clientHydrate(
        parentVNode,
        childRenderNodes,
        slotNodes,
        shadowRootNodes,
        hostElm,
        node.childNodes[i2],
        hostId
      );
    }
    if (node.shadowRoot) {
      for (i2 = node.shadowRoot.childNodes.length - 1; i2 >= 0; i2--) {
        clientHydrate(
          parentVNode,
          childRenderNodes,
          slotNodes,
          shadowRootNodes,
          hostElm,
          node.shadowRoot.childNodes[i2],
          hostId
        );
      }
    }
  } else if (node.nodeType === 8) {
    childIdSplt = node.nodeValue.split(".");
    if (childIdSplt[1] === hostId || childIdSplt[1] === "0") {
      childNodeType = childIdSplt[0];
      childVNode = {
        $flags$: 0,
        $hostId$: childIdSplt[1],
        $nodeId$: childIdSplt[2],
        $depth$: childIdSplt[3],
        $index$: childIdSplt[4],
        $elm$: node,
        $attrs$: null,
        $children$: null,
        $key$: null,
        $name$: null,
        $tag$: null,
        $text$: null
      };
      if (childNodeType === TEXT_NODE_ID) {
        childVNode.$elm$ = node.nextSibling;
        if (childVNode.$elm$ && childVNode.$elm$.nodeType === 3) {
          childVNode.$text$ = childVNode.$elm$.textContent;
          childRenderNodes.push(childVNode);
          node.remove();
          if (!parentVNode.$children$) {
            parentVNode.$children$ = [];
          }
          parentVNode.$children$[childVNode.$index$] = childVNode;
          if (shadowRootNodes && childVNode.$depth$ === "0") {
            shadowRootNodes[childVNode.$index$] = childVNode.$elm$;
          }
        }
      } else if (childVNode.$hostId$ === hostId) {
        if (childNodeType === SLOT_NODE_ID) {
          childVNode.$tag$ = "slot";
          if (childIdSplt[5]) {
            node["s-sn"] = childVNode.$name$ = childIdSplt[5];
          } else {
            node["s-sn"] = "";
          }
          node["s-sr"] = true;
          if (BUILD.shadowDom && shadowRootNodes) {
            childVNode.$elm$ = doc.createElement(childVNode.$tag$);
            if (childVNode.$name$) {
              childVNode.$elm$.setAttribute("name", childVNode.$name$);
            }
            node.parentNode.insertBefore(childVNode.$elm$, node);
            node.remove();
            if (childVNode.$depth$ === "0") {
              shadowRootNodes[childVNode.$index$] = childVNode.$elm$;
            }
          }
          slotNodes.push(childVNode);
          if (!parentVNode.$children$) {
            parentVNode.$children$ = [];
          }
          parentVNode.$children$[childVNode.$index$] = childVNode;
        } else if (childNodeType === CONTENT_REF_ID) {
          if (BUILD.shadowDom && shadowRootNodes) {
            node.remove();
          } else if (BUILD.slotRelocation) {
            hostElm["s-cr"] = node;
            node["s-cn"] = true;
          }
        }
      }
    }
  } else if (parentVNode && parentVNode.$tag$ === "style") {
    const vnode = newVNode(null, node.textContent);
    vnode.$elm$ = node;
    vnode.$index$ = "0";
    parentVNode.$children$ = [vnode];
  }
};
var initializeDocumentHydrate = (node, orgLocNodes) => {
  if (node.nodeType === 1) {
    let i2 = 0;
    for (; i2 < node.childNodes.length; i2++) {
      initializeDocumentHydrate(node.childNodes[i2], orgLocNodes);
    }
    if (node.shadowRoot) {
      for (i2 = 0; i2 < node.shadowRoot.childNodes.length; i2++) {
        initializeDocumentHydrate(node.shadowRoot.childNodes[i2], orgLocNodes);
      }
    }
  } else if (node.nodeType === 8) {
    const childIdSplt = node.nodeValue.split(".");
    if (childIdSplt[0] === ORG_LOCATION_ID) {
      orgLocNodes.set(childIdSplt[1] + "." + childIdSplt[2], node);
      node.nodeValue = "";
      node["s-en"] = childIdSplt[3];
    }
  }
};
var computeMode = (elm) => modeResolutionChain.map((h2) => h2(elm)).find((m) => !!m);
var parsePropertyValue = (propValue, propType) => {
  if (propValue != null && !isComplexType(propValue)) {
    if (BUILD.propBoolean && propType & 4) {
      return propValue === "false" ? false : propValue === "" || !!propValue;
    }
    if (BUILD.propNumber && propType & 2) {
      return parseFloat(propValue);
    }
    if (BUILD.propString && propType & 1) {
      return String(propValue);
    }
    return propValue;
  }
  return propValue;
};
var emitEvent = (elm, name, opts) => {
  const ev = plt.ce(name, opts);
  elm.dispatchEvent(ev);
  return ev;
};
var rootAppliedStyles = /* @__PURE__ */ new WeakMap();
var registerStyle = (scopeId2, cssText, allowCS) => {
  let style = styles.get(scopeId2);
  if (supportsConstructableStylesheets && allowCS) {
    style = style || new CSSStyleSheet();
    if (typeof style === "string") {
      style = cssText;
    } else {
      style.replaceSync(cssText);
    }
  } else {
    style = cssText;
  }
  styles.set(scopeId2, style);
};
var addStyle = (styleContainerNode, cmpMeta, mode) => {
  var _a;
  const scopeId2 = getScopeId(cmpMeta, mode);
  const style = styles.get(scopeId2);
  if (!BUILD.attachStyles) {
    return scopeId2;
  }
  styleContainerNode = styleContainerNode.nodeType === 11 ? styleContainerNode : doc;
  if (style) {
    if (typeof style === "string") {
      styleContainerNode = styleContainerNode.head || styleContainerNode;
      let appliedStyles = rootAppliedStyles.get(styleContainerNode);
      let styleElm;
      if (!appliedStyles) {
        rootAppliedStyles.set(styleContainerNode, appliedStyles = /* @__PURE__ */ new Set());
      }
      if (!appliedStyles.has(scopeId2)) {
        if (BUILD.hydrateClientSide && styleContainerNode.host && (styleElm = styleContainerNode.querySelector(`[${HYDRATED_STYLE_ID}="${scopeId2}"]`))) {
          styleElm.innerHTML = style;
        } else {
          styleElm = doc.createElement("style");
          styleElm.innerHTML = style;
          const nonce = (_a = plt.$nonce$) != null ? _a : queryNonceMetaTagContent(doc);
          if (nonce != null) {
            styleElm.setAttribute("nonce", nonce);
          }
          if (BUILD.hydrateServerSide || BUILD.hotModuleReplacement) {
            styleElm.setAttribute(HYDRATED_STYLE_ID, scopeId2);
          }
          styleContainerNode.insertBefore(styleElm, styleContainerNode.querySelector("link"));
        }
        if (cmpMeta.$flags$ & 4) {
          styleElm.innerHTML += SLOT_FB_CSS;
        }
        if (appliedStyles) {
          appliedStyles.add(scopeId2);
        }
      }
    } else if (BUILD.constructableCSS && !styleContainerNode.adoptedStyleSheets.includes(style)) {
      styleContainerNode.adoptedStyleSheets = [...styleContainerNode.adoptedStyleSheets, style];
    }
  }
  return scopeId2;
};
var attachStyles = (hostRef) => {
  const cmpMeta = hostRef.$cmpMeta$;
  const elm = hostRef.$hostElement$;
  const flags = cmpMeta.$flags$;
  const endAttachStyles = createTime("attachStyles", cmpMeta.$tagName$);
  const scopeId2 = addStyle(
    BUILD.shadowDom && supportsShadow && elm.shadowRoot ? elm.shadowRoot : elm.getRootNode(),
    cmpMeta,
    hostRef.$modeName$
  );
  if ((BUILD.shadowDom || BUILD.scoped) && BUILD.cssAnnotations && flags & 10) {
    elm["s-sc"] = scopeId2;
    elm.classList.add(scopeId2 + "-h");
    if (BUILD.scoped && flags & 2) {
      elm.classList.add(scopeId2 + "-s");
    }
  }
  endAttachStyles();
};
var getScopeId = (cmp, mode) => "sc-" + (BUILD.mode && mode && cmp.$flags$ & 32 ? cmp.$tagName$ + "-" + mode : cmp.$tagName$);
var setAccessor = (elm, memberName, oldValue, newValue, isSvg, flags) => {
  if (oldValue !== newValue) {
    let isProp = isMemberInElement(elm, memberName);
    let ln = memberName.toLowerCase();
    if (BUILD.vdomClass && memberName === "class") {
      const classList = elm.classList;
      const oldClasses = parseClassList(oldValue);
      const newClasses = parseClassList(newValue);
      classList.remove(...oldClasses.filter((c) => c && !newClasses.includes(c)));
      classList.add(...newClasses.filter((c) => c && !oldClasses.includes(c)));
    } else if (BUILD.vdomStyle && memberName === "style") {
      if (BUILD.updatable) {
        for (const prop in oldValue) {
          if (!newValue || newValue[prop] == null) {
            if (!BUILD.hydrateServerSide && prop.includes("-")) {
              elm.style.removeProperty(prop);
            } else {
              elm.style[prop] = "";
            }
          }
        }
      }
      for (const prop in newValue) {
        if (!oldValue || newValue[prop] !== oldValue[prop]) {
          if (!BUILD.hydrateServerSide && prop.includes("-")) {
            elm.style.setProperty(prop, newValue[prop]);
          } else {
            elm.style[prop] = newValue[prop];
          }
        }
      }
    } else if (BUILD.vdomKey && memberName === "key") {
    } else if (BUILD.vdomRef && memberName === "ref") {
      if (newValue) {
        newValue(elm);
      }
    } else if (BUILD.vdomListener && (BUILD.lazyLoad ? !isProp : !elm.__lookupSetter__(memberName)) && memberName[0] === "o" && memberName[1] === "n") {
      if (memberName[2] === "-") {
        memberName = memberName.slice(3);
      } else if (isMemberInElement(win, ln)) {
        memberName = ln.slice(2);
      } else {
        memberName = ln[2] + memberName.slice(3);
      }
      if (oldValue || newValue) {
        const capture = memberName.endsWith(CAPTURE_EVENT_SUFFIX);
        memberName = memberName.replace(CAPTURE_EVENT_REGEX, "");
        if (oldValue) {
          plt.rel(elm, memberName, oldValue, capture);
        }
        if (newValue) {
          plt.ael(elm, memberName, newValue, capture);
        }
      }
    } else if (BUILD.vdomPropOrAttr) {
      const isComplex = isComplexType(newValue);
      if ((isProp || isComplex && newValue !== null) && !isSvg) {
        try {
          if (!elm.tagName.includes("-")) {
            const n = newValue == null ? "" : newValue;
            if (memberName === "list") {
              isProp = false;
            } else if (oldValue == null || elm[memberName] != n) {
              elm[memberName] = n;
            }
          } else {
            elm[memberName] = newValue;
          }
        } catch (e) {
        }
      }
      let xlink = false;
      if (BUILD.vdomXlink) {
        if (ln !== (ln = ln.replace(/^xlink\:?/, ""))) {
          memberName = ln;
          xlink = true;
        }
      }
      if (newValue == null || newValue === false) {
        if (newValue !== false || elm.getAttribute(memberName) === "") {
          if (BUILD.vdomXlink && xlink) {
            elm.removeAttributeNS(XLINK_NS, memberName);
          } else {
            elm.removeAttribute(memberName);
          }
        }
      } else if ((!isProp || flags & 4 || isSvg) && !isComplex) {
        newValue = newValue === true ? "" : newValue;
        if (BUILD.vdomXlink && xlink) {
          elm.setAttributeNS(XLINK_NS, memberName, newValue);
        } else {
          elm.setAttribute(memberName, newValue);
        }
      }
    }
  }
};
var parseClassListRegex = /\s/;
var parseClassList = (value) => !value ? [] : value.split(parseClassListRegex);
var CAPTURE_EVENT_SUFFIX = "Capture";
var CAPTURE_EVENT_REGEX = new RegExp(CAPTURE_EVENT_SUFFIX + "$");
var updateElement = (oldVnode, newVnode, isSvgMode2) => {
  const elm = newVnode.$elm$.nodeType === 11 && newVnode.$elm$.host ? newVnode.$elm$.host : newVnode.$elm$;
  const oldVnodeAttrs = oldVnode && oldVnode.$attrs$ || EMPTY_OBJ;
  const newVnodeAttrs = newVnode.$attrs$ || EMPTY_OBJ;
  if (BUILD.updatable) {
    for (const memberName of sortedAttrNames(Object.keys(oldVnodeAttrs))) {
      if (!(memberName in newVnodeAttrs)) {
        setAccessor(elm, memberName, oldVnodeAttrs[memberName], void 0, isSvgMode2, newVnode.$flags$);
      }
    }
  }
  for (const memberName of sortedAttrNames(Object.keys(newVnodeAttrs))) {
    setAccessor(elm, memberName, oldVnodeAttrs[memberName], newVnodeAttrs[memberName], isSvgMode2, newVnode.$flags$);
  }
};
function sortedAttrNames(attrNames) {
  return attrNames.includes("ref") ? (
    // we need to sort these to ensure that `'ref'` is the last attr
    [...attrNames.filter((attr) => attr !== "ref"), "ref"]
  ) : (
    // no need to sort, return the original array
    attrNames
  );
}
var scopeId;
var contentRef;
var hostTagName;
var useNativeShadowDom = false;
var checkSlotFallbackVisibility = false;
var checkSlotRelocate = false;
var isSvgMode = false;
var createElm = (oldParentVNode, newParentVNode, childIndex, parentElm) => {
  var _a;
  const newVNode2 = newParentVNode.$children$[childIndex];
  let i2 = 0;
  let elm;
  let childNode;
  let oldVNode;
  if (BUILD.slotRelocation && !useNativeShadowDom) {
    checkSlotRelocate = true;
    if (newVNode2.$tag$ === "slot") {
      if (scopeId) {
        parentElm.classList.add(scopeId + "-s");
      }
      newVNode2.$flags$ |= newVNode2.$children$ ? (
        // slot element has fallback content
        // still create an element that "mocks" the slot element
        2
      ) : (
        // slot element does not have fallback content
        // create an html comment we'll use to always reference
        // where actual slot content should sit next to
        1
      );
    }
  }
  if (BUILD.isDev && newVNode2.$elm$) {
    consoleDevError(
      `The JSX ${newVNode2.$text$ !== null ? `"${newVNode2.$text$}" text` : `"${newVNode2.$tag$}" element`} node should not be shared within the same renderer. The renderer caches element lookups in order to improve performance. However, a side effect from this is that the exact same JSX node should not be reused. For more information please see https://stenciljs.com/docs/templating-jsx#avoid-shared-jsx-nodes`
    );
  }
  if (BUILD.vdomText && newVNode2.$text$ !== null) {
    elm = newVNode2.$elm$ = doc.createTextNode(newVNode2.$text$);
  } else if (BUILD.slotRelocation && newVNode2.$flags$ & 1) {
    elm = newVNode2.$elm$ = BUILD.isDebug || BUILD.hydrateServerSide ? slotReferenceDebugNode(newVNode2) : doc.createTextNode("");
  } else {
    if (BUILD.svg && !isSvgMode) {
      isSvgMode = newVNode2.$tag$ === "svg";
    }
    elm = newVNode2.$elm$ = BUILD.svg ? doc.createElementNS(
      isSvgMode ? SVG_NS : HTML_NS,
      BUILD.slotRelocation && newVNode2.$flags$ & 2 ? "slot-fb" : newVNode2.$tag$
    ) : doc.createElement(
      BUILD.slotRelocation && newVNode2.$flags$ & 2 ? "slot-fb" : newVNode2.$tag$
    );
    if (BUILD.svg && isSvgMode && newVNode2.$tag$ === "foreignObject") {
      isSvgMode = false;
    }
    if (BUILD.vdomAttribute) {
      updateElement(null, newVNode2, isSvgMode);
    }
    if ((BUILD.shadowDom || BUILD.scoped) && isDef(scopeId) && elm["s-si"] !== scopeId) {
      elm.classList.add(elm["s-si"] = scopeId);
    }
    if (newVNode2.$children$) {
      for (i2 = 0; i2 < newVNode2.$children$.length; ++i2) {
        childNode = createElm(oldParentVNode, newVNode2, i2, elm);
        if (childNode) {
          elm.appendChild(childNode);
        }
      }
    }
    if (BUILD.svg) {
      if (newVNode2.$tag$ === "svg") {
        isSvgMode = false;
      } else if (elm.tagName === "foreignObject") {
        isSvgMode = true;
      }
    }
  }
  elm["s-hn"] = hostTagName;
  if (BUILD.slotRelocation) {
    if (newVNode2.$flags$ & (2 | 1)) {
      elm["s-sr"] = true;
      elm["s-cr"] = contentRef;
      elm["s-sn"] = newVNode2.$name$ || "";
      elm["s-rf"] = (_a = newVNode2.$attrs$) == null ? void 0 : _a.ref;
      oldVNode = oldParentVNode && oldParentVNode.$children$ && oldParentVNode.$children$[childIndex];
      if (oldVNode && oldVNode.$tag$ === newVNode2.$tag$ && oldParentVNode.$elm$) {
        if (BUILD.experimentalSlotFixes) {
          relocateToHostRoot(oldParentVNode.$elm$);
        } else {
          putBackInOriginalLocation(oldParentVNode.$elm$, false);
        }
      }
    }
  }
  return elm;
};
var relocateToHostRoot = (parentElm) => {
  plt.$flags$ |= 1;
  const host = parentElm.closest(hostTagName.toLowerCase());
  if (host != null) {
    const contentRefNode = Array.from(host.childNodes).find((ref) => ref["s-cr"]);
    const childNodeArray = Array.from(parentElm.childNodes);
    for (const childNode of contentRefNode ? childNodeArray.reverse() : childNodeArray) {
      if (childNode["s-sh"] != null) {
        host.insertBefore(childNode, contentRefNode != null ? contentRefNode : null);
        childNode["s-sh"] = void 0;
        checkSlotRelocate = true;
      }
    }
  }
  plt.$flags$ &= ~1;
};
var putBackInOriginalLocation = (parentElm, recursive) => {
  plt.$flags$ |= 1;
  const oldSlotChildNodes = Array.from(parentElm.childNodes);
  if (parentElm["s-sr"] && BUILD.experimentalSlotFixes) {
    let node = parentElm;
    while (node = node.nextSibling) {
      if (node && node["s-sn"] === parentElm["s-sn"] && node["s-sh"] === hostTagName) {
        oldSlotChildNodes.push(node);
      }
    }
  }
  for (let i2 = oldSlotChildNodes.length - 1; i2 >= 0; i2--) {
    const childNode = oldSlotChildNodes[i2];
    if (childNode["s-hn"] !== hostTagName && childNode["s-ol"]) {
      parentReferenceNode(childNode).insertBefore(childNode, referenceNode(childNode));
      childNode["s-ol"].remove();
      childNode["s-ol"] = void 0;
      childNode["s-sh"] = void 0;
      checkSlotRelocate = true;
    }
    if (recursive) {
      putBackInOriginalLocation(childNode, recursive);
    }
  }
  plt.$flags$ &= ~1;
};
var addVnodes = (parentElm, before, parentVNode, vnodes, startIdx, endIdx) => {
  let containerElm = BUILD.slotRelocation && parentElm["s-cr"] && parentElm["s-cr"].parentNode || parentElm;
  let childNode;
  if (BUILD.shadowDom && containerElm.shadowRoot && containerElm.tagName === hostTagName) {
    containerElm = containerElm.shadowRoot;
  }
  for (; startIdx <= endIdx; ++startIdx) {
    if (vnodes[startIdx]) {
      childNode = createElm(null, parentVNode, startIdx, parentElm);
      if (childNode) {
        vnodes[startIdx].$elm$ = childNode;
        containerElm.insertBefore(childNode, BUILD.slotRelocation ? referenceNode(before) : before);
      }
    }
  }
};
var removeVnodes = (vnodes, startIdx, endIdx) => {
  for (let index = startIdx; index <= endIdx; ++index) {
    const vnode = vnodes[index];
    if (vnode) {
      const elm = vnode.$elm$;
      nullifyVNodeRefs(vnode);
      if (elm) {
        if (BUILD.slotRelocation) {
          checkSlotFallbackVisibility = true;
          if (elm["s-ol"]) {
            elm["s-ol"].remove();
          } else {
            putBackInOriginalLocation(elm, true);
          }
        }
        elm.remove();
      }
    }
  }
};
var updateChildren = (parentElm, oldCh, newVNode2, newCh, isInitialRender = false) => {
  let oldStartIdx = 0;
  let newStartIdx = 0;
  let idxInOld = 0;
  let i2 = 0;
  let oldEndIdx = oldCh.length - 1;
  let oldStartVnode = oldCh[0];
  let oldEndVnode = oldCh[oldEndIdx];
  let newEndIdx = newCh.length - 1;
  let newStartVnode = newCh[0];
  let newEndVnode = newCh[newEndIdx];
  let node;
  let elmToMove;
  while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
    if (oldStartVnode == null) {
      oldStartVnode = oldCh[++oldStartIdx];
    } else if (oldEndVnode == null) {
      oldEndVnode = oldCh[--oldEndIdx];
    } else if (newStartVnode == null) {
      newStartVnode = newCh[++newStartIdx];
    } else if (newEndVnode == null) {
      newEndVnode = newCh[--newEndIdx];
    } else if (isSameVnode(oldStartVnode, newStartVnode, isInitialRender)) {
      patch(oldStartVnode, newStartVnode, isInitialRender);
      oldStartVnode = oldCh[++oldStartIdx];
      newStartVnode = newCh[++newStartIdx];
    } else if (isSameVnode(oldEndVnode, newEndVnode, isInitialRender)) {
      patch(oldEndVnode, newEndVnode, isInitialRender);
      oldEndVnode = oldCh[--oldEndIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (isSameVnode(oldStartVnode, newEndVnode, isInitialRender)) {
      if (BUILD.slotRelocation && (oldStartVnode.$tag$ === "slot" || newEndVnode.$tag$ === "slot")) {
        putBackInOriginalLocation(oldStartVnode.$elm$.parentNode, false);
      }
      patch(oldStartVnode, newEndVnode, isInitialRender);
      parentElm.insertBefore(oldStartVnode.$elm$, oldEndVnode.$elm$.nextSibling);
      oldStartVnode = oldCh[++oldStartIdx];
      newEndVnode = newCh[--newEndIdx];
    } else if (isSameVnode(oldEndVnode, newStartVnode, isInitialRender)) {
      if (BUILD.slotRelocation && (oldStartVnode.$tag$ === "slot" || newEndVnode.$tag$ === "slot")) {
        putBackInOriginalLocation(oldEndVnode.$elm$.parentNode, false);
      }
      patch(oldEndVnode, newStartVnode, isInitialRender);
      parentElm.insertBefore(oldEndVnode.$elm$, oldStartVnode.$elm$);
      oldEndVnode = oldCh[--oldEndIdx];
      newStartVnode = newCh[++newStartIdx];
    } else {
      idxInOld = -1;
      if (BUILD.vdomKey) {
        for (i2 = oldStartIdx; i2 <= oldEndIdx; ++i2) {
          if (oldCh[i2] && oldCh[i2].$key$ !== null && oldCh[i2].$key$ === newStartVnode.$key$) {
            idxInOld = i2;
            break;
          }
        }
      }
      if (BUILD.vdomKey && idxInOld >= 0) {
        elmToMove = oldCh[idxInOld];
        if (elmToMove.$tag$ !== newStartVnode.$tag$) {
          node = createElm(oldCh && oldCh[newStartIdx], newVNode2, idxInOld, parentElm);
        } else {
          patch(elmToMove, newStartVnode, isInitialRender);
          oldCh[idxInOld] = void 0;
          node = elmToMove.$elm$;
        }
        newStartVnode = newCh[++newStartIdx];
      } else {
        node = createElm(oldCh && oldCh[newStartIdx], newVNode2, newStartIdx, parentElm);
        newStartVnode = newCh[++newStartIdx];
      }
      if (node) {
        if (BUILD.slotRelocation) {
          parentReferenceNode(oldStartVnode.$elm$).insertBefore(node, referenceNode(oldStartVnode.$elm$));
        } else {
          oldStartVnode.$elm$.parentNode.insertBefore(node, oldStartVnode.$elm$);
        }
      }
    }
  }
  if (oldStartIdx > oldEndIdx) {
    addVnodes(
      parentElm,
      newCh[newEndIdx + 1] == null ? null : newCh[newEndIdx + 1].$elm$,
      newVNode2,
      newCh,
      newStartIdx,
      newEndIdx
    );
  } else if (BUILD.updatable && newStartIdx > newEndIdx) {
    removeVnodes(oldCh, oldStartIdx, oldEndIdx);
  }
};
var isSameVnode = (leftVNode, rightVNode, isInitialRender = false) => {
  if (leftVNode.$tag$ === rightVNode.$tag$) {
    if (BUILD.slotRelocation && leftVNode.$tag$ === "slot") {
      return leftVNode.$name$ === rightVNode.$name$;
    }
    if (BUILD.vdomKey && !isInitialRender) {
      return leftVNode.$key$ === rightVNode.$key$;
    }
    return true;
  }
  return false;
};
var referenceNode = (node) => {
  return node && node["s-ol"] || node;
};
var parentReferenceNode = (node) => (node["s-ol"] ? node["s-ol"] : node).parentNode;
var patch = (oldVNode, newVNode2, isInitialRender = false) => {
  const elm = newVNode2.$elm$ = oldVNode.$elm$;
  const oldChildren = oldVNode.$children$;
  const newChildren = newVNode2.$children$;
  const tag = newVNode2.$tag$;
  const text = newVNode2.$text$;
  let defaultHolder;
  if (!BUILD.vdomText || text === null) {
    if (BUILD.svg) {
      isSvgMode = tag === "svg" ? true : tag === "foreignObject" ? false : isSvgMode;
    }
    if (BUILD.vdomAttribute || BUILD.reflect) {
      if (BUILD.slot && tag === "slot" && !useNativeShadowDom) {
        if (BUILD.experimentalSlotFixes && oldVNode.$name$ !== newVNode2.$name$) {
          newVNode2.$elm$["s-sn"] = newVNode2.$name$ || "";
          relocateToHostRoot(newVNode2.$elm$.parentElement);
        }
      } else {
        updateElement(oldVNode, newVNode2, isSvgMode);
      }
    }
    if (BUILD.updatable && oldChildren !== null && newChildren !== null) {
      updateChildren(elm, oldChildren, newVNode2, newChildren, isInitialRender);
    } else if (newChildren !== null) {
      if (BUILD.updatable && BUILD.vdomText && oldVNode.$text$ !== null) {
        elm.textContent = "";
      }
      addVnodes(elm, null, newVNode2, newChildren, 0, newChildren.length - 1);
    } else if (BUILD.updatable && oldChildren !== null) {
      removeVnodes(oldChildren, 0, oldChildren.length - 1);
    }
    if (BUILD.svg && isSvgMode && tag === "svg") {
      isSvgMode = false;
    }
  } else if (BUILD.vdomText && BUILD.slotRelocation && (defaultHolder = elm["s-cr"])) {
    defaultHolder.parentNode.textContent = text;
  } else if (BUILD.vdomText && oldVNode.$text$ !== text) {
    elm.data = text;
  }
};
var updateFallbackSlotVisibility = (elm) => {
  const childNodes = elm.childNodes;
  for (const childNode of childNodes) {
    if (childNode.nodeType === 1) {
      if (childNode["s-sr"]) {
        const slotName = childNode["s-sn"];
        childNode.hidden = false;
        for (const siblingNode of childNodes) {
          if (siblingNode !== childNode) {
            if (siblingNode["s-hn"] !== childNode["s-hn"] || slotName !== "") {
              if (siblingNode.nodeType === 1 && (slotName === siblingNode.getAttribute("slot") || slotName === siblingNode["s-sn"]) || siblingNode.nodeType === 3 && slotName === siblingNode["s-sn"]) {
                childNode.hidden = true;
                break;
              }
            } else {
              if (siblingNode.nodeType === 1 || siblingNode.nodeType === 3 && siblingNode.textContent.trim() !== "") {
                childNode.hidden = true;
                break;
              }
            }
          }
        }
      }
      updateFallbackSlotVisibility(childNode);
    }
  }
};
var relocateNodes = [];
var markSlotContentForRelocation = (elm) => {
  let node;
  let hostContentNodes;
  let j;
  for (const childNode of elm.childNodes) {
    if (childNode["s-sr"] && (node = childNode["s-cr"]) && node.parentNode) {
      hostContentNodes = node.parentNode.childNodes;
      const slotName = childNode["s-sn"];
      for (j = hostContentNodes.length - 1; j >= 0; j--) {
        node = hostContentNodes[j];
        if (!node["s-cn"] && !node["s-nr"] && node["s-hn"] !== childNode["s-hn"] && (!BUILD.experimentalSlotFixes || !node["s-sh"] || node["s-sh"] !== childNode["s-hn"])) {
          if (isNodeLocatedInSlot(node, slotName)) {
            let relocateNodeData = relocateNodes.find((r) => r.$nodeToRelocate$ === node);
            checkSlotFallbackVisibility = true;
            node["s-sn"] = node["s-sn"] || slotName;
            if (relocateNodeData) {
              relocateNodeData.$nodeToRelocate$["s-sh"] = childNode["s-hn"];
              relocateNodeData.$slotRefNode$ = childNode;
            } else {
              node["s-sh"] = childNode["s-hn"];
              relocateNodes.push({
                $slotRefNode$: childNode,
                $nodeToRelocate$: node
              });
            }
            if (node["s-sr"]) {
              relocateNodes.map((relocateNode) => {
                if (isNodeLocatedInSlot(relocateNode.$nodeToRelocate$, node["s-sn"])) {
                  relocateNodeData = relocateNodes.find((r) => r.$nodeToRelocate$ === node);
                  if (relocateNodeData && !relocateNode.$slotRefNode$) {
                    relocateNode.$slotRefNode$ = relocateNodeData.$slotRefNode$;
                  }
                }
              });
            }
          } else if (!relocateNodes.some((r) => r.$nodeToRelocate$ === node)) {
            relocateNodes.push({
              $nodeToRelocate$: node
            });
          }
        }
      }
    }
    if (childNode.nodeType === 1) {
      markSlotContentForRelocation(childNode);
    }
  }
};
var isNodeLocatedInSlot = (nodeToRelocate, slotName) => {
  if (nodeToRelocate.nodeType === 1) {
    if (nodeToRelocate.getAttribute("slot") === null && slotName === "") {
      return true;
    }
    if (nodeToRelocate.getAttribute("slot") === slotName) {
      return true;
    }
    return false;
  }
  if (nodeToRelocate["s-sn"] === slotName) {
    return true;
  }
  return slotName === "";
};
var nullifyVNodeRefs = (vNode) => {
  if (BUILD.vdomRef) {
    vNode.$attrs$ && vNode.$attrs$.ref && vNode.$attrs$.ref(null);
    vNode.$children$ && vNode.$children$.map(nullifyVNodeRefs);
  }
};
var renderVdom = (hostRef, renderFnResults, isInitialLoad = false) => {
  var _a, _b, _c, _d, _e;
  const hostElm = hostRef.$hostElement$;
  const cmpMeta = hostRef.$cmpMeta$;
  const oldVNode = hostRef.$vnode$ || newVNode(null, null);
  const rootVnode = isHost(renderFnResults) ? renderFnResults : h(null, null, renderFnResults);
  hostTagName = hostElm.tagName;
  if (BUILD.isDev && Array.isArray(renderFnResults) && renderFnResults.some(isHost)) {
    throw new Error(`The <Host> must be the single root component.
Looks like the render() function of "${hostTagName.toLowerCase()}" is returning an array that contains the <Host>.

The render() function should look like this instead:

render() {
  // Do not return an array
  return (
    <Host>{content}</Host>
  );
}
  `);
  }
  if (BUILD.reflect && cmpMeta.$attrsToReflect$) {
    rootVnode.$attrs$ = rootVnode.$attrs$ || {};
    cmpMeta.$attrsToReflect$.map(
      ([propName, attribute]) => rootVnode.$attrs$[attribute] = hostElm[propName]
    );
  }
  if (isInitialLoad && rootVnode.$attrs$) {
    for (const key of Object.keys(rootVnode.$attrs$)) {
      if (hostElm.hasAttribute(key) && !["key", "ref", "style", "class"].includes(key)) {
        rootVnode.$attrs$[key] = hostElm[key];
      }
    }
  }
  rootVnode.$tag$ = null;
  rootVnode.$flags$ |= 4;
  hostRef.$vnode$ = rootVnode;
  rootVnode.$elm$ = oldVNode.$elm$ = BUILD.shadowDom ? hostElm.shadowRoot || hostElm : hostElm;
  if (BUILD.scoped || BUILD.shadowDom) {
    scopeId = hostElm["s-sc"];
  }
  useNativeShadowDom = supportsShadow && (cmpMeta.$flags$ & 1) !== 0;
  if (BUILD.slotRelocation) {
    contentRef = hostElm["s-cr"];
    checkSlotFallbackVisibility = false;
  }
  patch(oldVNode, rootVnode, isInitialLoad);
  if (BUILD.slotRelocation) {
    plt.$flags$ |= 1;
    if (checkSlotRelocate) {
      markSlotContentForRelocation(rootVnode.$elm$);
      for (const relocateData of relocateNodes) {
        const nodeToRelocate = relocateData.$nodeToRelocate$;
        if (!nodeToRelocate["s-ol"]) {
          const orgLocationNode = BUILD.isDebug || BUILD.hydrateServerSide ? originalLocationDebugNode(nodeToRelocate) : doc.createTextNode("");
          orgLocationNode["s-nr"] = nodeToRelocate;
          nodeToRelocate.parentNode.insertBefore(nodeToRelocate["s-ol"] = orgLocationNode, nodeToRelocate);
        }
      }
      for (const relocateData of relocateNodes) {
        const nodeToRelocate = relocateData.$nodeToRelocate$;
        const slotRefNode = relocateData.$slotRefNode$;
        if (slotRefNode) {
          const parentNodeRef = slotRefNode.parentNode;
          let insertBeforeNode = slotRefNode.nextSibling;
          if (!BUILD.experimentalSlotFixes || insertBeforeNode && insertBeforeNode.nodeType === 1) {
            let orgLocationNode = (_a = nodeToRelocate["s-ol"]) == null ? void 0 : _a.previousSibling;
            while (orgLocationNode) {
              let refNode = (_b = orgLocationNode["s-nr"]) != null ? _b : null;
              if (refNode && refNode["s-sn"] === nodeToRelocate["s-sn"] && parentNodeRef === refNode.parentNode) {
                refNode = refNode.nextSibling;
                while (refNode === nodeToRelocate || (refNode == null ? void 0 : refNode["s-sr"])) {
                  refNode = refNode == null ? void 0 : refNode.nextSibling;
                }
                if (!refNode || !refNode["s-nr"]) {
                  insertBeforeNode = refNode;
                  break;
                }
              }
              orgLocationNode = orgLocationNode.previousSibling;
            }
          }
          if (!insertBeforeNode && parentNodeRef !== nodeToRelocate.parentNode || nodeToRelocate.nextSibling !== insertBeforeNode) {
            if (nodeToRelocate !== insertBeforeNode) {
              if (!BUILD.experimentalSlotFixes && !nodeToRelocate["s-hn"] && nodeToRelocate["s-ol"]) {
                nodeToRelocate["s-hn"] = nodeToRelocate["s-ol"].parentNode.nodeName;
              }
              parentNodeRef.insertBefore(nodeToRelocate, insertBeforeNode);
              if (nodeToRelocate.nodeType === 1) {
                nodeToRelocate.hidden = (_c = nodeToRelocate["s-ih"]) != null ? _c : false;
              }
            }
          }
          nodeToRelocate && typeof slotRefNode["s-rf"] === "function" && slotRefNode["s-rf"](nodeToRelocate);
        } else {
          if (nodeToRelocate.nodeType === 1) {
            if (isInitialLoad) {
              nodeToRelocate["s-ih"] = (_d = nodeToRelocate.hidden) != null ? _d : false;
            }
            nodeToRelocate.hidden = true;
          }
        }
      }
    }
    if (checkSlotFallbackVisibility) {
      updateFallbackSlotVisibility(rootVnode.$elm$);
    }
    plt.$flags$ &= ~1;
    relocateNodes.length = 0;
  }
  if (BUILD.experimentalScopedSlotChanges && cmpMeta.$flags$ & 2) {
    for (const childNode of rootVnode.$elm$.childNodes) {
      if (childNode["s-hn"] !== hostTagName && !childNode["s-sh"]) {
        if (isInitialLoad && childNode["s-ih"] == null) {
          childNode["s-ih"] = (_e = childNode.hidden) != null ? _e : false;
        }
        childNode.hidden = true;
      }
    }
  }
  contentRef = void 0;
};
var slotReferenceDebugNode = (slotVNode) => doc.createComment(
  `<slot${slotVNode.$name$ ? ' name="' + slotVNode.$name$ + '"' : ""}> (host=${hostTagName.toLowerCase()})`
);
var originalLocationDebugNode = (nodeToRelocate) => doc.createComment(
  `org-location for ` + (nodeToRelocate.localName ? `<${nodeToRelocate.localName}> (host=${nodeToRelocate["s-hn"]})` : `[${nodeToRelocate.textContent}]`)
);
var attachToAncestor = (hostRef, ancestorComponent) => {
  if (BUILD.asyncLoading && ancestorComponent && !hostRef.$onRenderResolve$ && ancestorComponent["s-p"]) {
    ancestorComponent["s-p"].push(new Promise((r) => hostRef.$onRenderResolve$ = r));
  }
};
var scheduleUpdate = (hostRef, isInitialLoad) => {
  if (BUILD.taskQueue && BUILD.updatable) {
    hostRef.$flags$ |= 16;
  }
  if (BUILD.asyncLoading && hostRef.$flags$ & 4) {
    hostRef.$flags$ |= 512;
    return;
  }
  attachToAncestor(hostRef, hostRef.$ancestorComponent$);
  const dispatch = () => dispatchHooks(hostRef, isInitialLoad);
  return BUILD.taskQueue ? writeTask(dispatch) : dispatch();
};
var dispatchHooks = (hostRef, isInitialLoad) => {
  const elm = hostRef.$hostElement$;
  const endSchedule = createTime("scheduleUpdate", hostRef.$cmpMeta$.$tagName$);
  const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
  let maybePromise;
  if (isInitialLoad) {
    if (BUILD.lazyLoad && BUILD.hostListener) {
      hostRef.$flags$ |= 256;
      if (hostRef.$queuedListeners$) {
        hostRef.$queuedListeners$.map(([methodName, event]) => safeCall(instance, methodName, event));
        hostRef.$queuedListeners$ = void 0;
      }
    }
    emitLifecycleEvent(elm, "componentWillLoad");
    if (BUILD.cmpWillLoad) {
      maybePromise = safeCall(instance, "componentWillLoad");
    }
  } else {
    emitLifecycleEvent(elm, "componentWillUpdate");
    if (BUILD.cmpWillUpdate) {
      maybePromise = safeCall(instance, "componentWillUpdate");
    }
  }
  emitLifecycleEvent(elm, "componentWillRender");
  if (BUILD.cmpWillRender) {
    maybePromise = enqueue(maybePromise, () => safeCall(instance, "componentWillRender"));
  }
  endSchedule();
  return enqueue(maybePromise, () => updateComponent(hostRef, instance, isInitialLoad));
};
var enqueue = (maybePromise, fn) => isPromisey(maybePromise) ? maybePromise.then(fn) : fn();
var isPromisey = (maybePromise) => maybePromise instanceof Promise || maybePromise && maybePromise.then && typeof maybePromise.then === "function";
var updateComponent = async (hostRef, instance, isInitialLoad) => {
  var _a;
  const elm = hostRef.$hostElement$;
  const endUpdate = createTime("update", hostRef.$cmpMeta$.$tagName$);
  const rc = elm["s-rc"];
  if (BUILD.style && isInitialLoad) {
    attachStyles(hostRef);
  }
  const endRender = createTime("render", hostRef.$cmpMeta$.$tagName$);
  if (BUILD.isDev) {
    hostRef.$flags$ |= 1024;
  }
  if (BUILD.hydrateServerSide) {
    await callRender(hostRef, instance, elm, isInitialLoad);
  } else {
    callRender(hostRef, instance, elm, isInitialLoad);
  }
  if (BUILD.isDev) {
    hostRef.$renderCount$ = hostRef.$renderCount$ === void 0 ? 1 : hostRef.$renderCount$ + 1;
    hostRef.$flags$ &= ~1024;
  }
  if (BUILD.hydrateServerSide) {
    try {
      serverSideConnected(elm);
      if (isInitialLoad) {
        if (hostRef.$cmpMeta$.$flags$ & 1) {
          elm["s-en"] = "";
        } else if (hostRef.$cmpMeta$.$flags$ & 2) {
          elm["s-en"] = "c";
        }
      }
    } catch (e) {
      consoleError(e, elm);
    }
  }
  if (BUILD.asyncLoading && rc) {
    rc.map((cb) => cb());
    elm["s-rc"] = void 0;
  }
  endRender();
  endUpdate();
  if (BUILD.asyncLoading) {
    const childrenPromises = (_a = elm["s-p"]) != null ? _a : [];
    const postUpdate = () => postUpdateComponent(hostRef);
    if (childrenPromises.length === 0) {
      postUpdate();
    } else {
      Promise.all(childrenPromises).then(postUpdate);
      hostRef.$flags$ |= 4;
      childrenPromises.length = 0;
    }
  } else {
    postUpdateComponent(hostRef);
  }
};
var renderingRef = null;
var callRender = (hostRef, instance, elm, isInitialLoad) => {
  const allRenderFn = BUILD.allRenderFn ? true : false;
  const lazyLoad = BUILD.lazyLoad ? true : false;
  const taskQueue = BUILD.taskQueue ? true : false;
  const updatable = BUILD.updatable ? true : false;
  try {
    renderingRef = instance;
    instance = allRenderFn ? instance.render() : instance.render && instance.render();
    if (updatable && taskQueue) {
      hostRef.$flags$ &= ~16;
    }
    if (updatable || lazyLoad) {
      hostRef.$flags$ |= 2;
    }
    if (BUILD.hasRenderFn || BUILD.reflect) {
      if (BUILD.vdomRender || BUILD.reflect) {
        if (BUILD.hydrateServerSide) {
          return Promise.resolve(instance).then((value) => renderVdom(hostRef, value, isInitialLoad));
        } else {
          renderVdom(hostRef, instance, isInitialLoad);
        }
      } else {
        const shadowRoot = elm.shadowRoot;
        if (hostRef.$cmpMeta$.$flags$ & 1) {
          shadowRoot.textContent = instance;
        } else {
          elm.textContent = instance;
        }
      }
    }
  } catch (e) {
    consoleError(e, hostRef.$hostElement$);
  }
  renderingRef = null;
  return null;
};
var postUpdateComponent = (hostRef) => {
  const tagName = hostRef.$cmpMeta$.$tagName$;
  const elm = hostRef.$hostElement$;
  const endPostUpdate = createTime("postUpdate", tagName);
  const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
  const ancestorComponent = hostRef.$ancestorComponent$;
  if (BUILD.cmpDidRender) {
    if (BUILD.isDev) {
      hostRef.$flags$ |= 1024;
    }
    safeCall(instance, "componentDidRender");
    if (BUILD.isDev) {
      hostRef.$flags$ &= ~1024;
    }
  }
  emitLifecycleEvent(elm, "componentDidRender");
  if (!(hostRef.$flags$ & 64)) {
    hostRef.$flags$ |= 64;
    if (BUILD.asyncLoading && BUILD.cssAnnotations) {
      addHydratedFlag(elm);
    }
    if (BUILD.cmpDidLoad) {
      if (BUILD.isDev) {
        hostRef.$flags$ |= 2048;
      }
      safeCall(instance, "componentDidLoad");
      if (BUILD.isDev) {
        hostRef.$flags$ &= ~2048;
      }
    }
    emitLifecycleEvent(elm, "componentDidLoad");
    endPostUpdate();
    if (BUILD.asyncLoading) {
      hostRef.$onReadyResolve$(elm);
      if (!ancestorComponent) {
        appDidLoad(tagName);
      }
    }
  } else {
    if (BUILD.cmpDidUpdate) {
      if (BUILD.isDev) {
        hostRef.$flags$ |= 1024;
      }
      safeCall(instance, "componentDidUpdate");
      if (BUILD.isDev) {
        hostRef.$flags$ &= ~1024;
      }
    }
    emitLifecycleEvent(elm, "componentDidUpdate");
    endPostUpdate();
  }
  if (BUILD.method && BUILD.lazyLoad) {
    hostRef.$onInstanceResolve$(elm);
  }
  if (BUILD.asyncLoading) {
    if (hostRef.$onRenderResolve$) {
      hostRef.$onRenderResolve$();
      hostRef.$onRenderResolve$ = void 0;
    }
    if (hostRef.$flags$ & 512) {
      nextTick(() => scheduleUpdate(hostRef, false));
    }
    hostRef.$flags$ &= ~(4 | 512);
  }
};
var appDidLoad = (who) => {
  if (BUILD.cssAnnotations) {
    addHydratedFlag(doc.documentElement);
  }
  if (BUILD.asyncQueue) {
    plt.$flags$ |= 2;
  }
  nextTick(() => emitEvent(win, "appload", { detail: { namespace: NAMESPACE } }));
  if (BUILD.profile && performance.measure) {
    performance.measure(`[Stencil] ${NAMESPACE} initial load (by ${who})`, "st:app:start");
  }
};
var safeCall = (instance, method, arg) => {
  if (instance && instance[method]) {
    try {
      return instance[method](arg);
    } catch (e) {
      consoleError(e);
    }
  }
  return void 0;
};
var emitLifecycleEvent = (elm, lifecycleName) => {
  if (BUILD.lifecycleDOMEvents) {
    emitEvent(elm, "stencil_" + lifecycleName, {
      bubbles: true,
      composed: true,
      detail: {
        namespace: NAMESPACE
      }
    });
  }
};
var addHydratedFlag = (elm) => BUILD.hydratedClass ? elm.classList.add("hydrated") : BUILD.hydratedAttribute ? elm.setAttribute("hydrated", "") : void 0;
var serverSideConnected = (elm) => {
  const children = elm.children;
  if (children != null) {
    for (let i2 = 0, ii = children.length; i2 < ii; i2++) {
      const childElm = children[i2];
      if (typeof childElm.connectedCallback === "function") {
        childElm.connectedCallback();
      }
      serverSideConnected(childElm);
    }
  }
};
var getValue = (ref, propName) => getHostRef(ref).$instanceValues$.get(propName);
var setValue = (ref, propName, newVal, cmpMeta) => {
  const hostRef = getHostRef(ref);
  const elm = BUILD.lazyLoad ? hostRef.$hostElement$ : ref;
  const oldVal = hostRef.$instanceValues$.get(propName);
  const flags = hostRef.$flags$;
  const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
  newVal = parsePropertyValue(newVal, cmpMeta.$members$[propName][0]);
  const areBothNaN = Number.isNaN(oldVal) && Number.isNaN(newVal);
  const didValueChange = newVal !== oldVal && !areBothNaN;
  if ((!BUILD.lazyLoad || !(flags & 8) || oldVal === void 0) && didValueChange) {
    hostRef.$instanceValues$.set(propName, newVal);
    if (BUILD.isDev) {
      if (hostRef.$flags$ & 1024) {
        consoleDevWarn(
          `The state/prop "${propName}" changed during rendering. This can potentially lead to infinite-loops and other bugs.`,
          "\nElement",
          elm,
          "\nNew value",
          newVal,
          "\nOld value",
          oldVal
        );
      } else if (hostRef.$flags$ & 2048) {
        consoleDevWarn(
          `The state/prop "${propName}" changed during "componentDidLoad()", this triggers extra re-renders, try to setup on "componentWillLoad()"`,
          "\nElement",
          elm,
          "\nNew value",
          newVal,
          "\nOld value",
          oldVal
        );
      }
    }
    if (!BUILD.lazyLoad || instance) {
      if (BUILD.watchCallback && cmpMeta.$watchers$ && flags & 128) {
        const watchMethods = cmpMeta.$watchers$[propName];
        if (watchMethods) {
          watchMethods.map((watchMethodName) => {
            try {
              instance[watchMethodName](newVal, oldVal, propName);
            } catch (e) {
              consoleError(e, elm);
            }
          });
        }
      }
      if (BUILD.updatable && (flags & (2 | 16)) === 2) {
        if (BUILD.cmpShouldUpdate && instance.componentShouldUpdate) {
          if (instance.componentShouldUpdate(newVal, oldVal, propName) === false) {
            return;
          }
        }
        scheduleUpdate(hostRef, false);
      }
    }
  }
};
var proxyComponent = (Cstr, cmpMeta, flags) => {
  var _a;
  const prototype = Cstr.prototype;
  if (BUILD.formAssociated && cmpMeta.$flags$ & 64 && flags & 1) {
    FORM_ASSOCIATED_CUSTOM_ELEMENT_CALLBACKS.forEach(
      (cbName) => Object.defineProperty(prototype, cbName, {
        value(...args) {
          const hostRef = getHostRef(this);
          const elm = BUILD.lazyLoad ? hostRef.$hostElement$ : this;
          const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
          if (!instance) {
            hostRef.$onReadyPromise$.then((instance2) => {
              const cb = instance2[cbName];
              typeof cb === "function" && cb.call(instance2, ...args);
            });
          } else {
            const cb = instance[cbName];
            typeof cb === "function" && cb.call(instance, ...args);
          }
        }
      })
    );
  }
  if (BUILD.member && cmpMeta.$members$) {
    if (BUILD.watchCallback && Cstr.watchers) {
      cmpMeta.$watchers$ = Cstr.watchers;
    }
    const members = Object.entries(cmpMeta.$members$);
    members.map(([memberName, [memberFlags]]) => {
      if ((BUILD.prop || BUILD.state) && (memberFlags & 31 || (!BUILD.lazyLoad || flags & 2) && memberFlags & 32)) {
        Object.defineProperty(prototype, memberName, {
          get() {
            return getValue(this, memberName);
          },
          set(newValue) {
            if (BUILD.isDev) {
              const ref = getHostRef(this);
              if (
                // we are proxying the instance (not element)
                (flags & 1) === 0 && // the element is not constructing
                (ref && ref.$flags$ & 8) === 0 && // the member is a prop
                (memberFlags & 31) !== 0 && // the member is not mutable
                (memberFlags & 1024) === 0
              ) {
                consoleDevWarn(
                  `@Prop() "${memberName}" on <${cmpMeta.$tagName$}> is immutable but was modified from within the component.
More information: https://stenciljs.com/docs/properties#prop-mutability`
                );
              }
            }
            setValue(this, memberName, newValue, cmpMeta);
          },
          configurable: true,
          enumerable: true
        });
      } else if (BUILD.lazyLoad && BUILD.method && flags & 1 && memberFlags & 64) {
        Object.defineProperty(prototype, memberName, {
          value(...args) {
            var _a2;
            const ref = getHostRef(this);
            return (_a2 = ref == null ? void 0 : ref.$onInstancePromise$) == null ? void 0 : _a2.then(() => {
              var _a3;
              return (_a3 = ref.$lazyInstance$) == null ? void 0 : _a3[memberName](...args);
            });
          }
        });
      }
    });
    if (BUILD.observeAttribute && (!BUILD.lazyLoad || flags & 1)) {
      const attrNameToPropName = /* @__PURE__ */ new Map();
      prototype.attributeChangedCallback = function(attrName, oldValue, newValue) {
        plt.jmp(() => {
          var _a2;
          const propName = attrNameToPropName.get(attrName);
          if (this.hasOwnProperty(propName)) {
            newValue = this[propName];
            delete this[propName];
          } else if (prototype.hasOwnProperty(propName) && typeof this[propName] === "number" && this[propName] == newValue) {
            return;
          } else if (propName == null) {
            const hostRef = getHostRef(this);
            const flags2 = hostRef == null ? void 0 : hostRef.$flags$;
            if (flags2 && !(flags2 & 8) && flags2 & 128 && newValue !== oldValue) {
              const elm = BUILD.lazyLoad ? hostRef.$hostElement$ : this;
              const instance = BUILD.lazyLoad ? hostRef.$lazyInstance$ : elm;
              const entry = (_a2 = cmpMeta.$watchers$) == null ? void 0 : _a2[attrName];
              entry == null ? void 0 : entry.forEach((callbackName) => {
                if (instance[callbackName] != null) {
                  instance[callbackName].call(instance, newValue, oldValue, attrName);
                }
              });
            }
            return;
          }
          this[propName] = newValue === null && typeof this[propName] === "boolean" ? false : newValue;
        });
      };
      Cstr.observedAttributes = Array.from(
        /* @__PURE__ */ new Set([
          ...Object.keys((_a = cmpMeta.$watchers$) != null ? _a : {}),
          ...members.filter(
            ([_, m]) => m[0] & 15
            /* HasAttribute */
          ).map(([propName, m]) => {
            var _a2;
            const attrName = m[1] || propName;
            attrNameToPropName.set(attrName, propName);
            if (BUILD.reflect && m[0] & 512) {
              (_a2 = cmpMeta.$attrsToReflect$) == null ? void 0 : _a2.push([propName, attrName]);
            }
            return attrName;
          })
        ])
      );
    }
  }
  return Cstr;
};
var initializeComponent = async (elm, hostRef, cmpMeta, hmrVersionId) => {
  let Cstr;
  if ((hostRef.$flags$ & 32) === 0) {
    hostRef.$flags$ |= 32;
    const bundleId = cmpMeta.$lazyBundleId$;
    if ((BUILD.lazyLoad || BUILD.hydrateClientSide) && bundleId) {
      Cstr = loadModule(cmpMeta, hostRef, hmrVersionId);
      if (Cstr.then) {
        const endLoad = uniqueTime(
          `st:load:${cmpMeta.$tagName$}:${hostRef.$modeName$}`,
          `[Stencil] Load module for <${cmpMeta.$tagName$}>`
        );
        Cstr = await Cstr;
        endLoad();
      }
      if ((BUILD.isDev || BUILD.isDebug) && !Cstr) {
        throw new Error(`Constructor for "${cmpMeta.$tagName$}#${hostRef.$modeName$}" was not found`);
      }
      if (BUILD.member && !Cstr.isProxied) {
        if (BUILD.watchCallback) {
          cmpMeta.$watchers$ = Cstr.watchers;
        }
        proxyComponent(
          Cstr,
          cmpMeta,
          2
          /* proxyState */
        );
        Cstr.isProxied = true;
      }
      const endNewInstance = createTime("createInstance", cmpMeta.$tagName$);
      if (BUILD.member) {
        hostRef.$flags$ |= 8;
      }
      try {
        new Cstr(hostRef);
      } catch (e) {
        consoleError(e);
      }
      if (BUILD.member) {
        hostRef.$flags$ &= ~8;
      }
      if (BUILD.watchCallback) {
        hostRef.$flags$ |= 128;
      }
      endNewInstance();
      fireConnectedCallback(hostRef.$lazyInstance$);
    } else {
      Cstr = elm.constructor;
      customElements.whenDefined(cmpMeta.$tagName$).then(
        () => hostRef.$flags$ |= 128
        /* isWatchReady */
      );
    }
    if (BUILD.style && Cstr.style) {
      let style = Cstr.style;
      if (BUILD.mode && typeof style !== "string") {
        style = style[hostRef.$modeName$ = computeMode(elm)];
        if (BUILD.hydrateServerSide && hostRef.$modeName$) {
          elm.setAttribute("s-mode", hostRef.$modeName$);
        }
      }
      const scopeId2 = getScopeId(cmpMeta, hostRef.$modeName$);
      if (!styles.has(scopeId2)) {
        const endRegisterStyles = createTime("registerStyles", cmpMeta.$tagName$);
        if (!BUILD.hydrateServerSide && BUILD.shadowDom && // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
        BUILD.shadowDomShim && cmpMeta.$flags$ & 8) {
          style = await Promise.resolve().then(() => (init_shadow_css(), shadow_css_exports)).then((m) => m.scopeCss(style, scopeId2, false));
        }
        registerStyle(scopeId2, style, !!(cmpMeta.$flags$ & 1));
        endRegisterStyles();
      }
    }
  }
  const ancestorComponent = hostRef.$ancestorComponent$;
  const schedule = () => scheduleUpdate(hostRef, true);
  if (BUILD.asyncLoading && ancestorComponent && ancestorComponent["s-rc"]) {
    ancestorComponent["s-rc"].push(schedule);
  } else {
    schedule();
  }
};
var fireConnectedCallback = (instance) => {
  if (BUILD.lazyLoad && BUILD.connectedCallback) {
    safeCall(instance, "connectedCallback");
  }
};
var connectedCallback = (elm) => {
  if ((plt.$flags$ & 1) === 0) {
    const hostRef = getHostRef(elm);
    const cmpMeta = hostRef.$cmpMeta$;
    const endConnected = createTime("connectedCallback", cmpMeta.$tagName$);
    if (BUILD.hostListenerTargetParent) {
      addHostEventListeners(elm, hostRef, cmpMeta.$listeners$, true);
    }
    if (!(hostRef.$flags$ & 1)) {
      hostRef.$flags$ |= 1;
      let hostId;
      if (BUILD.hydrateClientSide) {
        hostId = elm.getAttribute(HYDRATE_ID);
        if (hostId) {
          if (BUILD.shadowDom && supportsShadow && cmpMeta.$flags$ & 1) {
            const scopeId2 = BUILD.mode ? addStyle(elm.shadowRoot, cmpMeta, elm.getAttribute("s-mode")) : addStyle(elm.shadowRoot, cmpMeta);
            elm.classList.remove(scopeId2 + "-h", scopeId2 + "-s");
          }
          initializeClientHydrate(elm, cmpMeta.$tagName$, hostId, hostRef);
        }
      }
      if (BUILD.slotRelocation && !hostId) {
        if (BUILD.hydrateServerSide || (BUILD.slot || BUILD.shadowDom) && // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
        cmpMeta.$flags$ & (4 | 8)) {
          setContentReference(elm);
        }
      }
      if (BUILD.asyncLoading) {
        let ancestorComponent = elm;
        while (ancestorComponent = ancestorComponent.parentNode || ancestorComponent.host) {
          if (BUILD.hydrateClientSide && ancestorComponent.nodeType === 1 && ancestorComponent.hasAttribute("s-id") && ancestorComponent["s-p"] || ancestorComponent["s-p"]) {
            attachToAncestor(hostRef, hostRef.$ancestorComponent$ = ancestorComponent);
            break;
          }
        }
      }
      if (BUILD.prop && !BUILD.hydrateServerSide && cmpMeta.$members$) {
        Object.entries(cmpMeta.$members$).map(([memberName, [memberFlags]]) => {
          if (memberFlags & 31 && elm.hasOwnProperty(memberName)) {
            const value = elm[memberName];
            delete elm[memberName];
            elm[memberName] = value;
          }
        });
      }
      if (BUILD.initializeNextTick) {
        nextTick(() => initializeComponent(elm, hostRef, cmpMeta));
      } else {
        initializeComponent(elm, hostRef, cmpMeta);
      }
    } else {
      addHostEventListeners(elm, hostRef, cmpMeta.$listeners$, false);
      if (hostRef == null ? void 0 : hostRef.$lazyInstance$) {
        fireConnectedCallback(hostRef.$lazyInstance$);
      } else if (hostRef == null ? void 0 : hostRef.$onReadyPromise$) {
        hostRef.$onReadyPromise$.then(() => fireConnectedCallback(hostRef.$lazyInstance$));
      }
    }
    endConnected();
  }
};
var setContentReference = (elm) => {
  const contentRefElm = elm["s-cr"] = doc.createComment(
    BUILD.isDebug ? `content-ref (host=${elm.localName})` : ""
  );
  contentRefElm["s-cn"] = true;
  elm.insertBefore(contentRefElm, elm.firstChild);
};
var disconnectInstance = (instance) => {
  if (BUILD.lazyLoad && BUILD.disconnectedCallback) {
    safeCall(instance, "disconnectedCallback");
  }
  if (BUILD.cmpDidUnload) {
    safeCall(instance, "componentDidUnload");
  }
};
var disconnectedCallback = async (elm) => {
  if ((plt.$flags$ & 1) === 0) {
    const hostRef = getHostRef(elm);
    if (BUILD.hostListener) {
      if (hostRef.$rmListeners$) {
        hostRef.$rmListeners$.map((rmListener) => rmListener());
        hostRef.$rmListeners$ = void 0;
      }
    }
    if (!BUILD.lazyLoad) {
      disconnectInstance(elm);
    } else if (hostRef == null ? void 0 : hostRef.$lazyInstance$) {
      disconnectInstance(hostRef.$lazyInstance$);
    } else if (hostRef == null ? void 0 : hostRef.$onReadyPromise$) {
      hostRef.$onReadyPromise$.then(() => disconnectInstance(hostRef.$lazyInstance$));
    }
  }
};
var patchPseudoShadowDom = (hostElementPrototype, descriptorPrototype) => {
  patchCloneNode(hostElementPrototype);
  patchSlotAppendChild(hostElementPrototype);
  patchSlotAppend(hostElementPrototype);
  patchSlotPrepend(hostElementPrototype);
  patchSlotInsertAdjacentElement(hostElementPrototype);
  patchSlotInsertAdjacentHTML(hostElementPrototype);
  patchSlotInsertAdjacentText(hostElementPrototype);
  patchTextContent(hostElementPrototype);
  patchChildSlotNodes(hostElementPrototype, descriptorPrototype);
  patchSlotRemoveChild(hostElementPrototype);
};
var patchCloneNode = (HostElementPrototype) => {
  const orgCloneNode = HostElementPrototype.cloneNode;
  HostElementPrototype.cloneNode = function(deep) {
    const srcNode = this;
    const isShadowDom = BUILD.shadowDom ? srcNode.shadowRoot && supportsShadow : false;
    const clonedNode = orgCloneNode.call(srcNode, isShadowDom ? deep : false);
    if (BUILD.slot && !isShadowDom && deep) {
      let i2 = 0;
      let slotted, nonStencilNode;
      const stencilPrivates = [
        "s-id",
        "s-cr",
        "s-lr",
        "s-rc",
        "s-sc",
        "s-p",
        "s-cn",
        "s-sr",
        "s-sn",
        "s-hn",
        "s-ol",
        "s-nr",
        "s-si",
        "s-rf"
      ];
      for (; i2 < srcNode.childNodes.length; i2++) {
        slotted = srcNode.childNodes[i2]["s-nr"];
        nonStencilNode = stencilPrivates.every((privateField) => !srcNode.childNodes[i2][privateField]);
        if (slotted) {
          if (BUILD.appendChildSlotFix && clonedNode.__appendChild) {
            clonedNode.__appendChild(slotted.cloneNode(true));
          } else {
            clonedNode.appendChild(slotted.cloneNode(true));
          }
        }
        if (nonStencilNode) {
          clonedNode.appendChild(srcNode.childNodes[i2].cloneNode(true));
        }
      }
    }
    return clonedNode;
  };
};
var patchSlotAppendChild = (HostElementPrototype) => {
  HostElementPrototype.__appendChild = HostElementPrototype.appendChild;
  HostElementPrototype.appendChild = function(newChild) {
    const slotName = newChild["s-sn"] = getSlotName(newChild);
    const slotNode = getHostSlotNode(this.childNodes, slotName, this.tagName);
    if (slotNode) {
      const slotChildNodes = getHostSlotChildNodes(slotNode, slotName);
      const appendAfter = slotChildNodes[slotChildNodes.length - 1];
      const insertedNode = appendAfter.parentNode.insertBefore(newChild, appendAfter.nextSibling);
      updateFallbackSlotVisibility(this);
      return insertedNode;
    }
    return this.__appendChild(newChild);
  };
};
var patchSlotRemoveChild = (ElementPrototype) => {
  ElementPrototype.__removeChild = ElementPrototype.removeChild;
  ElementPrototype.removeChild = function(toRemove) {
    if (toRemove && typeof toRemove["s-sn"] !== "undefined") {
      const slotNode = getHostSlotNode(this.childNodes, toRemove["s-sn"], this.tagName);
      if (slotNode) {
        const slotChildNodes = getHostSlotChildNodes(slotNode, toRemove["s-sn"]);
        const existingNode = slotChildNodes.find((n) => n === toRemove);
        if (existingNode) {
          existingNode.remove();
          updateFallbackSlotVisibility(this);
          return;
        }
      }
    }
    return this.__removeChild(toRemove);
  };
};
var patchSlotPrepend = (HostElementPrototype) => {
  const originalPrepend = HostElementPrototype.prepend;
  HostElementPrototype.prepend = function(...newChildren) {
    newChildren.forEach((newChild) => {
      if (typeof newChild === "string") {
        newChild = this.ownerDocument.createTextNode(newChild);
      }
      const slotName = newChild["s-sn"] = getSlotName(newChild);
      const slotNode = getHostSlotNode(this.childNodes, slotName, this.tagName);
      if (slotNode) {
        const slotPlaceholder = document.createTextNode("");
        slotPlaceholder["s-nr"] = newChild;
        slotNode["s-cr"].parentNode.__appendChild(slotPlaceholder);
        newChild["s-ol"] = slotPlaceholder;
        const slotChildNodes = getHostSlotChildNodes(slotNode, slotName);
        const appendAfter = slotChildNodes[0];
        return appendAfter.parentNode.insertBefore(newChild, appendAfter.nextSibling);
      }
      if (newChild.nodeType === 1 && !!newChild.getAttribute("slot")) {
        newChild.hidden = true;
      }
      return originalPrepend.call(this, newChild);
    });
  };
};
var patchSlotAppend = (HostElementPrototype) => {
  HostElementPrototype.append = function(...newChildren) {
    newChildren.forEach((newChild) => {
      if (typeof newChild === "string") {
        newChild = this.ownerDocument.createTextNode(newChild);
      }
      this.appendChild(newChild);
    });
  };
};
var patchSlotInsertAdjacentHTML = (HostElementPrototype) => {
  const originalInsertAdjacentHtml = HostElementPrototype.insertAdjacentHTML;
  HostElementPrototype.insertAdjacentHTML = function(position, text) {
    if (position !== "afterbegin" && position !== "beforeend") {
      return originalInsertAdjacentHtml.call(this, position, text);
    }
    const container = this.ownerDocument.createElement("_");
    let node;
    container.innerHTML = text;
    if (position === "afterbegin") {
      while (node = container.firstChild) {
        this.prepend(node);
      }
    } else if (position === "beforeend") {
      while (node = container.firstChild) {
        this.append(node);
      }
    }
  };
};
var patchSlotInsertAdjacentText = (HostElementPrototype) => {
  HostElementPrototype.insertAdjacentText = function(position, text) {
    this.insertAdjacentHTML(position, text);
  };
};
var patchSlotInsertAdjacentElement = (HostElementPrototype) => {
  const originalInsertAdjacentElement = HostElementPrototype.insertAdjacentElement;
  HostElementPrototype.insertAdjacentElement = function(position, element) {
    if (position !== "afterbegin" && position !== "beforeend") {
      return originalInsertAdjacentElement.call(this, position, element);
    }
    if (position === "afterbegin") {
      this.prepend(element);
      return element;
    } else if (position === "beforeend") {
      this.append(element);
      return element;
    }
    return element;
  };
};
var patchTextContent = (hostElementPrototype) => {
  const descriptor = Object.getOwnPropertyDescriptor(Node.prototype, "textContent");
  Object.defineProperty(hostElementPrototype, "__textContent", descriptor);
  if (BUILD.experimentalScopedSlotChanges) {
    Object.defineProperty(hostElementPrototype, "textContent", {
      // To mimic shadow root behavior, we need to return the text content of all
      // nodes in a slot reference node
      get() {
        const slotRefNodes = getAllChildSlotNodes(this.childNodes);
        const textContent = slotRefNodes.map((node) => {
          var _a, _b;
          const text = [];
          let slotContent = node.nextSibling;
          while (slotContent && slotContent["s-sn"] === node["s-sn"]) {
            if (slotContent.nodeType === 3 || slotContent.nodeType === 1) {
              text.push((_b = (_a = slotContent.textContent) == null ? void 0 : _a.trim()) != null ? _b : "");
            }
            slotContent = slotContent.nextSibling;
          }
          return text.filter((ref) => ref !== "").join(" ");
        }).filter((text) => text !== "").join(" ");
        return " " + textContent + " ";
      },
      // To mimic shadow root behavior, we need to overwrite all nodes in a slot
      // reference node. If a default slot reference node exists, the text content will be
      // placed there. Otherwise, the new text node will be hidden
      set(value) {
        const slotRefNodes = getAllChildSlotNodes(this.childNodes);
        slotRefNodes.forEach((node) => {
          let slotContent = node.nextSibling;
          while (slotContent && slotContent["s-sn"] === node["s-sn"]) {
            const tmp = slotContent;
            slotContent = slotContent.nextSibling;
            tmp.remove();
          }
          if (node["s-sn"] === "") {
            const textNode = this.ownerDocument.createTextNode(value);
            textNode["s-sn"] = "";
            node.parentElement.insertBefore(textNode, node.nextSibling);
          } else {
            node.remove();
          }
        });
      }
    });
  } else {
    Object.defineProperty(hostElementPrototype, "textContent", {
      get() {
        var _a;
        const slotNode = getHostSlotNode(this.childNodes, "", this.tagName);
        if (((_a = slotNode == null ? void 0 : slotNode.nextSibling) == null ? void 0 : _a.nodeType) === 3) {
          return slotNode.nextSibling.textContent;
        } else if (slotNode) {
          return slotNode.textContent;
        } else {
          return this.__textContent;
        }
      },
      set(value) {
        var _a;
        const slotNode = getHostSlotNode(this.childNodes, "", this.tagName);
        if (((_a = slotNode == null ? void 0 : slotNode.nextSibling) == null ? void 0 : _a.nodeType) === 3) {
          slotNode.nextSibling.textContent = value;
        } else if (slotNode) {
          slotNode.textContent = value;
        } else {
          this.__textContent = value;
          const contentRefElm = this["s-cr"];
          if (contentRefElm) {
            this.insertBefore(contentRefElm, this.firstChild);
          }
        }
      }
    });
  }
};
var patchChildSlotNodes = (elm, cmpMeta) => {
  class FakeNodeList extends Array {
    item(n) {
      return this[n];
    }
  }
  if (cmpMeta.$flags$ & 8) {
    const childNodesFn = elm.__lookupGetter__("childNodes");
    Object.defineProperty(elm, "children", {
      get() {
        return this.childNodes.map((n) => n.nodeType === 1);
      }
    });
    Object.defineProperty(elm, "childElementCount", {
      get() {
        return elm.children.length;
      }
    });
    Object.defineProperty(elm, "childNodes", {
      get() {
        const childNodes = childNodesFn.call(this);
        if ((plt.$flags$ & 1) === 0 && getHostRef(this).$flags$ & 2) {
          const result = new FakeNodeList();
          for (let i2 = 0; i2 < childNodes.length; i2++) {
            const slot = childNodes[i2]["s-nr"];
            if (slot) {
              result.push(slot);
            }
          }
          return result;
        }
        return FakeNodeList.from(childNodes);
      }
    });
  }
};
var getAllChildSlotNodes = (childNodes) => {
  const slotRefNodes = [];
  for (const childNode of Array.from(childNodes)) {
    if (childNode["s-sr"]) {
      slotRefNodes.push(childNode);
    }
    slotRefNodes.push(...getAllChildSlotNodes(childNode.childNodes));
  }
  return slotRefNodes;
};
var getSlotName = (node) => node["s-sn"] || node.nodeType === 1 && node.getAttribute("slot") || "";
var getHostSlotNode = (childNodes, slotName, hostName) => {
  let i2 = 0;
  let childNode;
  for (; i2 < childNodes.length; i2++) {
    childNode = childNodes[i2];
    if (childNode["s-sr"] && childNode["s-sn"] === slotName && childNode["s-hn"] === hostName) {
      return childNode;
    }
    childNode = getHostSlotNode(childNode.childNodes, slotName, hostName);
    if (childNode) {
      return childNode;
    }
  }
  return null;
};
var getHostSlotChildNodes = (n, slotName) => {
  const childNodes = [n];
  while ((n = n.nextSibling) && n["s-sn"] === slotName) {
    childNodes.push(n);
  }
  return childNodes;
};
var proxyCustomElement = (Cstr, compactMeta) => {
  const cmpMeta = {
    $flags$: compactMeta[0],
    $tagName$: compactMeta[1]
  };
  if (BUILD.member) {
    cmpMeta.$members$ = compactMeta[2];
  }
  if (BUILD.hostListener) {
    cmpMeta.$listeners$ = compactMeta[3];
  }
  if (BUILD.watchCallback) {
    cmpMeta.$watchers$ = Cstr.$watchers$;
  }
  if (BUILD.reflect) {
    cmpMeta.$attrsToReflect$ = [];
  }
  if (BUILD.shadowDom && !supportsShadow && cmpMeta.$flags$ & 1) {
    cmpMeta.$flags$ |= 8;
  }
  if (BUILD.experimentalSlotFixes) {
    if (BUILD.scoped && cmpMeta.$flags$ & 2) {
      patchPseudoShadowDom(Cstr.prototype, cmpMeta);
    }
  } else {
    if (BUILD.slotChildNodesFix) {
      patchChildSlotNodes(Cstr.prototype, cmpMeta);
    }
    if (BUILD.cloneNodeFix) {
      patchCloneNode(Cstr.prototype);
    }
    if (BUILD.appendChildSlotFix) {
      patchSlotAppendChild(Cstr.prototype);
    }
    if (BUILD.scopedSlotTextContentFix && cmpMeta.$flags$ & 2) {
      patchTextContent(Cstr.prototype);
    }
  }
  const originalConnectedCallback = Cstr.prototype.connectedCallback;
  const originalDisconnectedCallback = Cstr.prototype.disconnectedCallback;
  Object.assign(Cstr.prototype, {
    __registerHost() {
      registerHost(this, cmpMeta);
    },
    connectedCallback() {
      connectedCallback(this);
      if (BUILD.connectedCallback && originalConnectedCallback) {
        originalConnectedCallback.call(this);
      }
    },
    disconnectedCallback() {
      disconnectedCallback(this);
      if (BUILD.disconnectedCallback && originalDisconnectedCallback) {
        originalDisconnectedCallback.call(this);
      }
    },
    __attachShadow() {
      if (supportsShadow) {
        if (BUILD.shadowDelegatesFocus) {
          this.attachShadow({
            mode: "open",
            delegatesFocus: !!(cmpMeta.$flags$ & 16)
          });
        } else {
          this.attachShadow({ mode: "open" });
        }
      } else {
        this.shadowRoot = this;
      }
    }
  });
  Cstr.is = cmpMeta.$tagName$;
  return proxyComponent(
    Cstr,
    cmpMeta,
    1 | 2
    /* proxyState */
  );
};
var addHostEventListeners = (elm, hostRef, listeners, attachParentListeners) => {
  if (BUILD.hostListener && listeners) {
    if (BUILD.hostListenerTargetParent) {
      if (attachParentListeners) {
        listeners = listeners.filter(
          ([flags]) => flags & 32
          /* TargetParent */
        );
      } else {
        listeners = listeners.filter(([flags]) => !(flags & 32));
      }
    }
    listeners.map(([flags, name, method]) => {
      const target = BUILD.hostListenerTarget ? getHostListenerTarget(elm, flags) : elm;
      const handler = hostListenerProxy(hostRef, method);
      const opts = hostListenerOpts(flags);
      plt.ael(target, name, handler, opts);
      (hostRef.$rmListeners$ = hostRef.$rmListeners$ || []).push(() => plt.rel(target, name, handler, opts));
    });
  }
};
var hostListenerProxy = (hostRef, methodName) => (ev) => {
  try {
    if (BUILD.lazyLoad) {
      if (hostRef.$flags$ & 256) {
        hostRef.$lazyInstance$[methodName](ev);
      } else {
        (hostRef.$queuedListeners$ = hostRef.$queuedListeners$ || []).push([methodName, ev]);
      }
    } else {
      hostRef.$hostElement$[methodName](ev);
    }
  } catch (e) {
    consoleError(e);
  }
};
var getHostListenerTarget = (elm, flags) => {
  if (BUILD.hostListenerTargetDocument && flags & 4)
    return doc;
  if (BUILD.hostListenerTargetWindow && flags & 8)
    return win;
  if (BUILD.hostListenerTargetBody && flags & 16)
    return doc.body;
  if (BUILD.hostListenerTargetParent && flags & 32)
    return elm.parentElement;
  return elm;
};
var hostListenerOpts = (flags) => supportsListenerOptions ? {
  passive: (flags & 1) !== 0,
  capture: (flags & 2) !== 0
} : (flags & 2) !== 0;
var hostRefs = BUILD.hotModuleReplacement ? window.__STENCIL_HOSTREFS__ || (window.__STENCIL_HOSTREFS__ = /* @__PURE__ */ new WeakMap()) : /* @__PURE__ */ new WeakMap();
var getHostRef = (ref) => hostRefs.get(ref);
var registerHost = (hostElement, cmpMeta) => {
  const hostRef = {
    $flags$: 0,
    $hostElement$: hostElement,
    $cmpMeta$: cmpMeta,
    $instanceValues$: /* @__PURE__ */ new Map()
  };
  if (BUILD.isDev) {
    hostRef.$renderCount$ = 0;
  }
  if (BUILD.method && BUILD.lazyLoad) {
    hostRef.$onInstancePromise$ = new Promise((r) => hostRef.$onInstanceResolve$ = r);
  }
  if (BUILD.asyncLoading) {
    hostRef.$onReadyPromise$ = new Promise((r) => hostRef.$onReadyResolve$ = r);
    hostElement["s-p"] = [];
    hostElement["s-rc"] = [];
  }
  addHostEventListeners(hostElement, hostRef, cmpMeta.$listeners$, false);
  return hostRefs.set(hostElement, hostRef);
};
var isMemberInElement = (elm, memberName) => memberName in elm;
var customError;
var consoleError = (e, el) => (customError || console.error)(e, el);
var STENCIL_DEV_MODE = BUILD.isTesting ? ["STENCIL:"] : [
  "%cstencil",
  "color: white;background:#4c47ff;font-weight: bold; font-size:10px; padding:2px 6px; border-radius: 5px"
];
var consoleDevError = (...m) => console.error(...STENCIL_DEV_MODE, ...m);
var consoleDevWarn = (...m) => console.warn(...STENCIL_DEV_MODE, ...m);
var cmpModules = /* @__PURE__ */ new Map();
var loadModule = (cmpMeta, hostRef, hmrVersionId) => {
  const exportName = cmpMeta.$tagName$.replace(/-/g, "_");
  const bundleId = cmpMeta.$lazyBundleId$;
  if (BUILD.isDev && typeof bundleId !== "string") {
    consoleDevError(
      `Trying to lazily load component <${cmpMeta.$tagName$}> with style mode "${hostRef.$modeName$}", but it does not exist.`
    );
    return void 0;
  }
  const module = !BUILD.hotModuleReplacement ? cmpModules.get(bundleId) : false;
  if (module) {
    return module[exportName];
  }
  return /* @vite-ignore */ /* webpackInclude: /\.entry\.js$/ */ /* webpackExclude: /\.system\.entry\.js$/ */ /* webpackMode: "lazy" */ globImport_entry_js(`./${bundleId}.entry.js${BUILD.hotModuleReplacement && hmrVersionId ? "?s-hmr=" + hmrVersionId : ""}`).then((importedModule) => {
    if (!BUILD.hotModuleReplacement) {
      cmpModules.set(bundleId, importedModule);
    }
    return importedModule[exportName];
  }, consoleError);
};
var styles = /* @__PURE__ */ new Map();
var modeResolutionChain = [];
var win = typeof window !== "undefined" ? window : {};
var doc = win.document || { head: {} };
var H = win.HTMLElement || class {
};
var plt = {
  $flags$: 0,
  $resourcesUrl$: "",
  jmp: (h2) => h2(),
  raf: (h2) => requestAnimationFrame(h2),
  ael: (el, eventName, listener, opts) => el.addEventListener(eventName, listener, opts),
  rel: (el, eventName, listener, opts) => el.removeEventListener(eventName, listener, opts),
  ce: (eventName, opts) => new CustomEvent(eventName, opts)
};
var supportsShadow = (
  // TODO(STENCIL-854): Remove code related to legacy shadowDomShim field
  BUILD.shadowDomShim && BUILD.shadowDom ? /* @__PURE__ */ (() => (doc.head.attachShadow + "").indexOf("[native") > -1)() : true
);
var supportsListenerOptions = /* @__PURE__ */ (() => {
  let supportsListenerOptions2 = false;
  try {
    doc.addEventListener(
      "e",
      null,
      Object.defineProperty({}, "passive", {
        get() {
          supportsListenerOptions2 = true;
        }
      })
    );
  } catch (e) {
  }
  return supportsListenerOptions2;
})();
var promiseResolve = (v) => Promise.resolve(v);
var supportsConstructableStylesheets = BUILD.constructableCSS ? /* @__PURE__ */ (() => {
  try {
    new CSSStyleSheet();
    return typeof new CSSStyleSheet().replaceSync === "function";
  } catch (e) {
  }
  return false;
})() : false;
var queueCongestion = 0;
var queuePending = false;
var queueDomReads = [];
var queueDomWrites = [];
var queueDomWritesLow = [];
var queueTask = (queue, write) => (cb) => {
  queue.push(cb);
  if (!queuePending) {
    queuePending = true;
    if (write && plt.$flags$ & 4) {
      nextTick(flush);
    } else {
      plt.raf(flush);
    }
  }
};
var consume = (queue) => {
  for (let i2 = 0; i2 < queue.length; i2++) {
    try {
      queue[i2](performance.now());
    } catch (e) {
      consoleError(e);
    }
  }
  queue.length = 0;
};
var consumeTimeout = (queue, timeout) => {
  let i2 = 0;
  let ts = 0;
  while (i2 < queue.length && (ts = performance.now()) < timeout) {
    try {
      queue[i2++](ts);
    } catch (e) {
      consoleError(e);
    }
  }
  if (i2 === queue.length) {
    queue.length = 0;
  } else if (i2 !== 0) {
    queue.splice(0, i2);
  }
};
var flush = () => {
  if (BUILD.asyncQueue) {
    queueCongestion++;
  }
  consume(queueDomReads);
  if (BUILD.asyncQueue) {
    const timeout = (plt.$flags$ & 6) === 2 ? performance.now() + 14 * Math.ceil(queueCongestion * (1 / 10)) : Infinity;
    consumeTimeout(queueDomWrites, timeout);
    consumeTimeout(queueDomWritesLow, timeout);
    if (queueDomWrites.length > 0) {
      queueDomWritesLow.push(...queueDomWrites);
      queueDomWrites.length = 0;
    }
    if (queuePending = queueDomReads.length + queueDomWrites.length + queueDomWritesLow.length > 0) {
      plt.raf(flush);
    } else {
      queueCongestion = 0;
    }
  } else {
    consume(queueDomWrites);
    if (queuePending = queueDomReads.length > 0) {
      plt.raf(flush);
    }
  }
};
var nextTick = (cb) => promiseResolve().then(cb);
var writeTask = /* @__PURE__ */ queueTask(queueDomWrites, true);

// ../../node_modules/ionicons/components/utils.js
var CACHED_MAP;
var getIconMap = () => {
  if (typeof window === "undefined") {
    return /* @__PURE__ */ new Map();
  } else {
    if (!CACHED_MAP) {
      const win2 = window;
      win2.Ionicons = win2.Ionicons || {};
      CACHED_MAP = win2.Ionicons.map = win2.Ionicons.map || /* @__PURE__ */ new Map();
    }
    return CACHED_MAP;
  }
};
var getUrl = (i2) => {
  let url = getSrc(i2.src);
  if (url) {
    return url;
  }
  url = getName(i2.name, i2.icon, i2.mode, i2.ios, i2.md);
  if (url) {
    return getNamedUrl(url, i2);
  }
  if (i2.icon) {
    url = getSrc(i2.icon);
    if (url) {
      return url;
    }
    url = getSrc(i2.icon[i2.mode]);
    if (url) {
      return url;
    }
  }
  return null;
};
var getNamedUrl = (iconName, iconEl) => {
  const url = getIconMap().get(iconName);
  if (url) {
    return url;
  }
  try {
    return getAssetPath(`svg/${iconName}.svg`);
  } catch (e) {
    console.warn(`[Ionicons Warning]: Could not load icon with name "${iconName}". Ensure that the icon is registered using addIcons or that the icon SVG data is passed directly to the icon component.`, iconEl);
  }
};
var getName = (iconName, icon, mode, ios, md) => {
  mode = (mode && toLower(mode)) === "ios" ? "ios" : "md";
  if (ios && mode === "ios") {
    iconName = toLower(ios);
  } else if (md && mode === "md") {
    iconName = toLower(md);
  } else {
    if (!iconName && icon && !isSrc(icon)) {
      iconName = icon;
    }
    if (isStr(iconName)) {
      iconName = toLower(iconName);
    }
  }
  if (!isStr(iconName) || iconName.trim() === "") {
    return null;
  }
  const invalidChars = iconName.replace(/[a-z]|-|\d/gi, "");
  if (invalidChars !== "") {
    return null;
  }
  return iconName;
};
var getSrc = (src) => {
  if (isStr(src)) {
    src = src.trim();
    if (isSrc(src)) {
      return src;
    }
  }
  return null;
};
var isSrc = (str) => str.length > 0 && /(\/|\.)/.test(str);
var isStr = (val) => typeof val === "string";
var toLower = (val) => val.toLowerCase();
var inheritAttributes = (el, attributes = []) => {
  const attributeObject = {};
  attributes.forEach((attr) => {
    if (el.hasAttribute(attr)) {
      const value = el.getAttribute(attr);
      if (value !== null) {
        attributeObject[attr] = el.getAttribute(attr);
      }
      el.removeAttribute(attr);
    }
  });
  return attributeObject;
};
var isRTL = (hostEl) => {
  if (hostEl) {
    if (hostEl.dir !== "") {
      return hostEl.dir.toLowerCase() === "rtl";
    }
  }
  return (document === null || document === void 0 ? void 0 : document.dir.toLowerCase()) === "rtl";
};

// ../../node_modules/ionicons/components/ion-icon.js
var validateContent = (svgContent) => {
  const div = document.createElement("div");
  div.innerHTML = svgContent;
  for (let i2 = div.childNodes.length - 1; i2 >= 0; i2--) {
    if (div.childNodes[i2].nodeName.toLowerCase() !== "svg") {
      div.removeChild(div.childNodes[i2]);
    }
  }
  const svgElm = div.firstElementChild;
  if (svgElm && svgElm.nodeName.toLowerCase() === "svg") {
    const svgClass = svgElm.getAttribute("class") || "";
    svgElm.setAttribute("class", (svgClass + " s-ion-icon").trim());
    if (isValid(svgElm)) {
      return div.innerHTML;
    }
  }
  return "";
};
var isValid = (elm) => {
  if (elm.nodeType === 1) {
    if (elm.nodeName.toLowerCase() === "script") {
      return false;
    }
    for (let i2 = 0; i2 < elm.attributes.length; i2++) {
      const name = elm.attributes[i2].name;
      if (isStr(name) && name.toLowerCase().indexOf("on") === 0) {
        return false;
      }
    }
    for (let i2 = 0; i2 < elm.childNodes.length; i2++) {
      if (!isValid(elm.childNodes[i2])) {
        return false;
      }
    }
  }
  return true;
};
var isSvgDataUrl = (url) => url.startsWith("data:image/svg+xml");
var isEncodedDataUrl = (url) => url.indexOf(";utf8,") !== -1;
var ioniconContent = /* @__PURE__ */ new Map();
var requests = /* @__PURE__ */ new Map();
var parser;
var getSvgContent = (url, sanitize) => {
  let req = requests.get(url);
  if (!req) {
    if (typeof fetch !== "undefined" && typeof document !== "undefined") {
      if (isSvgDataUrl(url) && isEncodedDataUrl(url)) {
        if (!parser) {
          parser = new DOMParser();
        }
        const doc2 = parser.parseFromString(url, "text/html");
        const svg = doc2.querySelector("svg");
        if (svg) {
          ioniconContent.set(url, svg.outerHTML);
        }
        return Promise.resolve();
      } else {
        req = fetch(url).then((rsp) => {
          if (rsp.ok) {
            return rsp.text().then((svgContent) => {
              if (svgContent && sanitize !== false) {
                svgContent = validateContent(svgContent);
              }
              ioniconContent.set(url, svgContent || "");
            });
          }
          ioniconContent.set(url, "");
        });
        requests.set(url, req);
      }
    } else {
      ioniconContent.set(url, "");
      return Promise.resolve();
    }
  }
  return req;
};
var iconCss = ":host{display:inline-block;width:1em;height:1em;contain:strict;fill:currentColor;-webkit-box-sizing:content-box !important;box-sizing:content-box !important}:host .ionicon{stroke:currentColor}.ionicon-fill-none{fill:none}.ionicon-stroke-width{stroke-width:32px;stroke-width:var(--ionicon-stroke-width, 32px)}.icon-inner,.ionicon,svg{display:block;height:100%;width:100%}@supports (background: -webkit-named-image(i)){:host(.icon-rtl) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}}@supports not selector(:dir(rtl)) and selector(:host-context([dir='rtl'])){:host(.icon-rtl) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}}:host(.flip-rtl):host-context([dir='rtl']) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}@supports selector(:dir(rtl)){:host(.flip-rtl:dir(rtl)) .icon-inner{-webkit-transform:scaleX(-1);transform:scaleX(-1)}:host(.flip-rtl:dir(ltr)) .icon-inner{-webkit-transform:scaleX(1);transform:scaleX(1)}}:host(.icon-small){font-size:1.125rem !important}:host(.icon-large){font-size:2rem !important}:host(.ion-color){color:var(--ion-color-base) !important}:host(.ion-color-primary){--ion-color-base:var(--ion-color-primary, #3880ff)}:host(.ion-color-secondary){--ion-color-base:var(--ion-color-secondary, #0cd1e8)}:host(.ion-color-tertiary){--ion-color-base:var(--ion-color-tertiary, #f4a942)}:host(.ion-color-success){--ion-color-base:var(--ion-color-success, #10dc60)}:host(.ion-color-warning){--ion-color-base:var(--ion-color-warning, #ffce00)}:host(.ion-color-danger){--ion-color-base:var(--ion-color-danger, #f14141)}:host(.ion-color-light){--ion-color-base:var(--ion-color-light, #f4f5f8)}:host(.ion-color-medium){--ion-color-base:var(--ion-color-medium, #989aa2)}:host(.ion-color-dark){--ion-color-base:var(--ion-color-dark, #222428)}";
var Icon = /* @__PURE__ */ proxyCustomElement(class Icon2 extends H {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.iconName = null;
    this.inheritedAttributes = {};
    this.didLoadIcon = false;
    this.svgContent = void 0;
    this.isVisible = false;
    this.mode = getIonMode();
    this.color = void 0;
    this.ios = void 0;
    this.md = void 0;
    this.flipRtl = void 0;
    this.name = void 0;
    this.src = void 0;
    this.icon = void 0;
    this.size = void 0;
    this.lazy = false;
    this.sanitize = true;
  }
  componentWillLoad() {
    this.inheritedAttributes = inheritAttributes(this.el, ["aria-label"]);
  }
  connectedCallback() {
    this.waitUntilVisible(this.el, "50px", () => {
      this.isVisible = true;
      this.loadIcon();
    });
  }
  componentDidLoad() {
    if (!this.didLoadIcon) {
      this.loadIcon();
    }
  }
  disconnectedCallback() {
    if (this.io) {
      this.io.disconnect();
      this.io = void 0;
    }
  }
  waitUntilVisible(el, rootMargin, cb) {
    if (Build.isBrowser && this.lazy && typeof window !== "undefined" && window.IntersectionObserver) {
      const io = this.io = new window.IntersectionObserver((data) => {
        if (data[0].isIntersecting) {
          io.disconnect();
          this.io = void 0;
          cb();
        }
      }, { rootMargin });
      io.observe(el);
    } else {
      cb();
    }
  }
  loadIcon() {
    if (Build.isBrowser && this.isVisible) {
      const url = getUrl(this);
      if (url) {
        if (ioniconContent.has(url)) {
          this.svgContent = ioniconContent.get(url);
        } else {
          getSvgContent(url, this.sanitize).then(() => this.svgContent = ioniconContent.get(url));
        }
        this.didLoadIcon = true;
      }
    }
    this.iconName = getName(this.name, this.icon, this.mode, this.ios, this.md);
  }
  render() {
    const { flipRtl, iconName, inheritedAttributes, el } = this;
    const mode = this.mode || "md";
    const shouldAutoFlip = iconName ? (iconName.includes("arrow") || iconName.includes("chevron")) && flipRtl !== false : false;
    const shouldBeFlippable = flipRtl || shouldAutoFlip;
    return h(Host, Object.assign({ role: "img", class: Object.assign(Object.assign({ [mode]: true }, createColorClasses(this.color)), { [`icon-${this.size}`]: !!this.size, "flip-rtl": shouldBeFlippable, "icon-rtl": shouldBeFlippable && isRTL(el) }) }, inheritedAttributes), Build.isBrowser && this.svgContent ? h("div", { class: "icon-inner", innerHTML: this.svgContent }) : h("div", { class: "icon-inner" }));
  }
  static get assetsDirs() {
    return ["svg"];
  }
  get el() {
    return this;
  }
  static get watchers() {
    return {
      "name": ["loadIcon"],
      "src": ["loadIcon"],
      "icon": ["loadIcon"],
      "ios": ["loadIcon"],
      "md": ["loadIcon"]
    };
  }
  static get style() {
    return iconCss;
  }
}, [1, "ion-icon", {
  "mode": [1025],
  "color": [1],
  "ios": [1],
  "md": [1],
  "flipRtl": [4, "flip-rtl"],
  "name": [513],
  "src": [1],
  "icon": [8],
  "size": [1],
  "lazy": [4],
  "sanitize": [4],
  "svgContent": [32],
  "isVisible": [32]
}]);
var getIonMode = () => Build.isBrowser && typeof document !== "undefined" && document.documentElement.getAttribute("mode") || "md";
var createColorClasses = (color) => {
  return color ? {
    "ion-color": true,
    [`ion-color-${color}`]: true
  } : null;
};
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["ion-icon"];
  components.forEach((tagName) => {
    switch (tagName) {
      case "ion-icon":
        if (!customElements.get(tagName)) {
          customElements.define(tagName, Icon);
        }
        break;
    }
  });
}
var defineCustomElement92 = defineCustomElement$1;

// src/components/ion-icon.tsx
var _tmpl$92 = /* @__PURE__ */ _$template92(`<ion-icon>`, true, false);
defineCustomElement92();
function IonIcon(props) {
  return (() => {
    var _el$ = _tmpl$92();
    _$spread92(_el$, props, false, false);
    _el$._$owner = _$getOwner92();
    return _el$;
  })();
}

// src/components/ion-router.tsx
import { template as _$template93 } from "solid-js/web";
import { insert as _$insert } from "solid-js/web";
import { createComponent as _$createComponent } from "solid-js/web";
import { getOwner as _$getOwner93 } from "solid-js/web";
import { use as _$use } from "solid-js/web";
import { spread as _$spread93 } from "solid-js/web";
import { mergeProps as _$mergeProps92 } from "solid-js/web";
import { defineCustomElement as defineCustomElement93 } from "@ionic/core/components/ion-router";
import { createEffect, createSignal, splitProps } from "solid-js";

// src/hooks/useRouter.tsx
import { createContext, useContext } from "solid-js";
var RouterContext = createContext();
function useRouter() {
  return useContext(RouterContext);
}
var RouterContextProvider = RouterContext.Provider;

// src/components/ion-router.tsx
var _tmpl$93 = /* @__PURE__ */ _$template93(`<ion-router>`, true, false);
defineCustomElement93();
function IonRouter(props) {
  const [_, propsToFix] = splitProps(props, ["ref"]);
  const fixedProps = () => fixProps(propsToFix);
  const [router, setRouter] = createSignal();
  createEffect(() => {
    const routerElement = router();
    if (typeof props.ref === "function") {
      if (routerElement) {
        props.ref(routerElement);
      }
    } else if (props.ref !== void 0) {
      props.ref = routerElement;
    }
  });
  return (() => {
    var _el$ = _tmpl$93();
    _$use(setRouter, _el$);
    _$spread93(_el$, _$mergeProps92(fixedProps), false, true);
    _el$._$owner = _$getOwner93();
    _$insert(_el$, _$createComponent(RouterContextProvider, {
      get value() {
        return router();
      },
      get children() {
        return props.children;
      }
    }));
    return _el$;
  })();
}

// src/components/ion-route.tsx
import { template as _$template94 } from "solid-js/web";
import { effect as _$effect } from "solid-js/web";
import { getOwner as _$getOwner94 } from "solid-js/web";
import { spread as _$spread94 } from "solid-js/web";
import { mergeProps as _$mergeProps93 } from "solid-js/web";
import { memo as _$memo2 } from "solid-js/web";
import { createComponent as _$createComponent2 } from "solid-js/web";
import { defineCustomElement as defineCustomElement94 } from "@ionic/core/components/ion-route";
import { splitProps as splitProps2 } from "solid-js";
var _tmpl$94 = /* @__PURE__ */ _$template94(`<ion-route>`, true, false);
defineCustomElement94();
function RouteRouterContextProvider(props) {
  Object.defineProperty(props.componentOptions.element, "renderRoot", {
    value: props.componentOptions.element
  });
  return _$createComponent2(RouterContextProvider, {
    get value() {
      return props.router;
    },
    get children() {
      return props.component(props.componentProps);
    }
  });
}
function IonRoute(props) {
  const router = useRouter();
  const [_, propsToFix] = splitProps2(props, ["component", "componentProps"]);
  const fixedProps = () => fixProps(propsToFix);
  return (() => {
    var _el$ = _tmpl$94();
    _$spread94(_el$, _$mergeProps93(fixedProps, {
      get component() {
        return typeof props.component === "string" ? props.component : ComponentRefElementName;
      }
    }), false, false);
    _el$._$owner = _$getOwner94();
    _$effect(() => _el$.componentProps = typeof props.component === "string" ? void 0 : {
      component: RouteRouterContextProvider,
      componentProps: {
        component: props.component,
        componentProps: props.componentProps ?? {},
        router
      }
    });
    return _el$;
  })();
}

// src/utils/setupIonicSolid.ts
import { initialize } from "@ionic/core/components";
function setupIonicSolid(config = {}) {
  if (typeof document !== "undefined") {
    document.documentElement.classList.add("ion-ce");
  }
  initialize({
    ...config
  });
}
export {
  ComponentRef,
  ComponentRefElementName,
  IonAccordion,
  IonAccordionGroup,
  IonActionSheet,
  IonAlert,
  IonApp,
  IonAvatar,
  IonBackButton,
  IonBackdrop,
  IonBadge,
  IonBreadcrumb,
  IonBreadcrumbs,
  IonButton,
  IonButtons,
  IonCard,
  IonCardContent,
  IonCardHeader,
  IonCardSubtitle,
  IonCardTitle,
  IonCheckbox,
  IonChip,
  IonCol,
  IonContent,
  IonDatetime,
  IonDatetimeButton,
  IonFab,
  IonFabButton,
  IonFabList,
  IonFooter,
  IonGrid,
  IonHeader,
  IonIcon,
  IonImg,
  IonInfiniteScroll,
  IonInfiniteScrollContent,
  IonInput,
  IonInputPasswordToggle,
  IonItem,
  IonItemDivider,
  IonItemGroup,
  IonItemOption,
  IonItemOptions,
  IonItemSliding,
  IonLabel,
  IonList,
  IonListHeader,
  IonLoading,
  IonMenu,
  IonMenuButton,
  IonMenuToggle,
  IonModal,
  IonNav,
  IonNavLink,
  IonNote,
  IonPicker,
  IonPickerColumn,
  IonPickerColumnOption,
  IonPickerLegacy,
  IonPickerLegacyColumn,
  IonPopover,
  IonProgressBar,
  IonRadio,
  IonRadioGroup,
  IonRange,
  IonRefresher,
  IonRefresherContent,
  IonReorder,
  IonReorderGroup,
  IonRippleEffect,
  IonRoute,
  IonRouteRedirect,
  IonRouter,
  IonRouterLink,
  IonRouterOutlet,
  IonRow,
  IonSearchbar,
  IonSegment,
  IonSegmentButton,
  IonSelect,
  IonSelectOption,
  IonSelectPopover,
  IonSkeletonText,
  IonSpinner,
  IonSplitPane,
  IonTab,
  IonTabBar,
  IonTabButton,
  IonTabs,
  IonText,
  IonTextarea,
  IonThumbnail,
  IonTitle,
  IonToast,
  IonToggle,
  IonToolbar,
  RouterContext,
  RouterContextProvider,
  setupIonicSolid,
  useRouter
};
/*! Bundled license information:

@stencil/core/internal/client/shadow-css.js:
  (**
   * @license
   * Copyright Google Inc. All Rights Reserved.
   *
   * Use of this source code is governed by an MIT-style license that can be
   * found in the LICENSE file at https://angular.io/license
   *
   * This file is a port of shadowCSS from `webcomponents.js` to TypeScript.
   * https://github.com/webcomponents/webcomponentsjs/blob/4efecd7e0e/src/ShadowCSS/ShadowCSS.js
   * https://github.com/angular/angular/blob/master/packages/compiler/src/shadow_css.ts
   *)

@stencil/core/internal/client/index.js:
  (*!__STENCIL_STATIC_IMPORT_SWITCH__*)
*/
//# sourceMappingURL=index.mjs.map